//======================================================================================================
// STR.H
// Copyright 2022 Everett Kaser
// All rights reserved
//======================================================================================================

//The MAKESTR() macro combines a string block # and a string # into a single DWORD for use in DLGRES->pText
#define	MAKESTR(b,s) (char *)((((b)<<16) | (s)))

//==========================================================
#define	BLK_MISC	1

#define	STR_NO_ORDER		1
#define	STR_OK				2
#define	STR_CANCEL			3
#define	STR_CLOSE			4
#define	STR_YES				5
#define	STR_NO				6
#define	STR_WHATEVER		7
#define	STR_BUMMER			8
#define	STR_WAYCOOL			9
#define	STR_EXIT			10
#define	STR_LOAD			11
#define	STR_RESET			12
#define	STR_RESIZING		13
#define	STR_BAD_HELP_FILE	14
#define	STR_BAD_HELP_PAGE	15
#define	STR_PUZZNUMERR		16
#define	STR_SAVE_FAILED		17
#define	STR_GAME_SAVED		18
#define	STR_LOG_HEADER		19
#define	STR_NEWBEST			20
#define	STR_CONTINUE		21
#define	STR_STARTNEWGAME	22
#define	STR_CONFIRM_RESTART	23
#define	STR_END_PUZZLES		24
#define	STR_TOO_MANY_MOVES	25
#define	STR_DEMO1			26
#define	STR_DEMO2			27
#define	STR_DEMO3			28
#define	STR_DEMO4			29
#define	STR_DEMO5			30

//==========================================================
#define	BLK_MENU	2

#define	STR_HELP			1
#define	STR_ABOUT			2
#define	STR_EXITGAME		3
#define	STR_CHANGE_PLAYER	4
#define	STR_ADD_PLAYER		5
#define	STR_RENAME_PLAYER	6
#define	STR_DELETE_PLAYER	7
#define	STR_CHANGE_MOOD		8
#define	STR_ADD_MOOD		9
#define	STR_RENAME_MOOD		10
#define	STR_DELETE_MOOD		11
#define	STR_MUSIC			12
#define	STR_IF				13
#define	STR_LANG			14
#define	STR_GRAPHICS		15
#define	STR_MOUSE_MAP		16
#define	STR_KEY_MAP			17
#define	STR_OPTIONS			18
#define	STR_BESTMOVES		19

//==========================================================
#define	BLK_OPT		3

#define	STR_BYPASS_TITLE	1
#define	STR_GAME_SOUNDS		2
#define	STR_ERROR_SOUNDS	3
#define	STR_PROMPT_NEXT		4
#define	STR_PROMPT_RESTART	5
#define	STR_ENABLE_CLICK	6
#define	STR_START_BOTTOM	7
#define	STR_SCRAMBLE_TILES	8
#define	STR_SHOW_TIMER		9
#define	STR_SHOW_MOVECNT	10
#define	STR_SHOW_BESTCNT	11
#define	STR_SHOW_TOOLTIPS	12
#define	STR_WIN_FIRE		13
#define	STR_WIN_QUILT		14
#define	STR_WIN_WEAVE		15
#define	STR_WIN_BOUNCE		16
#define	STR_WIN_RANDOM		17
#define	STR_WIN_NONE		18
#define	STR_WIN_DELAY		19
#define	STR_WIN_SPEED		20
#define	STR_WIN_DISP		21
#define	STR_PUZZLE_SIZE		22
#define	STR_CSV_SEP			23
#define	STR_REMOVE_PAUSE	24




//==========================================================
#define	BLK_DLG		4

#define	STR_BUILDDATE		1
#define	STR_REVISION		2
#define	STR_BUILDNUM		3
#define	STR_CONTACT			4
#define	STR_SCREEN			5
#define	STR_WINDOW			6
#define	STR_UI				7
#define	STR_ABOUT_KINT		8
#define	STR_ABOUT_COPY		9
// 10 unused
// 11 unused
// 12 unused
// 13 unused
#define	STR_IF_SIZE			14
#define	STR_UUSIZE_AUTO		15
#define	STR_UUSIZE			16
#define	STR_IF_FILE			17
#define	STR_IF_BY			18

#define	STR_SELPLAYER		19
#define	STR_SELECT			20

#define	STR_NEWPLAYER		21
#define	STR_DEFMOOD			22
#define	STR_COPYCURMOOD		23
#define	STR_COPYALLMOODS	24
#define	STR_NPDEFMOODNAME	25
#define	STR_ADD				26
#define	STR_SECRET_ID		27
#define	STR_NEEDNAME		28
#define	STR_DUPEPLAYER		29

#define	STR_REN_PLAYER		30
#define	STR_RENAME			31

#define	STR_CNFRM_DELPLYR	32

#define	STR_SELMOOD			33
#define	STR_SELECTMOOD		34

#define	STR_NEWMOODNAME		35	// New mood name:
#define	STR_NEWMOODCOPY		36	// Copy current mood settings
#define	STR_NEWMOODADD		37	// Add mood
#define	STR_DEFMOODNAME		38	// YourMoodName
#define	STR_MOODMUSTBENAMED	39	// Oops. All moods must be named
#define	STR_DUPEMOOD		40	// Sorry, you can't duplicate your mood names.

#define	STR_REN_MOOD		41
#define	STR_RENMOOD_BUTTON	42

#define	STR_CNFRM_DELMOOD	43

#define	STR_MUSIC_AVAIL		44
#define	STR_PLAYBACKMUSIC	45
#define	STR_PLAYWINMUSIC	46
#define	STR_M_ADDBACK		47
#define	STR_M_ADDBACKALL	48
#define	STR_M_REMBACK		49
#define	STR_M_REMBACKALL	50
#define	STR_M_TEST			51
#define	STR_M_STOPPLAY		52
#define	STR_M_ADDWIN		53
#define	STR_M_ADDWINALL		54
#define	STR_M_REMWIN		55
#define	STR_M_REMWINALL		56
#define	STR_M_RANDOM		57	

#define	STR_GG_FILE			58
// 59 unused
// 60 unused
#define	STR_LANG_STRINGS	61
#define	STR_LANG_HELP		62
// 63 unused
#define	STR_HELP_HIDE		64
#define	STR_HELP_EXPORT		65
#define	STR_HELP_INDEX		66
#define	STR_HELP_BACK		67
#define	STR_HELP_PREV		68
#define	STR_HELP_NEXT		69
#define	STR_TABLE_CONTENTS	70
#define	STR_NOTE			71
// 72-79 unused
#define	STR_CLRPICK_HUE		80
#define	STR_CLRPICK_SAT		81
#define	STR_CLRPICK_LIT		82
#define	STR_CP_DEC			83
#define	STR_CP_HEX			84
// 85-89 unused
#define	STR_DLG_EXPORT		90
#define	STR_EXPCLR			91
#define	STR_EXPCLR_BACK		92
#define	STR_EXPCLR_TEXT		93
#define STR_EXPCLR_H1		94
#define STR_EXPCLR_H2		95
#define STR_EXPCLR_H3		96
#define STR_EXPCLR_CONTBACK	97
#define STR_EXPCLR_CONTTEXT	98
#define STR_EXPCLR_CONTLINK	99
#define	STR_EXPCLR_HEADBACK	100
#define	STR_EXPCLR_HEADTEXT	101
#define	STR_EXPCLR_HEADFRAME	102
// 103-108 unused
#define	STR_EXPORT_FOOTER	109
#define	STR_EXFONT			110
#define	STR_EXFONT_SANS		111
#define	STR_EXFONT_SERIF	112
#define	STR_EXFONT_DEF		113
#define	STR_EXFONT_ARIAL	114
#define	STR_EXFONT_VERDANA	115
#define	STR_EXFONT_HELVETICA	116
#define	STR_EXFONT_TAHOMA	117
#define	STR_EXFONT_TIMES	118
#define	STR_EXFONT_GEORGIA	119
#define	STR_EXFONT_GARAMOND	120
#define	STR_EXFONT_TEXT		121
#define	STR_EXFONT_H1		122
#define	STR_EXFONT_H2		123
#define	STR_EXFONT_H3		124
#define	STR_RULETOP			125
#define	STR_RULEBOT			126
#define	STR_HRULE			127
#define	STR_HRULE2			128
#define	STR_LINKCONTENTS	129
#define	STR_EXPWIDTH		130
#define	STR_EXPLMARGIN		131
#define	STR_EXPCONTENTW		132
#define STR_EXPCONTENTSP	133
#define	STR_HEXPTO			134
#define	STR_EXPHELP			135
#define	STR_EXPSAVECHANGES	136
#define	STR_EXPEXP1			137
#define	STR_EXPEXP2			138
// 139 unused
#define	STR_EXP_ALLCNTS		140
#define	STR_EXP_CURBEST		141
#define	STR_IMP_CURBEST		142
#define	STR_MERGE_ALL		143
#define	STR_BEST_CNT		144
#define	STR_MERGE_CNT		145
#define	STR_BEST_PUZZNUM	146
#define	STR_BEST_MOVECNT	147
#define	STR_BEXPTO			148
#define	STR_BMEXPTO			149
#define	STR_MERGE_FROM		150
#define	STR_MERGE_BEST		151
#define	STR_MERGE_MERGE		152
#define	STR_MERGE_MERGED	153
#define	STR_SOLUTION_IMPORTED 154

//==========================================================
#define	BLK_MM		5
#define	STR_MM_BUTTGROUP	1
#define	STR_MM_ACTGROUP		2
// 3 unused
#define	STR_MM_LEFT			4
#define	STR_MM_MIDDLE		5
#define	STR_MM_RIGHT		6
#define	STR_MM_BACK			7
#define	STR_MM_FWD			8
#define	STR_MM_SLEFT		9
#define	STR_MM_SMIDDLE		10
#define	STR_MM_SRIGHT		11
#define	STR_MM_SBACK		12
#define	STR_MM_SFWD			13
#define	STR_MM_CLEFT		14
#define	STR_MM_CMIDDLE		15
#define	STR_MM_CRIGHT		16
#define	STR_MM_CBACK		17
#define	STR_MM_CFWD			18
#define	STR_MM_SCLEFT		19
#define	STR_MM_SCMIDDLE		20
#define	STR_MM_SCRIGHT		21
#define	STR_MM_SCBACK		22
#define	STR_MM_SCFWD		23

// NOTE: The following MUST be in the same order as the MM_functions in game.h or the EXPORT REFERENCE won't work right
#define	STR_MM_FIRST		24
#define	STR_MM_NOACTION		24
#define	STR_MM_MOVETILE		25
#define	STR_MM_FINDAVAIL	26
#define	STR_MM_FINDTPBT		27
#define	STR_MM_FINDALL		28
#define	STR_MM_UNDO			29
#define	STR_MM_REDO			30
#define	STR_MM_NEXT_MOOD	31
#define	STR_MM_PREV_MOOD	32
//#define	STR_MM 33-34 unused
#define	STR_MM_LAST			32

#define	STR_MM_CONFIRM		35
#define	STR_REV_WHEEL		36
#define	STR_REV_TILT		37
#define	STR_MIRROR_CHANGES	38
#define	STR_MM_EXPORT		39
#define	STR_MM_EXPORTED		40

//==========================================================
#define	BLK_KEY		6
#define	STR_KEY_SHIFT		1
#define	STR_KEY_CTL			2
#define	STR_KEYMAP_HEAD		3
#define	STR_KEYS_HEAD		4
#define	STR_FUNC_HEAD		5
#define	STR_KEYMAP_ADD		6
#define	STR_KEYMAP_DEL		7
#define	STR_KEY_NAME_CODE	8
#define	STR_KEYMAP_HELP		9
#define	STR_KEYMAP_RESET	10
#define	STR_KRESET_CONFIRM	11
#define	STR_REMAP_CONFIRM	12
#define	STR_KEYMAP_EXPORT	13
#define	STR_DUPE_FUNCS		14
#define	STR_KEYMAP_OVERWRITE	15
#define	STR_MOVE_FUNCS		16
#define	STR_KEYS_EXPORTED	17
#define	STR_KEYMAP_MOVE		18
#define	STR_KEYMAP_DUPE		19
#define	STR_KF_FIRSTFUNC	20	// must be same as the following first function name
#define	STR_KF_KM_DLG		20
#define	STR_KF_OPT_DLG		21
#define	STR_KF_SELMOOD		22
#define	STR_KF_NEXTPUZZ		23
#define	STR_KF_PREVPUZZ		24

//==========================================================
#define	BLK_BUTTS		7
#define	STR_MENU_BUTT		1
#define	STR_PUZZW_2			2
#define	STR_PUZZW_3			3
#define	STR_PUZZW_4			4
#define	STR_PUZZW_5			5
#define	STR_PUZZH_2			6
#define	STR_PUZZH_3			7
#define	STR_PUZZH_4			8
#define	STR_PUZZH_5			9
#define	STR_PUZZH_6			10
#define	STR_PUZZH_7			11
#define	STR_PREVPUZZ		12
#define	STR_NEXTPUZZ		13
#define	STR_PUZZNUM			14
#define	STR_RESTART			15
#define	STR_SAVEGAME		16
#define	STR_UNDO			17
#define	STR_REDO			18
#define	STR_PAUSE			19
#define	STR_MOVES			20
#define	STR_BEST			21
