//
//  main.h
//
//  Created by Everett Kaser on 4/16/18.
//  Copyright © 2018 Everett Kaser Software. All rights reserved.
//

#ifndef main_h
#define main_h

@import Foundation;
@import Cocoa;
@import CoreGraphics;
@import AVFoundation;


typedef uint8_t BYTE;
typedef uint16_t WORD;
//typedef unsigned long DWORD;
typedef uint32_t DWORD;
typedef uint64_t QWORD;
typedef int8_t  KCHAR;
typedef int16_t KSHORT;
typedef int32_t KLONG;
typedef int64_t KLONGLONG;
//typedef signed char	BOOL;

#define EKDBG   0

#if EKDBG
extern char EKDbuf[1024];
#endif

#define FALSE	0
#define TRUE	1

#define MAXFILES 16

#define    PATHLEN    1024

#define MAXFILES 16
extern KLONG    filesCnt;
extern FILE *files[MAXFILES];
extern struct	stat	fstats;
extern BOOL InSetWindowPos;
extern KLONG	KEloaded, killpgm;
extern char titleBuf[512];
extern DWORD	SWPopt, SWPh, SWPw, SWPy, SWPx, SWPvw, SWPvh;
extern KLONG    PhysicalScreenW, PhysicalScreenH, ScreenW, ScreenH, MaxScreenW, MaxScreenH;
extern DWORD    PCpreJSR;    // in case of crashes, gets us back one JSR from where the crash occurred. Might help.

typedef struct {
	WORD	y, mo, d, h, mi, s;
} KTIME;
/*
typedef struct {
	BYTE		*pBits;
	BYTE		*pAND;
	WORD		linelen, orient, physW, physH, logW, logH,unused1,unused2;
	KLONG		clipX1, clipX2, clipY1, clipY2;
	CGContextRef	bitmapContext;
	CGImageRef 		cgImage;
	//	void		*pPrev, *pNext;
} BMB, *PBMB;
*/

#define MAXBM	100
//extern CGContextRef	kCTX;
//extern CGImageRef	kBM[MAXBM];
//extern KLONG			BMcnt;
//struct KEEPBM {
//	CGContextRef    ctx;
//	CGImageRef      bm;
//	KLONG           w, h;
//};
//extern BMB kBM[MAXBM];
/*
typedef struct {
	BYTE	*pKode;				// ptr to memory block containing .KE
	DWORD	memlen;				// len of this .KE memory block
	DWORD	StackBase;			// offset in pKode of base of K stack for this .KE
	DWORD	reg4, reg5;			// save/init locations for SB, SP for this .KE
	
	DWORD	KEnum;
} KE;
*/
//#if KINT_POCKET_PC
//  #define	stricmp(s, d)	_stricmp(s, d)
//#endif

// The following are the KASM/KINT file-open flag definitions.
// These are consistent with standard C library #define values
// but if this is being translated to another language, it's
// good to know what the KASM code is going to be passing you and
// what it means....
#define	O_RDBIN		0x8000	// read only, binary
#define	O_WRBIN		0x8002	// read/write, binary
#define	O_WRBINNEW	0x8302	// read/write, binary, create or truncate

// The following are the KASM/KINT file-open directories
#define	DIR_GAME		0
#define	DIR_UI			1
#define DIR_IMAGES		2
#define DIR_BACKGNDS	3
#define DIR_MUSIC		4
#define DIR_SOUNDS		5
#define	DIR_GAME_IMG	6
#define	DIR_UI_COMMON	7
#define	DIR_LOSSY		0x40
#define	DIR_NOEXT		0x80

//**********************************************************************
void SetupScreen(void);

void FlushScreen(void);
void BuildPath(char *pMem, BOOL AppData);
int KMakeFolder(char *fname);
void KDelFolder(char *fname);
DWORD Kopen(char *fname, int oflags);
DWORD Kstat(char *fname, DWORD *modtim, BYTE *filtyp);
DWORD Kseek(DWORD fhandle, DWORD foffset, int origin);
void Kclose(DWORD fhandle);
DWORD Keof(DWORD fhandle);
DWORD Kread(DWORD fhandle, BYTE *pMem, DWORD numbytes);
DWORD Kwrite(DWORD fhandle, BYTE *pMem, DWORD numbytes);
int wildicmp(const char *string, const char *wild);
int stricmp(const char *s, const char *d);
void Kff(BOOL appdata);
DWORD Kfindfirst(char *fname, BYTE *fbuf, BYTE *attrib, BYTE *appdata);
DWORD Kfindnext(BYTE *fbuf, BYTE *attrib, BYTE *appdata);
void Kfindclose(void);
void Kdelete(char *fname);
void Krename(char *fname, char *tname);
void KGetTime(KTIME *pT);
void KTimeToString(BYTE *pMem);
DWORD KGetTicks(void);
void KSleep(DWORD tm);
void KSetCursor(WORD curtype);
void KCaptureMouse(BOOL cap);
void KSetTitle(void);
void KPlaySound(char *pMem);
void KPlaySoundMem(char *pMem, KLONG len, BOOL nostop);
int KMusicIsBusy(void);
void StopMusic(void);
void SetSWPv(void);

void InitHeap(void);
void CompactHeap(void);
void ChainHeap(KLONG ix, KLONG chain);
void UnchainHeap(KLONG ix);
DWORD GetHeapAdr(KLONG ix);
DWORD LockHeap(KLONG ix);
void UnlockHeap(KLONG ix);
void FreeHeap(KLONG ix);
void GrowHeap(DWORD AddLen);
DWORD AllocHeap(DWORD len);
void AutoUnlockHeap(DWORD curSP);
void* GetHeapPtr(KLONG ix);
void RelHeapPtr(KLONG ix);

BOOL KeyMsg(DWORD *cmd, DWORD *arg1, DWORD *arg2, DWORD *arg3);
BOOL PtrMsg(DWORD *cmd, DWORD *arg1, DWORD *arg2, DWORD *arg3);
void AddMsg(DWORD cmd, DWORD arg1, DWORD arg2, DWORD arg3);
void SendNextMsg(void);

BOOL LoadKE(void);

extern BOOL	MusicPlaying;
extern bool inSleep, inSetTitle;
extern void Dwrite(char *str);
extern void Ddel(void);
extern char    PgmPath[PATHLEN], TmpPath[PATHLEN], AppDataPath[PATHLEN], AppPath[PATHLEN];
extern BYTE    *mainKE;

#endif /* main_h */
