//
//  kintView.m
//  iKINT
//
//  Created by Everett Kaser on 1/9/13.
//  Copyright (c) 2013 Everett Kaser. All rights reserved.
//

#import "kintMAIN.h"
#import "kintView.h"
#import "kintPMACH.h"
#import "kintAppDelegate.h"
#import <AVFoundation/AVFoundation.h>

kintView		*pKV;
CGFloat			kScale;
int				kDPI;
char			scrat[64];
//int             numTouchesLast=0;
//DWORD           TouchesLastXY1, TouchesLastXY2;
// KINT requires VK key codes. This table will take a Mac keyCode and remap it to the closest VK equivalent.
static BYTE sMacKeyCodeToVK[128] =
{
	0x41, 0x53, 0x44, 0x46, 0x48, 0x47, 0x5a, 0x58, 0x43, 0x56, 0x00, 0x42, 0x51, 0x57, 0x45, 0x52,
	0x59, 0x54, 0x31, 0x32, 0x33, 0x34, 0x36, 0x35, 0xbb, 0x39, 0x37, 0xbd, 0x38, 0x30, 0xdd, 0x4f,
	0x55, 0xdb, 0x49, 0x50, 0x0d, 0x4c, 0x4a, 0xde, 0x4b, 0xba, 0xdc, 0xbc, 0xbf, 0x4e, 0x4d, 0xbe,
	0x09, 0x20, 0xc0, 0x08, 0x00, 0x1b, 0x00, 0x00, 0x10, 0x14, 0x12, 0x11, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x6e, 0x00, 0x6a, 0x00, 0x6b, 0x00, 0x90, 0x00, 0x00, 0x00, 0x6f, 0x0d, 0x00, 0x6d, 0x00,
	0x00, 0xbb, 0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, 0x00, 0x68, 0x69, 0x00, 0x00, 0x00,
	0x74, 0x75, 0x76, 0x72, 0x77, 0x78, 0x00, 0x7a, 0x00, 0x2c, 0x00, 0x91, 0x00, 0x79, 0x00, 0x7b,
	0x00, 0x13, 0x2d, 0x24, 0x21, 0x2e, 0x73, 0x23, 0x71, 0x22, 0x70, 0x25, 0x27, 0x28, 0x26, 0x00
};
DWORD KeyFlags=0, LastX, LastY;
BOOL    KINTptrmovePENDING=false;

NSTrackingArea *trackingArea=nil;

@implementation kintView
@synthesize startTouchPosition, cellTimer;
@synthesize audioPlayer;

//****************
-(id)initWithFrame: (CGRect)iRect {
	
	if( (self=[super initWithFrame:iRect]) ) {
		pKV = self;
		cellTimer = nil;
		pKV.postsFrameChangedNotifications = YES;
//		pKV.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;

		kScale = [[NSScreen mainScreen] backingScaleFactor];//[pKV contentScaleFactor];
//		gMacWindow = [[kApp window] windowRef];

//        NSLog(@"kScale=%f",kScale);
/*		if( UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad ) kDPI = (int)(132.0 * kScale);
		else if( UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone ) kDPI = (int)(163.0 * kScale);
		else kDPI = (int)(160.0 * kScale);
*/
		
	}
	return self;
}
-(BOOL)isOpaque {return YES;}
/*
void DumpStr(char *str) {
	
	DWORD	hFile;

	if( -1==(hFile=Kopen("dump.txt", O_WRBIN, DIR_GAME)) ) {
		if( -1==(hFile=Kopen("dump.txt", O_WRBINNEW, DIR_GAME)) ) return;
	}
	Kseek(hFile, 0, SEEK_END);
	Kwrite(hFile, (BYTE*)str, (DWORD)strlen(str));
	Kwrite(hFile, (BYTE*)"\r\n", 2);
	Kclose(hFile);
}
*/
/*
BYTE drFLAGS[1024];
int drx1[1024], drx2[1024], dry1[1024], dry2[1024], drHERE[1024];
int drADD=0, drBEG=0;

void DumpDR(void) {
	
	char	tbuf[64];
	DWORD	hFile;

	if( -1!=(hFile=Kopen("drdump.txt", O_WRBINNEW, DIR_GAME)) ) {
		Kwrite(hFile, (BYTE*)"*******************\n", 20);
		while( drADD!=drBEG ) {
			sprintf(tbuf, "0x%2.2X %d,%d %d,%d = %d\n", drFLAGS[drBEG], drx1[drBEG], dry1[drBEG], drx2[drBEG], dry2[drBEG], drHERE[drBEG]);
			if( ++drBEG>=sizeof(drFLAGS) ) drBEG = 0;
			Kwrite(hFile, (BYTE*)tbuf, (DWORD)strlen(tbuf));
		}
		Kclose(hFile);
	}
}
*/
//**************************
-(void)drawRect:(CGRect)rect {

/*	int	drI=drADD;
	if( KeyFlags & MK_LBUTT ) {
		drHERE[drADD] = 0;
		drFLAGS[drADD] = (inSleep?4:0) | (inSize?2:0) | (inKE?1:0);
		drx1[drADD] = (int)rect.origin.x;
		dry1[drADD] = (int)rect.origin.y;
		drx2[drADD] = (int)(rect.origin.x+rect.size.width);
		dry2[drADD] = (int)(rect.origin.y+rect.size.height);
		if( ++drADD>=sizeof(drFLAGS) ) drADD = 0;
		if( drADD==drBEG ) {
			if( ++drBEG>=sizeof(drFLAGS) ) drBEG = 0;
		}
//		NSLog(@"inSleep=%d inSize=%d inKE=%d", inSleep, inSize, inKE);
	}
*/
//	Dwrite("drawRect ENTER");
//	if( dispatch_get_main_queue()!=dispatch_get_current_queue() ) NSLog(@"NOT MAIN QUEUE!");
    
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"drawRect (%d,%d)(%d,%d) inSleep=%d inSize=%d inKE=%d\n", (int)rect.origin.x, (int)rect.origin.y, (int)rect.size.width, (int)rect.size.height,inSleep,inSize,inKE);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
	if( inSleep || inSize || !inKE ) {
//        NSLog(@"drawRect IN (%d,%d)(%d,%d) Dirty=(%d,%d)(%d,%d) SWPvw/vh=(%d,%d)",(int)rect.origin.x,(int)rect.origin.y, (int)rect.size.width,(int)rect.size.height,dirtyX1,dirtyY1,dirtyX2,dirtyY2, SWPvw,SWPvh);
        CGContextRef context = [[NSGraphicsContext currentContext] CGContext];
		//	NSLog(@"drawRect in kintView.m");
		CGRect dr = rect;//CGRectMake(0, 0, [pKV frame].size.width, [pKV frame].size.height);//rect;
		if( dr.origin.x<0 ) {
            NSLog(@"origin.x<0");
			dr.size.width += dr.origin.x;
			dr.origin.x = 0;
		}
		if( dr.origin.y<0 ) {
            NSLog(@"origin.y<0");
			dr.size.height += dr.origin.y;
			dr.origin.y = 0;
		}
        if( dr.size.width<=0 || dr.size.height<=0 ) {
            NSLog(@"return dr w=%f h=%f",dr.size.width,dr.size.height);
            return;
        }
		CGRect sr = dr;//CGRectMake(0, 0, [pKV frame].size.width, [pKV frame].size.height);
//        NSLog(@"frame height=%d",(int)([pKV frame].size.height));
		sr.origin.y = [pKV frame].size.height - (sr.origin.y + sr.size.height);

		if( (WORD)sr.size.width+(WORD)sr.origin.x > scrBM.w ) sr.size.width = (double)scrBM.w - sr.origin.x;
		if( (WORD)sr.size.height+(WORD)sr.origin.y > scrBM.h ) sr.size.height = (double)scrBM.h - sr.origin.y;
        if( sr.size.width<=0 || sr.size.height<=0 ) {
            NSLog(@"return sr w=%f h=%f",sr.size.width,sr.size.height);
            return;
        }
/*		{
			char buf[128];
			sprintf(buf,"s(%d,%d) d(%d,%d)",(int)sr.size.width,(int)sr.size.height, (int)dr.size.width,(int)dr.size.height);
			DumpStr(buf);
		}
 */
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"drawRect sr=(%d,%d)(%d,%d) dr=(%d,%d)(%d,%d)\n", (int)sr.origin.x, (int)sr.origin.y, (int)sr.size.width, (int)sr.size.height, (int)dr.origin.x, (int)dr.origin.y, (int)dr.size.width, (int)dr.size.height);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
		CGContextSaveGState(context);
			CGImageRef srcIR = CGBitmapContextCreateImage(scrBM.bitmapContext);
	//			CGImageRef srcImg = CGImageCreateWithImageInRect(srcIR, CGRectMake(sr.origin.x, CGImageGetHeight(srcIR)-sr.origin.y-sr.size.height, sr.size.width, sr.size.height));
				CGImageRef srcImg = CGImageCreateWithImageInRect(srcIR, sr);

//        NSLog(@"clip (%d,%d)(%d,%d)", (int)dr.origin.x,  (int)dr.origin.y, (int)dr.size.width, (int)dr.size.height);
					CGContextClipToRect(context, dr);
//        NSLog(@"ClipToRect(%d,%d, %d,%d)", (int)dr.origin.x, (int)dr.origin.y, (int)dr.size.width, (int)dr.size.height);
					CGContextSetAllowsAntialiasing(context, false);
					CGContextSetShouldAntialias(context, false);
					CGContextSetInterpolationQuality(context, kCGInterpolationNone);
					// NOTE: This next line is the REAL TIME-HOG when zooming and panning without the above setting of interpolation.
//		if( KeyFlags & MK_LBUTT ) drHERE[drI] = 1;
					CGContextDrawImage(context, dr, srcImg);
		
				CGImageRelease(srcImg);
			CGImageRelease(srcIR);
		CGContextRestoreGState(context);
//		dirtyX1 = dirtyY1 = 30000;
//		dirtyX2 = dirtyY2 = -1;
	} else {
//        NSLog(@"drawRect ELSE (%d,%d)(%d,%d)",(int)rect.origin.x,(int)rect.origin.y,(int)rect.size.width,(int)rect.size.height);
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"drawRect ELSE IN dirty=(%d,%d)(%d,%d)\n",dirtyX1,dirtyY1,dirtyX2,dirtyY2);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
		if( rect.origin.x < dirtyX1 ) dirtyX1 = rect.origin.x;
		if( rect.origin.y < dirtyY1 ) dirtyY1 = rect.origin.y;
		if( rect.origin.x+rect.size.width > dirtyX2 ) dirtyX2 = rect.origin.x+rect.size.width;
		if( rect.origin.y+rect.size.height > dirtyY2 ) dirtyY2 = rect.origin.y+rect.size.height;
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"drawRect ELSE OUT dirty=(%d,%d)(%d,%d)\n",dirtyX1,dirtyY1,dirtyX2,dirtyY2);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
	}
//	Dwrite("drawRect EXIT");
}

//************************************
-(BOOL)acceptsFirstResponder {
	return YES;
}
//************************************
-(BOOL)becomeFirstResponder {
	return YES;
}
//************************************
-(BOOL)resignFirstResponder {
	return YES;
}
//************************************
-(BOOL)acceptsMouseMovedEvents {
	return YES;
}
//************************************
-(void)updateTrackingAreas {
	
	if( trackingArea != nil ) [self removeTrackingArea:trackingArea];
	NSTrackingAreaOptions options=(NSTrackingActiveAlways | NSTrackingInVisibleRect | NSTrackingMouseEnteredAndExited | NSTrackingMouseMoved);
	trackingArea = [[NSTrackingArea alloc] initWithRect:[self bounds] options:options owner:self userInfo:nil];
	[self addTrackingArea : trackingArea];
}

//-------------------------------------------------------------------------
//  translate keyDown to true unichar via inputlayout
//-------------------------------------------------------------------------
NSString *translateInputForKeyDown(NSEvent *event, UInt32 *deadKeyState)
{
    // http://stackoverflow.com/questions/12547007/convert-key-code-into-key-equivalent-string
    // http://stackoverflow.com/questions/8263618/convert-virtual-key-code-to-unicode-string

    const size_t unicodeStringLength = 4;
    UniChar unicodeString[unicodeStringLength]= { 0, };
    UniCharCount reallength= 0;
    NSString *nsstring= nil;

    TISInputSourceRef fkis= TISCopyCurrentKeyboardInputSource();
    if (fkis) {
        CFDataRef cflayoutdata= (CFDataRef)TISGetInputSourceProperty(fkis, kTISPropertyUnicodeKeyLayoutData);
        const UCKeyboardLayout *keyboardlayout= (const UCKeyboardLayout *)CFDataGetBytePtr(cflayoutdata);
        CGEventFlags flags = (CGEventFlags)[event modifierFlags];
        UInt32 keymodifiers = (flags >> 16) & 0xFF;

        UCKeyTranslate(keyboardlayout,
                            [event keyCode], kUCKeyActionDown, keymodifiers,
                            LMGetKbdType(), 0,
                            deadKeyState,
                            unicodeStringLength, &reallength, unicodeString);
        CFRelease(fkis);
    }


    if (reallength>0) {
        nsstring= (NSString *)CFBridgingRelease(CFStringCreateWithCharacters(kCFAllocatorDefault, unicodeString, reallength));
    }

    return nsstring;
}

UInt32 deadKey;
char   keyUTF8[16];

//************************************
-(void)keyDown:(NSEvent *)event {
	
//    NSString *chars = [event characters];
    NSString *chars = translateInputForKeyDown(event, &deadKey);
    unichar keyChar;
    
    if( chars!=nil ) {
        strcpy(keyUTF8, [chars UTF8String]);

        
    //    Dwrite("keyDown");
        if( [chars length]==0 ) return;
        keyChar = [chars characterAtIndex:0];

        BYTE vkCode = sMacKeyCodeToVK[event.keyCode & 0x7f];
    #if false
        if( vkCode==0x20 || (vkCode >= 0x30 && vkCode <= 0x39) || (vkCode >= 0x41 && vkCode <= 0x5A) || (vkCode >= 0xBA && vkCode<=0xE0) ) {
            AddMsg(KHDR_ALPHAKEY_DOWN, vkCode, 1 /* repeatRate */, 0);
            if( !(KeyFlags & MK_CTL) ) {
                AddMsg(KHDR_CHAR, keyChar, 1 /* repeatRate */, 0);
            }
        } else {
    #endif
            AddMsg(KMSG_KEY_DOWN, vkCode, 1 /* repeatRate */, 0);
            AddMsg(KMSG_CHAR, *(DWORD*)keyUTF8, *(DWORD*)(keyUTF8+4) /* repeatRate */, 0);
    //	}
    }
//	NSLog(@"CHAR: %c keyDown:%@", keyChar, event);
}

//************************************
-(void)keyUp:(NSEvent *)event {

	NSString *chars = [event characters];
	unichar keyChar;
	
	if( [chars length]==0 ) return;
	keyChar = [chars characterAtIndex:0];
	
	BYTE vkCode = sMacKeyCodeToVK[event.keyCode & 0x7f];
	
/*	if( vkCode==0x20 || (vkCode >= 0x30 && vkCode <= 0x39) || (vkCode >= 0x41 && vkCode <= 0x5A) || (vkCode >= 0xBA && vkCode<=0xE0) ) {
		AddMsg(KHDR_ALPHAKEY_UP, vkCode, 1, 0);
	} else {
*/
        AddMsg(KMSG_KEY_UP, vkCode, 1 /* repeatRate */, 0);
//	}
//	NSLog(@"keyUp:%@", event);
	
}

//************************************
-(void)flagsChanged:(NSEvent *)event {
	
	DWORD	newFlags;
//	NSLog(@"flagsChanged:%@", event);
	newFlags = KeyFlags & ~(MK_SHIFT | MK_CTL | MK_ALT);

	if( event.modifierFlags & 0x00020000 ) newFlags |= MK_SHIFT;
	if( event.modifierFlags & 0x00100000 ) newFlags |= MK_CTL;	// actually testing for CMD key rather than CTL (0x00040000)
	if( event.modifierFlags & 0x00080000 ) newFlags |= MK_ALT;

	if( (newFlags ^ KeyFlags) & MK_SHIFT ) AddMsg((newFlags & MK_SHIFT) ? KMSG_KEY_DOWN : KMSG_KEY_UP, VK_SHIFT, 0, 0);
	if( (newFlags ^ KeyFlags) & MK_CTL ) AddMsg((newFlags & MK_CTL) ? KMSG_KEY_DOWN : KMSG_KEY_UP, VK_CONTROL, 0, 0);
	if( (newFlags ^ KeyFlags) & MK_ALT ) AddMsg((newFlags & MK_ALT) ? KMSG_KEY_DOWN : KMSG_KEY_UP, VK_MENU, 0, 0);

	KeyFlags = newFlags;
}

//************************************
-(void)mouseDown:(NSEvent *)event {
	
	if( [event clickCount] > 0 ) {
		NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
		DWORD x, y, fy;
		
//		x = (DWORD)(kScale*loc.x);
//		y = (DWORD)(kScale*loc.y);
		x = (DWORD)(loc.x);
		y = (DWORD)(loc.y);
//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
		DWORD fh = (DWORD)([self frame].size.height);

		fy = fh-y;
		
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"================DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD\nmouseDown (%d,%d) fy=%d\n", x,y,fy);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
		switch( [event type] ) {
			case NSEventTypeLeftMouseDown:
				KeyFlags |= MK_LBUTT;
				break;
			default:
				break;
		}
		LastX = x;
		LastY = fy;

//		NSLog(@"mouseDOWN evLOC=(%f,%f) LOC=(%f,%f) xy=(%d,%d) WNDH=%d fy=%d event=%@",[event locationInWindow].x, [event locationInWindow].y, loc.x, loc.y, x, y, fh, fy, event);
		
		AddMsg(KMSG_KEY_DOWN, K_LBUTT, KeyFlags, x | (fy<<16));
		
	}
}

//********************************************
-(void)mouseUp:(NSEvent *)event {
	
	
//	if( [event clickCount] > 0 ) {
		NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
		DWORD x, y, fy;
	
	//		x = (DWORD)(kScale*loc.x);
	//		y = (DWORD)(kScale*loc.y);
	x = (DWORD)(loc.x);
	y = (DWORD)(loc.y);
	//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
	DWORD fh = (DWORD)([self frame].size.height);

		fy = fh-y;
		
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"================UUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUUU\nmouseUp (%d,%d) fy=%d\n", x,y,fy);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
		switch( [event type] ) {
			case NSEventTypeLeftMouseUp:
				KeyFlags &= ~MK_LBUTT;
				break;
			case NSEventTypeRightMouseUp:
				KeyFlags &= ~MK_RBUTT;
				break;
			default:
				break;
		}
	LastX = x;
	LastY = fy;
//		NSLog(@"mouseUP evLOC=(%f,%f) LOC=(%f,%f) xy=(%d,%d) WNDH=%d fy=%d event=%@",[event locationInWindow].x, [event locationInWindow].y, loc.x, loc.y, x, y, fh, fy, event);

		AddMsg(KMSG_KEY_UP, K_LBUTT, KeyFlags, x | (fy<<16));
	AddMsg(KMSG_POINTER_MOVE, x, fy, KeyFlags);
//	}
}

//************************************
-(void)rightMouseDown:(NSEvent *)event {
	
	if( [event clickCount] > 0 ) {
		NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
		DWORD x, y, fy;
		
		//		x = (DWORD)(kScale*loc.x);
		//		y = (DWORD)(kScale*loc.y);
		x = (DWORD)(loc.x);
		y = (DWORD)(loc.y);
		//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
		DWORD fh = (DWORD)([self frame].size.height);

		fy = fh-y;
		
		switch( [event type] ) {
			case NSEventTypeRightMouseDown:
				KeyFlags |= MK_RBUTT;
				break;
			default:
				break;
		}
		LastX = x;
		LastY = fy;

//		NSLog(@"mouseDOWN evLOC=(%f,%f) LOC=(%f,%f) xy=(%d,%d) WNDH=%d fy=%d event=%@",[event locationInWindow].x, [event locationInWindow].y, loc.x, loc.y, x, y, fh, fy, event);
		
		AddMsg(KMSG_KEY_DOWN, MK_RBUTT, KeyFlags, x | (fy<<16));
		
	}
}

//DWORD rMSG=0, rMSGarg1, rMSGarg2, rMSGarg3;

//************************************
-(void)rightMouseUp:(NSEvent *)event {
	
	
	//	if( [event clickCount] > 0 ) {
	NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
	DWORD x, y, fy;
	
	//		x = (DWORD)(kScale*loc.x);
	//		y = (DWORD)(kScale*loc.y);
	x = (DWORD)(loc.x);
	y = (DWORD)(loc.y);
	//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
	DWORD fh = (DWORD)([self frame].size.height);

	fy = fh-y;
	
	switch( [event type] ) {
		case NSEventTypeLeftMouseUp:
			KeyFlags &= ~MK_LBUTT;
			break;
		case NSEventTypeRightMouseUp:
			KeyFlags &= ~MK_RBUTT;
			break;
		default:
			break;
	}
	
//	NSLog(@"mouseUP evLOC=(%f,%f) LOC=(%f,%f) xy=(%d,%d) WNDH=%d fy=%d event=%@",[event locationInWindow].x, [event locationInWindow].y, loc.x, loc.y, x, y, fh, fy, event);
	
	LastX = x;
	LastY = fy;
//	rMSG = KHDR_KEY_UP;
//	rMSGarg1 = K_RBUTT;
//	rMSGarg2 = KeyFlags;
//	rMSGarg3 = x | (fy<<16);
	AddMsg(KMSG_KEY_UP, K_RBUTT, KeyFlags, x | (fy<<16));
	AddMsg(KMSG_POINTER_MOVE, (DWORD)[event locationInWindow].x, (DWORD)([pKV frame].size.height-[event locationInWindow].y), KeyFlags);
	//	}
}

//************************************
-(void)otherMouseDown:(NSEvent *)event {
	
	if( [event clickCount] > 0 ) {
		NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
		DWORD x, y, fy, flg, key;
		
		//		x = (DWORD)(kScale*loc.x);
		//		y = (DWORD)(kScale*loc.y);
		x = (DWORD)(loc.x);
		y = (DWORD)(loc.y);
		//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
		DWORD fh = (DWORD)([self frame].size.height);

		fy = fh-y;
		
		if( [event buttonNumber]==2 ) {
			flg = MK_MBUTT;
			key = K_MBUTT;
		} else if( [event buttonNumber]==3 ) {
			flg = MK_BBUTT;
			key = K_BACKBUTT;
		} else {
			flg = MK_FBUTT;
			key = K_FWDBUTT;
		}
		KeyFlags |= flg;
		LastX = x;
		LastY = fy;

//		NSLog(@"mouseDOWN evLOC=(%f,%f) loc=(%f,%f) xy=(%d,%d) WNDH=%d fy=%d event=%@",[event locationInWindow].x, [event locationInWindow].y, loc.x, loc.y, x, y, fh, fy, event);
		
		AddMsg(KMSG_KEY_DOWN, key, KeyFlags, x | (fy<<16));
		
	}
}

//************************************
-(void)otherMouseUp:(NSEvent *)event {
	

	//	if( [event clickCount] > 0 ) {
	NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
	DWORD x, y, fy, flg, key;
	
	//		x = (DWORD)(kScale*loc.x);
	//		y = (DWORD)(kScale*loc.y);
	x = (DWORD)(loc.x);
	y = (DWORD)(loc.y);
	//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
	DWORD fh = (DWORD)([self frame].size.height);

	fy = fh-y;
	
	if( [event buttonNumber]==2 ) {
		flg = MK_MBUTT;
		key = K_MBUTT;
	} else if( [event buttonNumber]==3 ) {
		flg = MK_BBUTT;
		key = K_BACKBUTT;
	} else {
		flg = MK_FBUTT;
		key = K_FWDBUTT;
	}
	KeyFlags &= ~flg;
	LastX = x;
	LastY = fy;

//	NSLog(@"mouseUP evLOC=(%f,%f) LOC=(%f,%f) xy=(%d,%d) WNDH=%d fy=%d event=%@",[event locationInWindow].x, [event locationInWindow].y, loc.x, loc.y, x, y, fh, fy, event);
	
	AddMsg(KMSG_KEY_UP, key, KeyFlags, x | (fy<<16));
	AddMsg(KMSG_POINTER_MOVE, (DWORD)[event locationInWindow].x, (DWORD)([pKV frame].size.height-[event locationInWindow].y), KeyFlags);
	//	}
}

//************************************
-(void)mouseMoved:(NSEvent *)event {

	NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
	DWORD	x, y, fy;
	
//	Dwrite("mouseMoved ENTER");
	x = (DWORD)(loc.x);
	y = (DWORD)(loc.y);
	//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
	DWORD fh = (DWORD)([self frame].size.height);
	
	fy = fh-y;
	LastX = x;
	LastY = fy;
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"mouseMoved (%d,%d) fy=%d\n", x,y,fy);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
	if( !inKE && runKEmsg==0 && KINTmsgadd==KINTmsgrem ) {
//		if( KeyFlags & (MK_LBUTT | MK_MBUTT | MK_RBUTT | MK_BBUTT | MK_FBUTT) ) DumpStr("mM ADD");
		AddMsg(KMSG_POINTER_MOVE, x, fy, KeyFlags);
	} else {
//		if( true ) {
			KINTptrmovePENDING = false;
			KINTptrmove[0] = KMSG_POINTER_MOVE;
			KINTptrmove[1] = x;
			KINTptrmove[2] = fy;
			KINTptrmove[3] = KeyFlags;
			KINTptrmovePENDING = true;
/*		} else {
			// search msg queue and if find another KHDR_POINTER_MOVE waiting, just modify it's values
			DWORD	p;
			
			p = KINTmsgrem;
			while( p != KINTmsgadd ) {
				if( KINTmsgs[p*4]==KHDR_POINTER_MOVE ) {	// if found, modify it
					KINTmsgs[p*4+1] = x;
					KINTmsgs[p*4+2] = fy;
					KINTmsgs[p*4+3] = KeyFlags;
	//				if( KeyFlags & (MK_LBUTT | MK_MBUTT | MK_RBUTT | MK_BBUTT | MK_FBUTT) ) DumpStr("mM MOD");
					return;
				} else ++p;	// keep searching
				if( p==MAXMSGS ) p = 0;
			}
//		if( KeyFlags & (MK_LBUTT | MK_MBUTT | MK_RBUTT | MK_BBUTT | MK_FBUTT) ) DumpStr("mM SKIP");
//		AddMsg(KHDR_POINTER_MOVE, x, fy, KeyFlags);
		}
*/
	}
//	NSLog(@"MOVED (%d,%d)", (int)[event locationInWindow].x, (int)([pKV frame].size.height-[event locationInWindow].y));
//	Dwrite("mouseMoved EXIT");
}

//************************************
-(void)mouseDragged:(NSEvent *)event {

	// Added " || runKEmsg==KHDR_TIMER" because OQ's timer interrupts were happening
	// too frequently to let many KHDR_POINTER_MOVE messages through
	if( runKEmsg==0 || runKEmsg==KMSG_TIMER ) {
		NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
		DWORD	x, y, fy;
		
		x = (DWORD)(loc.x);
		y = (DWORD)(loc.y);
		//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
		DWORD fh = (DWORD)([self frame].size.height);
		
		fy = fh-y;
		LastX = x;
		LastY = fy;
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"mouseDragged (%d,%d) fy=%d\n", x,y,fy);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
		if( !inKE && runKEmsg==0 && KINTmsgadd==KINTmsgrem ) {
			AddMsg(KMSG_POINTER_MOVE, x, fy, KeyFlags);
//			if( KeyFlags & (MK_LBUTT | MK_MBUTT | MK_RBUTT | MK_BBUTT | MK_FBUTT) ) DumpStr("mD ADD");
		} else {
			KINTptrmovePENDING = false;
			KINTptrmove[0] = KMSG_POINTER_MOVE;
			KINTptrmove[1] = x;
			KINTptrmove[2] = fy;
			KINTptrmove[3] = KeyFlags;
			KINTptrmovePENDING = true;
		}
	//	NSLog(@"DRAGGED (%d,%d)", (int)[event locationInWindow].x, (int)[event locationInWindow].y);

/*	} else {
		char buf[128];
		sprintf(buf, "mD runKEmsg=%d inKE=%d", runKEmsg, inKE);
		if( KeyFlags & (MK_LBUTT | MK_MBUTT | MK_RBUTT | MK_BBUTT | MK_FBUTT) ) DumpStr(buf);
*/
		
	}
}

//************************************
-(void)rightMouseDragged:(NSEvent *)event {
	
	NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
	DWORD	x, y, fy;
	
	x = (DWORD)(loc.x);
	y = (DWORD)(loc.y);
	//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
	DWORD fh = (DWORD)([self frame].size.height);
	
	fy = fh-y;
	LastX = x;
	LastY = fy;
	if( runKEmsg==0 || runKEmsg==KMSG_TIMER ) {
		if( !inKE && runKEmsg==0 && KINTmsgadd==KINTmsgrem ) {
			AddMsg(KMSG_POINTER_MOVE, x, fy, KeyFlags);
//			if( KeyFlags & (MK_LBUTT | MK_MBUTT | MK_RBUTT | MK_BBUTT | MK_FBUTT) ) DumpStr("rmD ADD");
		} else {
			KINTptrmovePENDING = false;
			KINTptrmove[0] = KMSG_POINTER_MOVE;
			KINTptrmove[1] = x;
			KINTptrmove[2] = fy;
			KINTptrmove[3] = KeyFlags;
			KINTptrmovePENDING = true;
		}
		//AddMsg(KHDR_POINTER_MOVE, x, fy, KeyFlags);
	//	NSLog(@"DRAGGED (%d,%d)", (int)[event locationInWindow].x, (int)[event locationInWindow].y);
	} else {
		KINTptrmovePENDING = false;
		KINTptrmove[0] = KMSG_POINTER_MOVE;
		KINTptrmove[1] = x;
		KINTptrmove[2] = fy;
		KINTptrmove[3] = KeyFlags;
		KINTptrmovePENDING = true;
/*		char buf[128];
		// search msg queue and if find another KHDR_POINTER_MOVE waiting, just modify it's values
		DWORD	p;
		
		sprintf(buf, "rmD ADD runKEmsg=%d inKE=%d", runKEmsg, inKE);
		p = KINTmsgrem;
		while( p != KINTmsgadd ) {
			if( KINTmsgs[p*4]==KHDR_POINTER_MOVE ) {	// if found, modify it
				KINTmsgs[p*4+1] = x;
				KINTmsgs[p*4+2] = fy;
				KINTmsgs[p*4+3] = KeyFlags;
//				if( KeyFlags & (MK_LBUTT | MK_MBUTT | MK_RBUTT | MK_BBUTT | MK_FBUTT) ) DumpStr("rmD ELSE MOD");
				return;
			} else ++p;	// keep searching
			if( p==MAXMSGS ) p = 0;
		}
		sprintf(buf, "rmD SKIP runKEmsg=%d inKE=%d", runKEmsg, inKE);
//		if( KeyFlags & (MK_LBUTT | MK_MBUTT | MK_RBUTT | MK_BBUTT | MK_FBUTT) ) DumpStr(buf);
*/
	}
}

//************************************
-(void)otherMouseDragged:(NSEvent *)event {

	if( runKEmsg==0 || runKEmsg==KMSG_TIMER ) {
		NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
		DWORD	x, y, fy;
		
		x = (DWORD)(loc.x);
		y = (DWORD)(loc.y);
		//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
		DWORD fh = (DWORD)([self frame].size.height);
		
		fy = fh-y;
		LastX = x;
		LastY = fy;
		if( !inKE && runKEmsg==0 && KINTmsgadd==KINTmsgrem ) {
//			if( KeyFlags & (MK_LBUTT | MK_MBUTT | MK_RBUTT | MK_BBUTT | MK_FBUTT) ) DumpStr("omD ADD");
			AddMsg(KMSG_POINTER_MOVE, x, fy, KeyFlags);
		} else {
			KINTptrmovePENDING = false;
			KINTptrmove[0] = KMSG_POINTER_MOVE;
			KINTptrmove[1] = x;
			KINTptrmove[2] = fy;
			KINTptrmove[3] = KeyFlags;
			KINTptrmovePENDING = true;
		}
//		AddMsg(KHDR_POINTER_MOVE, x, fy, KeyFlags);
	//	NSLog(@"DRAGGED (%d,%d)", (int)[event locationInWindow].x, (int)[event locationInWindow].y);
	} else {
		char buf[128];
		sprintf(buf, "omD runKEmsg=%u inKE=%u", (unsigned int)runKEmsg, (unsigned int)inKE);
//		if( KeyFlags & (MK_LBUTT | MK_MBUTT | MK_RBUTT | MK_BBUTT | MK_FBUTT) ) DumpStr(buf);
	}
}

//*************************************************
#define	TICKLIMIT	7
-(void)scrollWheel:(NSEvent *)event {
	
	KLONG	ticks, x, y, val, fy;
	NSPoint loc = [self convertPoint:[event locationInWindow] fromView:nil];
	
	x = (KLONG)(loc.x);
	y = (KLONG)(loc.y);
	//		DWORD fh = (DWORD)(kScale*[self frame].size.height);
	KLONG fh = (KLONG)([self frame].size.height);
	
	fy = fh-y;
	LastX = x;
	LastY = fy;

	ticks = (KLONG)(10.0*[event deltaY]);
	if( ticks ) {
		val = ticks/abs(ticks);
		ticks = abs(ticks);
		if( ticks > TICKLIMIT ) ticks = TICKLIMIT;
//		NSLog(@"deltaY=%f ticks=%d",[event deltaY],ticks);
		while( ticks-- ) {
			if( runKEmsg==0 ) AddMsg(KMSG_KEY_DOWN, 0x00008003, val, (DWORD)((fy<<16) | x));
		}
	}
	ticks = (KLONG)(10.0*[event deltaX]);
	if( ticks ) {
		val = ticks/abs(ticks);
		ticks = abs(ticks);
		if( ticks > TICKLIMIT ) ticks = TICKLIMIT;
		while( ticks-- ) {
			if( runKEmsg==0 ) AddMsg(KMSG_KEY_DOWN, 0x00008004, val, (DWORD)((fy<<16) | x));
		}
	}
//	NSLog(@"WHEEL (%d,%d) ticks=%d %@", x, y, ticks, event);
}
extern bool ProgramReady;
DWORD otFLAG;
//*******************************
-(void)OnTimer:(NSTimer *)timer {
	
	// To avoid tiny little 5-pixel wide vertical white "window" line in bottom-left corner of display...
	if( windowReady /*gMacWindow*/ && ProgramReady && KINTmsgrem==KINTmsgadd ) {
        
        if( NSThread.currentThread.isMainThread ) {
//            Dwrite("OnTimer m");
            otFLAG = false;
            NSRect windowBounds = [[kApp window] frame];
            
            if( windowBounds.size.width < 10 ) {
                SWPx = 100;
                SWPy = 500;
                SWPw = SWPh = 480;
                KINT_SetWindowPos();
            }
        } else {
//            Dwrite("OnTimer n");
            otFLAG = true;
            [[NSOperationQueue mainQueue] addOperationWithBlock:^{
                NSRect windowBounds = [[kApp window] frame];
                
                if( windowBounds.size.width < 10 ) {
                    SWPx = 100;
                    SWPy = 500;
                    SWPw = SWPh = 480;
                    KINT_SetWindowPos();
                }
                otFLAG = false;
            }];
        }
        while( otFLAG )
            ;
	}
	// now handle timer
    if( !inKE ) {
        AddMsg(KMSG_TIMER, 0, 0, 0);
    } else {
		DWORD	p;
		
		p = KINTmsgrem;
		while( p != KINTmsgadd ) {
			if( KINTmsgs[p*4]==KMSG_TIMER ) {	// if found, don't add another
				return;
			} else ++p;	// keep searching
			if( p==MAXMSGS ) p = 0;
		}
	}
}

//volatile DWORD invFLAG;
//**********************************************************
void InvDirty(void) {
    
//    if( invFLAG ) NSLog(@"invFLAG");
    if( NSThread.currentThread.isMainThread ) {
//        invFLAG = false;
        if( dirtyX1<dirtyX2 ) {
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"InvDirty MAIN (%d,%d)(%d,%d)\n", dirtyX1,dirtyY1,dirtyX2,dirtyY2);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
//            NSLog(@"DIRTY=(%d,%d) (%d,%d) frameH=%f",dirtyX1,dirtyY1,dirtyX2, dirtyY2,[pKV frame].size.height);
            CGRect dirtyRect=CGRectMake(dirtyX1, [pKV frame].size.height-dirtyY2, dirtyX2-dirtyX1, dirtyY2-dirtyY1);
            dirtyX1 = dirtyY1 = 30000;
            dirtyX2 = dirtyY2 = -1;
            [pKV setNeedsDisplayInRect:dirtyRect];
        }
    } else {
//        invFLAG = true;
        [[NSOperationQueue mainQueue] addOperationWithBlock:^{
            if( dirtyX1<dirtyX2 ) {
#if EKDBG
{
DWORD    hFile;
sprintf(EKDbuf,"InvDirty BACK (%d,%d)(%d,%d)\n", dirtyX1,dirtyY1,dirtyX2,dirtyY2);
if( -1==(hFile = Kopen("debug.log", 0x8002)) ) hFile = Kopen("debug.log", 0x8302);
Kseek(hFile, 0, SEEK_END);
Kwrite(hFile, (BYTE*)EKDbuf, (DWORD)strlen(EKDbuf));
Kclose(hFile);
}
#endif
    //			NSLog(@"DIRTY=(%d,%d) (%d,%d) frameH=%f",dirtyX1,dirtyY1,dirtyX2, dirtyY2,[pKV frame].size.height);
                CGRect dirtyRect=CGRectMake(dirtyX1, [pKV frame].size.height-dirtyY2, dirtyX2-dirtyX1, dirtyY2-dirtyY1);
                dirtyX1 = dirtyY1 = 30000;
                dirtyX2 = dirtyY2 = -1;
                [pKV setNeedsDisplayInRect:dirtyRect];
    // NOTE: The following line had to be commented out
    // to make things work right on Big Sur. The display
    // wasn't being updated right unless the window was
    // maximized, and with it not maximized, there was
    // an extra 'pass' through drawRect, sort of, somehow.
    // Does commenting this out screw up things on OS < Big Sur?
    //			[pKV display];
            }
//            invFLAG = false;
        }];
    }
//    while( invFLAG )
//        ;
}
    
//****************************************************
DWORD runKEmsg=0, runKEarg1, runKEarg2, runKEarg3;

-(void)runKE {
	
	if( inKE ) NSLog(@"inKE runKE");
//NSLog(@"runKE->KEmsg %d",runKEmsg);
	if( KEloaded ) KEmsg(runKEmsg, runKEarg1, runKEarg2, runKEarg3);
//NSLog(@"runKE done");
}

//******************************************************************
// Called when you want the msg processed NOW
// MUST NOT BE CALLED if any other messages could be pending. ie. SPECIAL CASES ONLY!
DWORD ForceMsg(DWORD cmd, DWORD arg1, DWORD arg2, DWORD arg3) {

	if( inKE ) {	// SHOULD never happen unless you call ForceMsg when you should NOT be!
		NSLog(@"ForceMsg BAD CALL! cmd=%d", (int)cmd);
		SystemMessage("ForceMsg BAD CALL!");
	}
//NSLog(@"ForceMsg->KEmsg %d",cmd);
	return (KEloaded ? KEmsg(cmd, arg1, arg2, arg3) : 0);
//	return KEmsg(&mainKE, cmd, arg1, arg2, arg3);
}

//******************************************************************
// Called from AddMsg (sometimes) and SendNextMsg (always)
void KINTnonTimer(DWORD cmd, DWORD arg1, DWORD arg2, DWORD arg3) {

//    if( NSThread.currentThread.isMainThread ) Dwrite("KINTnonTimer m");
//    else Dwrite("KINTnonTimer n");
    if( inKE ) NSLog(@"inKE KINTnonTimer");
	if( inSleep || !windowReady /*gMacWindow*/ || TimerID==NULL ) {
//NSLog(@"KINTnonTimer KEmsg");
//        Dwrite("KINTnonTimer KEmsg");
		if( KEloaded ) KEmsg(cmd, arg1, arg2, arg3);
//		KEmsg(&mainKE, cmd, arg1, arg2, arg3);
	} else {
//NSLog(@"KINTnonTimer->runKE %d", cmd);
	//	while( runKEmsg ) ;
//        Dwrite("KINTnonTimer thread");
		runKEmsg = cmd;
		runKEarg1= arg1;
		runKEarg2= arg2;
		runKEarg3= arg3;
		
		NSThread *thread = [[NSThread alloc] initWithTarget:pKV selector:@selector(runKE) object:nil];
		[thread start];
	}
//    Dwrite("KINTnonTimerExit");
}
int	IdleCnt;
//*******************************
-(void)KINTtimer:(NSTimer *)timer {

    
/*    {
        char dBuf[128];
        sprintf(dBuf,"KINTtimer: %d %d %d",inKE,inSize,runKEmsg);
        Dwrite(dBuf);
    }
*/
    if( !inKE && !inSize && runKEmsg==0 ) {
//NSLog(@"TIMER SendNextMsg");
		if( firstSize ) {
//            Dwrite("KINTtimer first");
			firstSize = false;
			AddMsg(KMSG_WINDOW_SIZED, wndW, wndH, K_SIZED);
		}
		if( KINTmsgrem==KINTmsgadd ) {
			++IdleCnt;
			if( ((!isHidden && !(IdleCnt & 0x0F)) || (isHidden && !(IdleCnt & 0x0F))) ) AddMsg(KMSG_TIMER, 0, 0, 0);
//			if( !(IdleCnt & 0x7F) ) AddMsg(KHDR_IDLE, 0, 0, 0);
		}
//        Dwrite("KINTtimer nxt");
		SendNextMsg();
	}
//    Dwrite("KINTtimerExit");
	KMusicIsBusy();
}

@end

