#include "c.h"
#include "asm.h"
#include "ctype.h"

//static char rcsid[] = "$Id: expr.c,v 1.1 2002/08/28 23:12:43 drh Exp $";

extern Node node(long, Node, Node, Symbol);
extern int isalnum( int c );
extern int isdigit( int c );

char ASMbuf[512], *pASM;

static char prec[] = {
#define xx(a,b,c,d,e,f,g) c,
#define yy(a,b,c,d,e,f,g) c,
#include "token.h"
};
static long oper[] = {
#define xx(a,b,c,d,e,f,g) d,
#define yy(a,b,c,d,e,f,g) d,
#include "token.h"
};
float refinc = 1.0;
static Tree expr2(void);
static Tree expr3(long);
static Tree nullcheck(Tree);
static Tree postfix(Tree);
static Tree unary(void);
static Tree primary(void);
static Type super(Type ty);

static Type super(Type ty) {
	switch (ty->op) {
	case INT:
		if (ty->size < inttype->size)
			return inttype;
		break;
	case UNSIGNED:
		if (ty->size < unsignedtype->size)
			return unsignedtype;
		break;
	case POINTER:
		return unsignedptr;
	}
	return ty;
}
Tree expr(long tok) {
	static char stop[] = { IF, ID, '}', 0 };
	Tree p = expr1(0);

	while (t == ',') {
		Tree q;
		t = gettok();
		q = pointer(expr1(0));
		p = tree(RIGHT, q->type, root(value(p)), q);
	}
	if (tok)
		test(tok, stop);
	return p;
}
Tree expr0(long tok) {
	return root(expr(tok));
}
Tree expr1(long tok) {
	static char stop[] = { IF, ID, 0 };
	Tree p = expr2();

	if (t == '='
	|| (prec[t] >=  6 && prec[t] <=  8)
	|| (prec[t] >= 11 && prec[t] <= 13)) {
		long op = t;
		t = gettok();
		if (oper[op] == ASGN)
			p = asgntree(ASGN, p, value(expr1(0)));
		else
			{
				expect('=');
				p = incr(op, p, expr1(0));
			}
	}
	if (tok)
		test(tok, stop);
	return p;
}
Tree incr(long op, Tree v, Tree e) {
	return asgntree(ASGN, v, (*optree[op])(oper[op], v, e));
}
static Tree expr2(void) {
	Tree p = expr3(4);

	if (t == '?') {
		Tree l, r;
		Coordinate pts[2];
		if (Aflag > 1 && isfunc(p->type))
			warning("%s used in a conditional expression\n",
				funcname(p));
		p = pointer(p);
		t = gettok();
		pts[0] = src;
		l = pointer(expr(':'));
		pts[1] = src;
		r = pointer(expr2());
		if (generic(p->op) != CNST && events.points)
			{
				apply(events.points, &pts[0], &l);
				apply(events.points, &pts[1], &r);
			}
		p = condtree(p, l, r);
	}
	return p;
}
Tree value(Tree p) {
	long op = generic(rightkid(p)->op);

	if (p->type != voidtype
	&& (op==AND || op==OR || op==NOT || op==EQ || op==NE
	||  op== LE || op==LT || op== GE || op==GT))
		p = condtree(p, consttree(1, inttype),
			consttree(0, inttype));
	return p;
}
static Tree expr3(long k) {
	long k1;
	Tree p = unary();

	for (k1 = prec[t]; k1 >= k; k1--)
		while (prec[t] == k1 && *cp != '=') {
			Tree r;
			Coordinate pt;
			long op = t;
			t = gettok();
			pt = src;
			p = pointer(p);
			if (op == ANDAND || op == OROR) {
				r = pointer(expr3(k1));
				if (events.points)
					apply(events.points, &pt, &r);
			} else
				r = pointer(expr3(k1 + 1));
			p = (*optree[op])(oper[op], p, r);
		}
	return p;
}

//*****************************************************
Symbol ASMtext(char *start, long len) {

	Symbol	symp;
	char	*s;

	NEW0(symp, FUNC);
	symp->name = symp->x.name = (char *)allocate(len+1, FUNC);	// allocate space for string
	symp->scope = CONSTANTS;
	symp->type = chartype;
	symp->u.c.v.p = (void *)symp->name;

	for(s=(char *)symp->name; len; len--) *s++ = *start++;
	*s = '\0';
	return symp;
}

///*******************************************************
void asmformatd(char *bp, long long n) {

	unsigned long long m;
	char buf[25], *s = buf + sizeof buf;

	*--s = '\0';
	if( n < 0 ) m = -n;
	else m = n;
	do {
		*--s = (char)(m%10 + '0');
	} while( (m /= 10) != 0 );
	if( n < 0 ) *--s = '-';
	while( *s ) *bp++ = *s++;
	*bp = *s;
}

extern char hexdigs[];

///*******************************************************
void asmformatu(char *bp, unsigned long long n) {

	char buf[25], *s = buf + sizeof buf;
	long base=10;

	*--s = '\0';
	do {
		*--s = hexdigs[n%base];
	} while( (n /= base) != 0 );
	while( *s ) *bp++ = *s++;
	*bp = *s;
}

///*****************************************************
/// replace CNST and GLOBAL references with actual text,
/// leave LOCAL references with a ASMSEP marker.
void pruneASM(Tree p, long kid) {

	Tree	k;

	k = p->kids[kid];
	while( generic(k->op)==INDIR ) k = k->kids[0];
	switch( generic(k->op) ) {
	 case CNST:
		--pASM;	/// trash ASMSEP (not needed for CNST, we can just format out the number)

///GEEK: Can't use %lld or %llu in the following sprintf's, and I think it NEEDS to
/// Hopefully the asmformatd() an dasmformatu() functions should work.

		if( specific(k->op)==(CNST+I) ) asmformatd(pASM, k->u.v.ill);
		else asmformatu(pASM, k->u.v.ull);
		break;
	 case ADDRG:
		--pASM;	/// trash ASMSEP (not needed for GLOBAL, we can just format out the global's name)
		sprintf(pASM, "_%s", k->u.sym->name);
		break;
	 default:	/// local vars need the ASMSEP to mark where the stack-offset to the local needs to go)
		return;	/// return, because we didn't add/replace anything
	}
	pASM += strlen(pASM);	/// move pASM past the newly added text.
	p->kids[kid] = NULL;	/// prune off the branch, as it's been turned into text
	p->op = p->kids[0] ? asmop(ASM1) : asmop(ASM0);	/// top op is either 1-child (if 'kid' was 1, right-child) or 0-child (if 'kid' was 0, left-child)
}

//******************************************************
Tree ASMunary() {

	Tree			p=NULL;
	char			c, n;
	long			len;

/// chew up ASM line, breaking it into text and ARG trees

	/// init output ptr for line of ASM text
	pASM = ASMbuf;
/*
	/// handle lines starting with '@'
	while( getchr()=='@' ) {
		/// if "@:" label
		if( *(cp+1)==':' ) {	// handle '@:' labels
			*pASM++ = *cp++;
			*pASM++ = *cp++;
		/// else if "@OK"
		} else if( (toupper(*(cp+1))=='O' && toupper(*(cp+2))=='K') && (*(cp+3)==' ' || *(cp+3)=='\t') ) {	// handle '@ok'
			*pASM++ = *cp++;	// copy @ok
			*pASM++ = *cp++;
			*pASM++ = *cp++;
			*pASM++ = *cp++;	// and one whitespace
		} else break;
	}
*/
	/// handle lines starting with ':'
	while( getchr()==':' ) {
		/// if ":@" label
		if( *(cp+1)=='@' ) {	// handle ':@' labels
			*pASM++ = *cp++;
			*pASM++ = *cp++;
/*		/// else if "@OK"
		} else if( (toupper(*(cp+1))=='O' && toupper(*(cp+2))=='K') && (*(cp+3)==' ' || *(cp+3)=='\t') ) {	// handle '@ok'
			*pASM++ = *cp++;	// copy @ok
			*pASM++ = *cp++;
			*pASM++ = *cp++;
			*pASM++ = *cp++;	// and one whitespace
*/
		} else break;
	}
	/// chew up 'normal' asm line
	do {	/// entire ASM instruction must be on same line and | for end of ASM instruction
		if( *cp==' ' || *cp=='\t' ) c = *cp;	/// get whitespace ourselves, else we lose it in getchr()
		else if( EOI==(c = getchr()) ) {
errret:
			ASMbuf[0] = 0;
			return NULL;
		}
alreadyhavechar:
/// break out if '\n' (end of line), as one entire asm statement cannot be split over multiple lines
///	break out if '@' and NOT '@f...' or '@b...'
///	break out if ')' (end of _asm() statement)
		n = toupper(*(cp+1));	/// c=cur char, n=NEXT char (uppercased)
		if( c=='\n' || (c==ASMSEP && n!='F' && n!='B') || c==')' ) break;

		/// if global or local variable reference
		if( c=='[' ) {	/// indirect arg
			++cp;	/// skip '['
			*pASM++ = c;	/// copy out '['
			/// if [reg]
			if( (len=((*IR->x.ASMisreg)())) ) {	/// [reg], just copy
				/// ASMisreg() returns the length of the register name (unfetched)
				for(; len; len--) *pASM++ = *cp++;	/// copy register name into ASMbuf
				if( EOI==(c=getchr()) ) goto errret;
				++cp;
			/// else must be indirect address [numval], [global], [local]
			} else {
				*pASM++ = ASMSEP;	/// text separater mark

				t = gettok();	/// get the numval or the global or local identifier
				if( p==NULL ) {	/// if TREE not started yet
					p = tree(asmop(ASM1), unsignedlong, constexpr(0), NULL);	/// create TREE with ASM1 as the top op
					pruneASM(p, 0);		/// replace CNST or GLOBAL reference in LEFT-child with text
				} else if( NULL==p->kids[0] ) {	/// if TREE has no left child
					p->kids[0] = constexpr(0);		/// set left child to CNST(0)
					p->op = asmop(ASM1);			/// set TREE's top op to ASM1
					pruneASM(p, 0);					/// replace CNST or GLOBAL reference in LEFT-child with text
				} else if( NULL==p->kids[1] ) {	/// else if TREE has no right child
					p->kids[1] = constexpr(0);		/// set right child to CNST(0)
					p->op = asmop(ASM2);			/// set top op to ASM2 (line of ASM code has two parts)
					pruneASM(p, 1);					/// replace CNST or GLOBAL reference in LEFT-child with text
				} else error("Too many ASM arguments");	/// else if TREE has left and right children, ASM code is bad
				c = (char)t;
			}
			if( c!=']' ) error("_asm expected ']'");
			*pASM++ = c;
		} else if( c=='=' && n!='@' ) {	/// immediate argument (numval or address), but not @F or @B
			++cp;	/// skip '='
			*pASM++ = c;	/// copy out '='

			*pASM++ = ASMSEP;	/// text separater

			t = gettok();
			if( p==NULL ) {					/// if TREE not started yet
				p = tree(asmop(ASM1), unsignedlong, constexpr(0), NULL);
				pruneASM(p, 0);
			} else if( NULL==p->kids[0] ) {	/// else if no left child yet
				p->kids[0] = constexpr(0);
				p->op = asmop(ASM1);
				pruneASM(p, 0);
			} else if( NULL==p->kids[1] ) {	/// else if no right child yet
				p->kids[1] = constexpr(0);
				p->op = asmop(ASM2);
				pruneASM(p, 1);
			} else error("Too many ASM arguments");	/// else too complex of ASM line
			c = (char)t;
			--cp;	// put last char (@ or ;) back
			if( c==' ' || c=='\t' ) c = getchr();
			if( c!=ASMSEP && c!=')' && c!=';' ) error("_asm expected ')', ';', or '%c'", ASMSEP);
			goto alreadyhavechar;
		} else if( (len=((*IR->x.ASMisreg)())) ) {	/// else if REGISTER name
			for(; len; len--) *pASM++ = *cp++;	// copy register name into ASMbuf
		} else {	/// else just copy other characters
			*pASM++ = c;
			++cp;	// any other characters
		}
	} while( 1 );

	*pASM++ = '\n';
	if( p==NULL ) p = tree(asmop(ASM0), unsignedlong, NULL, NULL);	// create root ASM tree
	p->u.sym = ASMtext(ASMbuf, pASM-ASMbuf);
	ASMbuf[0] = 0;

	return p;
}

//****************************************************
Tree ASMexpr() {

	Tree	p;

	p = ASMunary();
	while( getchr()==ASMSEP ) {
		++cp;
		p = tree(asmop(ASM2), unsignedlong, p, ASMunary());
	}
	t = gettok();
	expect(')');
	return tree(ASMRET+U, unsignedlong, p, NULL);
}

//******************************************
static Tree unary(void) {

	Tree p;

	switch (t) {
	case '*':
		t = gettok();
		p = unary();
		p = pointer(p);
		if( isptr(p->type) && (isfunc(p->type->type) || isarray(p->type->type)) ) p = retype(p, p->type->type);
		else {
			if( YYnull ) p = nullcheck(p);
			p = rvalue(p);
		}
		break;
	case '&':
		t = gettok();
		p = unary();
		if( isarray(p->type) || isfunc(p->type) ) p = retype(p, ptr(p->type));
		else p = lvalue(p);
		if( isaddrop(p->op) && p->u.sym->sclass == REGISTER ) error("invalid operand of unary &; `%s' is declared register\n", p->u.sym->name);
		else if( isaddrop(p->op) ) p->u.sym->addressed = 1;
		break;
	case '+':    t = gettok(); p = unary(); p = pointer(p);
						  if (isarith(p->type))
						  	p = cast(p, promote(p->type));
						  else
						  	typeerror(ADD, p, NULL);  break;
	case '-':    t = gettok(); p = unary(); p = pointer(p);
						  if (isarith(p->type)) {
						  	Type ty = promote(p->type);
						  	p = cast(p, ty);
						  	if (isunsigned(ty)) {
						  		warning("unsigned operand of unary -\n");
						  		p = simplify(ADD, ty, simplify(BCOM, ty, p, NULL), cnsttree(ty, 1UL));
						  	} else
						  		p = simplify(NEG, ty, p, NULL);
						  } else
						  	typeerror(SUB, p, NULL); break;
	case '~':    t = gettok(); p = unary(); p = pointer(p);
						  if (isint(p->type)) {
						  	Type ty = promote(p->type);
						  	p = simplify(BCOM, ty, cast(p, ty), NULL);
						  } else
						  	typeerror(BCOM, p, NULL);  break;
	case '!':    t = gettok(); p = unary(); p = pointer(p);
						  if (isscalar(p->type))
						  	p = simplify(NOT, inttype, cond(p), NULL);
						  else
						  	typeerror(NOT, p, NULL); break;
	case INCR:
		t = gettok();
		p = unary();
		p = incr(INCR, pointer(p), consttree(1, inttype));
		break;
	case DECR:
		t = gettok();
		p = unary();
		p = incr(DECR, pointer(p), consttree(1, inttype));
		break;
	case TYPECODE:
	case SIZEOF:
		{
			long op = t;
			Type ty;

			p = NULL;
			t = gettok();
			if( t=='(' ) {
				t = gettok();
				if( istypename(t, tsym) ) {
					ty = typename();
					expect(')');
				} else {
					p = postfix(expr(')'));
					ty = p->type;
				}
			} else {
				p = unary();
				ty = p->type;
			}
			assert(ty);
			if( op==TYPECODE ) p = cnsttree(inttype, (long)ty->op);
			else {
				if( isfunc(ty) || ty->size==0 ) error("invalid type argument `%t' to `sizeof'\n", ty);
				else if( p && rightkid(p)->op==FIELD ) error("`sizeof' applied to a bit field\n");
				p = cnsttree(unsignedlong, (unsigned long)ty->size);
			}
		}
		break;
	case ASM:
		{
//			long	op = t;

			p = NULL;
			t = gettok();
			if( t=='(' ) {
				p = ASMexpr();
			} else expect('(');
//			t = gettok();
		}
		break;
	case '(':
		t = gettok();
		if (istypename(t, tsym)) {
			Type ty, ty1 = typename(), pty;
			expect(')');
			ty = unqual(ty1);
			if (isenum(ty)) {
				Type ty2 = ty->type;
				if (isconst(ty1))
					ty2 = qual(CONST, ty2);
				if (isvolatile(ty1))
					ty2 = qual(VOLATILE, ty2);
				ty1 = ty2;
				ty = ty->type;
			}
			p = pointer(unary());
			pty = p->type;
			if (isenum(pty))
				pty = pty->type;
			if( (isarith(pty) && isarith(ty)) ||  (isptr(pty)   && isptr(ty)) ) {
				explicitCast++;
				p = cast(p, ty);
				explicitCast--;
			} else if( (isptr(pty) && isint(ty)) || (isint(pty) && isptr(ty)) ) {
				if (Aflag >= 1 && ty->size < pty->size)
					warning("conversion from `%t' to `%t' is compiler dependent\n", p->type, ty);

				p = cast(p, ty);
			} else if (ty != voidtype) {
				error("cast from `%t' to `%t' is illegal\n",
					p->type, ty1);
				ty1 = inttype;
			}
			if (generic(p->op) == INDIR || ty->size == 0)
				p = tree(RIGHT, ty1, NULL, p);
			else
				p = retype(p, ty1);
		} else
			p = postfix(expr(')'));
		break;
	default:
		p = postfix(primary());
	}
	return p;
}

static Tree postfix(Tree p) {
	for (;;)
		switch (t) {
		case INCR:  p = tree(RIGHT, p->type,
			    	tree(RIGHT, p->type,
			    		p,
			    		incr(t, p, consttree(1, inttype))),
			    	p);
			    t = gettok(); break;
		case DECR:  p = tree(RIGHT, p->type,
			    	tree(RIGHT, p->type,
			    		p,
			    		incr(t, p, consttree(1, inttype))),
			    	p);
			    t = gettok(); break;
		case '[':   {
			    	Tree q;
			    	t = gettok();
			    	q = expr(']');
			    	if( YYnull ) {
			    		if( isptr(p->type) ) p = nullcheck(p);
			    		else if( isptr(q->type) ) q = nullcheck(q);
			    	}
			    	p = (*optree['+'])(ADD, pointer(p), pointer(q));
			    	if (isptr(p->type) && isarray(p->type->type))
			    		p = retype(p, p->type->type);
			    	else
			    		p = rvalue(p);
			    } break;
		case '(':   {
			    	Type ty;
			    	Coordinate pt;
			    	p = pointer(p);
			    	if (isptr(p->type) && isfunc(p->type->type))
			    		ty = p->type->type;
			    	else {
			    		error("found `%t' expected a function\n", p->type);
			    		ty = func(voidtype, NULL, 1);
			    		p = retype(p, ptr(ty));
			    	}
			    	pt = src;
			    	t = gettok();
			    	p = call(p, ty, pt);
			    } break;
		case '.':   t = gettok();
			    if (t == ID) {
			    	if (isstruct(p->type)) {
			    		Tree q = addrof(p);
			    		p = field(q, token);
			    		q = rightkid(q);
			    		if (isaddrop(q->op) && q->u.sym->temporary)
			    			p = tree(RIGHT, p->type, p, NULL);
			    	} else
			    		error("left operand of . has incompatible type `%t'\n",
			    			p->type);
			    	t = gettok();
			    } else
			    	error("field name expected\n"); break;
		case DEREF: t = gettok();
			    p = pointer(p);
			    if (t == ID) {
			    	if (isptr(p->type) && isstruct(p->type->type)) {
			    		if (YYnull)
			    			p = nullcheck(p);
			    		p = field(p, token);
			    	} else
			    		error("left operand of -> has incompatible type `%t'\n", p->type);

			    	t = gettok();
			    } else
			    	error("field name expected\n"); break;
		default:
			return p;
		}
}
static Tree primary(void) {
	Tree p;

	assert(t != '(');
	switch (t) {
	case ICON:
	case FCON: p = tree(mkop(CNST,tsym->type), tsym->type, NULL, NULL);
		   p->u.v = tsym->u.c.v;
 break;
	case SCON: if (ischar(tsym->type->type))
		   	tsym->u.c.v.p = stringn(tsym->u.c.v.p, tsym->type->size);
		   else
		   	tsym->u.c.v.p = memcpy(allocate((tsym->type->size/widechar->size)*sizeof (long), PERM),
		   		tsym->u.c.v.p, (tsym->type->size/widechar->size)*sizeof (long));
		   tsym = constant(tsym->type, tsym->u.c.v);
		   if (tsym->u.c.loc == NULL)
		   	tsym->u.c.loc = genident(STATIC, tsym->type, GLOBAL);
		   p = idtree(tsym->u.c.loc); break;
	case ID:   if (tsym == NULL)
		   	{
				Symbol p = install(token, &identifiers, level, PERM);
				p->src = src;
				if (getchr() == '(') {
					Symbol q = lookup(token, externals);
					p->type = func(inttype, NULL, 1);
					p->sclass = EXTERN;
					if (Aflag >= 1)
						warning("missing prototype\n");
					if (q && !eqtype(q->type, p->type, 1))
						warning("implicit declaration of `%s' does not match previous declaration at %w\n", q->name, &q->src);

					if (q == NULL) {
						q = install(p->name, &externals, GLOBAL, PERM);
						q->type = p->type;
						q->sclass = EXTERN;
						q->src = src;
						(*IR->defsymbol)(q);
					}
					p->u.alias = q;
				} else {
					error("undeclared identifier `%s'\n", p->name);
					p->sclass = AUTO;
					p->type = inttype;
					if (p->scope == GLOBAL)
						(*IR->defsymbol)(p);
					else
						addlocal(p);
				}
				t = gettok();
				if (xref)
					use(p, src);
				return idtree(p);
			}
		   if (xref)
		   	use(tsym, src);
		   if (tsym->sclass == ENUM)
		   	p = consttree(tsym->u.value, inttype);
		   else {
		   	if (tsym->sclass == TYPEDEF)
		   		error("illegal use of type name `%s'\n", tsym->name);
		   	p = idtree(tsym);
		   } break;
	case FIRSTARG:
		if (level > PARAM && cfunc && cfunc->u.f.callee[0])
			p = idtree(cfunc->u.f.callee[0]);
		else {
			error("illegal use of `%k'\n", FIRSTARG);
			p = cnsttree(inttype, 0L);
		}
		break;
	default:
		error("illegal expression\n");
			p = cnsttree(inttype, 0L);
	}
	t = gettok();
	return p;
}
Tree idtree(Symbol p) {
	long op;
	Tree e;
	Type ty = p->type ? unqual(p->type) : voidptype;

	if (p->scope == GLOBAL || p->sclass == STATIC)
		op = ADDRG;
	else if (p->scope == PARAM) {
		op = ADDRF;
		if (isstruct(p->type) && !IR->wants_argb)
			{
				e = tree(mkop(op,voidptype), ptr(ptr(p->type)), NULL, NULL);
				e->u.sym = p;
				return rvalue(rvalue(e));
			}
	} else if (p->sclass == EXTERN) {
		assert(p->u.alias);
		p = p->u.alias;
		op = ADDRG;
	} else
		op = ADDRL;
	p->ref += refinc;
	if (isarray(ty))
		e = tree(mkop(op,voidptype), p->type,      NULL, NULL);
	else if (isfunc(ty))
		e = tree(mkop(op,funcptype), p->type,      NULL, NULL);
	else
		e = tree(mkop(op,voidptype), ptr(p->type), NULL, NULL);
	e->u.sym = p;
	if (isptr(e->type))
		e = rvalue(e);
	return e;
}

Tree rvalue(Tree p) {
	Type ty = deref(p->type);

	ty = unqual(ty);
	return tree(mkop(INDIR,ty), ty, p, NULL);
}

//***********************************
Tree lvalue(Tree p) {

	if( generic(p->op) != INDIR ) {
		error("lvalue required\n");
		return value(p);
	} else if( unqual(p->type)==voidtype ) warning("`%t' used as an lvalue\n", p->type);
	return p->kids[0];
}

Tree retype(Tree p, Type ty) {
	Tree q;

	if (p->type == ty)
		return p;
	q = tree(p->op, ty, p->kids[0], p->kids[1]);
	q->node = p->node;
	q->u = p->u;
	return q;
}
Tree rightkid(Tree p) {
	while (p && p->op == RIGHT)
		if (p->kids[1])
			p = p->kids[1];
		else if (p->kids[0])
			p = p->kids[0];
		else
			assert(0);
	assert(p);
	return p;
}
long hascall(Tree p) {
	if (p == 0)
		return 0;
	if (generic(p->op) == CALL || (IR->mulops_calls &&
	  (p->op == DIV+I || p->op == MOD+I || p->op == MUL+I
	|| p->op == DIV+U || p->op == MOD+U || p->op == MUL+U)))
		return 1;
	return hascall(p->kids[0]) || hascall(p->kids[1]);
}

Type binary(Type xty, Type yty) {
#define xx(t) if (xty == t || yty == t) return t
	xx(longdouble);
	xx(doubletype);
	xx(floattype);
	xx(unsignedlonglong);
	xx(longlong);
	xx(unsignedlong);
	if( (xty == longtype && yty == unsignedtype) ||  (xty == unsignedtype && yty == longtype) ) {
		if( longtype->size > unsignedtype->size ) return longtype;
		else return unsignedlong;
	}
	xx(longtype);
	xx(unsignedtype);
	return inttype;
#undef xx
}

Tree pointer(Tree p) {
	if (isarray(p->type))
		/* assert(p->op != RIGHT || p->u.sym == NULL), */
		p = retype(p, atop(p->type));
	else if (isfunc(p->type))
		p = retype(p, ptr(p->type));
	return p;
}
Tree cond(Tree p) {
	long op = generic(rightkid(p)->op);

	if (op == AND || op == OR || op == NOT
	||  op == EQ  || op == NE
	||  op == LE  || op == LT || op == GE || op == GT)
		return p;
	p = pointer(p);
	return (*optree[NEQ])(NE, p, consttree(0, inttype));
}
Tree cast(Tree p, Type type) {
	Type src, dst;

	p = value(p);
	if (p->type == type)
		return p;
	dst = unqual(type);
	src = unqual(p->type);
	if (src->op != dst->op || src->size != dst->size) {
		switch (src->op) {
		case INT:
			if (src->size < inttype->size)
				p = simplify(CVI, inttype, p, NULL);
			break;
		case UNSIGNED:
			if (src->size < inttype->size)
				p = simplify(CVU, inttype, p, NULL);
			else if (src->size < unsignedtype->size)
				p = simplify(CVU, unsignedtype, p, NULL);
			break;
		case ENUM:
			p = retype(p, inttype);
			break;
		case POINTER:
			if (isint(dst) && src->size > dst->size)
				warning("conversion from `%t' to `%t' is undefined\n", p->type, type);
			p = simplify(CVP, super(src), p, NULL);
			break;
		case FLOAT:
			break;
		default: assert(0);
		}
		{
			src = unqual(p->type);
			dst = super(dst);
			if (src->op != dst->op)
				switch (src->op) {
				case INT:
					p = simplify(CVI, dst, p, NULL);
					break;
				case UNSIGNED:
					if (isfloat(dst)) {
						Type ssrc = signedint(src);
						Tree two = cnsttree(doubletype, (double)2.0);
						p = (*optree['+'])(ADD,
							(*optree['*'])(MUL,
								two,
								simplify(CVU, ssrc,
									simplify(RSH, src,
										p, consttree(1, inttype)), NULL)),
							simplify(CVU, ssrc,
								simplify(BAND, src,
									p, consttree(1, unsignedtype)), NULL));
					} else
						p = simplify(CVU, dst, p, NULL);
					break;
				case FLOAT:
					if (isunsigned(dst)) {
						Type sdst = signedint(dst);
						Tree c = cast(cnsttree(doubletype, (double)sdst->u.sym->u.limits.max.ill + 1), src);
						p = condtree(
							simplify(GE, src, p, c),
							(*optree['+'])(ADD,
								cast(cast(simplify(SUB, src, p, c), sdst), dst),
								cast(cnsttree(unsignedlong, (unsigned long)sdst->u.sym->u.limits.max.ill + 1), dst)),
							simplify(CVF, sdst, p, NULL));
					} else
						p = simplify(CVF, dst, p, NULL);
					break;
				default: assert(0);
				}
			dst = unqual(type);
		}
	}
	src = unqual(p->type);
	switch (src->op) {
	case INT:
		if (src->op != dst->op || src->size != dst->size)
			p = simplify(CVI, dst, p, NULL);
		break;
	case UNSIGNED:
		if (src->op != dst->op || src->size != dst->size)
			p = simplify(CVU, dst, p, NULL);
		break;
	case FLOAT:
		if (src->op != dst->op || src->size != dst->size)
			p = simplify(CVF, dst, p, NULL);
		break;
	case POINTER:
		if (src->op != dst->op)
			p = simplify(CVP, dst, p, NULL);
		else {
			if( (isfunc(src->type) && !isfunc(dst->type)) || (!isfunc(src->type) && isfunc(dst->type)) )
				warning("conversion from `%t' to `%t' is compiler dependent\n", p->type, type);

			if (src->size != dst->size)
				p = simplify(CVP, dst, p, NULL);
		}
		break;
	default: assert(0);
	}
	return retype(p, type);
}
Tree field(Tree p, const char *name) {
	Field q;
	Type ty1, ty = p->type;

	if (isptr(ty))
		ty = deref(ty);
	ty1 = ty;
	ty = unqual(ty);
	if ((q = fieldref(name, ty)) != NULL) {
		if (isarray(q->type)) {
			ty = q->type->type;
			if (isconst(ty1) && !isconst(ty))
				ty = qual(CONST, ty);
			if (isvolatile(ty1) && !isvolatile(ty))
				ty = qual(VOLATILE, ty);
			ty = array(ty, q->type->size/ty->size, q->type->align);
		} else {
			ty = q->type;
			if (isconst(ty1) && !isconst(ty))
				ty = qual(CONST, ty);
			if (isvolatile(ty1) && !isvolatile(ty))
				ty = qual(VOLATILE, ty);
			ty = ptr(ty);
		}
		if (YYcheck && !isaddrop(p->op) && q->offset > 0)	/* omit */
			p = nullcall(ty, YYcheck, p, consttree(q->offset, inttype));	/* omit */
		else					/* omit */
		p = simplify(ADD+P, ty, p, consttree(q->offset, signedptr));

		if (q->lsb) {
			p = tree(FIELD, ty->type, rvalue(p), NULL);
			p->u.field = q;
		} else if (!isarray(q->type))
			p = rvalue(p);

	} else {
		error("unknown field `%s' of `%t'\n", name, ty);
		p = rvalue(retype(p, ptr(inttype)));
	}
	return p;
}
/* funcname - return name of function f or a function' */
char *funcname(Tree f) {
	if (isaddrop(f->op))
		return stringf("`%s'", f->u.sym->name);
	return "a function";
}
static Tree nullcheck(Tree p) {
	if (!needconst && YYnull && isptr(p->type)) {
		p = value(p);
		if (strcmp(YYnull->name, "_YYnull") == 0) {
			Symbol t1 = temporary(REGISTER, voidptype);
			p = tree(RIGHT, p->type,
				tree(OR, voidtype,
					cond(asgn(t1, cast(p, voidptype))),
					vcall(YYnull, voidtype,	(file && *file ? pointer(idtree(mkstr(file)->u.c.loc)) : cnsttree(voidptype, NULL)), cnsttree(inttype, (long)lineno)		, NULL)),
				idtree(t1));
		}

		else
			p = nullcall(p->type, YYnull, p, cnsttree(inttype, 0L));

	}
	return p;
}
Tree nullcall(Type pty, Symbol f, Tree p, Tree e) {
	Type ty;

	if (isarray(pty))
		return retype(nullcall(atop(pty), f, p, e), pty);
	ty = unqual(unqual(p->type)->type);
	return vcall(f, pty,
		p, e,
		cnsttree(inttype, (long)ty->size),
		cnsttree(inttype, (long)ty->align),
		(file && *file ? pointer(idtree(mkstr(file)->u.c.loc)) : cnsttree(voidptype, NULL)), cnsttree(inttype, (long)lineno)		, NULL);
}
