//======================================================================================================
// DLG.C
// Copyright 2022 Everett Kaser
// All rights reserved
//======================================================================================================
#include	"lib.h"
#include	"player.h"
#include	"main.h"
#include	"dlg.h"
#include	"id.h"
#include	"str.h"
#include	"game.h"

void HelpChange();
void UpdateKeyMapList();
void UpdateUUsize();
DWORD CopyMood(DWORD hSRCmood);
BYTE *GetMergePtr(long n);

char str_mod_help0[]={0x2B,0x2E,0x40,0x2A,0x3B,0x2E,0x23,0x09,0x3D,0x51,0x4E,0x09,0x51,0x4E,0x55,0x59,0x09,0x5C,0x5D,0x5B,0x52,0x57,0x50,0x5C,0x09,0x51,0x4A,0x5F,0x4E,0x09,0x4B,0x4E,0x4E,0x57,0x09,0x56,0x58,0x4D,0x52,0x4F,0x52,0x4E,0x4D,0x0A,0x09,0x2C,0x58,0x57,0x5D,0x4A,0x4C,0x5D,0x23,0};
char str_mod_help1[]={0x2E,0x5F,0x4E,0x5B,0x4E,0x5D,0x5D,0x09,0x34,0x4A,0x5C,0x4E,0x5B,0x09,0x3C,0x58,0x4F,0x5D,0x60,0x4A,0x5B,0x4E,0};
char str_mod_help2[]={0x39,0x38,0x2B,0x09,0x1D,0x19,0x1C,0};
char str_mod_help3[]={0x2A,0x55,0x4B,0x4A,0x57,0x62,0x09,0x38,0x3B,0x09,0x22,0x20,0x1C,0x1B,0x1A,0x16,0x19,0x1A,0x1A,0x20,0};
char str_mod_help4[]={0x4E,0x5F,0x4E,0x5B,0x4E,0x5D,0x5D,0x29,0x54,0x4A,0x5C,0x4E,0x5B,0x17,0x4C,0x58,0x56,0};
char str_mod_help5[]={0x60,0x60,0x60,0x17,0x54,0x4A,0x5C,0x4E,0x5B,0x17,0x4C,0x58,0x56,0};

char	LicStr[]={0x35,0x32,0x2C,0x2E,0x37,0x3C,0x2E,0x2D,0};
char	DemoStr[]={0x11,0x2D,0x2E,0x36,0x38,0x12,0};
char	AllRights[]={0x2A,0x55,0x55,0x09,0x5B,0x52,0x50,0x51,0x5D,0x5C,0x09,0x5B,0x4E,0x5C,0x4E,0x5B,0x5F,0x4E,0x4D,0};

char	*AddLangSTR = "STR_%s.txt";
char	*AddLangHLP = "HLP_%s.txt";

BOOL	gateHelpScroll=FALSE;

long	GoHelpMark;
char	GoHelpName[32];

long	MenuCurSelID=ID_MENU_OPTIONS;
HWND	hMenuDlg;
DLGRES	*curCtls=NULL;

MOOD	tmpMood;
char	MenuMoodName[64];

HWND	hSIZEbutt[20];
long	numButtSize, wButtSize, firstSizeX, firstSizeY;
char	SIZEbuttNAME[20][4];
DWORD	hSBBM=0;
char	IFsizeStr[128];
char	BestButtStr[128];
char	MergeButtStr[128];
char	MergeFileName[32];
DWORD	hMergeData=0, MERGEcnt, BESTcnt;
char	MergeCntStr[128];
char	BestCntStr[128];

char	AboutDate[32], AboutBuildNum[32], AboutRevision[32], AboutScreen[64], AboutWindow[32], AboutUI[32], AboutKINT[32];

char	UUstr[64];

BOOL	GraphicsBad;

char	CurMusic[128];
BOOL	MusicDlgStop=FALSE;
char	TestText[128];
DWORD	OldMusicFlags;
HWND	hMusicFocus=0;

long	MMshowButt=-1;
long	MMbutt;

char	LangStrBy[128];	// NOTE: LangStrBy and LangHlpBy MUST be the same size so UpdateLangCredit() doesn't have to worry about which one it's doing for length checking
char	LangHlpBy[128];

BOOL	IsMenuKey;

//============ HELP STUFF =====================
char	HelpBMname[] = "HELP.png";
DWORD	hHelpBM=0;
long	CurHelpPage=1, CurHelpMark, CurHelpScroll=-1;
long	HelpPageH;
long	HelpPageMarks[32];
long	LinkCnt;
long	HelpCursor;
char	*HelpTitleStr;
char	*HelpSubtitleStr;

long	HTSPACE;
long	HTH;

char	*tabSTART, *tabNEXT;

typedef struct {
		long	x1, x2, y1, pid, mid;
		char	*p;
	} HELPLINK;

HELPLINK	HelpLinks[128];
WORD		BackStack[200];
long		BackStackCnt;

char		HelpText1[]="Copyright 2022 Everett Kaser";
char		HelpText2[]="All rights reserved";

#define	HBMUU	4

KEYMAP	WorkKeyMaps[MAXKEYMAP];
DWORD	WorkKeyMapsCnt;
char	MoveDupeStr[128];
BYTE	MDkey;
long	MDkeyIX, MDflags;

DWORD	DlgResultI;

char	StatusTime[16], StatusMoves[16], StatusBest[16];

//=======================================================================
DWORD MenuButtProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	BUTTONBM	*pW;
	RECT		r, rc, ri;
	long		i, xs, ys, ws, hs;
	DWORD		*pClrs, clrs[2];
	QWORD		qw;
	
	pW = (BUTTONBM*)HeapPtr(hW);
	switch( msg ) {
	 case WM_ACTIVATE:
		if( hMenuDlg ) {
			SendMsg(hMenuDlg, WM_DESTROY, ID_OK, 0, 0);
		} else {
			// if this is the first time run (most of menu is disabled), hide the MENU button so they can't use it to escape
			if( MenuDlg[1].flags & CF_DISABLED ) ShowWnd(FindWndID(ID_MENU_BUTT), SW_HIDE);
			else {
				// do modified PAUSE without redraw
				Paused = TRUE;
				PauseTime = TimeMilli();
				if( IsMusic() ) PauseMusic();
			}
			
			if( arg3==ID_MENU_HELP && !HelpChanged ) {
				strcpy(GoHelpName, (char*)arg1);
				GoHelpMark = arg2;
			}

			DoModal(MenuDlg, hMain);

			if( Paused ) SetPause(0);
			
			SetupUUvars();
			LoadUI(CurMood.UIimage);
			if( GraphicsBad ) {
				SetupDispVars();
				LoadGraphics(CurMood.images);
			}
			mainDrawAll();
			InvalidateAllWnd(hMain);
		}
		return 0;
	 case WM_PAINT:
		GetRectWnd(hW, &r);
		GetRectInvalid(&ri);
		if( IntersectRect(&ri, &r) ) {
			ClipRectBM(0, ri, &rc);

			if( !(pW->flags & CF_DISABLED) ) {
				ys = Y_MENUBUTT*UIBMU;
				if( pW->flags & CF_DOWN ) {
					xs = (X_MENUBUTT+12)*UIBMU;
				} else {
					xs = X_MENUBUTT*UIBMU;
				}
				DrawBM(0, r.x, r.y, hUIBM, xs, ys, UIBMU*12, UIBMU*5, 0);
			}
			
			ClipRectBM(0, rc, NULL);
		}
		return 0;
	 case WM_PARENTSIZED:
		if( pW->id==ID_MENU_BUTT_CLOSE ) {	// we have to handle this one ourself, because it doesn't have a DLGRES
			if( pW->uu && pW->uu!=UU ) {
				InvalidateAllWnd(hW);
				
				pW->uu = UU;
				pW->w = UU*12;
				pW->h = UU5;
				pW->xoff = 0;
				pW->yoff = -pW->h;
				
				InvalidateAllWnd(hW);
			}
		} else {
			if( pW->uu && pW->uu!=UU ) {
				InvalidateAllWnd(hW);
				
				pW->uu = UU;
				pW->w = UU*12;
				pW->h = UU5;
				pW->xoff = 0;
				pW->yoff = 0;
				
				InvalidateAllWnd(hW);
			}
		}
		return 0;
	 case WM_LBUTTUP:
		ButtonBMProc(hW, msg, arg1, arg2, arg3);
		return 0;
	 case WM_HOVER:
		SetCursor(CURSOR_NORMAL);
		return BarButtBMProc(hW, msg, arg1, arg2, arg3);
	 case WM_SETFOCUS:
		SetFocus(hMain);
		return 0;
	 case WM_NOTIFY:
		switch( arg1 ) {
		 case WN_STRINGS_RELOADED:
			if( pW && pW->pRES ) pW->text = (DWORD)GetCtlString(pW->pRES);
			break;
		}
		break;
	}
	return ButtonBMProc(hW, msg, arg1, arg2, arg3);
}

//=======================================================================
DWORD CurMoodProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	TEXT	*pW;
	RECT	r, ri, rc;
	long	i, x, y, w, h, align, th;
	DWORD	clrs[2], *pClrs, dw;
	
	pW = (TEXT*)HeapPtr(hW);
	switch( msg ) {
	 case WM_GETCOLORS:
		pClrs = (DWORD*)arg1;
		pClrs[0] = Colors[ClrTEXTfillNORM];
		pClrs[1] = Colors[ClrMOODname];
		return 0;
	 case WM_LBUTTDN:
		IgnoreMouseUp = TRUE;	// Avoid GroupBox changing focus when clicked on this control
		return 0;
	 case WM_PAINT:
		GetRectWnd(hW, &r);
		GetRectInvalid(&ri);
		if( IntersectRect(&ri, &r) ) {
			ClipRectBM(0, ri, &rc);

			x = r.x;
			y = r.y;
			w = r.w;
			h = r.h;

			SendMsg(hW, WM_GETCOLORS, (DWORD)&clrs[0], 0, 0);

			DrawRectBM(0, x, y, w, h, clrs[0], CLR_NONE);

			if( pW->text ) {
				th = TEXTH+1;
				do {
					--th;
					dw = DrawTextBM(0, (char*)pW->text, x+UU, y+TEXTYSPACE, w-2*UU, th, (pW->flags & TF_CLEAR) | TF_GET_WIDTH, CLR_NONE, clrs[1]);
				} while( th>1 && (dw>>16) > w-2*UU );
				DrawTextBM(0, (char*)pW->text, x+UU, y+(UU4-th)/2, w-2*UU, th, pW->flags & TF_CLEAR, CLR_NONE, clrs[1]);
			}
			
			ClipRectBM(0, rc, NULL);
		}
		return 0;
	 default:
		break;
	}
	return TextProc(hW, msg, arg1, arg2, arg3);
}

//=====================================================================
void UpdateLangCredit(HWND hWby, HWND hWlist) {

	DWORD	hFile;
	char	*s, *d;
	long	i;
	
	if( ((WND*)HeapPtr(hWby))->id==ID_LANG_STR_BY ) {
		d = LangStrBy;
		strcpy(ScratBuf, StringsDir);
		s = AddLangSTR;
	} else {
		d = LangHlpBy;
		strcpy(ScratBuf, HelpDir);
		s = AddLangHLP;
	}

	SendMsg(hWlist, LBM_GETITEM, -1, (DWORD)(ScratBuf+2048), LBGI_TEXT);
	sprintf(ScratBuf+strlen(ScratBuf), s, ScratBuf+2048);
	if( -1!=(hFile=fopen(ScratBuf, O_RDBIN)) ) {
		fread(hFile, ScratBuf+256, 256);
		fclose(hFile);

		s = ScratBuf+256;
		while( *s!='\r' && *s!='\n' ) ++s;	// skip checksum line
		while( *s=='\r' || *s=='\n' ) ++s;	// skip checksum EOL
		for(i=0; i<sizeof(LangStrBy)-1 && *s!='\r' && *s!='\n'; i++) *d++ = *s++;	// copy credits line
	}
	*d = 0;
	InvalidateAllWND(hWby);
}

//==========================================================================
DWORD sizeProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	HWND		hB;
	RADIOBUTT	*pW, *pB;
	RECT		r, ri, rc;
	long		i, x, y, dx, dy, dw, dh, xs, ys, delt, ex, ouu;
	DWORD		clrs[3];
	POINT		lp[3];
	
	pW = (RADIOBUTT*)HeapPtr(hW);
	switch( msg ) {
	 case WM_ACTIVATE:
		RadioButtonProc(hW, msg, arg1, arg2, arg3);
		tmpMood.UU = pW->id - ID_IF_SIZEBUTT0;
		for(i=0; i<numButtSize; i++) {
			hB = FindWndID(ID_IF_SIZEBUTT0+i);
			pB = (RADIOBUTT*)HeapPtr(hB);
			pB->flags &= ~CF_CHECKED;
		}
		pW->flags |= CF_CHECKED;

		UpdateUUsize();
		break;
	 case WM_PAINT:
		GetRectWnd(hW, &r);
		GetRectInvalid(&ri);
		if( IntersectRect(&ri, &r) ) {
			ClipRectBM(0, ri, &rc);
		
			if( pW->flags & CF_DISABLED ) clrs[1] = Colors[ClrTEXTtextDISABLED];
			else if( hW==hFocus ) clrs[1] = Colors[ClrTEXTtextFOCUS];
			else if( hW==hHover ) clrs[1] = Colors[ClrTEXTtextHOVER];
			else clrs[1] = Colors[ClrTEXTtextNORM];

			dx = r.x;
			dy = r.y;
			dw = r.w;
			dh = r.h;
			ouu = wButtSize/6;
			
			
			xs = ouu*((hW==hFocus) ? 12 : ((hW==hHover) ? 6 : 0));
			if( pW->flags & CF_DOWN ) {
				ys = ouu*6;
				delt = ouu;
			} else {
				ys = 0;
				delt = 3*ouu/4;
			}
			
			clrs[0] = GetPixelBM(hSBBM, xs+ouu-1, ys+ouu-1);

			DrawRectBM(0, dx, dy, dw, dh, clrs[0], clrs[1]);
			
			RepDrawBM(0, dx, dy, hSBBM, xs, ys, ouu, ouu, 0, 0, 0);
			RepDrawBM(0, dx+ouu, dy, hSBBM, xs+ouu, ys, ouu*4, ouu, 0, dx+dw-ouu, 0);
			RepDrawBM(0, dx+dw-ouu, dy, hSBBM, xs+5*ouu, ys, ouu, ouu, 0, 0, 0);
			RepDrawBM(0, dx, dy+ouu, hSBBM, xs, ys+ouu, ouu, ouu*4, 0, 0, dy+dh-ouu);
			RepDrawBM(0, dx+dw-ouu, dy+ouu, hSBBM, xs+5*ouu, ys+ouu, ouu, ouu*4, 0, 0, dy+dh-ouu);
			RepDrawBM(0, dx, dy+dh-ouu, hSBBM, xs, ys+5*ouu, ouu, ouu, 0, 0, 0);
			RepDrawBM(0, dx+ouu, dy+dh-ouu, hSBBM, xs+ouu, ys+5*ouu, ouu*4, ouu, 0, dx+dw-ouu, 0);
			RepDrawBM(0, dx+dw-ouu, dy+dh-ouu, hSBBM, xs+5*ouu, ys+5*ouu, ouu, ouu, 0, 0, 0);
			
			DrawTextBM(0, (char*)pW->text, dx+delt, dy+delt, dw-2*ouu, dh-2*ouu, CF_CENTER, clrs[0], clrs[1]);
			
			ClipRectBM(0, rc, NULL);
		}
		return 0;
	 case WM_PARENTSIZED:
		GetRectWnd(hMenuDlg, &r);
		SendMsg(hW, WM_COMMAND, WC_MOVE, (31*(numButtSize+2))-r.x+(pW->id-ID_IF_SIZEBUTT0)*wButtSize, 6*(numButtSize+2)-r.y);
		return 0;
	}
	return RadioButtonProc(hW, msg, arg1, arg2, arg3);
}

//=====================================================================
void AddMenuCtls(DLGRES *pCtls, BOOL setDefFocus) {
	
	long		i, j, x, y, fs;
	char		name[512];
	DWORD		hMOOD;
	MOOD		*pMOOD;
	DWORD		hM, hW, hMergeFile;
	FILELIST	*pM;
	WND			*pW;
	RECT		r, ri;
	WNDSCROLL	*pWS;
	DLGRES		*pRES;
	BYTE		*pF, *pB;
	
	curCtls = pCtls;
	if( curCtls!=NULL ) {
		// Create additional controls for this menu section
		CreateMenuCtls(curCtls, setDefFocus);
		
		// init control values from temp variables
		if( curCtls==HelpCtls ) {
			BackStackCnt = 0;
			if( !ReadHelp(tmpMood.HelpName) ) {
				if( !ReadHelp(defHelp) ) {
					SetFocusID(ID_MENU_ABOUT);
					SendMsgID(ID_MENU_ABOUT, WM_ACTIVATE, 0, 0, 0);
					return;
				}
			}
			hHelpBM = LoadBM(pAtS[10]);	// load HELP graphics file
			if( HackUU ) hHackUIBM = LoadBM(pAtS[11]);
			if( HackGU ) hHackGBM = LoadBM(pAtS[12]);

			if( HelpChanged ) {
				GoHelp("CONTACT", 0);
			} else {
				HelpChange();
			}

			if( CurHelpScroll<0 ) CurHelpScroll = HelpPageMarks[CurHelpMark]/HTH;
			SendMsg(FindWndID(ID_HELP_TEXT), WM_COMMAND, WC_SETSCROLLPOS, 0, CurHelpScroll);
			// gateHelpScroll gets set in the Vscroll's WM_CREATE and it
			// prevents WN_SCROLL notifications to HelpTextProc from 
			// saving invalid preliminary values for the Vscroll position until we've
			// had a chance to restore it here. We're done now, so clear it.
			gateHelpScroll = FALSE;
		} else if( curCtls==BestMovesCtls ) {
			// set text for BEST COUNTS button
			sprintf(BestButtStr, KString(BLK_DLG, STR_EXP_ALLCNTS), HumanButtNum);
			// set text for MERGE ALL button
			sprintf(MergeButtStr, KString(BLK_DLG, STR_MERGE_ALL), HumanButtNum);
			
			// read and count available MERGE solutions and set status string
			MERGEcnt = 0;
			sprintf(MergeFileName, "%dCTMERGE", HumanButtNum);
			fs = fsize(MergeFileName);
			if( fs > 0 ) {
				if( -1!=(hMergeFile=fopen(MergeFileName, O_RDBIN)) ) {
					hMergeData = HeapAlloc(fs);
					pB = (BYTE*)HeapPtr(hMergeData);
					fread(hMergeFile, pB, fs);
					fclose(hMergeFile);

					pF = GetMergePtr(0);
					for(i=j=0; i<65536; i++) {
						if( !(i & 0x3FF) ) {
							if( pF-pB != ((DWORD*)pB)[i>>10] ) {
								if( j==0 ) {
									sprintf(ScratBuf, "Corrupted MERGE file at puzzle# %d [%8.8X -- %8.8X]", i+1, pF-pB, ((DWORD*)pB)[i>>10]);
									SystemMessage(ScratBuf);
									j = 1;
								}
								((DWORD*)pB)[i>>10] = pF-pB;
							}
						}
						if( *((WORD*)pF) ) {	// if MERGE has an entry
							++MERGEcnt;
						}
						pF += 2 + 2*(*(WORD*)pF);	// skip to next MERGE entry
					}
				}
			}
			sprintf(MergeCntStr, KString(BLK_DLG, STR_MERGE_CNT), HumanButtNum, MERGEcnt);
			// count BEST solutions and set status string
			BESTcnt = 0;
			pB = (BYTE*)HeapPtr(hBest);
			if( NULL!=(pF=GetBestPtr(0)) ) {
				for(i=j=0; i<65536; i++) {
					if( !(i & 0x3FF) ) {
						if( pF-pB != ((DWORD*)pB)[i>>10] ) {
							if( j==0 ) {
								sprintf(ScratBuf, "Corrupted BEST file at puzzle# %d [%8.8X -- %8.8X]", i+1, pF-pB, ((DWORD*)pB)[i>>10]);
								SystemMessage(ScratBuf);
								j = 1;
							}
							((DWORD*)pB)[i>>10] = pF-pB;
						}
					}
					if( *((WORD*)pF) ) {	// if MERGE has an entry
						++BESTcnt;
					}
					pF += 2 + 2*(*(WORD*)pF);	// skip to next MERGE entry
				}
			}
			sprintf(BestCntStr, KString(BLK_DLG, STR_BEST_CNT), HumanButtNum, BESTcnt);
		} else if( curCtls==AboutCtls ) {
			sprintf(AboutDate, KString(BLK_DLG, STR_BUILDDATE), (long)*(WORD*)0xD6, (long)*(BYTE*)0xD8, (long)*(BYTE*)0xD9);
			sprintf(AboutRevision, KString(BLK_DLG, STR_REVISION), (long)*(BYTE*)0xDA, (long)*(BYTE*)0xDB);
			sprintf(AboutBuildNum, KString(BLK_DLG, STR_BUILDNUM), *(long*)0xDC);
			sprintf(AboutKINT, KString(BLK_DLG, STR_ABOUT_KINT), (long)*(BYTE*)0xC4, (long)*(BYTE*)0xC5, (long)*(WORD*)0xC6);
			sprintf(AboutScreen, KString(BLK_DLG, STR_SCREEN), ScreenW, ScreenH, MaxScreenW, MaxScreenH);
			sprintf(AboutWindow, KString(BLK_DLG, STR_WINDOW), ViewW,ViewH);
			sprintf(AboutUI, KString(BLK_DLG, STR_UI), UU, GU);
		} else if( curCtls==SelPlyCtls ) {
			name[0] = 0;
			for(i=0; i<=maxID; i++) {
				sprintf(ScratBuf, iniPLAYER, i);
				if( iniFindSec(ScratBuf) ) {
					iniFindVar(iniNAME);
					iniGetStr(ScratBuf, 64);
					SendMsgID(ID_LIST, LBM_ADDSTRING, (DWORD)(ScratBuf), 0, 0);
					if( i==CurPlayer.id ) strcpy(name, ScratBuf);
				}
			}
			SendMsgID(ID_LIST, LBM_SELSTRING, (DWORD)name, 0, 0);
		} else if( curCtls==AddPlyCtls ) {
			SendMsgID(ID_NEWPLYNAME, ELM_LIMITTEXT, 31, 0, 0);
			SendMsgID(ID_NEWPLYNAME, ELM_SETTEXT, (DWORD)KString(BLK_DLG, STR_SECRET_ID), 0, 0);
			SetCheckID(ID_COPYALLMOODS, TRUE);
			SendMsgID(ID_NPDEFMOODNAME, ELM_LIMITTEXT, 31, 0, 0);
			SendMsgID(ID_NPDEFMOODNAME, ELM_SETTEXT, (DWORD)KString(BLK_DLG, STR_DEFMOODNAME), 0, 0);
			EnableWndID(ID_NPDEFMOODNAME, FALSE);
		} else if( curCtls==RenPlyCtls ) {
			SendMsgID(ID_RENPLYNAME, ELM_LIMITTEXT, 31, 0, 0);
			SendMsgID(ID_RENPLYNAME, ELM_SETTEXT, (DWORD)CurPlayer.name, 0, 0);
		} else if( curCtls==DelPlyCtls ) {
			
		} else if( curCtls==SelMoodCtls ) {
			name[0] = 0;
			for(hMOOD=CurPlayer.hFirstMood; hMOOD && (pMOOD=(MOOD*)HeapPtr(hMOOD)); hMOOD=pMOOD->hNext) {
				SendMsgID(ID_LIST, LBM_ADDSTRING, (DWORD)(pMOOD->name), 0, 0);
			}
			SendMsgID(ID_LIST, LBM_SELSTRING, (DWORD)(tmpMood.name), 0, 0);
		} else if( curCtls==AddMoodCtls ) {
			SendMsgID(ID_NEWMOODNAME, ELM_LIMITTEXT, 31, 0, 0);
			SendMsgID(ID_NEWMOODNAME, ELM_SETTEXT, (DWORD)KString(BLK_DLG, STR_DEFMOODNAME), 0, 0);
			SetCheckID(ID_COPYCURMOOD, TRUE);
		} else if( curCtls==RenMoodCtls ) {
			SendMsgID(ID_RENMOODNAME, ELM_LIMITTEXT, 31, 0, 0);
			SendMsgID(ID_RENMOODNAME, ELM_SETTEXT, (DWORD)tmpMood.name, 0, 0);
		} else if( curCtls==DelMoodCtls ) {
			
		} else if( curCtls==GraphCtls ) {
			ScratBuf[7000] = 0;
			if( -1!=FindFirst("images/*", ScratBuf, NULL, NULL) ) {
				do {
					if( strcmp(ScratBuf, ".") && strcmp(ScratBuf, "..") ) {
						if( !strcmp(tmpMood.images, ScratBuf) ) strcpy(ScratBuf+7000, ScratBuf);
						if( -1==SendMsgID(ID_LIST, LBM_FINDSTRING, (DWORD)(ScratBuf), 0, 0) )
							SendMsgID(ID_LIST, LBM_ADDSTRING, (DWORD)(ScratBuf), 0, 0);
					}
				} while( -1 != FindNext(ScratBuf, 0, 0) );
				FindClose();
			}
			if( ScratBuf[7000] ) SendMsgID(ID_LIST, LBM_SELSTRING, (DWORD)(ScratBuf+7000), 0, 0);
			else SendMsgID(ID_LIST, LBM_SETCURSEL, 0, 0, 0);

			SetCheckID(ID_MIRROR_CHANGES, tmpMood.flags2 & PF2_MIRROR_GRAPHICS);
		} else if( curCtls==IFSCtls ) {
			ScratBuf[7000] = 0;
			if( -1!=FindFirst("UIimages/*", ScratBuf, NULL, NULL) ) {
				do {
					if( strcmp(ScratBuf, ".") && strcmp(ScratBuf, "..") ) {
						if( !strcmp(tmpMood.UIimage, ScratBuf) ) strcpy(ScratBuf+7000, ScratBuf);
						if( -1==SendMsgID(ID_LIST, LBM_FINDSTRING, (DWORD)(ScratBuf), 0, 0) )
							SendMsgID(ID_LIST, LBM_ADDSTRING, (DWORD)(ScratBuf), 0, 0);
					}
				} while( -1 != FindNext(ScratBuf, 0, 0) );
				FindClose();
			}
			if( ScratBuf[7000] ) SendMsgID(ID_LIST, LBM_SELSTRING, (DWORD)(ScratBuf+7000), 0, 0);
			else SendMsgID(ID_LIST, LBM_SETCURSEL, 0, 0, 0);
			
			GetRectWnd(hMenuDlg, &r);
			firstSizeX = r.x;
			firstSizeY = r.y;

			for(i=0; i<numButtSize; i++) {
				hSIZEbutt[i] = CreateWnd(ID_IF_SIZEBUTT0+i, WT_BUTTONTEXT, (31*(numButtSize+2))-firstSizeX+i*wButtSize, 6*(numButtSize+2)-firstSizeY, wButtSize, wButtSize, WF_SHOW+CF_TABSTOP+((i==0)?CF_GROUP:0)+((tmpMood.UU==i)?CF_CHECKED:0), hMenuDlg, sizeProc);
				pW = (WND*)HeapPtr(hSIZEbutt[i]);
				pW->type = WT_RADIOBUTTON;
				if( i==0 ) strcpy(SIZEbuttNAME[i], KString(BLK_DLG, STR_UUSIZE_AUTO));
				else sprintf(SIZEbuttNAME[i],"%d", 3+i);
				pW->text = (DWORD)SIZEbuttNAME[i];
			}
			UpdateUUsize();
			SetCheckID(ID_MIRROR_CHANGES, tmpMood.flags2 & PF2_MIRROR_INTERFACE);
		} else if( curCtls==LangCtls ) {
			hW = FindWndID(ID_LANG_STRINGS);
			pW = (WND*)HeapPtr(hW);
			strcpy(ScratBuf, StringsDir);
			strcat(ScratBuf, "STR_*.txt");
			if( -1!=FindFirst(ScratBuf, ScratBuf, NULL, NULL) ) {
				do {
					if( strcmp(ScratBuf, ".") && strcmp(ScratBuf, "..") ) {
						strcpy(ScratBuf+2000, ScratBuf+4);	// get rid of STR_
						ScratBuf[2000+strlen(ScratBuf+2000)-4] = 0;	// get rid of .txt
						if( -1==SendMsg(hW, LBM_FINDSTRING, (DWORD)(ScratBuf+2000), 0, 0) ) {
							SendMsg(hW, LBM_ADDSTRING, (DWORD)(ScratBuf+2000), 0, 0);
							if( !strcmp(ScratBuf, tmpMood.StringsName) ) {
								strcpy(ScratBuf+3000, ScratBuf+2000);
							}
						}
					}
				} while( -1 != FindNext(ScratBuf, 0, 0) );
				FindClose();
			}
			SendMsg(hW, LBM_SELSTRING, (DWORD)(ScratBuf+3000), 0, 0);
			UpdateLangCredit(FindWndID(ID_LANG_STR_BY), hW);

			hW = FindWndID(ID_LANG_HELP);
			pW = (WND*)HeapPtr(hW);
			strcpy(ScratBuf, HelpDir);
			strcat(ScratBuf, "HLP_*.txt");
			if( -1!=FindFirst(ScratBuf, ScratBuf, NULL, NULL) ) {
				do {
					if( strcmp(ScratBuf, ".") && strcmp(ScratBuf, "..") ) {
						strcpy(ScratBuf+2000, ScratBuf+4);	// get rid of HLP_
						ScratBuf[2000+strlen(ScratBuf+2000)-4] = 0;	// get rid of .txt
						if( -1==SendMsg(hW, LBM_FINDSTRING, (DWORD)(ScratBuf+2000), 0, 0) ) {
							SendMsg(hW, LBM_ADDSTRING, (DWORD)(ScratBuf+2000), 0, 0);
							if( !strcmp(ScratBuf, tmpMood.HelpName) ) {
								strcpy(ScratBuf+3000, ScratBuf+2000);
							}
						}
					}
				} while( -1 != FindNext(ScratBuf, 0, 0) );
				FindClose();
			}
			SendMsg(hW, LBM_SELSTRING, (DWORD)(ScratBuf+3000), 0, 0);
			UpdateLangCredit(FindWndID(ID_LANG_HLP_BY), hW);

			SetCheckID(ID_MIRROR_CHANGES, tmpMood.flags2 & PF2_MIRROR_LANGUAGE);
		} else if( curCtls==MusicCtls ) {
			SetCheckID(ID_RANDMUSIC, tmpMood.flags & PF_RAND_MUSIC);
			SetCheckID(ID_PLAYBACK, tmpMood.flags & PF_BACK_MUSIC);
			SetCheckID(ID_PLAYWIN, tmpMood.flags & PF_WIN_MUSIC);
			if( -1!=FindFirst("../MUSIC/*.MID", ScratBuf, NULL, NULL) ) {
				do {
					if( strcmp(ScratBuf, ".") && strcmp(ScratBuf, "..") ) {
						if( -1==SendMsgID(ID_LIST, LBM_FINDSTRING, (DWORD)(ScratBuf), 0, 0) )
							SendMsgID(ID_LIST, LBM_ADDSTRING, (DWORD)ScratBuf, 0, 0);
					}
				} while( -1 != FindNext(ScratBuf, 0, 0) );
				FindClose();
			}
			SendMsgID(ID_LIST, LBM_SELSTRING, (DWORD)CurMusic, 0, 0);
			for(hM=tmpMood.hBackMusic; hM && (pM=((FILELIST*)HeapPtr(hM))); hM=pM->hNext) {
				SendMsgID(ID_LISTBACK, LBM_ADDSTRING, (DWORD)(pM->name), 0, 0);
			}
			SendMsgID(ID_LISTBACK, LBM_SELSTRING, (DWORD)CurMusic, 0, 0);
			for(hM=tmpMood.hWinMusic; hM && (pM=((FILELIST*)HeapPtr(hM))); hM=pM->hNext) {
				SendMsgID(ID_LISTWIN, LBM_ADDSTRING, (DWORD)(pM->name), 0, 0);
			}
			SendMsgID(ID_LISTWIN, LBM_SELSTRING, (DWORD)CurMusic, 0, 0);
			SetTestStopButton();

			SetCheckID(ID_MIRROR_CHANGES, tmpMood.flags2 & PF2_MIRROR_MUSIC);
		} else if( curCtls==MouseMapCtls ) {
			MMbutt = 0;
			SetCheckID(ID_MM_LEFT, TRUE);
			SetCheckID(ID_REV_WHEEL, tmpMood.flags & PF_REV_WHEEL);
			SetCheckID(ID_REV_TILT, tmpMood.flags & PF_REV_TILT);
			SetCheckID(ID_MIRROR_CHANGES, tmpMood.flags2 & PF2_MIRROR_MOUSE);
		} else if( curCtls==KeyMapCtls ) {
			memcpy((BYTE*)&WorkKeyMaps, (BYTE*)&tmpMood.KeyMaps, sizeof(WorkKeyMaps));
			WorkKeyMapsCnt = tmpMood.KeyMapsCnt;

			SendMsgID(ID_KEYMAP_LIST, LBM_SORTCOL, 1, 0, 0);	// sort list by function name
			UpdateKeyMapList();
			
			for(i=0; i<KeysCnt; i++) SendMsgID(ID_KEYS_LIST, LBM_ADDSTRING, (DWORD)Keys[i].name, (DWORD)i, 0);
			for(i=0; i<KF_NUMFUNCS; i++) SendMsgID(ID_FUNC_LIST, LBM_ADDSTRING, (DWORD)KString(BLK_KEY, STR_KF_FIRSTFUNC+i), (DWORD)i, 0);

			SetCheckID(ID_MIRROR_CHANGES, tmpMood.flags2 & PF2_MIRROR_KEYS);
		} else if( curCtls==OptionsCtls ) {
			SetCheckID(ID_BYPASS_TITLE, tmpMood.flags & PF_BYPASS_TITLE);
			SetCheckID(ID_GAMESOUNDS, tmpMood.flags & PF_GAMESOUNDS);
			SetCheckID(ID_ERRORSOUNDS, tmpMood.flags & PF_ERRORSOUNDS);
			SetCheckID(ID_PROMPTNEXT, tmpMood.flags & PF_PROMPTNEXT);
			SetCheckID(ID_PROMPTRESTART, tmpMood.flags & PF_PROMPTRESTART);
			SetCheckID(ID_ENABLECLICK, tmpMood.flags & PF_ENABLECLICK);
			SetCheckID(ID_STARTBOTTOM, tmpMood.flags & PF_STARTBOTTOM);
			SetCheckID(ID_SCRAMBLEORDER, tmpMood.flags & PF_SCRAMBLEORDER);
			SetCheckID(ID_SHOWTIMER, tmpMood.flags & PF_SHOWTIMER);
			SetCheckID(ID_REMOVE_PAUSE, tmpMood.flags & PF_REMOVE_PAUSE);
			SetCheckID(ID_SHOWTILESMOVED, tmpMood.flags & PF_SHOWTILESMOVED);
			SetCheckID(ID_SHOWBESTCOUNT, tmpMood.flags & PF_SHOWBESTCOUNT);
			SetCheckID(ID_SHOW_TOOLTIPS, tmpMood.flags & PF_SHOW_TOOLTIPS);
			
			SetCheckID(ID_WIN_FIRE+tmpMood.WinDisp, TRUE);
			SendMsgID(ID_WIN_DELAY, ELM_LIMITTEXT, 3, 0, 0);
			SendMsgID(ID_WIN_DELAY, ELM_SETNUM, (DWORD)tmpMood.WinDelay, 0, 0);
			SendMsgID(ID_WIN_SPEED, ELM_LIMITTEXT, 3, 0, 0);
			SendMsgID(ID_WIN_SPEED, ELM_SETNUM, (DWORD)tmpMood.WinSpeed, 0, 0);
			SendMsgID(ID_PUZZLE_SIZE, ELM_LIMITTEXT, 3, 0, 0);
			SendMsgID(ID_PUZZLE_SIZE, ELM_SETNUM, (DWORD)tmpMood.LimitPuzzSize, 0, 0);
			SendMsgID(ID_CSV_SEP, ELM_LIMITTEXT, 1, 0, 0);
			ScratBuf[0] = (char)tmpMood.CSVsep;
			ScratBuf[1] = 0;
			SendMsgID(ID_CSV_SEP, ELM_SETTEXT, (DWORD)ScratBuf, 0, 0);

			SetCheckID(ID_MIRROR_CHANGES, tmpMood.flags2 & PF2_MIRROR_OPTIONS);
		} else if( curCtls==ExitCtls ) {
			
		} else SystemMessage("Programmer oops: AddMenuCtls() curCtls");
	}
}

#define	OPTION_FLAGS	(PF_BYPASS_TITLE | PF_GAMESOUNDS | PF_ERRORSOUNDS | PF_PROMPTNEXT\
						| PF_PROMPTRESTART | PF_ENABLECLICK | PF_STARTBOTTOM | PF_SCRAMBLEORDER\
						| PF_SHOWTIMER | PF_SHOWTILESMOVED | PF_SHOWBESTCOUNT | PF_SHOW_TOOLTIPS\
						| PF_REMOVE_PAUSE)
#define	MOUSE_FLAGS		(PF_REV_WHEEL | PF_REV_TILT)
#define	MUSIC_FLAGS		(PF_RAND_MUSIC | PF_BACK_MUSIC | PF_WIN_MUSIC)

//=======================================================================
void SaveMenuCtls() {
	
	long		i;
	DWORD		hMOOD, hN, hP, hT, hTP;
	FILELIST	*pN, *pP, *pT, *pTP;
	MOOD		*pM;
	SBINFO		sbi;
	
	if( curCtls!=NULL ) {
		if( curCtls==HelpCtls ) {
			if( hHelpBM ) DeleteBM(hHelpBM);
			hHelpBM = 0;
			if( HackUU ) DeleteBM(hHackUIBM);
			hHackUIBM = 0;
			if( HackGU ) DeleteBM(hHackGBM);
			hHackGBM = 0;
			if( hHelpStyle ) HeapFree(hHelpStyle);
			hHelpStyle = 0;
		} else if( curCtls==BestMovesCtls ) {
			if( hMergeData ) HeapFree(hMergeData);
			hMergeData = 0;
		} else if( curCtls==AboutCtls ) {
		} else if( curCtls==SelPlyCtls ) {
		} else if( curCtls==AddPlyCtls ) {
		} else if( curCtls==RenPlyCtls ) {
		} else if( curCtls==DelPlyCtls ) {
		} else if( curCtls==SelMoodCtls ) {
		} else if( curCtls==AddMoodCtls ) {
		} else if( curCtls==RenMoodCtls ) {
		} else if( curCtls==DelMoodCtls ) {
		} else if( curCtls==GraphCtls ) {
			if( GetCheckID(ID_MIRROR_CHANGES) ) tmpMood.flags2 |= PF2_MIRROR_GRAPHICS;
			else tmpMood.flags2 &= ~PF2_MIRROR_GRAPHICS;
			
			for(hMOOD=CurPlayer.hFirstMood; hMOOD && (pM=(MOOD*)HeapPtr(hMOOD)); hMOOD=pM->hNext) {
				if( tmpMood.flags2 & PF2_MIRROR_GRAPHICS ) {	// if mirroring, copy appropriate stuff everywhere and set MIRROR everywhere
					// copy:
					//	tmpMood.images
					strcpy(pM->images, tmpMood.images);
					pM->flags2 |= PF2_MIRROR_GRAPHICS;	// set MIRROR everywhere
				} else pM->flags2 &= ~PF2_MIRROR_GRAPHICS;	// if not mirroring, clear MIRROR everywhere
			}
		} else if( curCtls==IFSCtls ) {
			if( GetCheckID(ID_MIRROR_CHANGES) ) tmpMood.flags2 |= PF2_MIRROR_INTERFACE;
			else tmpMood.flags2 &= ~PF2_MIRROR_INTERFACE;
			
			for(i=0; i<numButtSize; i++) SendMsgID(ID_IF_SIZEBUTT0+i, WM_DESTROY, 0, 0, 0);

			for(hMOOD=CurPlayer.hFirstMood; hMOOD && (pM=(MOOD*)HeapPtr(hMOOD)); hMOOD=pM->hNext) {
				if( tmpMood.flags2 & PF2_MIRROR_INTERFACE ) {	// if mirroring, copy appropriate stuff everywhere and set MIRROR everywhere
					// copy:
					//	tmpMood.UIimage
					strcpy(pM->UIimage, tmpMood.UIimage);
					pM->UU = tmpMood.UU;
					pM->flags2 |= PF2_MIRROR_INTERFACE;	// set MIRROR everywhere
				} else pM->flags2 &= ~PF2_MIRROR_INTERFACE;	// if not mirroring, clear MIRROR everywhere
			}
		} else if( curCtls==LangCtls ) {
			if( GetCheckID(ID_MIRROR_CHANGES) ) tmpMood.flags2 |= PF2_MIRROR_LANGUAGE;
			else tmpMood.flags2 &= ~PF2_MIRROR_LANGUAGE;
			
			SendMsgID(ID_LANG_STRINGS, LBM_GETITEM, -1, (DWORD)ScratBuf, LBGI_TEXT);
			sprintf(tmpMood.StringsName, AddLangSTR, ScratBuf);
			SendMsgID(ID_LANG_HELP, LBM_GETITEM, -1, (DWORD)ScratBuf, LBGI_TEXT);
			sprintf(tmpMood.HelpName, AddLangHLP, ScratBuf);

			for(hMOOD=CurPlayer.hFirstMood; hMOOD && (pM=(MOOD*)HeapPtr(hMOOD)); hMOOD=pM->hNext) {
				if( tmpMood.flags2 & PF2_MIRROR_LANGUAGE ) {	// if mirroring, copy appropriate stuff everywhere and set MIRROR everywhere
					// copy:
					//	tmpMood.images
					strcpy(pM->HelpName, tmpMood.HelpName);
					strcpy(pM->StringsName, tmpMood.StringsName);
					pM->flags2 |= PF2_MIRROR_LANGUAGE;	// set MIRROR everywhere
				} else pM->flags2 &= ~PF2_MIRROR_LANGUAGE;	// if not mirroring, clear MIRROR everywhere
			}
			// force update of status outputs on toolbar
			Game.LastMoves = -1;
			Game.LastBest = -1;
		} else if( curCtls==MusicCtls ) {
			DWORD		f=tmpMood.flags & PF_RAND_MUSIC;
			DWORD		hM;
			FILELIST	*pMU;
			
			if( GetCheckID(ID_MIRROR_CHANGES) ) tmpMood.flags2 |= PF2_MIRROR_MUSIC;
			else tmpMood.flags2 &= ~PF2_MIRROR_MUSIC;

			MusicDlgStop = FALSE;
			tmpMood.flags &= ~MUSIC_FLAGS;
			
			if( GetCheckID(ID_RANDMUSIC  ) ) {
				if( f ^ (tmpMood.flags & PF_RAND_MUSIC) ) {
					for(hM=tmpMood.hBackMusic; hM && (pMU=((FILELIST*)HeapPtr(hM))); hM=pMU->hNext) pMU->flags |= MUF_PLAYED;
					for(hM=tmpMood.hWinMusic;  hM && (pMU=((FILELIST*)HeapPtr(hM))); hM=pMU->hNext) pMU->flags |= MUF_PLAYED;
				}
				tmpMood.flags |= PF_RAND_MUSIC;
			}
			if( GetCheckID(ID_PLAYBACK) ) tmpMood.flags |= PF_BACK_MUSIC;
			if( GetCheckID(ID_PLAYWIN) ) tmpMood.flags |= PF_WIN_MUSIC;
			if( IsMusic() ) {
				if( !(tmpMood.flags & PF_BACK_MUSIC) ) StopMusic();
			}
			hMusicFocus = 0;
			
			for(i=0, hMOOD=CurPlayer.hFirstMood; hMOOD && (pM=(MOOD*)HeapPtr(hMOOD)); ++i, hMOOD=pM->hNext) {
				if( tmpMood.flags2 & PF2_MIRROR_MUSIC ) {	// if mirroring, copy appropriate stuff everywhere and set MIRROR everywhere
					pM->flags = (pM->flags & ~MUSIC_FLAGS) | (tmpMood.flags & MUSIC_FLAGS);	// copy flags
					
					if( i!=CurPlayer.CurMoodNum ) {	// if this mood is not the CURRENT (tmpMood) mood
						// we've deleted a music file from tmpMood, delete it from all other moods if there
						hN = pM->hBackMusic;
						hP = 0;
						
						while( hN && (pN=(FILELIST*)HeapPtr(hN)) ) {
							for(hT=tmpMood.hBackMusic, hTP=0; hT && (pT=(FILELIST*)HeapPtr(hT)); hTP=hT, hT=pT->hNext) {
								if( !strcmp(pN->name, pT->name) ) break;
							}
							if( hT==0 ) {	// didn't find hN in tmpMood, remove it
								if( hP ) {	// not the first music file
									pP = (FILELIST*)HeapPtr(hP);
									pP->hNext = pN->hNext;	// unlink it from the chain
									HeapFree(hN);	// free it
									hN = pP->hNext;
								} else {	// is the first music file
									pM->hBackMusic = pN->hNext;	// unlink it from the start of the chain
									HeapFree(hN);	// free it
									hN = pM->hBackMusic;
								}
								--pM->BackMusicCnt;
							} else {
								hP = hN;
								hN = pN->hNext;
							}
						}
						// we've added a music file to tmpMood, add it to all other moods if not already there
						hT = tmpMood.hBackMusic;
						hTP = 0;
						
						while( hT && (pT=(FILELIST*)HeapPtr(hT)) ) {
							for(hN=pM->hBackMusic, hP=0; hN && (pN=(FILELIST*)HeapPtr(hN)); hP=hN, hN=pN->hNext) {
								if( !strcmp(pN->name, pT->name) ) break;
							}
							if( hN==0 ) {	// didn't find hT in this mood, add it
								hN = HeapAlloc(sizeof(FILELIST));
								pN = (FILELIST*)HeapPtr(hN);
								pN->hNext = pM->hBackMusic;
								pN->flags = 0;
								strcpy(pN->name, pT->name);
								pM->hBackMusic = hN;
								++pM->BackMusicCnt;
							} else {
								hTP = hT;
								hT = pT->hNext;
							}
						}
						
						// we've deleted a music file from tmpMood, delete it from all other moods if there
						hN = pM->hWinMusic;
						hP = 0;
						
						while( hN && (pN=(FILELIST*)HeapPtr(hN)) ) {
							for(hT=tmpMood.hWinMusic, hTP=0; hT && (pT=(FILELIST*)HeapPtr(hT)); hTP=hT, hT=pT->hNext) {
								if( !strcmp(pN->name, pT->name) ) break;
							}
							if( hT==0 ) {	// didn't find hN in tmpMood, remove it
								if( hP ) {	// not the first music file
									pP = (FILELIST*)HeapPtr(hP);
									pP->hNext = pN->hNext;	// unlink it from the chain
									HeapFree(hN);	// free it
									hN = pP->hNext;
								} else {	// is the first music file
									pM->hWinMusic = pN->hNext;	// unlink it from the start of the chain
									HeapFree(hN);	// free it
									hN = pM->hWinMusic;
								}
								--pM->WinMusicCnt;
							} else {
								hP = hN;
								hN = pN->hNext;
							}
						}
						// we've added a music file to tmpMood, add it to all other moods if not already there
						hT = tmpMood.hWinMusic;
						hTP = 0;
						
						while( hT && (pT=(FILELIST*)HeapPtr(hT)) ) {
							for(hN=pM->hWinMusic, hP=0; hN && (pN=(FILELIST*)HeapPtr(hN)); hP=hN, hN=pN->hNext) {
								if( !strcmp(pN->name, pT->name) ) break;
							}
							if( hN==0 ) {	// didn't find hT in this mood, add it
								hN = HeapAlloc(sizeof(FILELIST));
								pN = (FILELIST*)HeapPtr(hN);
								pN->hNext = pM->hWinMusic;
								pN->flags = 0;
								strcpy(pN->name, pT->name);
								pM->hWinMusic = hN;
								++pM->WinMusicCnt;
							} else {
								hTP = hT;
								hT = pT->hNext;
							}
						}
					}
					pM->flags2 |= PF2_MIRROR_MUSIC;	// set MIRROR everywhere
				} else pM->flags2 &= ~PF2_MIRROR_MUSIC;	// if not mirroring, clear MIRROR everywhere
			}
		} else if( curCtls==MouseMapCtls ) {
			if( GetCheckID(ID_MIRROR_CHANGES) ) tmpMood.flags2 |= PF2_MIRROR_MOUSE;
			else tmpMood.flags2 &= ~PF2_MIRROR_MOUSE;

			tmpMood.flags &= ~MOUSE_FLAGS;
			if( GetCheckID(ID_REV_WHEEL) ) tmpMood.flags |= PF_REV_WHEEL;
			if( GetCheckID(ID_REV_TILT) ) tmpMood.flags |= PF_REV_TILT;
			
			for(hMOOD=CurPlayer.hFirstMood; hMOOD && (pM=(MOOD*)HeapPtr(hMOOD)); hMOOD=pM->hNext) {
				if( tmpMood.flags2 & PF2_MIRROR_MOUSE ) {	// if mirroring, copy appropriate stuff everywhere and set MIRROR everywhere
					// copy:
					//	tmpMood.Actions[]
					//	tmpMood.flags & (PF_REV_WHEEL | PF_REV_TILT)
					//	tmpMood.flags2 & PF2_MIRROR_MOUSE
					memcpy(&pM->Actions[0], &tmpMood.Actions[0], sizeof(tmpMood.Actions));	// copy actions
					pM->flags = (pM->flags & ~MOUSE_FLAGS) | (tmpMood.flags & MOUSE_FLAGS);	// copy flags
					pM->flags2 |= PF2_MIRROR_MOUSE;	// set MIRROR everywhere
				} else pM->flags2 &= ~PF2_MIRROR_MOUSE;	// if not mirroring, clear MIRROR everywhere
			}
		} else if( curCtls==KeyMapCtls ) {
			if( GetCheckID(ID_MIRROR_CHANGES) ) tmpMood.flags2 |= PF2_MIRROR_KEYS;
			else tmpMood.flags2 &= ~PF2_MIRROR_KEYS;

			memcpy((BYTE*)&tmpMood.KeyMaps, (BYTE*)&WorkKeyMaps, sizeof(tmpMood.KeyMaps));
			tmpMood.KeyMapsCnt = WorkKeyMapsCnt;
			
			for(hMOOD=CurPlayer.hFirstMood; hMOOD && (pM=(MOOD*)HeapPtr(hMOOD)); hMOOD=pM->hNext) {
				if( tmpMood.flags2 & PF2_MIRROR_KEYS ) {	// if mirroring, copy appropriate stuff everywhere and set MIRROR everywhere
					// copy:
					//	tmpMood.KeyMaps[]
					//	tmpMood.KeyMapsCnt
					//	tmpMood.flags2 & PF2_MIRROR_KEYS
					memcpy((BYTE*)&pM->KeyMaps[0], (BYTE*)&tmpMood.KeyMaps[0], sizeof(tmpMood.KeyMaps));	// copy key maps
					pM->KeyMapsCnt = tmpMood.KeyMapsCnt;	// copy count
					pM->flags2 |= PF2_MIRROR_KEYS;	// set MIRROR everywhere
				} else pM->flags2 &= ~PF2_MIRROR_MOUSE;	// if not mirroring, clear MIRROR everywhere
			}
		} else if( curCtls==OptionsCtls ) {
			if( GetCheckID(ID_MIRROR_CHANGES) ) tmpMood.flags2 |= PF2_MIRROR_OPTIONS;
			else tmpMood.flags2 &= ~PF2_MIRROR_OPTIONS;

			tmpMood.flags &= ~OPTION_FLAGS;
			
			if( GetCheckID(ID_BYPASS_TITLE  ) ) tmpMood.flags |= PF_BYPASS_TITLE;
			if( GetCheckID(ID_GAMESOUNDS    ) ) tmpMood.flags |= PF_GAMESOUNDS;
			if( GetCheckID(ID_ERRORSOUNDS   ) ) tmpMood.flags |= PF_ERRORSOUNDS;
			if( GetCheckID(ID_PROMPTNEXT    ) ) tmpMood.flags |= PF_PROMPTNEXT;
			if( GetCheckID(ID_PROMPTRESTART ) ) tmpMood.flags |= PF_PROMPTRESTART;
			if( GetCheckID(ID_ENABLECLICK   ) ) tmpMood.flags |= PF_ENABLECLICK;
			if( GetCheckID(ID_STARTBOTTOM   ) ) tmpMood.flags |= PF_STARTBOTTOM;
			if( GetCheckID(ID_SCRAMBLEORDER ) ) tmpMood.flags |= PF_SCRAMBLEORDER;
			if( GetCheckID(ID_SHOWTIMER     ) ) tmpMood.flags |= PF_SHOWTIMER;
			if( GetCheckID(ID_REMOVE_PAUSE  ) ) tmpMood.flags |= PF_REMOVE_PAUSE;
			if( GetCheckID(ID_SHOWTILESMOVED) ) tmpMood.flags |= PF_SHOWTILESMOVED;
			if( GetCheckID(ID_SHOWBESTCOUNT ) ) tmpMood.flags |= PF_SHOWBESTCOUNT;
			if( GetCheckID(ID_SHOW_TOOLTIPS ) ) tmpMood.flags |= PF_SHOW_TOOLTIPS;

			for(tmpMood.WinDisp=0; !GetCheckID(ID_WIN_FIRE+tmpMood.WinDisp); ++tmpMood.WinDisp) ;
			tmpMood.WinSpeed = SendMsgID(ID_WIN_SPEED, ELM_GETNUM, 0, 0, 0);
			tmpMood.WinDelay = SendMsgID(ID_WIN_DELAY, ELM_GETNUM, 0, 0, 0);
			tmpMood.LimitPuzzSize = SendMsgID(ID_PUZZLE_SIZE, ELM_GETNUM, 0, 0, 0);
			if( tmpMood.LimitPuzzSize<50 )  tmpMood.LimitPuzzSize = 50;
			if( tmpMood.LimitPuzzSize>100 ) tmpMood.LimitPuzzSize = 100;
			SendMsgID(ID_CSV_SEP, ELM_GETTEXT, (DWORD)ScratBuf, 2, 0);
			if( ScratBuf[0] ) tmpMood.CSVsep = ScratBuf[0];
			else tmpMood.CSVsep = ',';
			
			for(hMOOD=CurPlayer.hFirstMood; hMOOD && (pM=(MOOD*)HeapPtr(hMOOD)); hMOOD=pM->hNext) {
				if( tmpMood.flags2 & PF2_MIRROR_OPTIONS ) {	// if mirroring, copy appropriate stuff everywhere and set MIRROR everywhere
					// copy:
					//	tmpMood.flags & (PF_REV_WHEEL | PF_REV_TILT)
					//	tmpMood.WinDisp, tmpMood.WinSpeed, tmpMood.WinDelay
					//	tmpMood.flags2 & PF2_MIRROR_MOUSE
					pM->flags = (pM->flags & ~OPTION_FLAGS) | (tmpMood.flags & OPTION_FLAGS);	// copy flags
					pM->WinDisp = tmpMood.WinDisp;
					pM->WinSpeed = tmpMood.WinSpeed;
					pM->WinDelay = tmpMood.WinDelay;
					pM->LimitPuzzSize = tmpMood.LimitPuzzSize;
					pM->flags2 |= PF2_MIRROR_OPTIONS;	// set MIRROR everywhere
				} else pM->flags2 &= ~PF2_MIRROR_OPTIONS;	// if not mirroring, clear MIRROR everywhere
			}
		} else if( curCtls==ExitCtls ) {
			
		} else SystemMessage("Programmer oops: SaveMenuCtls() curCtls");
	}
}

//=======================================================================
void DelMood() {
	
	long	i;
	DWORD	hMOOD, hPREV;
	MOOD	*pMOOD;
	QWORD	qw;
	WNDPOS	wndPos;
	
// Prompt and delete current mood, then switch menu to CHANGE MOOD and load the first mood
	if( CurPlayer.MoodCnt>1 && ID_YES==MessageBox(KString(BLK_DLG, STR_CNFRM_DELMOOD), MB_YESNO) ) {
		// Free current player mood
		for(i=0, hPREV=0, hMOOD=CurPlayer.hFirstMood; hMOOD && (pMOOD=(MOOD*)HeapPtr(hMOOD)) && strcmp(tmpMood.name, pMOOD->name); ++i, hPREV=hMOOD, hMOOD=pMOOD->hNext) ;
		if( hMOOD ) {
			// remove this mood from the chain of moods
			if( hPREV ) ((MOOD*)HeapPtr(hPREV))->hNext = pMOOD->hNext;
			else CurPlayer.hFirstMood = pMOOD->hNext;
			--CurPlayer.MoodCnt;
			sprintf(ScratBuf, iniMOOD, CurPlayer.id, CurPlayer.MoodCnt);	// iniDelSec the last player's mood from the ini file
			if( iniFindSec(ScratBuf) ) iniDelSec();
			
			CurPlayer.CurMoodNum = 0;	// change mood# to the first one
			// preserve mood #1's wndPos, as otherwise the EndPlayer() would save the CURRENT window position
			memcpy((BYTE*)&wndPos, (BYTE*)&((MOOD*)HeapPtr(CurPlayer.hFirstMood))->wndPos, sizeof(WNDPOS));
			SetWndPos(&wndPos);
			EndPlayer();	// write all the moods out with the (new) proper #s
			StartPlayer(TRUE);	// reload the player and first mood cleanly
			
			memcpy((BYTE*)&tmpMood, (BYTE*)&CurMood, sizeof(MOOD));
			strcpy(MenuMoodName, tmpMood.name);
			
			if( CurPlayer.MoodCnt>1 ) {
				// switch to CHANGE MOOD menu
				SendMsgID(ID_MENU_MOOD_SEL, WM_ACTIVATE, 0, 0, 0);
				SetFocusID(ID_MENU_MOOD_SEL);
			} else {
				// switch to OPTIONS menu
				SendMsgID(ID_MENU_OPTIONS, WM_ACTIVATE, 0, 0, 0);
				SetFocusID(ID_MENU_OPTIONS);
			}
		}
		if( CurPlayer.MoodCnt<2 ) {
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_DEL)))->flags |= CF_DISABLED;
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_SEL)))->flags |= CF_DISABLED;
		} else {
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_DEL)))->flags &= ~CF_DISABLED;
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_SEL)))->flags &= ~CF_DISABLED;
		}
		InvalidateAllWnd(FindWndID(ID_MENU_CURMOOD));
		UpdateTitleBar();
		// now let hMain know that the window (may have) changed, for resizing
		qw = GetViewSize();
		ViewW = (DWORD)(qw & 0xFFFFFFFF);
		ViewH = (DWORD)(qw>>32);
		SendMsg(hMain, WM_PARENTSIZED, 0, 0, 0);
	}
}

//=======================================================================
void DelPlayer() {

	long	h, i;
	
// if DELETE PLAYER got activated, prompt and delete current player, then switch to CHANGE PLAYER and load the first player
	if( ID_YES==MessageBox(KString(BLK_DLG, STR_CNFRM_DELPLYR), MB_YESNO) ) {
		// Free current player moods
		h = CurPlayer.MoodCnt;
		EndPlayer();
		
		// iniDelSec player moods
		for(i=0; i<h; i++) {
			sprintf(ScratBuf, iniMOOD, CurPlayer.id, i);	// format name of mood section
			if( iniFindSec(ScratBuf) ) iniDelSec();
		}

		// iniDelSec player
		sprintf(ScratBuf, iniPLAYER, CurPlayer.id);
		if( iniFindSec(ScratBuf) ) {
			iniDelSec();
			if( --NumPlayers<2 ) {
				((WND*)HeapPtr(FindWndID(ID_MENU_PLYR_DEL)))->flags |= CF_DISABLED;
				((WND*)HeapPtr(FindWndID(ID_MENU_PLYR_SEL)))->flags |= CF_DISABLED;
			}
		}

		// find first player, set CurPlayer.id to its #, and StartPlayer()
		for(i=0; i<=maxID; i++) {
			sprintf(ScratBuf, iniPLAYER, i);
			if( iniFindSec(ScratBuf) ) break;
		}
		if( i>maxID ) SystemMessage("Programmer's oops: couldn't find a player");
		else {
			CurPlayer.id = i;
			StartPlayer(TRUE);
			memcpy((BYTE*)&tmpMood, (BYTE*)&CurMood, sizeof(MOOD));
			if( NumPlayers>1 ) {
				// switch to CHANGE PLAYER menu
				SendMsgID(ID_MENU_PLYR_SEL, WM_ACTIVATE, 0, 0, 0);
				SetFocusID(ID_MENU_PLYR_SEL);
			} else {
				// switch to OPTIONS menu
				SendMsgID(ID_MENU_OPTIONS, WM_ACTIVATE, 0, 0, 0);
				SetFocusID(ID_MENU_OPTIONS);
			}
		}
		if( CurPlayer.MoodCnt<2 ) {
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_DEL)))->flags |= CF_DISABLED;
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_SEL)))->flags |= CF_DISABLED;
		} else {
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_DEL)))->flags &= ~CF_DISABLED;
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_SEL)))->flags &= ~CF_DISABLED;
		}
	}
}

//=======================================================================
void ReloadCtls() {
	
	DLGRES	*pSC;
	long	SMCSID;
	
	if( curCtls!=NULL ) {
		pSC = curCtls;
		SMCSID = MenuCurSelID;

		++BlockPaint;

		SaveMenuCtls();	// save values from controls to tmpMood
		DestroyMenuCtls(curCtls);
		InvalidateAllWnd(hMenuDlg);

		MenuCurSelID = SMCSID;

		// now create controls for this menu item and initialize them from tmpMood
		AddMenuCtls(pSC, 1);
		--BlockPaint;

		InvalidateAllWnd(hMenuDlg);

		UpdateInvalid();
	}
}

//=======================================================================
DWORD MenuItemProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	RADIOBUTT	*pW;
	RECT		r, ri, rc;
	long		i, x, y, w, h, align, th;
	DWORD		clrs[2], *pClrs, dw;
	DWORD		hF, hMOOD, hPREV, hN;
	MOOD		*pMOOD;
	WND			*pF, *pN;
	QWORD		qw;
	DLGRES		*pDR;
	char		*pMT, *pA;
	
	
	pW = (RADIOBUTT*)HeapPtr(hW);
	switch( msg ) {
	 case WM_ACTIVATE:
		if( MenuCurSelID != pW->id ) {
			++BlockPaint;
			
				if( curCtls!=NULL ) {
					SaveMenuCtls();	// save values from controls to tmpMood
					DestroyMenuCtls(curCtls);
					InvalidateAllWnd(hMenuDlg);
					if( pW->id==ID_MENU_EXIT ) UpdateInvalid();
					i = 0;	// don't set focus
				} else i = 1;	// set focus

				MenuCurSelID = pW->id;

				RadioButtonProc(hW, msg, arg1, arg2, arg3);	// to 'select' the 'radiobutton' menu
				
				// now create controls for this menu item and initialize them from tmpMood
				AddMenuCtls(pW->pRES->xx, i);
			--BlockPaint;
			InvalidateAllWnd(hMenuDlg);
		} else InvalidateAllWnd(hW);
		UpdateInvalid();
		return 0;
	 case WM_NOTIFY:
		switch( arg1 ) {
		 case WN_STRINGS_RELOADED:
			break;
		}
		break;
	 case WM_SETFOCUS:
		break;
	 case WM_GETCOLORS:
		pClrs = (DWORD*)arg1;
		if( pW->flags & CF_DISABLED ) {
			pClrs[0] = Colors[ClrTEXTfillNORM];
			pClrs[1] = Colors[ClrTEXTtextDISABLED];
		} else if( hW==hFocus ) {
			pClrs[0] = Colors[ClrTEXTfillFOCUS];
			pClrs[1] = Colors[ClrTEXTtextFOCUS];
		} else if( pW->id==MenuCurSelID ) {
			pClrs[0] = Colors[ClrTEXTfillCUR];
			pClrs[1] = Colors[ClrTEXTtextCUR];
		} else if( hW==hHover ) {
			pClrs[0] = Colors[ClrTEXTfillHOVER];
			pClrs[1] = Colors[ClrTEXTtextHOVER];
		} else {
			pClrs[0] = Colors[ClrTEXTfillNORM];
			pClrs[1] = Colors[ClrTEXTtextNORM];
		}
		return 0;
	 case WM_PAINT:
		GetRectWnd(hW, &r);
		GetRectInvalid(&ri);
		if( IntersectRect(&ri, &r) ) {
			ClipRectBM(0, ri, &rc);

			x = r.x;
			y = r.y;
			w = r.w;
			h = r.h;

			SendMsg(hW, WM_GETCOLORS, (DWORD)&clrs[0], 0, 0);

			DrawRectBM(0, x, y, w, h, clrs[0], CLR_NONE);

			if( pW->text ) {
				th = TEXTH+1;
				do {
					--th;
					dw = DrawTextBM(0, (char*)pW->text, x+UU, y+TEXTYSPACE, w-2*UU, th, (pW->flags & TF_CLEAR) | TF_GET_WIDTH, CLR_NONE, clrs[1]);
				} while( th>1 && (dw>>16) > w-2*UU );
				DrawTextBM(0, (char*)pW->text, x+UU, y+(UU4-th)/2, w-2*UU, th, pW->flags & TF_CLEAR, CLR_NONE, clrs[1]);
			}
			
			ClipRectBM(0, rc, NULL);
		}
		return 0;
	 case WM_CHAR:
		if( IsMenuKey ) {
			IsMenuKey = FALSE;
			return 0;
		}
		pA = (char*)arg1;	// get ptr to (possibly UTF8) char
		if( *pA>=0 && *pA<=127 ) {
			ScratBuf[0] = pA[0];
			ScratBuf[1] = 0;
		} else if( (*pA & 0xF8)==0xF0 ) {	// 4-byte UTF8 char
			*(DWORD*)ScratBuf = *(DWORD*)pA;
			ScratBuf[4] = 0;
		} else if( (*pA & 0xF0)==0xE0 ) {	// 3-byte UTF8 char
			ScratBuf[0] = pA[0];
			ScratBuf[1] = pA[1];
			ScratBuf[2] = pA[2];
			ScratBuf[3] = 0;
		} else if( (*pA & 0xE0)==0xC0 ) {	// 2-byte UTF8 char
			*(WORD*)ScratBuf = *(WORD*)pA;
			ScratBuf[2] = 0;
		} else goto keyill;
		charupper(ScratBuf);
		strcpy(ScratBuf+32, ScratBuf);
		
		for(pDR=&MenuDlg[0]; pDR->id && pDR->id!=MenuCurSelID; ++pDR) ;	// find currently selected menu item
		x = ID_OK;
dotop:	
		for(++pDR; pDR->id && pDR->id!=x; pDR++) {	// find next one starting with this letter before end of list
			if( (hF = FindWndID(pDR->id)) ) {
				pF = (WND*)HeapPtr(hF);
				if( !(pF->flags & CF_DISABLED) ) {
					pMT = (char*)pF->text;	// get ptr to (possibly UTF8) menu label
					if( *pMT>=0 && *pMT<=127 ) {
						ScratBuf[0] = pMT[0];
						ScratBuf[1] = 0;
					} else if( (*pMT & 0xF8)==0xF0 ) {	// 4-byte UTF8 char
						*(DWORD*)ScratBuf = *(DWORD*)pMT;
						ScratBuf[4] = 0;
					} else if( (*pMT & 0xF0)==0xE0 ) {	// 3-byte UTF8 char
						ScratBuf[0] = pMT[0];
						ScratBuf[1] = pMT[1];
						ScratBuf[2] = pMT[2];
						ScratBuf[3] = 0;
					} else if( (*pMT & 0xE0)==0xC0 ) {	// 2-byte UTF8 char
						*(WORD*)ScratBuf = *(WORD*)pMT;
						ScratBuf[2] = 0;
					} else goto keyill;
					charupper(ScratBuf);
					if( !strcmp(ScratBuf, ScratBuf+32) ) break;
				}
			}
		}
		if( pDR->id!=x ) {	// found a match, jump to it
			SendMsgID(pDR->id, WM_ACTIVATE, 0, 0, 0);
			SetFocusID(pDR->id);
			return 0;
		}
		if( x==ID_OK ) {
			x = MenuCurSelID;
			pDR = &MenuDlg[1];	// point to ID_MENU_GROUP, which will get incremented to ID_MENU_HELP
			goto dotop;
		}
keyill:
		BeepIll();
		return 0;
	 case WM_KEYUP:
		// first, check to see if it's the MENU open/close key
		for(i=0; i<tmpMood.KeyMapsCnt; i++) {
			if( arg1==(DWORD)tmpMood.KeyMaps[i].key && (KeyFlags & (MK_SHIFT | MK_CTL))==(DWORD)tmpMood.KeyMaps[i].flags ) {
				if( tmpMood.KeyMaps[i].func==KF_MENU_DLG ) {
					SendMsgID(ID_MENU_BUTT_CLOSE, WM_ACTIVATE, ID_OK, 0, 0);
					return 0;
				}
			}
		}
		break;
	 case WM_KEYDN:
		// first, check to see if it's the MENU open/close key
		for(i=0; i<tmpMood.KeyMapsCnt; i++) {
			if( arg1==(DWORD)tmpMood.KeyMaps[i].key && (KeyFlags & (MK_SHIFT | MK_CTL))==(DWORD)tmpMood.KeyMaps[i].flags ) {
				if( tmpMood.KeyMaps[i].func==KF_MENU_DLG ) {
					IsMenuKey = TRUE;	// alpha keys that MENU might be mapped to won't also activate matching MENU ITEM first letters
					return 0;
				}
			}
		}
		IsMenuKey = FALSE;
		// if not MENU open/close, then process other special keys
		switch( arg1 ) {
		 case K_ENTER:
			if( pW->id==ID_MENU_EXIT || pW->id==ID_MENU_MOOD_DEL || pW->id==ID_MENU_PLYR_DEL ) goto idaction;
			break;
		 case K_DNCURS:
			if( pW->id==ID_MENU_OPTIONS || (pW->id==ID_MENU_PLYR_REN && (((WND*)HeapPtr(FindWndID(ID_MENU_OPTIONS)))->flags & CF_DISABLED)) ) return 0;
			break;
		 case K_RTCURS:
			for(hF=((WND*)HeapPtr(hMenuDlg))->child1; hF && (pF=(WND*)HeapPtr(hF)) && !(pF->flags & CF_FOCUS); hF=pF->nextSib) ;
			if( hF ) {
				pF = ((WND*)HeapPtr(hF));
				// if RadioButton, find the currently selected button in the group and select it
				if( pF->type==WT_RADIOBUTTON ) {
					// find start of group of radio buttons
					for(hN=hF; hN && (pN=((WND*)HeapPtr(hN))) && !(pN->flags & CF_GROUP); hN=pN->nextSib) ;
					// now search forward, as long as hN && WT_RADIOBUTTON && !focus
					for(; hN && (pN=((WND*)HeapPtr(hN))) && pN->type==WT_RADIOBUTTON && !(pN->flags & CF_CHECKED); hN=pN->nextSib) ;
					// if didn't find a checked radiobutton, go ahead with hF (the CF_FOCUS button)
					if( pN->type==WT_RADIOBUTTON && (pN->flags & CF_CHECKED) ) hF = hN;
				}
			}
			if( hF ) SetFocus(hF);
			return 0;
		}
		break;
	 case WM_HOVER:
		SetCursor(CURSOR_NORMAL);
		break;
	 case WM_LBUTTDN:
		break;
	 case WM_LBUTTUP:
idaction:
		if( pW->flags & CF_DISABLED ) {
			BeepIll();
			return 0;
		}
		if( pW->id==ID_MENU_EXIT ) {
			SaveMenuCtls();
			SendMsg(hMain, WM_QUERY_QUIT, 0, 0, 0);
		}
		if( pW->id==ID_MENU_MOOD_DEL ) {
			DelMood();
			if( curCtls==SelMoodCtls ) ReloadCtls();
			return 0;
		}
		if( pW->id==ID_MENU_PLYR_DEL ) {
			DelPlayer();
			if( curCtls==SelPlyCtls ) ReloadCtls();
			return 0;
		}
		break;
	}
	return RadioButtonProc(hW, msg, arg1, arg2, arg3);
}

//=======================================================================
DWORD MenuSpaceProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	TEXT		*pW;
	DLGRES		*pDR;
	RECT		r, ri, rc;
	long		x, y, dx, ex, sh;
	
	if( msg!=WM_CREATE ) pW = (TEXT*)HeapPtr(hW);
	switch( msg ) {
	 case WM_CREATE:
		pDR = (DLGRES*)arg1;
		hW = AllocateWnd(pDR->id, pDR->type, pDR->ux*UU, pDR->uy*UU, pDR->uw*UU, pDR->uh*UU, pDR->flags, arg2, MenuSpaceProc, sizeof(TEXT));
		pW = (TEXT*)HeapPtr(hW);
		pW->pRES = pDR;
		pW->text = (DWORD)pDR->pText;
		InvalidateAllWnd(hW);
		return hW;
	 case WM_PAINT:
		if( pW->text ) {	// if need to show 'line'
			GetRectWnd(hW, &r);
			GetRectInvalid(&ri);
			if( IntersectRect(&ri, &r) ) {
				ClipRectBM(0, ri, &rc);
			
				if( pW->text > 1 ) {
					x = X_SEPLINE*UIBMU;
					y = Y_SEPLINE*UIBMU;
					sh = UIBMU;
				} else {
					x = X_MOODLINE*UIBMU;
					y = Y_MOODLINE*UIBMU;
					sh = UIBMU2;
				}
				dx= r.x;
				ex = r.x+r.w-UU2;
				
				DrawBM(0, dx, r.y, hUIBM, x, y, UIBMU2, sh, 0);
				
				x  += UIBMU2;
				dx += UU2;
				
				RepDrawBM(0, dx, r.y, hUIBM, x, y, UIBMU4, sh, 0, ex, 0);
				
				x += UIBMU4;
				DrawBM(0, ex, r.y, hUIBM, x, y, UIBMU2, sh, 0);

				ClipRectBM(0, rc, NULL);
			}
		}
		return 0;
	 case WM_LBUTTDN:
		IgnoreMouseUp = TRUE;
		return 0;
	 case WM_LBUTTUP:
		return 0;
	}
	return DefWndProc(hW, msg, arg1, arg2, arg3);
}

//=======================================================================
DWORD MenuGroupboxProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	WND			*pW;
	
	pW = (WND*)HeapPtr(hW);
	switch( msg ) {
	 case WM_LBUTTDN:
		// make sure focus doesn't get set to a non-curMenu item via an errant click
		IgnoreMouseUp = TRUE;
		return 0;
	}
	return GroupboxProc(hW, msg, arg1, arg2, arg3);
}

//=========================================================================
void UpdateCurMood() {
	
	DWORD	hMOOD;
	MOOD	*pMOOD;
	long	i;

	for(i=0, hMOOD=CurPlayer.hFirstMood; hMOOD && (pMOOD=(MOOD*)HeapPtr(hMOOD)) && i<CurPlayer.CurMoodNum; i++, hMOOD=pMOOD->hNext) ;
	if( hMOOD ) memcpy((BYTE*)pMOOD, (BYTE*)&CurMood, sizeof(MOOD));
	else SystemMessage("Programmer's oops: player's mood not found");
}

//=========================================================================
void SaveMoodChanges() {
	
	DWORD	f;
	
	// determine if things changed that need updating immediately
	f = CurMood.flags ^ tmpMood.flags;

	memcpy((BYTE*)&CurMood, (BYTE*)&tmpMood, sizeof(MOOD));	// save working copy of settings
	UpdateCurMood();

	if( f & PF_SCRAMBLEORDER ) {
		RandomizeTiles();
		NeedDrawAll = TRUE;
	}
	if( f & PF_STARTBOTTOM ) {
		if( 0==Game.DoCnt ) SetJustifyCols((tmpMood.flags & PF_STARTBOTTOM) ? 2 : 1);
	}
}

//=========================================================================
void UpdateUUsize() {
	
	HWND		hW;
	long		i;
	
	for(i=0; i<numButtSize; i++) {
		hW = FindWndID(ID_IF_SIZEBUTT0+i);
		if( hW && ((WND*)HeapPtr(hW))->flags & CF_CHECKED ) break;
	}
	if( i<numButtSize ) {
		tmpMood.UU = i;
		SetupUUvars();
		if( tmpMood.UU ) ShowWnd(FindWndID(ID_IF_SIZE), SW_HIDE);
		else {
			ShowWnd(FindWndID(ID_IF_SIZE), SW_SHOW);
			sprintf(IFsizeStr, KString(BLK_DLG, STR_IF_SIZE), UU);
		}
		--((WND*)HeapPtr(hMain))->w;	// to force hMain to think the size HAS changed
		SendMsg(hMain, WM_PARENTSIZED, 0, 0, 0);
	}
}

//=========================================================================
void GoHelp(char *pagnam, long mark) {
	
	WND			*pTitleW;
	WNDSCROLL	*pTextW;
	long		page;

	for(page=0; page<NumHelpPages; page++) if( !strcmp(pagnam, HelpPageNames[page]) ) break;
	
	SetCursor(CURSOR_NORMAL);
	HelpCursor = 0;
	if( CurHelpPage<2 ) {
		if( page>=2 ) {	// change title window to smaller size
			pTitleW = ((WND*)HeapPtr(FindWndID(ID_HELP_TITLE)));
			pTextW = ((WNDSCROLL*)HeapPtr(FindWndID(ID_HELP_TEXT)));
			if( HelpCtls[1].uh>6 ) {
				HelpCtls[1].uh -= 8;
				HelpCtls[2].uh += 8;
				HelpCtls[2].uy -= 8;
				pTitleW->h   = HelpCtls[1].uh*UU;
				pTextW->h    = HelpCtls[2].uh*UU;
				pTextW->yoff = HelpCtls[2].uy*UU;
				SendMsgID(ID_HELP_TEXT, WM_COMMAND, WC_SETSURFSIZE, 1, 1);
			}
		}
	} else {
		if( page<2 ) {	// change title window to larger size
			pTitleW = ((WND*)HeapPtr(FindWndID(ID_HELP_TITLE)));
			pTextW = ((WNDSCROLL*)HeapPtr(FindWndID(ID_HELP_TEXT)));
			if( HelpCtls[1].uh<14 ) {
				HelpCtls[1].uh += 8;
				HelpCtls[2].uh -= 8;
				HelpCtls[2].uy += 8;
				pTitleW->h   = HelpCtls[1].uh*UU;
				pTextW->h    = HelpCtls[2].uh*UU;
				pTextW->yoff = HelpCtls[2].uy*UU;
				SendMsgID(ID_HELP_TEXT, WM_COMMAND, WC_SETSURFSIZE, 1, 1);
			}
		}
	}
	CurHelpPage = page;
	CurHelpMark = mark;

	HelpChange();
	SendMsgID(ID_HELP_TEXT, WM_COMMAND, WC_SETSCROLLPOS, 0, mark);
	InvalidateAllWND(hMenuDlg);
}

//=========================================================================
DWORD MenuDlgProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	HWND		hC, hS, hF, hN, hT;
	WND			*pC, *pS, *pF, *pN, *pTitleW;
	WNDSCROLL	*pTextW;
	DIALOG		*pW;
	RECT		r, mr, ri;
	long		i, x, y, w, h;
	DWORD		msgbuf[4];
	SBINFO		sbi;

	pW = (DIALOG*)HeapPtr(hW);
	switch( msg ) {
	 case WM_CREATE:
		hMenuDlg = hW;
		GraphicsBad = FALSE;	// clear flag that indicates if GameGraphics need to be reloaded at exit from the dialog
		
		// Dialog is created, copy all permanent settings to temp variables.
		memcpy((BYTE*)&tmpMood, (BYTE*)&CurMood, sizeof(MOOD));	// get working copy of settings
		curCtls = NULL;
		strcpy(MenuMoodName, tmpMood.name);	// for showing mood name on MENU (DLGRES control needs constant, non-calculated address)

		// Save current/previous 'current' menu selection, and change it to 'nothing'
		// so that when we SetCheck() it, that item will get a WM_ACTIVATE and set up its controls.
		// Otherwise, no WM_ACTIVATE would get sent and the controls for that item wouldn't get created
		// when the menu dialog was opened.
		i = MenuCurSelID;

		if( GoHelpName[0] ) i = ID_MENU_HELP;
		MenuCurSelID = -1;

		SetCheckID(i, TRUE);
		SetFocusID(i);

		if( NumPlayers<2 ) {
			((WND*)HeapPtr(FindWndID(ID_MENU_PLYR_DEL)))->flags |= CF_DISABLED;
			((WND*)HeapPtr(FindWndID(ID_MENU_PLYR_SEL)))->flags |= CF_DISABLED;
		}
		if( CurPlayer.MoodCnt<2 ) {
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_DEL)))->flags |= CF_DISABLED;
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_SEL)))->flags |= CF_DISABLED;
		} else {
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_DEL)))->flags &= ~CF_DISABLED;
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_SEL)))->flags &= ~CF_DISABLED;
		}
		if( ((WND*)HeapPtr(FindWndID(ID_MENU_OPTIONS)))->flags & CF_DISABLED ) {
			// if we're in the first-time startup RENAME (most of the menu is DISABLED),
			// DON'T create the CLOSE menu button, and DO set the focus to the rename window
			SetFocusID(ID_RENPLYNAME);
			
		} else {
			// this is a normal menu open, so create the second 'fake' MENU button
			// that is a child of the menu dialog, so that it's active while in
			// the modal menu dialog. Being a child of the menu dialog, it will
			// automatically get destroyed when the dialog is closed/destroyed.
			CreateButtonBM(ID_MENU_BUTT_CLOSE, -MENU_XOFF*UU, -5*UU, UU*12, UU*5, WF_SHOW, 0, 0, 0, UIBMU*12, UIBMU*5, hMenuDlg, MenuButtProc);
			pS = (WND*)HeapPtr(FindWndID(ID_MENU_BUTT));
			pF = (WND*)HeapPtr(FindWndID(ID_MENU_BUTT_CLOSE));
			pF->text = pS->text;
		}
		if( GoHelpName[0] && !HelpChanged ) {
			GoHelp(GoHelpName, GoHelpMark);
			GoHelpName[0] = 0;
		}
		return 0;
	 case WM_DESTROY:
		SaveMenuCtls();	// save values from controls to tmpMood

		if( arg1==ID_OK ) {
			SaveMoodChanges();
		} else {
			// restore any CANCEL'd UIsize changes
			memcpy((BYTE*)&tmpMood, (BYTE*)&CurMood, sizeof(MOOD));
			SetupUUvars();
			--((WND*)HeapPtr(hMain))->w;
			SendMsg(hMain, WM_PARENTSIZED, 0, 0, 0);
		}

		if( hHelpBM ) DeleteBM(hHelpBM);
		hHelpBM = 0;
		if( HackUU ) DeleteBM(hHackUIBM);
		hHackUIBM = 0;
		if( HackGU ) DeleteBM(hHackGBM);
		hHackGBM = 0;
		SetCursor(CURSOR_NORMAL);
		HelpCursor = 0;
		
		hMenuDlg = 0;
		curCtls = NULL;	// indicate no controls exist for next creation of this dialog
		ShowWnd(FindWndID(ID_MENU_BUTT), SW_SHOW);	// just in case it was hidden
		
		SetupDispVars();
		if( !ShuttingDown ) LoadGraphics(tmpMood.images);

		SetFocus(hMain);

		DefDlgProc(hW, msg, arg1, arg2, arg3);	// destroy dialog and all controls
		
		// NOTE: DefDlgProc() doesn't come back, as the modal dialog is destroyed!
		
		return 0;
	 case WM_PARENTSIZED:
		++BlockPaint;	// for speed and clean redrawing
		InvalidateAllWnd(hW);
		DefDlgProc(hW, msg, arg1, arg2, arg3);
		sprintf(IFsizeStr, KString(BLK_DLG, STR_IF_SIZE), UU);
		--BlockPaint;
		return 0;
	 case WM_NOTIFY:
		switch( arg1 ) {
		 case WN_CHILDSETFOCUS:
			pW->hLCfocus = arg2;
			// if this dialog is not the parent of the top-most window, move it to the top
			hF = (HWND)ZStack[Zcnt-1];	// get top-most window
			while( hF && hF!=hW ) {
				pF = (WND*)HeapPtr(hF);
				hN = pF->parent;
				hF = hN;
			}
			if( hF != hW ) SendMsg(hW, WM_COMMAND, WC_ZTOP, 0, 0);
			return 0;
		 case WN_CHILDKILLFOCUS:
			return 0;
		 case WN_CHILDDESTROY:
			if( pW->hLCfocus == arg2 ) pW->hLCfocus = 0;
			return 0;
		 case WN_SELCHANGED:
			if( MenuCurSelID==ID_MENU_INTERFACE ) {
				pS = (WND*)HeapPtr(arg2);
				if( pS->id == ID_LIST && !BlockPaint ) {	// !BlockPaint avoids reloading the UI when ID_MENU_INTERFACE is selected, at which point the UU hasn't changed, so it doesn't NEED reloading.
					SendMsg(arg2, LBM_GETITEM, -1, (DWORD)tmpMood.UIimage, LBGI_TEXT);
					LoadUI(tmpMood.UIimage);
					mainDrawAll();
					InvalidateAllWnd(hMain);
				}
			} else if( MenuCurSelID==ID_MENU_GRAPHICS ) {
				pS = (WND*)HeapPtr(arg2);
				if( pS->id == ID_LIST ) {
					SendMsg(arg2, LBM_GETITEM, -1, (DWORD)tmpMood.images, LBGI_TEXT);
					GraphicsBad = TRUE;	// flag that the game will need to reload the proper-sized graphics at exit from the menu/dialog
					GU = UU;	// set GU so that the game graphics are scaled for the preview window
					InitGUvars();
					LoadGraphics(tmpMood.images);

					InvalidateAllWnd(FindWndID(ID_GG_PREVIEW));
					InvalidateAllWnd(FindWndID(ID_GG_CREDITS));
				}
			} else if( MenuCurSelID==ID_MENU_LANG ) {
				pS = (WND*)HeapPtr(arg2);
				if( pS->id == ID_LANG_STRINGS ) {
					UpdateLangCredit(FindWndID(ID_LANG_STR_BY), arg2);
					SendMsg(arg2, LBM_GETITEM, -1, (DWORD)ScratBuf, LBGI_TEXT);
					sprintf(tmpMood.StringsName, AddLangSTR, ScratBuf);
					LoadStrings(tmpMood.StringsName);
					// set pW->text for MENU button!
					hN = FindWndID(ID_MENU_BUTT_CLOSE);
					if( hN ) ((WND*)HeapPtr(hN))->text = (DWORD)KString(BLK_BUTTS, STR_MENU_BUTT);
					SendMsg(hMain, WM_NOTIFY, WN_STRINGS_RELOADED, 0, 0);
				} else if( pS->id == ID_LANG_HELP ) {
					UpdateLangCredit(FindWndID(ID_LANG_HLP_BY), arg2);
				}
			} else if( arg3 >= ID_DEFMOOD && arg3<=ID_COPYALLMOODS ) {
				EnableWndID(ID_NPDEFMOODNAME, GetCheckID(ID_DEFMOOD));	// enable/disable editing mood name
			}
			return 0;
		 case WN_SCROLL:
			return 0;
		 case WN_MODIFIED:
			return 0;
		}
		break;
	 case WM_KEYDN:
		if( MenuCurSelID==ID_MENU_HELP && FindWndID(ID_MENU_HELP)!=hFocus ) {
			hT = FindWndID(ID_HELP_TEXT);
			pTextW = (WNDSCROLL*)HeapPtr(hT);
			switch( arg1 ) {
			 case K_RTCURS:
				SetFocusID(ID_HELP_NEXT);
				return SendMsgID(ID_HELP_NEXT, WM_ACTIVATE, 0, 0, 0);
			 case K_LFCURS:
				SetFocusID(ID_HELP_PREV);
				return SendMsgID(ID_HELP_PREV, WM_ACTIVATE, 0, 0, 0);
			 case K_DNCURS:
				if( pTextW->hScrollV ) {
					SendMsg(pTextW->hScrollV, WM_COMMAND, WC_GETSCROLLINFO, (DWORD)&sbi, 0);
					if( pTextW->scrollY < sbi.maxPos ) {
						++pTextW->scrollY;
						SendMsg(hT, WM_COMMAND, WC_SETSCROLLBARS, 0, 0);
					}
				}
				return 0;
			 case K_UPCURS:
				if( pTextW->hScrollV ) {
					if( pTextW->scrollY ) {
						--pTextW->scrollY;
						SendMsg(hT, WM_COMMAND, WC_SETSCROLLBARS, 0, 0);
					}
				}
				return 0;
			 case K_PGDN:
				if( pTextW->hScrollV ) {
					SendMsg(pTextW->hScrollV, WM_COMMAND, WC_GETSCROLLINFO, (DWORD)&sbi, 0);
					if( pTextW->scrollY < sbi.maxPos ) {
						pTextW->scrollY += sbi.PageSize;
						SendMsg(hT, WM_COMMAND, WC_SETSCROLLBARS, 0, 0);
					}
				}
				return 0;
			 case K_PGUP:
				if( pTextW->hScrollV ) {
					if( pTextW->scrollY ) {
						SendMsg(pTextW->hScrollV, WM_COMMAND, WC_GETSCROLLINFO, (DWORD)&sbi, 0);
						pTextW->scrollY -= min(pTextW->scrollY, sbi.PageSize);
						SendMsg(hT, WM_COMMAND, WC_SETSCROLLBARS, 0, 0);
					}
				}
				return 0;
			 default:
				break;
			}
		}
		switch( arg1 ) {
		 case K_F1:
			SendMsgID(ID_MENU_BUTT_CLOSE, WM_ACTIVATE, ID_OK, 0, 0);
			return 0;
		 case K_ENTER:
			for(hF=pW->child1; hF && (pF=(WND*)HeapPtr(hF)) && !(pF->flags & CF_DEFAULT); hF=pF->nextSib) ;
			if( hF && (pF->flags & CF_DEFAULT) ) SendMsg(hF, WM_ACTIVATE, 0, 0, 0);
			return 0;
		}
		break;
	 case WM_PTRMOVE:
		SetCursor(CURSOR_NORMAL);
		break;
	 case HM_HYPERJUMP:
		if( arg3==0 ) {	// save "back" if NOT coming from BACK button
			if( BackStackCnt > 98 ) {
				memcpy((BYTE *)BackStack, (BYTE *)(BackStack+2), sizeof(BackStack)-4);
				--BackStackCnt;
				--BackStackCnt;
			}
			BackStack[BackStackCnt++] = CurHelpPage;
			BackStack[BackStackCnt++] = ((WNDSCROLL*)HeapPtr(FindWndID(ID_HELP_TEXT)))->scrollY;
		}
		GoHelp(HelpPageNames[arg1], arg3 ? arg2 : HelpPageMarks[arg2]/HTH);
		break;
	}	
	return DefDlgProc(hW, msg, arg1, arg2, arg3);
}

//=======================================================================
DWORD AboutCopyProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	if( msg==WM_ACTIVATE ) {
		sprintf(ScratBuf, "%s %d.%d\n%s\neverett@kaser.com\nwww.kaser.com\n%s\n%s\n%s\n%s\n%s\n%s\n",
			PgmTitle, (long)*(BYTE*)0xDA, (long)*(BYTE*)0xDB,
			Copyright,
			AboutDate,
			AboutBuildNum,
			AboutKINT,
			AboutScreen,
			AboutWindow,
			AboutUI
		);
		WriteClipboard(ScratBuf, strlen(ScratBuf));
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD PlayerSelProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	long	i, newID;
	char	name[64];
	
	if( msg==WM_ACTIVATE ) {
		SendMsgID(ID_LIST, LBM_GETITEM, SendMsgID(ID_LIST, LBM_GETCURSEL, 0,0,0), (DWORD)name, LBGI_TEXT);
		// try to find that player in the .ini
		for(i=0; i<=maxID; i++) {
			sprintf(ScratBuf, iniPLAYER, i);
			if( iniFindSec(ScratBuf) ) {
				iniFindVar(iniNAME);
				iniGetStr(ScratBuf, 64);
				if( !strcmp(ScratBuf, name) ) {
					SaveMoodChanges();
					EndPlayer();	// end current player

					CurPlayer.id = i;
					
					StartPlayer(TRUE);
					memcpy((BYTE*)&tmpMood, (BYTE*)&CurMood, sizeof(MOOD));
					strcpy(MenuMoodName, CurMood.name);
					return 0;
				}
			}
		}
		SystemMessage("PO: player not found");
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
void NextPlayer() {
	
	long	i;
	
	for(i=CurPlayer.id+1; i<=maxID; i++) {
		sprintf(ScratBuf, iniPLAYER, i);
		if( iniFindSec(ScratBuf) ) break;
	}
	if( i>maxID ) {
		for(i=0; i<CurPlayer.id; i++) {
			sprintf(ScratBuf, iniPLAYER, i);
			if( iniFindSec(ScratBuf) ) break;
		}
	}
	if( i!=CurPlayer.id ) {
		EndPlayer();
		CurPlayer.id = i;
		StartPlayer(TRUE);
		strcpy(MenuMoodName, CurMood.name);
	}
}

//==========================================================================
void PrevPlayer() {
	
	long	i;
	
	for(i=(long)CurPlayer.id-1; i>=0; i--) {
		sprintf(ScratBuf, iniPLAYER, i);
		if( iniFindSec(ScratBuf) ) break;
	}
	if( i<0 ) {
		for(i=maxID; i>CurPlayer.id; i--) {
			sprintf(ScratBuf, iniPLAYER, i);
			if( iniFindSec(ScratBuf) ) break;
		}
	}
	if( i!=CurPlayer.id ) {
		EndPlayer();
		CurPlayer.id = i;
		StartPlayer(TRUE);
		strcpy(MenuMoodName, CurMood.name);
	}
}

//==========================================================================
DWORD PlayerListProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	long	i, newID;
	char	name[64];
	
	if( msg==WM_LBUTTDBLCLICK ) {
		SendMsgID(ID_SELPLAYER, WM_ACTIVATE, 0, 0, 0);
		return 0;
	}
	return ListBoxProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD PlayerAddProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	long	i, newID;
	char	name[64], moodname[64];
	DWORD	hM, hN, hS, hP;
	WNDPOS	wndPos;
	MOOD	*pMOOD;
	
	if( msg==WM_ACTIVATE ) {
		// get new player name
		SendMsgID(ID_NEWPLYNAME, ELM_GETTEXT, (DWORD)name, 64, 0);
		
		// if no name, error
		if( name[0]==0 ) {
			MessageBox(KString(BLK_DLG, STR_NEEDNAME), MB_BUMMER);
			return 0;
		}
		
		// check for player name already being used
		newID = -1;
		for(i=0; i<=maxID; i++) {
			sprintf(ScratBuf, iniPLAYER, i);
			if( iniFindSec(ScratBuf) ) {
				if( iniFindVar(iniNAME) && iniGetStr(ScratBuf, 64) && !strcmp(ScratBuf, name) ) break;
			} else if( newID==-1 ) newID = i;
		}
		if( i<=maxID ) {
			MessageBox(KString(BLK_DLG, STR_DUPEPLAYER), MB_BUMMER);
			return 0;
		}
		
		// get the setting for moods
		for(i=0; i<3; i++) if( GetCheckID(ID_DEFMOOD+i) ) break;
		// if DEFAULT MOOD...
		if( i==0 ) {
			// check for non-NULL mood name
			SendMsgID(ID_NPDEFMOODNAME, ELM_GETTEXT, (DWORD)moodname, 64, 0);
			if( moodname[0]==0 ) {
				MessageBox(KString(BLK_DLG, STR_MOODMUSTBENAMED), MB_BUMMER);
				return 0;
			}
			// it's a new player, and they're doing the default mood,
			// so we don't need to worry about a duplicate mood name.
		}
		// save any changes already made to current player's mood
		SaveMoodChanges();
		
		// if there was no "deleted player hole" in the ID list, increase the maxID and use it.
		if( newID==-1 ) newID = ++maxID;
		
		// all clear, add the new player
		++NumPlayers;

		switch( i ) {
		 case 0:	// DEFAULT MOOD
			// don't change the window size/position regardless
			// of whether we're copying the current player or not.
			memcpy((BYTE*)&wndPos, (BYTE*)&CurMood.wndPos, sizeof(WNDPOS));

			// shutdown the current player, save game, whatever
			EndPlayer();
			
			// now create the default player settings for this new player
			DefaultCurPlayer();
			// set MOOD NAME
			strcpy(CurMood.name, moodname);

			// set the current window size & pos to where's it's currently at
			memcpy((BYTE*)&CurMood.wndPos, (BYTE*)&wndPos, sizeof(WNDPOS));
			
			break;
		 case 1:	// COPY CURRENT MOOD from current player
			hM = CopyMood(0);
			// shutdown the current player
			EndPlayer();
			
			// now set the current (only) mood for the new 'current' player
			CurPlayer.hFirstMood = hM;	// restore the 'current' player's mood for the new player
			CurPlayer.MoodCnt = 1;
			
			break;
		 case 2:	// COPY ALL MOODS from current player
			hS = CurPlayer.hFirstMood;	// save current player's moods
			i  = CurPlayer.MoodCnt;
			CurPlayer.hFirstMood = 0;	// so EndPlayer() doesn't delete them

			EndPlayer();
			
			CurPlayer.hFirstMood = hS;	// restore the 'current' player's moods for the new player
			CurPlayer.MoodCnt = i;
			break;
		}
		strcpy(MenuMoodName, CurMood.name);
		CurMood.flags2 &= ~PF2_SEEN_QUICKSTART;
		memcpy((BYTE*)&tmpMood, (BYTE*)&CurMood, sizeof(MOOD));

		// set the new player's name and ID
		strcpy(CurPlayer.name, name);
		CurPlayer.id = newID;

		// okay, new player all ready to go, save to records in .ini
		SaveMoodChanges();
		iniSavePlayer();
		
		// startup the new player, init game, whatever
		StartPlayer(TRUE);
		
		if( NumPlayers>1 ) {
			((WND*)HeapPtr(FindWndID(ID_MENU_PLYR_DEL)))->flags &= ~CF_DISABLED;
			((WND*)HeapPtr(FindWndID(ID_MENU_PLYR_SEL)))->flags &= ~CF_DISABLED;
		}

		SendMsgID(ID_MENU_OPTIONS, WM_ACTIVATE, 0, 0, 0);
		SetFocusID(ID_MENU_OPTIONS);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD PlayerRenProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	long	i, n, p;
	WND		*pS, *pF;
	char	*po, *pn, *pp;
	
	switch( msg ) {
	 case WM_ACTIVATE:
		// in game.c char	*SaveGameRename		= "CT_%s_*.sav";
		for(pp=SaveGameRename; *pp!='%'; ++pp) ;
		p = pp-SaveGameRename;
		// generate wildcard old name of saved games to rename
		sprintf(ScratBuf+6000, SaveGameRename, CurPlayer.name);
		for(po=ScratBuf+6000; *po!='*'; ++po) ;
		i = po-(ScratBuf+6000)-1;	// -1 to include the '_' before the '*'
		
		// get new player name
		SendMsgID(ID_RENPLYNAME, ELM_GETTEXT, (DWORD)CurPlayer.name, 64, 0);
		
		// generate wildcard new name of saved games
		sprintf(ScratBuf+7000, SaveGameRename, CurPlayer.name);
		for(pn=ScratBuf+7000; *pn!='*'; ++pn) ;
		n = pn-(ScratBuf+7000)-1;	// -1 to include the '_' before the '*'
		
		// now rename any saved game files for old player name (to new player name)
		if( -1!=FindFirst(ScratBuf+6000, ScratBuf, NULL, NULL) ) {
			do {
				strcpy(ScratBuf+1000, ScratBuf);	// copy the old name
				strcpy(ScratBuf+1000+p, CurPlayer.name);	// overwrite the player name
				strcpy(ScratBuf+1000+n, ScratBuf+i);		// overwrite the remainder of this save file's name
				frename(ScratBuf, ScratBuf+1000);
			} while( -1 != FindNext(ScratBuf, 0, 0) );
			FindClose();
		}
		
		UpdateTitleBar();
		iniSavePlayer();
		// if this is the first time run, re-enable the rest of the menu and the menu button
		if( MenuDlg[1].flags & CF_DISABLED ) {
			ShowWnd(FindWndID(ID_MENU_BUTT), SW_SHOW);
			// re-enable the menu items
			for(i=1; MenuDlg[i].id; i++) {
				if( (MenuDlg[i].flags & CF_DISABLED) && MenuDlg[i].id!=ID_MENU_PLYR_SEL && MenuDlg[i].id!=ID_MENU_PLYR_DEL ) {
					MenuDlg[i].flags &= ~CF_DISABLED;	// fix the dialog for next time
					EnableWndID(MenuDlg[i].id, TRUE);	// enable them NOW
				}
			}
			// create the 2nd menu button that's a child of the menu dialog
			CreateButtonBM(ID_MENU_BUTT_CLOSE, -MENU_XOFF*UU, -5*UU, UU*10, UU*5, WF_SHOW, 0, 0, 0, UIBMU*10, UIBMU*5, hMenuDlg, MenuButtProc);
			pS = (WND*)HeapPtr(FindWndID(ID_MENU_BUTT));
			pF = (WND*)HeapPtr(FindWndID(ID_MENU_BUTT_CLOSE));
			pF->text = pS->text;
			SendMsgID(ID_MENU_MOOD_REN, WM_ACTIVATE, 0, 0, 0);
			SetFocusID(ID_RENMOODNAME);
			memcpy((BYTE*)&CurMood, (BYTE*)&tmpMood, sizeof(MOOD));	// in case of CANCEL
		} else {
			SendMsgID(ID_MENU_MOOD_REN, WM_ACTIVATE, 0, 0, 0);
			SetFocusID(ID_RENMOODNAME);
		}
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MoodSelProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	long	i;
	char	name[64];
	MOOD	*pMOOD;
	DWORD	hMOOD;
	QWORD	size;
	
	if( msg==WM_ACTIVATE ) {
		SaveMoodChanges();	// save any changes to the current mood
		SendMsgID(ID_LIST, LBM_GETITEM, SendMsgID(ID_LIST, LBM_GETCURSEL, 0,0,0), (DWORD)name, LBGI_TEXT);
		// try to find that mood in the player's mood list
		// check if player already has a mood by this name
		for(i=0, hMOOD=CurPlayer.hFirstMood; hMOOD && (pMOOD=(MOOD*)HeapPtr(hMOOD)) && strcmp(name, pMOOD->name); i++, hMOOD=pMOOD->hNext) ;
		if( hMOOD ) {
			strcpy(MenuMoodName, pMOOD->name);	// for showing mood name on MENU
			InvalidateAllWnd(FindWndID(ID_MENU_CURMOOD));
			EndMood();
			StartMood(i, TRUE);
			return 0;
		}
		SystemMessage("PO: mood not found");
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MoodListProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	if( msg==WM_LBUTTDBLCLICK ) {
		SendMsgID(ID_SELMOOD, WM_ACTIVATE, 0, 0, 0);
		return 0;
	}
	return ListBoxProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
// Create a copy of a mood, creating new Heap blocks for music, etc., and copy all mood settings
// hSRCmood *MUST* be a valid Heap handle to a valid MOOD or 0 (in which case CurMood is used)!
DWORD CopyMood(DWORD hSRCmood) {
	
	DWORD		hNEWmood;
	MOOD		*pSRCmood, *pNEWmood;
	DWORD		hMold, hMoldNext, hMnew, hMnewPrev;
	FILELIST	*pMold, *pMnew, *pMnewPrev;
	
	hNEWmood = HeapAlloc(sizeof(MOOD));
	pNEWmood = (MOOD*)HeapPtr(hNEWmood);
	if( hSRCmood==0 ) pSRCmood = &CurMood;
	else pSRCmood = (MOOD*)HeapPtr(hSRCmood);
	
	memcpy((BYTE*)pNEWmood, (BYTE*)pSRCmood, sizeof(MOOD));
	pNEWmood->hNext = 0;
	
	// create new Heap blocks for back/win music for new mood
	for(hMold=pSRCmood->hBackMusic; hMold && (pMold=(FILELIST*)HeapPtr(hMold)); hMold=pMold->hNext) {
		hMnew = HeapAlloc(sizeof(FILELIST));
		if( hMold==pSRCmood->hBackMusic ) pNEWmood->hBackMusic = hMnew;
		else pMnew->hNext = hMnew;	// store next music handle in previous one's hNext
		hMnewPrev = hMnew;
		pMnew = (FILELIST*)HeapPtr(hMnew);
		strcpy(pMnew->name, pMold->name);
		pMnew->hNext = pMnew->flags = 0;
	}
	for(hMold=pSRCmood->hWinMusic; hMold && (pMold=(FILELIST*)HeapPtr(hMold)); hMold=pMold->hNext) {
		hMnew = HeapAlloc(sizeof(FILELIST));
		if( hMold==pSRCmood->hWinMusic ) pNEWmood->hWinMusic = hMnew;
		else pMnew->hNext = hMnew;
		hMnewPrev = hMnew;
		pMnew = (FILELIST*)HeapPtr(hMnew);
		strcpy(pMnew->name, pMold->name);
		pMnew->hNext = pMnew->flags = 0;
	}
	return hNEWmood;
}

//==========================================================================
DWORD MoodAddProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	long		i;
	char		name[64];
	DWORD		hMOOD, hPREV, hNEW, hMold, hMoldNext, hMnew, hMnewPrev;
	MOOD		*pMOOD, *pNEW;
	WNDPOS		wndPos;
	FILELIST	*pMold, *pMnew, *pMnewPrev;
	
	if( msg==WM_ACTIVATE ) {
		// get new mood name
		SendMsgID(ID_NEWMOODNAME, ELM_GETTEXT, (DWORD)name, 64, 0);
		
		// if no name, error
		if( name[0]==0 ) {
			MessageBox(KString(BLK_DLG, STR_MOODMUSTBENAMED), MB_BUMMER);
			return 0;
		}
		
		// check if player already has a mood by this name
		for(hMOOD=CurPlayer.hFirstMood; hMOOD && (pMOOD=(MOOD*)HeapPtr(hMOOD)) && strcmp(name, pMOOD->name); hMOOD=pMOOD->hNext) ;
		if( hMOOD ) {
			MessageBox(KString(BLK_DLG, STR_DUPEMOOD), MB_BUMMER);
			return 0;
		}
		
		// get the setting for mood creation
		i = GetCheckID(ID_COPYCURMOOD);
		
		// all clear, add the new mood

		SaveMoodChanges();	// save any changes that might have been made to the CURRENT mood before adding a new one

		EndMood();
		
		if( i==0 ) {	// DEFAULT MOOD
			// don't change the window size/position regardless
			// of whether we're copying the current mood or not.
			memcpy((BYTE*)&wndPos, (BYTE*)&CurMood.wndPos, sizeof(WNDPOS));
			
			// setup default settings
			DefaultCurMood();
			CurMood.flags2 |= PF2_SEEN_QUICKSTART;
			// set the current window size & pos to where's it's currently at
			memcpy((BYTE*)&CurMood.wndPos, (BYTE*)&wndPos, sizeof(WNDPOS));
		}
		// set MOOD NAME
		strcpy(CurMood.name, name);

		// make sure our working copy matches the 'current' copy
		CurMood.hNext = 0;
		hNEW = CopyMood(0);
		
		// add this new mood block onto the end of the list
		for(hPREV=0, hMOOD=CurPlayer.hFirstMood; hMOOD && (pMOOD=(MOOD*)HeapPtr(hMOOD)); hPREV=hMOOD, hMOOD=pMOOD->hNext) ;
		CurPlayer.CurMoodNum = CurPlayer.MoodCnt++;
		((MOOD*)HeapPtr(hPREV))->hNext = hNEW;

		pNEW = (MOOD*)HeapPtr(hNEW);
		memcpy((BYTE*)&tmpMood, (BYTE*)pNEW, sizeof(MOOD));
		memcpy((BYTE*)&CurMood, (BYTE*)pNEW, sizeof(MOOD));

		// okay, new mood all ready to go, save to records in .ini
		iniSavePlayer();
		
		if( CurPlayer.MoodCnt>1 ) {
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_DEL)))->flags &= ~CF_DISABLED;
			((WND*)HeapPtr(FindWndID(ID_MENU_MOOD_SEL)))->flags &= ~CF_DISABLED;
		}

		StartMood(CurPlayer.CurMoodNum, TRUE);
		
		SendMsgID(ID_MENU_OPTIONS, WM_ACTIVATE, 0, 0, 0);
		SetFocusID(ID_MENU_OPTIONS);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MoodRenProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	long	i;
	
	switch( msg ) {
	 case WM_ACTIVATE:
		SendMsgID(ID_RENMOODNAME, ELM_GETTEXT, (DWORD)tmpMood.name, 64, 0);
		strcpy(CurMood.name, tmpMood.name);
		strcpy(MenuMoodName, tmpMood.name);
		SaveMoodChanges();	// save changes to Heap block
		InvalidateAllWnd(FindWndID(ID_MENU_CURMOOD));
		iniSavePlayer();
		UpdateTitleBar();
		SendMsgID(ID_MENU_OPTIONS, WM_ACTIVATE, 0, 0, 0);
		SetFocusID(ID_MENU_OPTIONS);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD IFcreditsProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	WND			*pW;
	DLGRES		*pDR;
	RECT		r, ri, rc;
	long		x, y, dx, ex;
	
	if( msg!=WM_CREATE ) pW = (WND*)HeapPtr(hW);
	switch( msg ) {
	 case WM_CREATE:
		pDR = (DLGRES*)arg1;
		hW = AllocateWnd(pDR->id, pDR->type, pDR->ux*UU, pDR->uy*UU, pDR->uw*UU, pDR->uh*UU, pDR->flags, arg2, IFcreditsProc, sizeof(WND));
		pW = (WND*)HeapPtr(hW);
		pW->pRES = pDR;
		InvalidateAllWnd(hW);
		return hW;
	 case WM_PAINT:
		GetRectWnd(hW, &r);
		GetRectInvalid(&ri);
		if( IntersectRect(&ri, &r) ) {
			ClipRectBM(0, ri, &rc);

			StretchBM(0, r.x, r.y, r.w, r.h, hUIBMO, 8*UIBMUO, 0, 16*UIBMUO, 4*UIBMUO);

			ClipRectBM(0, rc, NULL);
		}
		return 0;
	}
	return DefWndProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD GGcreditsProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	WND			*pW;
	DLGRES		*pDR;
	RECT		r, ri, rc;
	long		x, y, dx, ex;
	
	if( msg!=WM_CREATE ) pW = (WND*)HeapPtr(hW);
	switch( msg ) {
	 case WM_CREATE:
		pDR = (DLGRES*)arg1;
		hW = AllocateWnd(pDR->id, pDR->type, pDR->ux*UU, pDR->uy*UU, pDR->uw*UU, pDR->uh*UU, pDR->flags, arg2, GGcreditsProc, sizeof(WND));
		pW = (WND*)HeapPtr(hW);
		pW->pRES = pDR;
		InvalidateAllWnd(hW);
		return hW;
	 case WM_PAINT:
		GetRectWnd(hW, &r);
		GetRectInvalid(&ri);
		if( IntersectRect(&ri, &r) ) {
			ClipRectBM(0, ri, &rc);

			StretchBM(0, r.x, r.y, r.w, r.h, hGBMO, 0, 1, 3*GBMOwh, GBMOwh-1);

			ClipRectBM(0, rc, NULL);
		}
		return 0;
	}
	return DefWndProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
// These 'POINT' X/Ys are actually tile COLUMN/ROWs for which image from the
// SIZED game graphics to draw at which spot in the PREVIEW window.
POINT	GGP[]={
	{15,0},{0,0},{1,0},{2,1},{4,2},{6,0},{9,0},{12,0},{15,0},
	{15,3},{0,3},{1,3},{2,3},{3,3},{6,3},{9,3},{12,3},{15,3},
	{15,4},{0,4},{1,4},{2,4},{3,4},{6,4},{9,4},{12,4},{15,4},
	{15,5},{0,5},{1,5},{2,5},{3,5},{6,5},{9,5},{12,5},{15,5},
	{15,6},{0,6},{1,6},{2,6},{3,6},{6,6},{9,6},{12,6},{15,6},
	{15,7},{0,7},{1,7},{2,7},{3,7},{6,7},{9,7},{12,7},{15,7},
	{15,8},{0,8},{1,8},{2,8},{3,8},{6,8},{9,8},{12,8},{15,8},
	{15,9},{0,9},{1,9},{2,9},{3,9},{6,9},{9,9},{12,9},{15,9},
	{15,0},{0,0},{1,0},{2,1},{4,2},{6,0},{9,0},{12,0},{15,0}
};
DWORD GGpreviewProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	WND			*pW;
	DLGRES		*pDR;
	RECT		r, ri, rc;
	long		i, j, k, t, x, y, bx, by, dx, dy, dw, dh, xs, ys;
	POINT		p[3];
	DWORD		clr;
	
	if( msg!=WM_CREATE ) pW = (WND*)HeapPtr(hW);
	switch( msg ) {
	 case WM_CREATE:
		pDR = (DLGRES*)arg1;
		hW = AllocateWnd(pDR->id, pDR->type, pDR->ux*UU, pDR->uy*UU, pDR->uw*UU, pDR->uh*UU, pDR->flags, arg2, GGpreviewProc, sizeof(WND));
		pW = (WND*)HeapPtr(hW);
		pW->pRES = pDR;
		InvalidateAllWnd(hW);
		return hW;
	 case WM_PAINT:
		GetRectWnd(hW, &r);
		GetRectInvalid(&ri);
		if( IntersectRect(&ri, &r) ) {
			ClipRectBM(0, ri, &rc);

			// when GameGraphics was selected, GU was set equal to UU
			// so we can use GU/UU interchangeably here. The preview
			// window is 9*9+1+1+1=84 UUs/GUs wide and tall,
			//	9*9 for 9 tile faces of GU9 width
			//	+1 GU for the left-most tile EDGE
			//	+1+1 for one GU "window edge and spacing"
			bx = r.x + GU;
			by = r.y + GU;
			
			dx = r.x;
			dy = r.y;
			dw = r.w;
			dh = r.h;

			xs = X_INBOX*UIBMU;
			ys = Y_INBOX*UIBMU;

			clr = GetPixelBM(hUIBMO, X_INBOX*UIBMUO+UIBMUO-1, Y_INBOX*UIBMUO+UIBMUO-1);
			DrawRectBM(0, dx, dy, dw, dh, clr, CLR_NONE);
			
			RepDrawBM(0, dx, dy, hUIBM, xs, ys, UIBMU, UIBMU, 0, 0, 0);	// top-left corner
			RepDrawBM(0, dx+UU, dy, hUIBM, xs+UIBMU, ys, UIBMU4, UIBMU, 0, dx+dw-UU, 0);	// top
			RepDrawBM(0, dx+dw-UU, dy, hUIBM, xs+5*UIBMU, ys, UIBMU, UIBMU, 0, 0, 0);	// top-right corner
			RepDrawBM(0, dx, dy+UU, hUIBM, xs, ys+UIBMU, UIBMU, UIBMU4, 0, 0, dy+dh-UU);	// left
			RepDrawBM(0, dx+dw-UU, dy+UU, hUIBM, xs+5*UIBMU, ys+UIBMU, UIBMU, UIBMU4, 0, 0, dy+dh-UU);	// right
			RepDrawBM(0, dx, dy+dh-UU, hUIBM, xs, ys+5*UIBMU, UIBMU, UIBMU, 0, 0, 0);	// bottom-left corner
			RepDrawBM(0, dx+UU, dy+dh-UU, hUIBM, xs+UIBMU, ys+5*UIBMU, UIBMU4, UIBMU, 0, dx+dw-UU, 0);	// bottom
			RepDrawBM(0, dx+dw-UU, dy+dh-UU, hUIBM, xs+5*UIBMU, ys+5*UIBMU, UIBMU, UIBMU, 0, 0, 0);	// bottom-right corner

			for(j=0; j<9; j++) {
				for(i=8; i>=0; i--) {
					x = bx + i*GU9;
					y = by + j*GU9;
					DrawBM(0, x, y, hGBM, GGP[j*9+i].x*GU10, GGP[j*9+i].y*GU10, GU10, GU10, 0);
				}
			}

			ClipRectBM(0, rc, NULL);
		}
		return 0;
	}
	return DefWndProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
void SetTestStopButton() {

	DWORD	f;
	HWND	hW;

	if( (hW=FindWndID(ID_TEST)) ) {
		if( IsMusic() ) {
			MusicDlgStop = FALSE;
			((BUTTONTEXT*)HeapPtr(hW))->text = (DWORD)KString(BLK_DLG, STR_M_STOPPLAY);
		} else {
			MusicDlgStop = TRUE;
			((BUTTONTEXT*)HeapPtr(hW))->text = (DWORD)KString(BLK_DLG, STR_M_TEST);
		}
		InvalidateAllWnd(hW);
		
		f = SendMsgID(ID_LISTBACK, LBM_GETCOUNT, 0, 0, 0) ? 1 : 0;
		EnableWndID(ID_REMBACK, f);
		EnableWndID(ID_REMBACKALL, f);
		
		f = SendMsgID(ID_LISTWIN, LBM_GETCOUNT, 0, 0, 0) ? 1 : 0;
		EnableWndID(ID_REMWIN, f);
		EnableWndID(ID_REMWINALL, f);
		
		f = SendMsgID(ID_LIST, LBM_GETCOUNT, 0, 0, 0) ? 1 : 0;
		EnableWndID(ID_ADDBACK, f);
		EnableWndID(ID_ADDBACKALL, f);
		EnableWndID(ID_ADDWIN, f);
		EnableWndID(ID_ADDWINALL, f);
	}
}

//==========================================================================
DWORD MavailProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	switch( msg ) {
	 case WM_SETFOCUS:
		hMusicFocus = hW;
		break;
	 case WM_LBUTTDBLCLICK:
		return 0;
	}
	return ListBoxProc(hW, msg, arg1, arg2, arg3);
}


//==========================================================================
DWORD MaddbackProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD		hN, hP, s;
	FILELIST	*pN;

	switch( msg ) {
	 case WM_ACTIVATE:
		if( SendMsgID(ID_LIST, LBM_GETCOUNT, 0, 0, 0) ) {
			s = SendMsgID(ID_LIST, LBM_GETCURSEL, 0, 0, 0);
			SendMsgID(ID_LIST, LBM_GETITEM, s, (DWORD)ScratBuf, LBGI_TEXT);
			hN = hP = tmpMood.hBackMusic;
			while( hN ) {
				pN = (FILELIST*)HeapPtr(hN);
				if( !strcmp(pN->name, ScratBuf) ) break;
				hP = hN;
				hN = pN->hNext;
			}
			if( !hN ) {	// didn't find it in the BackMusic list
				hN = HeapAlloc(sizeof(FILELIST));
				pN = (FILELIST*)HeapPtr(hN);
				pN->hNext = 0;
				pN->flags = 0;
				strcpy(pN->name, ScratBuf);
				if( tmpMood.hBackMusic==0 ) tmpMood.hBackMusic = hN;
				else ((FILELIST*)HeapPtr(hP))->hNext = hN;
				++tmpMood.BackMusicCnt;
				SendMsgID(ID_LISTBACK, LBM_ADDSTRING, (DWORD)ScratBuf, 0, 0);
			}
			SendMsgID(ID_LISTBACK, LBM_SELSTRING, (DWORD)ScratBuf, 0, 0);
			SendMsgID(ID_LIST, LBM_SETCURSEL, s+1, 0, 0);
		}
		SetTestStopButton();
		if( hMusicFocus) SetFocus(hMusicFocus);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MaddbackallProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	s, i;

	switch( msg ) {
	 case WM_ACTIVATE:
		++BlockPaint;
		if( s = SendMsgID(ID_LIST, LBM_GETCOUNT, 0, 0, 0) ) {
			for(i=0; i<s; i++) {
				SendMsgID(ID_LIST, LBM_SETCURSEL, i, 0, 0);
				SendMsgID(ID_ADDBACK, WM_ACTIVATE, 0, 0, 0);
			}
		}
		--BlockPaint;
		UpdateInvalid();
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MrembackProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD		s, hN, hP, hNN;
	FILELIST	*pN, *pNN;

	switch( msg ) {
	 case WM_ACTIVATE:
		if( SendMsgID(ID_LISTBACK, LBM_GETCOUNT, 0, 0, 0) ) {
			s = SendMsgID(ID_LISTBACK, LBM_GETCURSEL, 0, 0, 0);
			SendMsgID(ID_LISTBACK, LBM_GETITEM, s, (DWORD)ScratBuf, LBGI_TEXT);
			hP = 0;
			hN = tmpMood.hBackMusic;
			while( hN ) {
				pN = (FILELIST*)HeapPtr(hN);
				if( !strcmp(pN->name, ScratBuf) ) break;
				hP = hN;
				hN = pN->hNext;
			}
			if( hN ) {	// found it in the BackMusic list
				hNN = pN->hNext;
				if( !hP ) tmpMood.hBackMusic = hNN;
				else ((FILELIST*)HeapPtr(hP))->hNext = hNN;
				HeapFree(hN);
				--tmpMood.BackMusicCnt;
				SendMsgID(ID_LISTBACK, LBM_DELITEM, s, 0, 0);
			}
		}
		SetTestStopButton();
		if( hMusicFocus) SetFocus(hMusicFocus);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MrembackallProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	switch( msg ) {
	 case WM_ACTIVATE:
		++BlockPaint;
		while( SendMsgID(ID_LISTBACK, LBM_GETCOUNT, 0, 0, 0) ) {
			SendMsgID(ID_LISTBACK, LBM_SETCURSEL, 0, 0, 0);
			SendMsgID(ID_REMBACK, WM_ACTIVATE, 0, 0, 0);
		}
		--BlockPaint;
		UpdateInvalid();
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MaddwinProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD		hN, hP, s;
	FILELIST	*pN;

	switch( msg ) {
	 case WM_ACTIVATE:
		if( SendMsgID(ID_LIST, LBM_GETCOUNT, 0, 0, 0) ) {
			s = SendMsgID(ID_LIST, LBM_GETCURSEL, 0, 0, 0);
			SendMsgID(ID_LIST, LBM_GETITEM, s, (DWORD)ScratBuf, LBGI_TEXT);
			hN = hP = tmpMood.hWinMusic;
			while( hN ) {
				pN = (FILELIST*)HeapPtr(hN);
				if( !strcmp(pN->name, ScratBuf) ) break;
				hP = hN;
				hN = pN->hNext;
			}
			if( !hN ) {	// didn't find it in the WinMusic list
				hN = HeapAlloc(sizeof(FILELIST));
				pN = (FILELIST*)HeapPtr(hN);
				pN->hNext = 0;
				pN->flags = 0;
				strcpy(pN->name, ScratBuf);
				if( tmpMood.hWinMusic==0 ) tmpMood.hWinMusic = hN;
				else ((FILELIST*)HeapPtr(hP))->hNext = hN;
				++tmpMood.WinMusicCnt;
				SendMsgID(ID_LISTWIN, LBM_ADDSTRING, (DWORD)ScratBuf, 0, 0);
			}
			SendMsgID(ID_LISTWIN, LBM_SELSTRING, (DWORD)ScratBuf, 0, 0);
			SendMsgID(ID_LIST, LBM_SETCURSEL, s+1, 0, 0);
		}
		SetTestStopButton();
		if( hMusicFocus) SetFocus(hMusicFocus);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MaddwinallProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	s, i;

	switch( msg ) {
	 case WM_ACTIVATE:
		++BlockPaint;
		if( s = SendMsgID(ID_LIST, LBM_GETCOUNT, 0, 0, 0) ) {
			for(i=0; i<s; i++) {
				SendMsgID(ID_LIST, LBM_SETCURSEL, i, 0, 0);
				SendMsgID(ID_ADDWIN, WM_ACTIVATE, 0, 0, 0);
			}
		}
		--BlockPaint;
		UpdateInvalid();
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MremwinProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD		s, hN, hP, hNN;
	FILELIST	*pN, *pNN;

	switch( msg ) {
	 case WM_ACTIVATE:
		if( SendMsgID(ID_LISTWIN, LBM_GETCOUNT, 0, 0, 0) ) {
			s = SendMsgID(ID_LISTWIN, LBM_GETCURSEL, 0, 0, 0);
			SendMsgID(ID_LISTWIN, LBM_GETITEM, s, (DWORD)ScratBuf, LBGI_TEXT);
			hP = 0;
			hN = tmpMood.hWinMusic;
			while( hN ) {
				pN = (FILELIST*)HeapPtr(hN);
				if( !strcmp(pN->name, ScratBuf) ) break;
				hP = hN;
				hN = pN->hNext;
			}
			if( hN ) {	// found it in the WinMusic list
				hNN = pN->hNext;
				if( !hP ) tmpMood.hWinMusic = hNN;
				else ((FILELIST*)HeapPtr(hP))->hNext = hNN;
				HeapFree(hN);
				--tmpMood.WinMusicCnt;
				SendMsgID(ID_LISTWIN, LBM_DELITEM, s, 0, 0);
			}
		}
		SetTestStopButton();
		if( hMusicFocus) SetFocus(hMusicFocus);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MremwinallProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	switch( msg ) {
	 case WM_ACTIVATE:
		++BlockPaint;
		while( SendMsgID(ID_LISTWIN, LBM_GETCOUNT, 0, 0, 0) ) {
			SendMsgID(ID_LISTWIN, LBM_SETCURSEL, 0, 0, 0);
			SendMsgID(ID_REMWIN, WM_ACTIVATE, 0, 0, 0);
		}
		--BlockPaint;
		UpdateInvalid();
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MtestProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	f;
	WND		*pW;

	switch( msg ) {
	 case WM_ACTIVATE:
		pW = (WND*)HeapPtr(hW);
		if( IsMusic() ) {
			StopMusic();
		} else {
			if( !hMusicFocus ) hMusicFocus = FindWndID(ID_LIST);
			if( SendMsg(hMusicFocus, LBM_GETCOUNT, 0, 0, 0) ) {
				SendMsg(hMusicFocus, LBM_GETITEM, -1, (DWORD)ScratBuf, LBGI_TEXT);
				StartMusic(ScratBuf);
				strcpy(CurMusic, ScratBuf);
			}
		}
		SetTestStopButton();
		if( hMusicFocus ) SetFocus(hMusicFocus);
		else 
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MbackProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	switch( msg ) {
	 case WM_SETFOCUS:
		hMusicFocus = hW;
		break;
	 case WM_LBUTTDBLCLICK:
		return 0;
	}
	return ListBoxProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MwinProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	switch( msg ) {
	 case WM_SETFOCUS:
		hMusicFocus = hW;
		break;
	 case WM_LBUTTDBLCLICK:
		return 0;
	}
	return ListBoxProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MMButtonProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	RADIOBUTT	*pW;
	RECT	r, ri, rc;
	long	xs, ys;
	DWORD	clrs[3];
	
	pW = (RADIOBUTT*)HeapPtr(hW);
	switch( msg ) {
	 case WM_ACTIVATE:
		MMbutt = pW->id - ID_MM_LEFT;
		SetCheckID(ID_MM_FIRSTACT+tmpMood.Actions[MMbutt], TRUE);
		break;
	 case WM_PAINT:
		if( MMshowButt >= 0 ) {
			GetRectWnd(hW, &r);
			GetRectInvalid(&ri);
			if( IntersectRect(&ri, &r) ) {
				ClipRectBM(0, ri, &rc);

				if( tmpMood.Actions[pW->id-ID_MM_LEFT]==MMshowButt ) {
					xs = UIBMU*X_RADIOGREEN;
					ys = UIBMU*Y_RADIOGREEN;
				} else {
					xs = UIBMU*X_RADIOBUTT;
					ys = UIBMU*Y_RADIOBUTT;
				}
				
				SendMsg(hW, WM_GETCOLORS, (DWORD)&clrs[0], 0, 0);
				
				DrawRectBM(0, r.x, r.y, r.w, r.h, clrs[0], CLR_NONE);
				
				DrawBM(0, r.x, r.y, hUIBM, xs, ys, UIBMU4, UIBMU4, 0);

				if( pW->text ) {
					DrawTextBM(0, (char*)pW->text, r.x+UU4, r.y+TEXTYSPACE, r.w-UU4, TEXTH, CF_LEFT, CLR_NONE, clrs[1]);
				}

				ClipRectBM(0, rc, NULL);
			}
			return 0;
		}
		break;
	}
	return RadioButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MMActButtonProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	RADIOBUTT	*pW;
	
	pW = (RADIOBUTT*)HeapPtr(hW);
	switch( msg ) {
	 case WM_ACTIVATE:
		tmpMood.Actions[MMbutt] = pW->id - ID_MM_FIRSTACT;
		break;
	 case WM_RBUTTDN:
		CaptureMouse(hW);
		MMshowButt = ((WND*)HeapPtr(hW))->id - ID_MM_FIRSTACT;
		InvalidateAllWND(hMenuDlg);
		return 0;
	 case WM_RBUTTUP:
		ReleaseMouse();
		MMshowButt = -1;
		InvalidateAllWND(hMenuDlg);
		return 0;
	}
	return RadioButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MMresetProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i;
	
	switch( msg ) {
	 case WM_ACTIVATE:
		if( ID_YES==MessageBox(KString(BLK_MM, STR_MM_CONFIRM), MB_YESNO) ) {
			memcpy(tmpMood.Actions, defactions, sizeof(defactions));
			for(i=19; i>0; i--) if( GetCheckID(ID_MM_LEFT+i) ) break;
			SetCheckID(ID_MM_FIRSTACT+tmpMood.Actions[i], TRUE);
		}
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD MapExportProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	WND		*pW;
	HANDLE	hFile;
	char	eolbuf[8];
	long	i, j, eollen;
	BOOL	first;
	
	pW = (WND*)HeapPtr(hW);
	if( msg==WM_ACTIVATE ) {
		GetEOL(eolbuf, 7);
		eollen = strlen(eolbuf);
		sprintf(ScratBuf+7000, "%s_%s_MouseButtonMappings.TXT", CurPlayer.name, CurMood.name);
		if( -1!=(hFile=fopen(ScratBuf+7000, O_WRBINNEW)) ) {
			for(i=0; i<MM_NUMACTIONS; i++) {
				fwrite(hFile, KString(BLK_MM, STR_MM_FIRST + i), strlen(KString(BLK_MM, STR_MM_FIRST + i)));
				fwrite(hFile, (BYTE*)": ", 2);
				first = TRUE;
				for(j=0; j<20; j++) {
					if( CurMood.Actions[j]==i ) {
						if( !first ) fwrite(hFile, (BYTE*)", ", 2);
						strcpy(ScratBuf, KString(BLK_MM, STR_MM_LEFT+j));
						fwrite(hFile, ScratBuf, strlen(ScratBuf));
						first = FALSE;
					}
				}
				fwrite(hFile, eolbuf, eollen);
			}
			fclose(hFile);
			GetAppDataPath(ScratBuf+6000);
			sprintf(ScratBuf, "%s\n%s%s", KString(BLK_MM, STR_MM_EXPORTED), ScratBuf+6000, ScratBuf+7000);
			BeepCool();
			MessageBox(ScratBuf, MB_WAYCOOL);
		}
		
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
//==========================================================================
//==========================================================================
// HELP
//==========================================================================
//==========================================================================
//==========================================================================

//==========================================================================
DWORD HelpHideProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	WND			*pW;
	HWND		hH;
	WNDSCROLL	*pH;
	
	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_LBUTTDN:
		CaptureMouse(hW);
		SendMsg(pW->parent, WM_SHOW, SW_HIDE, 0, 0);
		return 0;
	 case WM_PTRMOVE:
		if( hW!=hCapture || (arg3 & MK_LBUTT) ) break;

	// @@@@@ FALLS THROUGH!!! @@@@@

	 case WM_LBUTTUP:
		if( hW==hCapture ) {
			ReleaseMouse();
			SendMsg(pW->parent, WM_SHOW, SW_SHOW, 0, 0);
			hH = FindWndID(ID_HELP_TEXT);
			pH = (WNDSCROLL*)HeapPtr(hH);
			ShowWnd(pH->hScrollH, SW_HIDE);
			return 0;
		}
		break;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD HelpIndexProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	WND		*pW;
	
	pW = ((WND*)HeapPtr(hW));
	if( msg==WM_ACTIVATE ) {
		SendMsg(pW->parent, HM_HYPERJUMP, 1, 0, 0);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD HelpBackProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	WND		*pW;
	
	pW = ((WND*)HeapPtr(hW));
	if( msg==WM_ACTIVATE ) {
		if( BackStackCnt ) {
			SendMsg(pW->parent, HM_HYPERJUMP, BackStack[BackStackCnt-2], BackStack[BackStackCnt-1], 1);
			--BackStackCnt;
			--BackStackCnt;
		} else BeepIll();
		return 0;
	} else if( msg==WM_PAINT ) {
		pW->flags &= ~CF_DISABLED;
		if( !BackStackCnt ) pW->flags |= CF_DISABLED;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
char HelpExportHead1[]	= "\
<!DOCTYPE html>\r\n\
<html lang=\"";
char HelpExportHead2[]	= "\
\">\r\n\
<head>\r\n\
\t<meta charset=\"UTF-8\">\r\n\
\t<title>";
char HelpExportHead3[]	= "\
</title>\r\n\
\t<style>\r\n";

char HelpExportBody[]	= "\
\t\tbody {\r\n\
%s%s\r\n\
\t\t}\r\n\
\
\t\tdiv.help {\r\n\
\t\t\toverflow: auto;\r\n\
%s%s\
\t\t}\r\n\
";

char HelpHeadFoot[]		= "\
\t\theader, footer {\r\n\
\t\t\ttext-align: center;\r\n\
\t\t\tmargin-left: 0em;\r\n\
\t\t\tmargin-right: 0em;\r\n\
%s%s%s\r\n\
\t\t}\r\n\
";

char HelpExportStyle1[]	= "\t\tol.ekl0 {counter-reset: list -1;}\r\n\
\t\tol.ekl0 > li {counter-increment: list;}\r\n\
\t\tol.ekl0 > li::marker {content: counter(list) \") \";}\r\n\
\t\tol.ekl1 {counter-reset: list 0;}\r\n\
\t\tol.ekl1 > li {counter-increment: list;}\r\n\
\t\tol.ekl1 > li::marker {content: counter(list) \") \";}\r\n\
\t\tdiv.help h2, h3 { display: inline; }\r\n\
\t\tdiv.help h2 {text-align:left; top: 5px;}\r\n\
\t\tli.b025 {margin-bottom:.25em;}\r\n\
\t\tli.b050 {margin-bottom:.5em;}\r\n\
\t\tli.b075 {margin-bottom:.75em;}\r\n\
\t\tli.b100 {margin-bottom:1em;}\r\n\
\t\tdiv.help p {margin-top:0em; margin-right: 1em;}\r\n\
\t\tdiv.help img {float:left; margin-right:5px;}\r\n\
\t\tdiv.atG {clear: left;}\r\n\
";
char HelpExportStyle15[]= "\t\t.imgwrap {%s}\r\n";

char HelpExportStyle2[]	= "\t\t.pathnote {position: relative; vertical-align: super; font-size: .75em; border-bottom: 1px dotted black;}\r\n\
\t\t.pathnote:before { content: \"%s\"; visibility: hidden; opacity: 0; width: 15em; background-color: black; color: #fff; text-align: center; border-radius: 5px; padding: 5px 0; font-size: 1.33em; position: absolute; z-index: 1; left: 0; top: 110%;}\r\n\
\t\t.pathnote:hover:before {opacity: 1; visibility: visible;}\r\n\
";
char HelpExportStyle3[] = "\
\t\tdiv.container {width: 100%;}\r\n\
\t\t.contentsbar {\r\n\
\t\t\tposition: fixed;\r\n\
\t\t\ttop:0px;\r\n\
\t\t\tleft:0px;\r\n\
\t\t\theight: 100%;\r\n\
\t\t\tborder-right: 1px solid #000000;\r\n\
\t\t\tline-height: 100%;\r\n\
\t\t\tpadding-left: 1em;\r\n\
\t\t\tpadding-top: 0.5em;\r\n\
";
char HelpExportStyle35[]= "\
%s\
%s\
\t\t\twidth: %dem;\r\n\
\t\t}\r\n\
\
\t\tp.contents {\r\n\
\t\t\twidth: %dem;\r\n\
\t\t\tmargin-top: 0em;\r\n\
\t\t\tmargin-bottom: %fem;\r\n\
\t\t\tpadding-left: 1em;\r\n\
\t\t\ttext-indent: -1em;\r\n\
\t\t}\r\n\
\
\t\tp.contents a {text-decoration: none;}\r\n\
\t\t.link {%s}\r\n\
";
char HelpExportStyle36[]= "\
\t\thr.rule1 {margin-top:%3.3fem; margin-bottom:%3.3fem;}\r\n\
\t\thr.rule2 {margin-top:%3.3fem; margin-bottom:%3.3fem;}\r\n\
";

char HelpExportStyle4[] = "\t</style>\r\n";

char HelpExportHead35[]	= "</head>\r\n<body>\r\n";
char HelpExportHead351[]= "<div class=\"container\">\r\n\t<div class=\"contentsbar\">\r\n\t\t<h2 style=\"margin-top:0em; margin-bottom:.5em;\">Contents</h2>\r\n\t\t<hr>\r\n";
char HelpExportHead352[]= "\t</div>\r\n\r\n";

char HelpExportHead36[]	= "\t<div class=\"help\">\r\n\r\n\
\t\t<header style=\"margin-top:0px; padding:0px;\">\
<h1 style=\"margin-bottom:0em;padding:0px; top: 5px;\">\
";
char HelpExportHead4[]	= "</h1>\r\n";
char HelpExportHead5[]	= "<p style=\"align: center; margin-bottom:.5em;\">";
char HelpExportByEK[]	= "Original Help text by Everett Kaser";
char HelpExportByOther[]= "</p></header>\r\n";

char HelpExportFoot[]	= "\r\n\t</div>\r\n</body>\r\n</html>\r\n";
char hrule1[]			= "<hr class=\"rule1\">\r\n";
char hrule2[]			= "<hr class=\"rule2\">\r\n";
char SpanRed[]			= "<span style=\"color:red\">";
char TempBM[]			= "__HELPBM.png";
char HelpIcon[]			= "\t<link rel=\"icon\" href=\"data:image/png;base64,";
char GStartTable[]		= "<div class=\"imgwrap\">\r\n<span>";


char GEndTable[]		= "</span></div>\r\n<div class=\"atG\"></div>\r\n";
char ListStyle[4][128];
char *ListClose[4] = {
	"</ul>",
	"</ul>",
	"</ol>",
	"</ol>"
};
char *ListLI[5] = {
	"<li>",
	"<li class=\"b025\">",
	"<li class=\"b050\">",
	"<li class=\"b075\">",
	"<li class=\"b100\">"
};
char LinkContents[128];

//==========================================================================
// copy a string from str to the end of buf, translating &, <, > into proper HTML character references.
// buf and str must both be NUL-terminated at entry
void HTMLappend(char *buf, char *str) {

	buf += strlen(buf);
	while( *str ) {
		if( *str=='&' ) {
			strcpy(buf, "&amp;");
			buf += 5;
		} else if( *str=='<' ) {
			strcpy(buf, "&lt;");
			buf += 4;
		} else if( *str=='>' ) {
			strcpy(buf, "&gt;");
			buf += 4;
		} else if( *str=='"' ) {
			strcpy(buf, "&quot;");
			buf += 6;
		} else if( *str=='\'' ) {
			strcpy(buf, "&apos;");
			buf += 6;
		} else *buf++ = *str;
		++str;
	}
	*buf = 0;
}

//==========================================================================
void ExportHelpPage(DWORD hFile, long pagid) {

	long	i, j, x, y, w, h, lasttab, flags, seennonimg, dx, tw, th, dw, dh, Gn, cf;
	long	gSIZE, lmargin, lensave, startX, f, maxh, Ztype, Znum, LIH, liseentext;
	long	tcnt, ttotW, tcolW, tclrnum, tcol;
	char	*s, *e, *d, *z, *li, *tp, c, *dsave, *nc, *tmp, tmp2[48];
	BOOL	intable=FALSE, comS, comH, InZ=FALSE, inp=FALSE, InG=FALSE;
	HELPOBJ	*pH;
	DWORD	hBM, hBF, hMEM, hSRC;
	BYTE	*pMEM;
	WORD	lhf, *tS, *tN;
	double	dgn;

	Gn = 0;			// default margin-bottom for graphics to 0
	comS = comH = FALSE;	// default no screen or html comment at start of each page
	
	for(i=0; i<NumHelpPages; i++) if( *((WORD *)(HelpPages[i]+4))==pagid ) break;
	if( i >= NumHelpPages ) return;
	
	s = HelpPages[i];
	e = s + *((DWORD *)s);	// get end of page
	s += 6;				// skip page len and ID
	d = s+2;			// ptr to TITLE
	s += *((WORD *)s);	// skip title
	dsave = s+2;		// ptr to SUBTITLE
	s += *((WORD *)s);	// skip subtitle

	fwrite(hFile, "<br>\r\n", 6);
	
	// output an id (mark/target) for link references to this page
	sprintf(ScratBuf, "<div id=\"L%2.2d%2.2d\"></div>\r\n", pagid, 0);
	fwrite(hFile, ScratBuf, strlen(ScratBuf));

	if( CurPlayer.HelpExportFlags & HEF_HRULE ) fwrite(hFile, hrule1, strlen(hrule1));

	// output the heading for this 'page'
//      <h2 style="text-align:left; top: 5px;">Help Contents</h2>
//      <h3>(REAL men don&#39;t ask for directions...)</h3><br>

	ScratBuf[0] = 0;
	if( *d ) {
		strcpy(ScratBuf, "<h2>");
		HTMLappend(ScratBuf, d);
		strcat(ScratBuf, "</h2>");
		if( *dsave ) {
			strcat(ScratBuf, " <h3>");
			HTMLappend(ScratBuf, dsave);
			strcat(ScratBuf, "</h3>");
		}
		strcat(ScratBuf, "<br>\r\n");
		fwrite(hFile, ScratBuf, strlen(ScratBuf));

		if( CurPlayer.HelpExportFlags & HEF_HRULE2 ) fwrite(hFile, hrule2, strlen(hrule2));
	}
	/*
	Miscellaneous HTML notes
	surrounding the <br> at the end of a line with:
	<span style="vertical-align: top; line-height: 150%;"><br></span>
	will cause the line break to be 1 1/2 lines instead of just one line,
	but will leave the rest of the paragraph single-spaced.
	
	Inside the <head></head> section, you can declare styles:
	<style>
	body {background-color: powderblue;}
	h1   {color: blue;}
	p    {color: red;}
	</style>
	
	body {
		background-color: black;
		color: white;
	}

	*/
	
	lmargin = seennonimg = lasttab = 0;
	while( s<e ) {	// locate/wrap all objects
		d = s+2;	// skip object length
		flags = *((WORD *)d);
		d += 2;		// skip flags
		if( (flags & 7)==4 ) {	// if stand-alone TAB (only outside a DIV)
			dw = (long)((flags>>8)&0x0FF);
			if( cf & (1<<tcol) ) strcpy(tmp2, " style=\"text-align: center;\"");
			else tmp2[0] = 0;
			if( dw==1 ) {
				if( inp ) {
					fwrite(hFile, "</p>", 4);
					inp = FALSE;
				}
				lasttab = (long)*((WORD*)d);
				sprintf(ScratBuf, "<p style=\"margin-left: %dem;\">", lasttab/2);
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
				inp = TRUE;
			} else if( dw==0 ) {	// end table
				intable = FALSE;
				sprintf(ScratBuf, "</td></tr>\r\n</tbody>\r\n</table>\r\n</div>\r\n");
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
			} else if( dw==252 ) {	// start-of-row
				tclrnum = *((WORD*)d);
				sprintf(ScratBuf, "<tr><td class=\"clr%d\"%s>", tclrnum, tmp2);
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
				tcol = 1;
			} else if( dw==253 ) {	// end-of-row
				sprintf(ScratBuf, "</td></tr>\r\n");
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
				tcol = 0;
			} else if( dw==255 ) {	// start new column
				sprintf(ScratBuf, "</td><td class=\"clr%d\"%s>", tclrnum, tmp2);
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
				++tcol;
			} else {	// starting table
				tcol = 0;
				tcnt = (*((WORD*)s) - 6)/2;
				tS = tN = (WORD*)d;
				cf = (long)*((WORD*)(s + *((WORD*)s) - 2));	// get column centering flags
				// add up width of table in UU
				for(i=1, ttotW=-(long)(*tN++); i<tcnt; i++) {
					ttotW += (long)(*tN)-(long)(*(tN-1));
					tN++;
				}
				// get width of left margin
				i = (long)*tS;
				intable = TRUE;
				sprintf(ScratBuf, "\r\n<div><table style=\"margin-left: %3.3fem; width: %3.3fem; border-collapse: collapse; cellpadding: 0px; cellspacing: 0px;\">\r\n", ((double)i)*0.34, ((double)ttotW)*0.34);
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
				for(i=1; i<tcnt; i++) {
					sprintf(ScratBuf, "<col style=\"width: %3.3fem;\">\r\n", ((double)(tS[i]-tS[i-1]))*0.34);
					fwrite(hFile, ScratBuf, strlen(ScratBuf));
				}
				sprintf(ScratBuf, "<tbody>\r\n");
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
			}
		}
		switch( flags & 0x0007 ) {
		 case 0:	// TEXT
			if( !InZ && !inp && !intable ) {
				inp = TRUE;
				strcpy(ScratBuf, "<p>");
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
			}
			
			if( flags & 0x80 ) fwrite(hFile, SpanRed, strlen(SpanRed));
			if( flags & 0x10 ) fwrite(hFile, "<b>", 3);
			if( flags & 0x20 ) fwrite(hFile, "<i>", 3);
			if( flags & 0x40 ) fwrite(hFile, "<u>", 3);

			ScratBuf[0] = 0;
			HTMLappend(ScratBuf, d);
			fwrite(hFile, ScratBuf, strlen(ScratBuf));
				
			if( flags & 0x40 ) fwrite(hFile, "</u>", 4);
			if( flags & 0x20 ) fwrite(hFile, "</i>", 4);
			if( flags & 0x10 ) fwrite(hFile, "</b>", 4);
			if( flags & 0x80 ) fwrite(hFile, "</span>", 7);
			liseentext = 1;
			break;
		 case 1:	// GAME GRAPHIC
			if( HackGU ) {
				hSRC = hHackGBM;
				gSIZE = HackGU;
			} else {
				hSRC = hGBM;
				gSIZE = GU;
			}
			goto expgraph;
		 case 2:	// UI GRAPHIC
			if( HackUU ) {
				hSRC = hHackUIBM;
				gSIZE = HackUU;
			} else {
				hSRC = hUIBM;
				gSIZE = UIBMU;
			}
			if( (flags & 7)==2 && (flags & 0x0300)==0x0200 ) {	// really @G>
				if( inp ) {
					fwrite(hFile, "</p>\r\n", 6);
					inp = FALSE;
				}
				fwrite(hFile, GEndTable, strlen(GEndTable));
				InG = FALSE;
			} else if( (flags & 7)==2 && (flags & 0x0300)==0x0300 ) {	// really @Gn>
				Gn = (flags>>10)&0x3F;
			} else {
				// we need to "glue together" any contiguous graphics
				// so that HTML can put a SPACE around them, altogether,
				// rather than around each image individually. So, we
				// need to process not just THIS graphic, but any
				// following graphic blocks until a non-graphic block
				// occurs.
				// NOTE: For ALL contiguous graphics, the scaling (i.e., w/dw) MUST be the same.
				// This is not checked/enforced by the the code, but the
				// HelpWriter MUST guarantee it, or all Hell will stroll
				// casually about.
				
				// first, scan through all contiguous graphics, building
				// a TOTAL sum of their target widths, terminating on the
				// first non-graphic or @G> (wrap past graphic).
expgraph:

				if( (flags & 7)!=2 || (flags & 0x0300)==00 ) {
					// starting a graphics/text block (table)
					InG = TRUE;
					if( CurPlayer.HelpExportWidth ) sprintf(ScratBuf+8000, " style=\"width: %dem; border: 1px solid #000;\"", CurPlayer.HelpExportWidth);
					else ScratBuf[8000] = 0;
					sprintf(ScratBuf, GStartTable, ScratBuf+8000);
					fwrite(hFile, ScratBuf, strlen(ScratBuf));
				}

				dsave = d;
				tw = th = 0;
				do {
					tw += 8*(*((WORD *)(dsave+8)));	// accumulate DST widths
					th = max(th, 8*(*((WORD*)(dsave+6)))*(*((WORD *)(d+8)))/(*((WORD *)(d+4))));	// find max DST heights for all @G objects
					dsave += 14;	// skip past @G object (14 = 2*7 (len,flags,x,y,w,h,dstW)), leaving dsave pointing at just past FLAGS of next object
					f = *((WORD*)(dsave-2));	// get FLAGS of next object
				// keep going as long as all are true:
				//	not past end of help text (dsave<e)
				//	next object is an @G object ((f & 7)>=1 && (f & 7)<=3)
				//	next object is not @G> "end graphics" ((f & 7)!=2 || !(f & 0x0200))
				} while( dsave<e && (f & 7)>=1 && (f & 7)<=3 && ((f & 7)!=2 || !(f & 0x0200)) );

				hBM = CreateBM(tw, th);
				SetAlphaBM(hBM, 0, 0, tw, th, 0xFFFFFFFFFFFFFFFFLL, 0);
				// now stretch each of the list of graphics into the amalgamated BM
				dx = 0;
				do {
					x = gSIZE*(*((WORD *)(d)));
					y = gSIZE*(*((WORD *)(d+2)));
					w = gSIZE*(*((WORD *)(d+4)));
					h = gSIZE*(*((WORD *)(d+6)));
					dw= 8*(*((WORD *)(d+8)));
					dh= dw*h/w;
					StretchBM(hBM, dx, 0, dw, dh, hSRC, x, y, w, h);
					dx += dw;
					d += 14;
					f = *((WORD*)(d-2));
				} while( d<e && (f & 7)>=1 && (f & 7)<=3 && ((f & 7)!=2 || !(f & 0x0200)) );
				s = d-18;	// move 's' back to the start of the last graphic block, so it can be skipped at the end of the loop
				// now save the amalgamated BM to a temp file and delete the memory bitmap
				SaveBM(hBM, TempBM, 1);	// save BM as a .PNG file
				DeleteBM(hBM);			// delete the BM

				x = fsize(TempBM);
				hMEM = HeapAlloc(x);	// allocate memory into which to read the .PNG file
				hBF = fopen(TempBM, O_RDBIN);
				pMEM = (BYTE*)HeapPtr(hMEM);
				fread(hBF, pMEM, x);
				fclose(hBF);
				fremove(TempBM);		// remove the .PNG file

				if( Gn ) {
					sprintf(tmp2, "margin-bottom:%.4fem;", ((double)Gn/4.0));
				} else tmp2[0] = 0;
				sprintf(ScratBuf, "<img style=\"%s\" alt=\"image\" width=\"%d\" height=\"%d\" src=\"data:image/png;base64,", tmp2, tw, th);
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
				fwrite64(hFile, pMEM, x);
				fwrite(hFile, "\"/>\r\n", 5);
				HeapFree(hMEM);
			}
			break;
		 case 3:	// HELP GRAPHIC
			hSRC = hHelpBM;
			gSIZE= 4;
			goto expgraph;
		 case 4:	// TAB
			break;	// handled before switch()
		 case 5:	// MARK #
			sprintf(ScratBuf, "<div id=\"L%2.2d%2.2d\"></div>", pagid, (flags>>8)&0xFF);
			fwrite(hFile, ScratBuf, strlen(ScratBuf));
			break;
		 case 6:	// HYPERLINK
			if( *((WORD*)d)==0xFFFF ) {	// special external link
					 if( *((WORD*)(d+2))==0 ) strcpy(ScratBuf, "<a href=\"https://www.kaser.com\">");
				else if( *((WORD*)(d+2))==1 ) strcpy(ScratBuf, "<a href=\"mailto:Everett%20Kaser%20%3Ceverett@kaser.com%3E\">");
				else if( *((WORD*)(d+2))==2 ) sprintf(ScratBuf,"<a href=\"%s\">", d+6);
			} else {
				sprintf(ScratBuf, "<a %shref=\"#L%2.2d%2.2d\">", (pagid==1?"style=\"text-decoration: none;\" ":""),*((WORD*)d), *((WORD*)(d+2)));
			}
			HTMLappend(ScratBuf, d+6);
			strcat(ScratBuf, "</a>");
			fwrite(hFile, ScratBuf, strlen(ScratBuf));
			break;
// ExportHelpPage()'s MISC handling
		 case 7:	// MISC
			switch( flags & 0x0038 ) {
			 case 0x0000:	// // LINE BREAK
				if( intable ) {
					sprintf(ScratBuf, "</td></tr>\r\n<tr><td>");
					fwrite(hFile, ScratBuf, strlen(ScratBuf));
				} else {
					// S==0 do 1.5 CR/LFs or </p> or </li>\r\n<li>
					// S==1 do 1 CR/LF or <br> or </li>\r\n<li>
					if( (flags & 0x0040)==0 ) {	// @L
						if( InZ ) {	// <li>\r\n<li>
							if( !liseentext ) strcpy(ScratBuf, "&nbsp;");
							else ScratBuf[0] = 0;
							if( li==s ) LIH = 0;
							sprintf(ScratBuf+strlen(ScratBuf), "</li>\r\n%s", ListLI[LIH]);
							liseentext = 0;
						} else if( inp ) {	// </p>
							strcpy(ScratBuf, "</p>\r\n");
							inp = FALSE;
						} else strcpy(ScratBuf, "<br>\r\n");
						fwrite(hFile, ScratBuf, strlen(ScratBuf));
					} else {	// @L0
						if( InZ ) {	// <li>\r\n<li>
							if( !liseentext ) strcpy(ScratBuf, "&nbsp;");
							else ScratBuf[0] = 0;
							if( li==s ) LIH = 0;
							sprintf(ScratBuf+strlen(ScratBuf), "</li>\r\n%s", ListLI[LIH]);
							liseentext = 0;
						} else if( inp ) {	// <br>\r\n
							strcpy(ScratBuf, "<br>\r\n");
						} else {	// <p>&nbsp;</p>\r\n
							strcpy(ScratBuf, "<p style=\"margin-bottom:0px;margin-top:0px;\">&nbsp;</p>\r\n");
						}
						fwrite(hFile, ScratBuf, strlen(ScratBuf));
					}
				}
				break;
			 case 0x0008:	// comment out on SCREEN
				if( (flags & 0x0040) && !inp ) {
					inp = TRUE;	// [*] note, so start a paragraph
					fwrite(hFile, "<p>", 3);
				}
				fwrite(hFile, d, strlen(d));	// write the literal stuff out
				break;
			 case 0x0010:	// comment out for HTML
				do {
					s += *((WORD *)s);	// skip it until end of page or end of HTML comment-out
				} while( s<e && (*((WORD*)(s+2)) & 0x03F)!=0x17 );
				break;
			 case 0x0018:	// start/end of LIST
				if( !InZ ) {	// starting LIST
					InZ = TRUE;
					Ztype = (flags>>6) & 3;
					Znum = 0;
					LIH = (flags>>8) & 7;
					if( inp ) {
						fwrite(hFile, "</p>\r\n", 6);
						inp = FALSE;
					}
					for(z=s; z<e && (*((WORD*)(z+2)) & 0x003F)!=0x001F; z+=*((WORD*)z)) {
						if( (*((WORD*)(z+2)) & 0x003F)==0x0007 ) {	// if @L or @L0 within list
							li = z;	// save it, eventually it will be the LAST @L, which needs a normal <li> to start the next line, ignoring LIH
						}
					}
				} else {
					InZ = FALSE;
				}
				// do auto @L at start and end of @Zn> (replaces an @L)
				if( InZ ) {
					if( li==s ) LIH = 0;
					sprintf(ScratBuf, "\r\n%s\r\n%s", ListStyle[Ztype], ListLI[LIH]);
				} else {
					sprintf(ScratBuf, "</li>\r\n%s\r\n", ListClose[Ztype]);
				}
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
				break;
			}
			break;
		}
		s += *((WORD *)s);	// skip this object, move on to the next one
	}
	if( inp ) fwrite(hFile, "</p>\r\n", 6);
	if( (CurPlayer.HelpExportFlags & HEF_LINKCONTENTS) && pagid > 1 ) {
		sprintf(LinkContents, "<br><a href=\"#L0100\">%s</a>\r\n", KString(BLK_DLG, STR_TABLE_CONTENTS));
		fwrite(hFile, LinkContents, strlen(LinkContents));
	}
}

DWORD	curExpClrNum, tmpExpFonts[HEFONT_NUM], curExpFontNum, tmpExpWidth;
long	InDoSetColor;

//==========================================================================
void DoSetColor(DWORD hsl) {
	
	++InDoSetColor;
	SendMsgID(ID_COLOR_PICKER, CPM_SETCOLOR_HSL, hsl, 0, 0);
	--InDoSetColor;
}

//==========================================================================
DWORD ExportColorProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	CHECKBOX	*pW;
	RECT		r;
	POINT		lp[2];
	
	pW = ((CHECKBOX*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
	 case WM_SETFOCUS:
		curExpClrNum = pW->id - ID_EXPCLR_BACK;
		CheckboxProc(hW, msg, arg1, arg2, arg3);
		DoSetColor(pW->color);
		return 0;
	 case WM_PAINT:
		CheckboxProc(hW, msg, arg1, arg2, arg3);
		GetRectWnd(hW, &r);
		if( pW->id - ID_EXPCLR_BACK == curExpClrNum ) {
			DrawRectBM(0, r.x, r.y, 7*UU+4, r.h, CLR_NONE, Colors[ClrTEXTfillCUR]);
			DrawRectBM(0, r.x+1, r.y+1, 7*UU+2, r.h-2, CLR_NONE, Colors[ClrTEXTfillCUR]);
		}
		return 0;
	}
	return CheckboxProc(hW, msg, arg1, arg2, arg3);
}

BOOL	gateSetFont=FALSE;

//==========================================================================
// html object types (p,h1,h2,h3)
DWORD FontButtonProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	RADIOBUTT	*pW;
	long		c;
	
	pW = ((RADIOBUTT*)HeapPtr(hW));
	c = pW->id - ID_EXFONT_TEXT;
	switch( msg ) {
	 case WM_ACTIVATE:
	 case WM_SETFOCUS:
		gateSetFont = TRUE;
		curExpFontNum = c;
		RadioButtonProc(hW, msg, arg1, arg2, arg3);
		SetCheckID(ID_EXFONT_DEF+tmpExpFonts[c], TRUE);
		gateSetFont = FALSE;
		return 0;
	}
	return RadioButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
// Specific font family radio buttons (Arial, Times New Roman, etc)
DWORD FontTypeProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	RADIOBUTT	*pW;
	long		c;
	
	pW = ((RADIOBUTT*)HeapPtr(hW));
	c = pW->id - ID_EXFONT_DEF;
	switch( msg ) {
	 case WM_ACTIVATE:
	 case WM_SETFOCUS:
		tmpExpFonts[curExpFontNum] = c;
		break;
	}
	return RadioButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
void SaveExpChanges() {
	
	long	i;
	
	memcpy((BYTE*)CurPlayer.HelpExportFonts, (BYTE*)&tmpExpFonts, sizeof(tmpExpFonts));
	
	CurPlayer.HelpExportFlags =0;
	for(i=0; i<HEC_NUMCOLORS; i++) {
		if( GetCheckID(ID_EXPCLR_BACK+i) ) CurPlayer.HelpExportFlags |= (HEF_BACK<<i);
		CurPlayer.HelpExportColors[i] = SendMsgID(ID_EXPCLR_BACK+i, CBM_GETCOLOR_HSL, 0, 0, 0);
	}
	if( GetCheckID(ID_EXPCLR_BACK) ) CurPlayer.HelpExportFlags |= HEF_BACK;
	if( GetCheckID(ID_EXPCLR_TEXT) ) CurPlayer.HelpExportFlags |= HEF_TEXT;
	if( GetCheckID(ID_HRULE) ) CurPlayer.HelpExportFlags |= HEF_HRULE;
	if( GetCheckID(ID_HRULE2) ) CurPlayer.HelpExportFlags |= HEF_HRULE2;
	if( GetCheckID(ID_LINKCONTENTS) ) CurPlayer.HelpExportFlags |= HEF_LINKCONTENTS;
	if( GetCheckID(ID_CP_HEX) ) CurPlayer.HelpExportFlags |= HEF_CP_HEX;

	CurPlayer.HelpExportWidth = SendMsgID(ID_EXPWIDTH, ELM_GETNUM, 0, 0, 0);
	CurPlayer.HelpExportLmargin = SendMsgID(ID_EXPLMARGIN, ELM_GETNUM, 0, 0, 0);
	CurPlayer.HelpExportContentWidth = SendMsgID(ID_EXPCONTENTW, ELM_GETNUM, 0, 0, 0);
	CurPlayer.HelpExportContentSpacing = SendMsgID(ID_EXPCONTENTSP, ELM_GETNUM, 0, 0, 0);
	CurPlayer.HelpExportRule1Top = SendMsgID(ID_HRULETOP, ELM_GETNUM, 0, 0, 0);
	CurPlayer.HelpExportRule1Bot = SendMsgID(ID_HRULEBOT, ELM_GETNUM, 0, 0, 0);
	CurPlayer.HelpExportRule2Top = SendMsgID(ID_HRULE2TOP, ELM_GETNUM, 0, 0, 0);
	CurPlayer.HelpExportRule2Bot = SendMsgID(ID_HRULE2BOT, ELM_GETNUM, 0, 0, 0);
}

//==========================================================================
DWORD ExportDlgProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	t;
	RECT	r;
	DIALOG	*pW;
	long	i;
	DWORD	hC;
	WND		*pC;
	
	pW = (DIALOG*)HeapPtr(hW);
	switch( msg ) {
	 case WM_CREATE:
		// tell ColorPicker to create edit controls and any other init stuff
		SendMsgID(ID_COLOR_PICKER, CPM_INIT, 0, 0, 0);
		
		// set Color Picker from ini
		
		// set tmpExpClr's from CurPlayer
		memcpy((BYTE*)&tmpExpFonts, (BYTE*)CurPlayer.HelpExportFonts, sizeof(tmpExpFonts));
		curExpFontNum = 0;
		gateSetFont = TRUE;
		SetCheckID(ID_EXFONT_TEXT+curExpFontNum, TRUE);
		SetCheckID(ID_EXFONT_DEF+tmpExpFonts[curExpFontNum], TRUE);
		gateSetFont = FALSE;
		
		for(i=0; i<HEC_NUMCOLORS; i++) {
			SetCheckID(ID_EXPCLR_BACK+i, CurPlayer.HelpExportFlags & (HEF_BACK<<i));
			SendMsgID(ID_EXPCLR_BACK+i, CBM_SETCOLOR_HSL, CurPlayer.HelpExportColors[i], 0, 0);
		}
		SetCheckID(ID_HRULE, CurPlayer.HelpExportFlags & HEF_HRULE);
		SetCheckID(ID_HRULE2, CurPlayer.HelpExportFlags & HEF_HRULE2);
		SetCheckID(ID_LINKCONTENTS, CurPlayer.HelpExportFlags & HEF_LINKCONTENTS);
		
		SendMsgID(ID_EXPWIDTH, ELM_SETNUM, CurPlayer.HelpExportWidth, 0, 0);
		SendMsgID(ID_EXPLMARGIN, ELM_SETNUM, CurPlayer.HelpExportLmargin, 0, 0);
		SendMsgID(ID_EXPCONTENTW, ELM_SETNUM, CurPlayer.HelpExportContentWidth, 0, 0);
		SendMsgID(ID_EXPCONTENTSP, ELM_SETNUM, CurPlayer.HelpExportContentSpacing, 0, 0);
		SendMsgID(ID_HRULETOP, ELM_SETNUM, CurPlayer.HelpExportRule1Top, 0, 0);
		SendMsgID(ID_HRULEBOT, ELM_SETNUM, CurPlayer.HelpExportRule1Bot, 0, 0);
		SendMsgID(ID_HRULE2TOP, ELM_SETNUM, CurPlayer.HelpExportRule2Top, 0, 0);
		SendMsgID(ID_HRULE2BOT, ELM_SETNUM, CurPlayer.HelpExportRule2Bot, 0, 0);

		SetFocusID(ID_EXPCLR_BACK);
		SendMsgID(ID_COLOR_PICKER, CPM_SETHEX, CurPlayer.HelpExportFlags & HEF_CP_HEX, 0, 0);
		break;
	 case WM_DESTROY:
		if( arg1==ID_OK ) SaveExpChanges();
		break;
	 case WM_NOTIFY:
		switch( arg1 ) {
		 case WN_MODIFIED:
			pC = (WND*)HeapPtr(arg2);
			if( !InDoSetColor ) {
				if( pC->id==ID_COLOR_PICKER ) {
					SendMsgID(ID_EXPCLR_BACK+curExpClrNum, CBM_SETCOLOR_HSL, arg3, 0, 0);
				}
			}
			return 0;
		 case WN_SELCHANGED:
			if( !gateSetFont ) {
				pC = (WND*)HeapPtr(arg2);
				if( pC->id>=ID_EXFONT_DEF && pC->id<=ID_EXFONT_GARAMOND ) {
					tmpExpFonts[curExpFontNum] = pC->id - ID_EXFONT_DEF;
				}
			}
			return 0;
		}
		break;
	}
	return DefDlgProc(hW, msg, arg1, arg2, arg3);
}

#define	DUMPHELPSTRUCTS	0

#if DUMPHELPSTRUCTS
char HT[]="TEXTGAMGUIG HLPGTAB MARKLINKNONE";
#endif

char	*fontStyles[HEFONT_NUM]={
	"p",
	"h1",
	"h2",
	"h3"
};

//==========================================================================
DWORD HSL2HTML(DWORD hsl) {
	
	DWORD	rgb, r, g, b;
	
	rgb = HSL2RGB(hsl);
	r = rgb & 0x0FF;
	g = (rgb>>8) & 0x0FF;
	b = (rgb>>16) & 0x0FF;
	return (((r<<8)|g)<<8)|b;
}

//==========================================================================
DWORD BGR2RGB(DWORD rgb) {
	
	DWORD	r, g, b;
	
	r = rgb & 0x0FF;
	g = (rgb>>8) & 0x0FF;
	b = (rgb>>16) & 0x0FF;
	return (((r<<8)|g)<<8)|b;
}

//==========================================================================
DWORD HelpExportProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	hFile, rgb, r, g, b, brgb, trgb;
	long	page, i;
	char	*pS;
	
#if DUMPHELPSTRUCTS
	long	flags, dw;
	char	*s, *e, *d, *dsave;
	BOOL	indiv=FALSE;

	// Dump the entire Help file's data structures to the file "HelpDump.txt" for easier debugging
	hFile = fopen("HelpDump.txt", O_WRBINNEW);
	for(page=0; page<NumHelpPages; page++) {
		s = HelpPages[0];
		e = s + *((DWORD *)s);	// get end of page
		s += 6;				// skip page len and ID
		d = s+2;			// ptr to TITLE
		s += *((WORD *)s);	// skip title
		dsave = s+2;		// ptr to SUBTITLE
		s += *((WORD *)s);	// skip subtitle
	
		fwrite(hFile, "======================================================================\r\n", 72);
		sprintf(ScratBuf, "PAGE %d: %s %s\r\n", pagid, d, dsave);
		fwrite(hFile, ScratBuf, strlen(ScratBuf));
		for(; s<e; s += *((WORD*)s)) {
			dw = *((WORD*)(s+2));
			switch( dw & 7 ) {
			 case 0:
				sprintf(ScratBuf, "%4.4s 0x%4.4X %s %s", HT+4*(dw & 7), dw, (dw & 8)?"BB":"  ", s+4);
				break;
			 case 1:
			 case 2:
			 case 3:
				sprintf(ScratBuf, "%4.4s 0x%4.4X %s", HT+4*(dw & 7), dw, (dw & 8)?"BB":"  ");
				break;
			 case 4:
			 case 5:
				sprintf(ScratBuf, "%4.4s 0x%4.4X %s 0x%2.2X", HT+4*(dw & 7), dw, (dw & 8)?"BB":"  ", (dw>>8)&0x0FF);
				break;
			 case 6:
				sprintf(ScratBuf, "%4.4s 0x%4.4X %s %s", HT+4*(dw & 7), dw, (dw & 8)?"BB":"  ", s+10);
				break;
			 case 7:
				sprintf(ScratBuf, "%4.4s 0x%4.4X %s", HT+4*(dw & 7), dw, (dw & 8)?"BB":"  ");
				break;
			}
			strcat(ScratBuf, "\r\n");
			fwrite(hFile, ScratBuf, strlen(ScratBuf));
		}
		fclose(hFile);
#endif

	if( msg==WM_ACTIVATE ) {
		if( ID_OK!=(r=DoModal(ExportDlg, hMenuDlg)) ) {
			if( r==ID_EXPHELP ) {
				PopupHelp((char*)resultModalarg2, 0);
				SendMsgID(ID_HELP_TEXT, WM_COMMAND, WC_SETSCROLLPOS, 0, HelpPageMarks[resultModalarg3]/HTH);
			}
			return 0;
		}
		
		strcpy(ScratBuf+1024, tmpMood.HelpName+4);
		ScratBuf[1024-4+strlen(ScratBuf+1024)] = 0;
		sprintf(ScratBuf, "Help%s_%s.html", pAtS[0], ScratBuf+1024);
		if( -1!=(hFile=fopen(ScratBuf, O_WRBINNEW)) ) {
			strcpy(ScratBuf, HelpExportHead1);
			HTMLappend(ScratBuf, pAtS[8]);	// HelpLang
			strcat(ScratBuf, HelpExportHead2);
			HTMLappend(ScratBuf, pAtS[1]);	// PgmTitle
			strcat(ScratBuf, HelpExportHead3);
			fwrite(hFile, ScratBuf, strlen(ScratBuf));

			brgb = HSL2HTML(CurPlayer.HelpExportColors[HEC_BACK]);
			trgb = HSL2HTML(CurPlayer.HelpExportColors[HEC_TEXT]);

			ScratBuf[1000] = ScratBuf[1100] = ScratBuf[1200] = ScratBuf[1300] = 0;
			if( CurPlayer.HelpExportFlags & HEF_BACK ) sprintf(ScratBuf+1000, "\t\t\tbackground-color: #%6.6X;\r\n", brgb);
			if( CurPlayer.HelpExportFlags & HEF_TEXT ) sprintf(ScratBuf+1100, "\t\t\tcolor: #%6.6X;\r\n", trgb);
			sprintf(ScratBuf+1200, "\t\t\tmargin-left: %dem;\r\n", CurPlayer.HelpExportLmargin+(CurPlayer.HelpExportContentWidth ? (CurPlayer.HelpExportContentWidth+1) : 0));
			if( CurPlayer.HelpExportWidth ) sprintf(ScratBuf+1300, "\t\t\tmax-width: %dem;\r\n", CurPlayer.HelpExportWidth);
			sprintf(ScratBuf, HelpExportBody, ScratBuf+1000, ScratBuf+1100, ScratBuf+1200, ScratBuf+1300);
			fwrite(hFile, ScratBuf, strlen(ScratBuf));

			ScratBuf[1000] = ScratBuf[1100] = ScratBuf[1200] = 0;
			if( CurPlayer.HelpExportFlags & HEF_HEADBACK ) sprintf(ScratBuf+1000, "\t\t\tbackground-color: #%6.6X;\r\n", HSL2HTML(CurPlayer.HelpExportColors[HEC_HEADBACK]));
			if( CurPlayer.HelpExportFlags & HEF_HEADTEXT ) sprintf(ScratBuf+1100, "\t\t\tcolor: #%6.6X;\r\n", HSL2HTML(CurPlayer.HelpExportColors[HEC_HEADTEXT]));
			if( CurPlayer.HelpExportFlags & HEF_HEADFRAME) sprintf(ScratBuf+1200, "\t\t\tborder: 1px solid #%6.6X;\r\n", HSL2HTML(CurPlayer.HelpExportColors[HEC_HEADFRAME]));
			sprintf(ScratBuf, HelpHeadFoot, ScratBuf+1000, ScratBuf+1100, ScratBuf+1200);
			fwrite(hFile, ScratBuf, strlen(ScratBuf));
			
			for(i=0; i<3; i++) {
				if( CurPlayer.HelpExportFlags & (HEF_H1<<i) ) {
					brgb = HSL2HTML(CurPlayer.HelpExportColors[HEC_H1+i]);
					sprintf(ScratBuf, "\t\th%d {color: #%6.6X;}\r\n", i+1, brgb);
					fwrite(hFile, ScratBuf, strlen(ScratBuf));
				}
			}
			for(i=0; i<HEFONT_NUM; i++) {
				if( CurPlayer.HelpExportFonts[i] ) {
					sprintf(ScratBuf, "\t\t%s {font-family: %s;}\r\n", fontStyles[i], KString(BLK_DLG, STR_EXFONT_DEF+CurPlayer.HelpExportFonts[i]));
					fwrite(hFile, ScratBuf, strlen(ScratBuf));
				}
			}
			if( CurPlayer.HelpExportFonts[0] ) sprintf(ScratBuf, "font-family: %s;", KString(BLK_DLG, STR_EXFONT_DEF+CurPlayer.HelpExportFonts[0]));
			else ScratBuf[0] = 0;
			sprintf(ListStyle[0], "<ul style=\"list-style-type:none;%s\">", ScratBuf);
			sprintf(ListStyle[1], "<ul style=\"list-style-type:disc;%s\">", ScratBuf);
			sprintf(ListStyle[2], "<ol class=\"ekl0\" style=\"%s\">", ScratBuf);
			sprintf(ListStyle[3], "<ol class=\"ekl1\" style=\"%s\">", ScratBuf);
			
			fwrite(hFile, HelpExportStyle1, strlen(HelpExportStyle1));
			
			sprintf(ScratBuf, "\t\ttd {padding-left: %3.3fem;}\r\n", 0.34);
			fwrite(hFile, ScratBuf, strlen(ScratBuf));
			for(i=0; i<TableColorCnt; i++) {
				rgb = BGR2RGB(TableColor[i].frame);
				brgb= BGR2RGB(TableColor[i].back);
				trgb= BGR2RGB(TableColor[i].text);
				sprintf(ScratBuf, "\t\ttd.clr%d {border: 1px solid #%6.6X; background-color: #%6.6X; color: #%6.6X;}\r\n", i, rgb, brgb, trgb);
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
			}
			
			ScratBuf[1000] = 0;
			if( CurPlayer.HelpExportWidth ) {
				sprintf(ScratBuf+1000, "max-width:%dem;", CurPlayer.HelpExportWidth);
			}
			sprintf(ScratBuf, HelpExportStyle15, ScratBuf+1000);
			fwrite(hFile, ScratBuf, strlen(ScratBuf));

			
			sprintf(ScratBuf, HelpExportStyle2, KString(BLK_DLG, STR_NOTE));
			fwrite(hFile, ScratBuf, strlen(ScratBuf));

			if( CurPlayer.HelpExportContentWidth ) {
				fwrite(hFile, HelpExportStyle3, strlen(HelpExportStyle3));

				ScratBuf[8000] = ScratBuf[8100] = ScratBuf[8200] = 0;
				if( CurPlayer.HelpExportFlags & HEF_CONTBACK ) {
					brgb = HSL2HTML(CurPlayer.HelpExportColors[HEC_CONTBACK]);
					sprintf(ScratBuf+8000, "\t\t\tbackground-color: #%6.6X;\r\n", brgb);
				}
				if( CurPlayer.HelpExportFlags & HEF_CONTTEXT ) {
					brgb = HSL2HTML(CurPlayer.HelpExportColors[HEC_CONTTEXT]);
					sprintf(ScratBuf+8100, "\t\t\tcolor: #%6.6X;\r\n", brgb);
				}
				if( CurPlayer.HelpExportFlags & HEF_CONTLINK ) {
					brgb = HSL2HTML(CurPlayer.HelpExportColors[HEC_CONTLINK]);
					sprintf(ScratBuf+8200, "color: #%6.6X;", brgb);
				}
				sprintf(ScratBuf, HelpExportStyle35,
					ScratBuf+8000,
					ScratBuf+8100,
					CurPlayer.HelpExportContentWidth,
					CurPlayer.HelpExportContentWidth-1,
					(double)(long)CurPlayer.HelpExportContentSpacing*0.1,
					ScratBuf+8200);
				fwrite(hFile, ScratBuf, strlen(ScratBuf));
			}
			sprintf(ScratBuf, HelpExportStyle36,
				(double)(long)CurPlayer.HelpExportRule1Top*0.1,
				(double)(long)CurPlayer.HelpExportRule1Bot*0.1,
				(double)(long)CurPlayer.HelpExportRule2Top*0.1,
				(double)(long)CurPlayer.HelpExportRule2Bot*0.1
			);
			fwrite(hFile, ScratBuf, strlen(ScratBuf));

			fwrite(hFile, HelpExportStyle4, strlen(HelpExportStyle4));
			
			if( HelpIconX >= 0 ) {	// output icon link
				DWORD	hBM, hMEM, hBF;
				BYTE	*pMEM;
				long	x;
				
				hBM = CreateBM(32, 32);
				SetAlphaBM(hBM, 0, 0, 32, 32, 0xFFFFFFFFFFFFFFFFLL, 0);
				DrawBM(hBM, 0, 0, hHelpBM, HelpIconX*4, HelpIconY*4, 32, 32, 0);
				// now save the icon BM to a temp file and delete the memory bitmap
				SaveBM(hBM, TempBM, 1);	// save BM as a .PNG file
				DeleteBM(hBM);			// delete the BM

				x = fsize(TempBM);
				hMEM = HeapAlloc(x);	// allocate memory into which to read the .PNG file
				hBF = fopen(TempBM, O_RDBIN);
				pMEM = (BYTE*)HeapPtr(hMEM);
				fread(hBF, pMEM, x);
				fclose(hBF);
				fremove(TempBM);		// remove the .PNG file

				fwrite(hFile, HelpIcon, strlen(HelpIcon));
				fwrite64(hFile, pMEM, x);
				fwrite(hFile, "\"/>\r\n", 5);
				HeapFree(hMEM);
			}
			if( hHelpStyle ) {	// dump custom @S> header (style or whatever) stuff
				pS = (char*)HeapPtr(hHelpStyle);
				fwrite(hFile, pS, strlen(pS));
			}
			fwrite(hFile, HelpExportHead35, strlen(HelpExportHead35));
			
			if( CurPlayer.HelpExportContentWidth ) {
				// now output the CONTENTS block for the left column
				fwrite(hFile, HelpExportHead351, strlen(HelpExportHead351));
				for(page=0; page<NumHelpPages; page++) {
					if( page!=1 ) {
						for(i=0; i<NumHelpPages; i++) if( *((WORD *)(HelpPages[i]+4))==page ) break;
						sprintf(ScratBuf, "\t\t<p class=\"contents\"><a class=\"link\" href=\"#L%2.2d00\">%s</a></p>\r\n", page, HelpPages[i]+8);
						fwrite(hFile, ScratBuf, strlen(ScratBuf));
					}
				}
				fwrite(hFile, HelpExportHead352, strlen(HelpExportHead352));
			}
			
			fwrite(hFile, HelpExportHead36, strlen(HelpExportHead36));

			ScratBuf[0] = 0;
			HTMLappend(ScratBuf, pAtS[1]);	// PgmTitle
			strcat(ScratBuf, HelpExportHead4);
			strcat(ScratBuf, HelpExportHead5);
			HTMLappend(ScratBuf, Copyright);
			strcat(ScratBuf, "</p>");
			strcat(ScratBuf, HelpExportHead5);
			strcat(ScratBuf, HelpExportByEK);
			strcat(ScratBuf, "<br>");
			if( strcmp(HelpCredits, HelpExportByEK) ) sprintf(ScratBuf+strlen(ScratBuf), "%s<br>", HelpCredits);
			strcat(ScratBuf, "<br>\r\n");
			strcat(ScratBuf, HelpExportByOther);
			
			fwrite(hFile, ScratBuf, strlen(ScratBuf));

			for(page=0; page<NumHelpPages; page++) {
				ExportHelpPage(hFile, page);
			}
			fwrite(hFile, "<br><br><br>", 12);

			sprintf(ScratBuf, "<footer>%s</footer></div>", KString(BLK_DLG, STR_EXPORT_FOOTER));
			fwrite(hFile, ScratBuf, strlen(ScratBuf));

			fwrite(hFile, HelpExportFoot, strlen(HelpExportFoot));
			fclose(hFile);
			
			// regenerate output filename
			strcpy(ScratBuf+1024, tmpMood.HelpName+4);
			ScratBuf[1024-4+strlen(ScratBuf+1024)] = 0;
			sprintf(ScratBuf, "Help%s_%s.html", pAtS[0], ScratBuf+1024);
			
			// show where the exported file is
			GetAppDataPath(ScratBuf+1024);
			sprintf(ScratBuf+2048, KString(BLK_DLG, STR_HEXPTO), ScratBuf+1024, ScratBuf);
			MessageBox(ScratBuf+2048, MB_OK);
		}
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD HelpPrevProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i;
	WND		*pW;

	pW = ((WND*)HeapPtr(hW));
	if( msg==WM_ACTIVATE ) {
		for(i=0; i<NumHelpPages; i++) if( *((WORD *)(HelpPages[i]+4))==CurHelpPage ) break;
		if( i ) {
			++BlockPaint;
			SendMsg(pW->parent, HM_HYPERJUMP, *((WORD *)(HelpPages[i-1]+4)), 0, 0);
			--BlockPaint;
		} else BeepIll();
		return 0;
	} else if( msg==WM_PAINT ) {
		for(i=0; i<NumHelpPages; i++) if( *((WORD *)(HelpPages[i]+4))==CurHelpPage ) break;
		pW->flags &= ~CF_DISABLED;
		if( i==0 ) pW->flags |= CF_DISABLED;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD HelpNextProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i;
	WND		*pW;

	pW = ((WND*)HeapPtr(hW));
	if( msg==WM_ACTIVATE ) {
		for(i=0; i<NumHelpPages; i++) if( *((WORD *)(HelpPages[i]+4))==CurHelpPage ) break;
		if( i < NumHelpPages-1 ) {
			++BlockPaint;
			SendMsg(pW->parent, HM_HYPERJUMP, *((WORD *)(HelpPages[i+1]+4)), 0, 0);
			--BlockPaint;
		} else BeepIll();
		return 0;
	} else if( msg==WM_PAINT ) {
		for(i=0; i<NumHelpPages; i++) if( *((WORD *)(HelpPages[i]+4))==CurHelpPage ) break;
		pW->flags &= ~CF_DISABLED;
		if( i>=NumHelpPages-1 ) pW->flags |= CF_DISABLED;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
void PopupHelp(char *pagnam, long mark) {
	
	// called when MenuDlg is NOT already up
	// So:
	//	Set MenuCurSelID = ID_MENU_HELP
	//	Set CurHelpPage = page
	//	Set CurHelpMark = mark
	//	Create MenuDlg
	// May need a few other state-flags or something to make Help come up at the right spot
	
	long	page;
	
	if( !hMenuDlg ) {
		SendMsgID(ID_MENU_BUTT, WM_ACTIVATE, (DWORD)GoHelpName, mark, ID_MENU_HELP);
	} else {
		if( MenuCurSelID != ID_MENU_HELP ) SendMsgID(ID_MENU_HELP, WM_ACTIVATE, 0, 0, 0);
		for(page=0; page<NumHelpPages; page++) if( !strcmp(pagnam, HelpPageNames[page]) ) break;
		
		if( CurHelpPage!=page || CurHelpMark!=mark ) GoHelp(pagnam, mark);
	}
}

//==========================================================================
DWORD ExpHelpButtProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	if( msg==WM_ACTIVATE ) {
		SaveExpChanges();
		SendMsg(((WND*)HeapPtr(hW))->parent, WM_DESTROY, ID_EXPHELP, (DWORD)"TOOLMENU", 1);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD ExpSaveButtProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	if( msg==WM_ACTIVATE ) {
		SaveExpChanges();
		SendMsg(((WND*)HeapPtr(hW))->parent, WM_DESTROY, ID_CANCEL, 0, 0);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

// for generating the proper DrawTextBM() flags from the HELPOBJ flags
DWORD	HelpTextFlags[]={
	0,
	CF_BOLD,
	CF_ITALIC,
	CF_BOLD | CF_ITALIC,
	CF_UNDERLINE,
	CF_UNDERLINE | CF_BOLD,
	CF_UNDERLINE | CF_ITALIC,
	CF_UNDERLINE | CF_BOLD | CF_ITALIC
};

//==========================================================================
DWORD HelpTextProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	WNDSCROLL	*pW;
	SBINFO		sbi;
	RECT	r, rc, ir;
	long	i, x, y, w, h, fH, fU, startY, dx, dy, dw, dh, ys, xs, bot, gSIZE;
	DLGRES	*pDR;
	HELPOBJ	*pH;
	BYTE	c;
	POINT	lp[3];
	DWORD	ix, iy, iw, ih, clr, backclr;
	DWORD	hImg, hSRC;
	long	x1, x2, y1, y2, flags;
	long	tableX[32], tableCol=-1, tableH=(5*HTH+1)/4, tableDY=(tableH-HTH)/2, curtabclr=0;

	pW = (WNDSCROLL*)HeapPtr(hW);
	switch( msg ) {
	 case WM_CREATE:
		// gateHelpScroll gets set in the here and it
		// prevents WN_SCROLL notifications to from 
		// saving invalid preliminary values for the Vscroll position until we've
		// had a chance to restore it in AddMenuCtls.
		gateHelpScroll = TRUE;
		pDR = (DLGRES*)arg1;
		x = pDR->ux * UU;
		y = pDR->uy * UU;
		w = pDR->uw * UU;
		h = pDR->uh * UU;
		hW = AllocateWnd(pDR->id, WT_WNDSCROLL, x, y, w, h, pDR->flags | WF_WNDSCROLL, arg2, HelpTextProc, sizeof(WNDSCROLL));
		
		pW = (WNDSCROLL*)HeapPtr(hW);

		pW->surfW = 1;
		pW->surfH = 1;
		pW->ppuX = 1;
		pW->ppuY = HTH;
		pW->clientOffX = pW->clientOffY = UU/2;
		pW->clientW = pW->clientH = pW->h-UU;

		pW->pRES = pDR;
		
		w = UU3;
		
		pW->hScrollV = CreateScrollbar(SendMsg(hW, WM_COMMAND, WC_GETSCROLLID, 0, 0), pW->w - w, 0, w, pW->h, CF_VERSCROLL, hW, 0);
		pW->hScrollH = CreateScrollbar(SendMsg(hW, WM_COMMAND, WC_GETSCROLLID, 1, 0), 0, pW->h - w, pW->w-w, w, 0, hW, 0);

		InvalidateAllWnd(hW);
		return hW;
	 case WM_NOTIFY:
		switch( arg1 ) {
		 case WN_SCROLL:
			if( !gateHelpScroll && arg2==pW->hScrollV ) {
				SendMsg(pW->hScrollV, WM_COMMAND, WC_GETSCROLLINFO, (DWORD)&sbi, 0);
				CurHelpScroll = sbi.Pos;
			}
			break;
		}
		break;
	 case WM_PAINT:
		GetRectWnd(hW, &r);
		if( GetRectInvalid(&ir) ) {
			if( IntersectRect(&ir, &r) ) {
				LinkCnt = 0;
				ClipRectBM(0, ir, &rc);

				dx = r.x;
				dy = r.y;
				dw = r.w;
				dh = r.h;

				xs = X_INBOX*UIBMU;
				ys = Y_INBOX*UIBMU;

				backclr = Colors[ClrHelpBack];
				clr = GetPixelBM(hUIBMO, X_INBOX*UIBMUO+UIBMUO-1, Y_INBOX*UIBMUO+UIBMUO-1);
				DrawRectBM(0, dx, dy, dw, dh, clr, CLR_NONE);
				
				RepDrawBM(0, dx, dy, hUIBM, xs, ys, UIBMU, UIBMU, 0, 0, 0);	// top-left corner
				RepDrawBM(0, dx+UU, dy, hUIBM, xs+UIBMU, ys, UIBMU4, UIBMU, 0, dx+dw-UU, 0);	// top
				RepDrawBM(0, dx+dw-UU, dy, hUIBM, xs+5*UIBMU, ys, UIBMU, UIBMU, 0, 0, 0);	// top-right corner
				RepDrawBM(0, dx, dy+UU, hUIBM, xs, ys+UIBMU, UIBMU, UIBMU4, 0, 0, dy+dh-UU);	// left
				RepDrawBM(0, dx+dw-UU, dy+UU, hUIBM, xs+5*UIBMU, ys+UIBMU, UIBMU, UIBMU4, 0, 0, dy+dh-UU);	// right
				RepDrawBM(0, dx, dy+dh-UU, hUIBM, xs, ys+5*UIBMU, UIBMU, UIBMU, 0, 0, 0);	// bottom-left corner
				RepDrawBM(0, dx+UU, dy+dh-UU, hUIBM, xs+UIBMU, ys+5*UIBMU, UIBMU4, UIBMU, 0, dx+dw-UU, 0);	// bottom
				RepDrawBM(0, dx+dw-UU, dy+dh-UU, hUIBM, xs+5*UIBMU, ys+5*UIBMU, UIBMU, UIBMU, 0, 0, 0);	// bottom-right corner

				r.x += UU/2;
				r.y += UU/2;
				r.w -= UU;
				r.h -= UU;
				GetRectInvalid(&ir);
				IntersectRect(&ir, &r);

				ClipRectBM(0, ir, NULL);

				startY = r.y - pW->scrollY*HTH;
				pH = HelpPage;
		/*
		The FLAGS word in an OBJECT has this bitwise layout:
		 vvvv vvvv ruib nttt	for TABS and MARKS
		 xxxx xxgx ruib nttt	for GRAPHICS
		 xxxx xxxx ruib nttt	for all others
		where:
		 ttt is the TYPE of the object:
				0 text
				1 GAME graphic
				2 UI graphic
				3 HELP graphic
				4 TAB
				5 page MARK
				6 HYPERTEXT LINK
				7 no object (as in a series of new-lines)
		 n is set if break to a new line before displaying this object
		 b is set if text is BOLD
		 i is set if text is ITALIC
		 u is set if text is UNDERLINED
		 r is set if text is RED rather than BLACK
		 g is set if a UI GRAPHIC is really an "@G>" 'break graphic'
		 vvvvvvvv is the absolute number of LUs for the TAB to move over from the left margin
				and is the MARK number for MARKS.
		 x bits are unused

		*/
				bot = r.x+r.h;
				while( pH->p && startY+pH->y < r.x+r.h) {
					x1 = r.x + pH->x;
					y1 = startY + pH->y;
					if( y1<bot ) {
						switch( pH->flags & 7 ) {
						 case 0:	// draw TEXT
							c = pH->p[pH->len];
							pH->p[pH->len] = 0;
							clr = (pH->flags & 0x0080)? CLR_RED : Colors[ClrHelpText];
							flags = HelpTextFlags[(pH->flags>>4)&0x07];	// get bold,italic,underline bits
							if( y1+HTH>r.y ) {
								if( tableCol>=0 ) DrawTextBM(0, pH->p, x1, y1, r.w-(x1-r.x), HTH, flags, TableColor[curtabclr].back, TableColor[curtabclr].text);
								else DrawTextBM(0, pH->p, x1, y1, r.w-(x1-r.x), HTH, flags, backclr, clr);
							}
							pH->p[pH->len] = c;
							break;
						 case 1:	// draw GAME GRAPHIC
							if( HackGU ) {
								hSRC = hHackGBM;
								gSIZE = HackGU;
							} else {
								hSRC = hGBM;
								gSIZE = GU;
							}
							goto drawgraph;
						 case 2:	// draw UI GRAPHIC
							if( !(pH->flags & 0x0200) ) {
								if( HackUU ) {
									hSRC = hHackUIBM;
									gSIZE = HackUU;
								} else {
									hSRC = hUIBM;
									gSIZE = UIBMU;
								}
								goto drawgraph;
							}
							break;
						 case 3:	// draw HELP GRAPHIC
							hSRC = hHelpBM;
							gSIZE = 4;
		drawgraph:
							ix = *((WORD *)(pH->p+0)) * gSIZE;
							iy = *((WORD *)(pH->p+2)) * gSIZE;
							iw = *((WORD *)(pH->p+4)) * gSIZE;
							ih = *((WORD *)(pH->p+6)) * gSIZE;

							w  = *((WORD *)(pH->p+8)) * UU;
							h  = (w*ih)/iw;
							if( y1+h>r.y ) StretchBM(0, x1, y1, w, h, hSRC, ix, iy, iw, ih);
							break;
						 case 4:	// tab/table
							dw = (long)((pH->flags>>8) & 0x0FF);
							if( dw==0 ) {	// end of current table
								tableCol=-1;
							} else if( dw==1 ) {	// simple tab, not a table
								// handled in WrapHelp
							} else if( dw==252 ) {	// start-of-row
								tableCol = 0;
								curtabclr = (long)pH->len;
								goto drawbox;
							} else if( dw==253 ) {	// end-of-row
								tableCol = 0;
							} else if( dw==255 ) {	// advance to next tab
								++tableCol;
drawbox:
								w  = tableX[tableCol+1]-tableX[tableCol]+1;
								h  = tableH+1;
								DrawRectBM(0, x1-1, y1-tableDY, w, h, TableColor[curtabclr].back, TableColor[curtabclr].frame);
							} else {	// start table
								// set table column pixel X offsets
								for(i=0; i<pH->len; i++) tableX[i] = (long)(*((WORD*)(pH->p+2*i)))*UU;
								tableCol = 0;
							}
							break;
						 case 6:	// hypertext link
							if( y1+HTH>r.y ) {
								w = DrawTextBM(0, pH->p+6, x1, y1, r.w-(x1-r.x), HTH, CF_UNDERLINE, Colors[ClrHelpBack], Colors[ClrHelpLink])>>16;

			//				w = SysDrawText(0, x1, y1, r.x2, r.y2, pH->p+6, Fonts[LU][0], kUI.ColorEditBack, kUI.ColorHelpLink, CTL_TOP_LEFT, 8)>>16;

								HelpLinks[LinkCnt].x1 = x1;
								HelpLinks[LinkCnt].y1 = y1;
								HelpLinks[LinkCnt].x2 = x1+w;
								HelpLinks[LinkCnt].pid= *((WORD *)pH->p);
								HelpLinks[LinkCnt].mid= *((WORD *)(pH->p+2));
								HelpLinks[LinkCnt++].p = pH->p+6;
							}
							break;
						 default:
							break;
						}
					}
					++pH;
				}
				ClipRectBM(0, rc, NULL);
			}
		}
		NotifyChildren(hW, WM_PAINT, 0, 0, 0);
		return 0;
	 case WM_HOVER:
		return 0;
	 case WM_PTRMOVE:
		for(ih=0; ih<LinkCnt; ih++) {
			if( (long)arg1>=HelpLinks[ih].x1 && (long)arg1<HelpLinks[ih].x2
			 && (long)arg2>=HelpLinks[ih].y1 && (long)arg2<HelpLinks[ih].y1+HTH ) break;
		}
		if( ih<LinkCnt ) {
			if( HelpCursor!=1 ) {
				SetCursor(CURSOR_LINK);
				HelpCursor = 1;
			}
		} else if( HelpCursor ) {
			if( HelpCursor!=0 ) {
				SetCursor(CURSOR_NORMAL);
				HelpCursor = 0;
			}
		}
		return 0;
	 case WM_LBUTTUP:
		for(ih=0; ih<LinkCnt; ih++) {
			if( (long)arg1>=HelpLinks[ih].x1 && (long)arg1<HelpLinks[ih].x2
			 && (long)arg2>=HelpLinks[ih].y1 && (long)arg2<HelpLinks[ih].y1+HTH ) break;
		}
		if( ih<LinkCnt ) {
			if( HelpLinks[ih].pid==0x0FFFF ) {	// special external link?
				switch( HelpLinks[ih].mid ) {
				 case 0:
					DoHTML("https://www.kaser.com");
					break;
				 case 1:
					DoHTML("mailto:Everett Kaser%20%3Ceverett@kaser.com%3E");
					break;
				 case 2:
					DoHTML(HelpLinks[ih].p);
					break;
				}
			} else {
				SendMsg(pW->parent, HM_HYPERJUMP, HelpLinks[ih].pid, HelpLinks[ih].mid, 0);
			}
		}
		return 0;
	 case WM_PARENTSIZED:
		if( pW->uu != UU ) {
			HelpChange();
		}
		break;
	}
	return ScrollWndProc(hW, msg, arg1, arg2, arg3);
}

long	SecretPDclickCnt;

//==========================================================================
DWORD HelpTitleProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	WND		*pW;
	RECT	r, rc, ir;
	long	x, y, w, h, dx, dy, dw, dh, xs, ys;
	DLGRES	*pDR;
	DWORD	clr;

	if( msg!=WM_CREATE ) pW = (WND*)HeapPtr(hW);
	switch( msg ) {
	 case WM_CREATE:
		pDR = (DLGRES*)arg1;
		hW = AllocateWnd(pDR->id, pDR->type, pDR->ux*UU, pDR->uy*UU, pDR->uw*UU, pDR->uh*UU, pDR->flags, arg2, HelpTitleProc, sizeof(WND));
		pW = (WND*)HeapPtr(hW);
		pW->pRES = pDR;
		InvalidateAllWnd(hW);
		return hW;
	 case WM_PAINT:
		GetRectWnd(hW, &r);
		if( GetRectInvalid(&ir) ) {
			if( IntersectRect(&ir, &r) ) {
				ClipRectBM(0, ir, &rc);

				dx = r.x;
				dy = r.y;
				dw = r.w;
				dh = r.h;

				xs = X_INBOX*UIBMU;
				ys = Y_INBOX*UIBMU;

				clr = GetPixelBM(hUIBMO, X_INBOX*UIBMUO+UIBMUO-1, Y_INBOX*UIBMUO+UIBMUO-1);
				DrawRectBM(0, dx, dy, dw, dh, clr, CLR_NONE);
				
				RepDrawBM(0, dx, dy, hUIBM, xs, ys, UIBMU, UIBMU, 0, 0, 0);	// top-left corner
				RepDrawBM(0, dx+UU, dy, hUIBM, xs+UIBMU, ys, UIBMU4, UIBMU, 0, dx+dw-UU, 0);	// top
				RepDrawBM(0, dx+dw-UU, dy, hUIBM, xs+5*UIBMU, ys, UIBMU, UIBMU, 0, 0, 0);	// top-right corner
				RepDrawBM(0, dx, dy+UU, hUIBM, xs, ys+UIBMU, UIBMU, UIBMU4, 0, 0, dy+dh-UU);	// left
				RepDrawBM(0, dx+dw-UU, dy+UU, hUIBM, xs+5*UIBMU, ys+UIBMU, UIBMU, UIBMU4, 0, 0, dy+dh-UU);	// right
				RepDrawBM(0, dx, dy+dh-UU, hUIBM, xs, ys+5*UIBMU, UIBMU, UIBMU, 0, 0, 0);	// bottom-left corner
				RepDrawBM(0, dx+UU, dy+dh-UU, hUIBM, xs+UIBMU, ys+5*UIBMU, UIBMU4, UIBMU, 0, dx+dw-UU, 0);	// bottom
				RepDrawBM(0, dx+dw-UU, dy+dh-UU, hUIBM, xs+5*UIBMU, ys+5*UIBMU, UIBMU, UIBMU, 0, 0, 0);	// bottom-right corner

				
				if( CurHelpPage<2 ) {
					StretchBM(0, r.x+UU2, r.y+UU, 12*330*UU/120, 12*UU, hSplashBM, 200, 460, 330, 120);
					h = 12*UU;
					w = 200*h/120;
					StretchBM(0, r.x+r.w-2*UU-w, r.y+UU, w, h, hSplashBM, 0, 460, 200, 120);
					y = r.y+UU/2;
					DrawTextBM(0, pAtS[1], r.x, y, r.w, HTH, CF_CENTER | CF_BOLD, CLR_NONE, Colors[ClrHelpTitle]);
					y += 5*UU;
					DrawTextBM(0, HelpText1, r.x, y, r.w, 3*UU, CF_CENTER | CF_ITALIC, CLR_NONE, Colors[ClrHelpSubTitle]);
					y += 7*UU/2;
					DrawTextBM(0, HelpText2, r.x, y, r.w, 3*UU, CF_CENTER | CF_ITALIC, CLR_NONE, Colors[ClrHelpSubTitle]);
				} else {
					h = r.h-8;
					w = h*4/5;
					StretchBM(0, r.x+UU2, r.y+4, w, h, hSplashBM, 530, 460, 32, 40);
					x = r.x+(2+4+2)*UU;
					w = DrawTextBM(0, HelpTitleStr, x, r.y+UU, r.w - (x - r.x), HTH, CF_LEFT | CF_BOLD, CLR_NONE, Colors[ClrHelpTitle])>>16;
					x += w+5*UU;
					DrawTextBM(0, HelpSubtitleStr, x, r.y+UU, r.w - (x - r.x), HTH, CF_LEFT, CLR_NONE, Colors[ClrHelpSubTitle]);
				}
				ClipRectBM(0, rc, NULL);
			}
		}
		break;
	 case WM_LBUTTUP:
		if( SecretPDclickCnt==5 ) {
			BeepCool();
			CurPlayer.SolvedTotal += SPECIAL_TOTAL;
		} else if( SecretPDclickCnt==6 ) {
			BeepJustify();
			TestBest = TRUE;
		}
		break;
	 case WM_RBUTTUP:
		++SecretPDclickCnt;
		break;
	}
	return DefWndProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD HelpChangedProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	RECT	r;
	long	x, y, w, h;
	DLGRES	*pDR;
	WND		*pW;

	if( msg!=WM_CREATE ) pW = (WND*)HeapPtr(hW);
	switch( msg ) {
	 case WM_CREATE:
		pDR = (DLGRES*)arg1;
		hW = AllocateWnd(pDR->id, pDR->type, pDR->ux*UU, pDR->uy*UU, pDR->uw*UU, pDR->uh*UU, pDR->flags, arg2, HelpChangedProc, sizeof(WND));
		pW = (WND*)HeapPtr(hW);
		pW->pRES = pDR;
		InvalidateAllWnd(hW);
		return hW;
	 case WM_PAINT:
		if( HelpChanged && CurHelpPage==0 ) {
			GetRectWnd(hW, &r);

			DrawRectBM(0, r.x, r.y, r.w, r.h, 0xFFA0A0FF, CLR_BLACK);

			x = r.x + 8*UU;
			y = r.y + 2*UU;
			DrawTextBM(0, str_mod_help0, x-((w==0)?UU4:0), y, r.w, TEXTH, CF_LEFT, CLR_NONE, CLR_BLACK);
			y += UU4;
			DrawTextBM(0, str_mod_help1, x-((w==0)?UU4:0), y, r.w, TEXTH, CF_LEFT, CLR_NONE, CLR_BLACK);
			y += UU4;
			DrawTextBM(0, str_mod_help2, x-((w==0)?UU4:0), y, r.w, TEXTH, CF_LEFT, CLR_NONE, CLR_BLACK);
			y += UU4;
			DrawTextBM(0, str_mod_help3, x-((w==0)?UU4:0), y, r.w, TEXTH, CF_LEFT, CLR_NONE, CLR_BLACK);
			y += UU4;
			DrawTextBM(0, str_mod_help4, x-((w==0)?UU4:0), y, r.w, TEXTH, CF_LEFT, CLR_NONE, CLR_BLACK);
			y += UU4;
			DrawTextBM(0, str_mod_help5, x-((w==0)?UU4:0), y, r.w, TEXTH, CF_LEFT, CLR_NONE, CLR_BLACK);
		}
//		else ShowWnd(hW, SW_HIDE);

		return 0;
	 default:
		break;
	}
	return DefWndProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
char	*Z0="";
BYTE	bullet[]={0xE2, 0x80, 0xA2, ' ', 0};
char	Zi[100][8]={
	"0) ", "1) ", "2) ", "3) ", "4) ", "5) ", "6) ", "7) ", "8) ", "9) ",
	"10) ", "11) ", "12) ", "13) ", "14) ", "15) ", "16) ", "17) ", "18) ", "19) ",
	"20) ", "21) ", "22) ", "23) ", "24) ", "25) ", "26) ", "27) ", "28) ", "29) ",
	"30) ", "31) ", "32) ", "33) ", "34) ", "35) ", "36) ", "37) ", "38) ", "39) ",
	"40) ", "41) ", "42) ", "43) ", "44) ", "45) ", "46) ", "47) ", "48) ", "49) ",
	"50) ", "51) ", "52) ", "53) ", "54) ", "55) ", "56) ", "57) ", "58) ", "59) ",
	"60) ", "61) ", "62) ", "63) ", "64) ", "65) ", "66) ", "67) ", "68) ", "69) ",
	"70) ", "71) ", "72) ", "73) ", "74) ", "75) ", "76) ", "77) ", "78) ", "79) ",
	"80) ", "81) ", "82) ", "83) ", "84) ", "85) ", "86) ", "87) ", "88) ", "89) ",
	"90) ", "91) ", "92) ", "93) ", "94) ", "95) ", "96) ", "97) ", "98) ", "99) "
};
WORD	LastHelpFlags;	// for remembering the most recent text formatting flags for @Zn>
long	ListItemH;		// = s (from @Zn.s>) * HTH/4 (additional spacing after list items)

//==========================================================================
void WrapHelp(long pagid) {

	HELPOBJ	*pH;
	long	i, maxho, flags, imgH, lineH, seennonimg, dw, lmargin, x, lensave, startX, gSIZE;
	long	xo=UU, ww=((WND*)HeapPtr(FindWndID(ID_HELP_TEXT)))->w-7*UU;
	char	*s, *e, *d, c, *dsave;
	long	pwtl, wwlim, Ztype, Znum, Gn=0, IsEndG, IsGnext, tcol, tabCenterW=0, tabCenterCols;
	BOOL	trimleadspace=FALSE, InZ=FALSE;
	
	SecretPDclickCnt = 0;
	LastHelpFlags = 0;

	for(i=0; i<NumHelpPages; i++) if( *((WORD *)(HelpPages[i]+4))==pagid ) break;
	if( i >= NumHelpPages ) {
		MessageBox(KString(BLK_MISC, STR_BAD_HELP_PAGE), MB_BUMMER);
		return;
	}
	s = HelpPages[i];
	e = s + *((DWORD *)s);	// get end of page
	s += 6;				// skip page len and ID
	HelpTitleStr = s+2;
	s += *((WORD *)s);	// skip title
	HelpSubtitleStr = s+2;
	s += *((WORD *)s);	// skip subtitle
	pH = HelpPage;
	tabSTART = NULL;	// not in table
	maxho = ((KHelpBuf+MAXHELPLEN) - (char *)pH)/sizeof(HELPOBJ);
	x = lmargin = imgH = HelpPageH = seennonimg = 0;//seentab = 0;
	memset((BYTE*)HelpPageMarks, 0, sizeof(HelpPageMarks));
	while( s<e && maxho ) {	// locate/wrap all objects
		d = s+2;
		flags = *((WORD *)d);
		// if @Zn> LIST set flags from saved last help flags
		if( (flags & 0x003F)==0x001F ) pH->flags = (LastHelpFlags & 0xFF70);
		// else set and save flags
		else if( (flags & 0x07)<7 ) pH->flags = LastHelpFlags = flags;
			
		d += 2;
		pH->x = x+xo;		// set X for this object (spaced over by extra xo)
		pH->y = HelpPageH;	// set Y for this object (running height of help so far)
		pH->p = d;			// set pointer to this object's data
		switch( flags & 0x0007 ) {
		 case 0:	// TEXT
			if( trimleadspace ) {
				while( *d==' ' ) {
					++d;
					++pH->p;
				}
				trimleadspace = FALSE;
			}
			if( seennonimg==0 && lmargin ) {x += UU; pH->x += UU;}	// if haven't already spaced after image, space text after image a little bit
			seennonimg = 1;	// flag that we've already spaced (if appropriate) after image
			lensave = 0;
			pH->len = 0;	// text length counter
			dsave = d;		// save start of text
			startX = x;		// save starting X of text
			if( *d==0 || *d==' ' || *(d+1)!=' ' ) {	// try to force comma/period after bold/italic at end of line to stay on the same line rather than starting the next line with a comma/period
				wwlim = ww;
				if( x>=wwlim ) goto newline;
			} else wwlim = ww+UU2;
			if( tabCenterW ) {	// if centering text in a table cell
				// TF_GET_WIDTH in the flags prevents any actual drawing, simply returning the pixw and charlen of the drawn text
				pwtl = DrawTextBM(0, d, x, 0, wwlim-x, HTH, HelpTextFlags[(pH->flags>>4)&0x07]+TF_GET_WIDTH+TF_BREAK_SPACE+((x<=lmargin)?TF_BREAK_CHAR:0), CLR_WHITE, CLR_BLACK);
				pH->len += (pwtl & 0x0FFFF);
				d += (pwtl & 0x0FFFF);
				pH->x = x-UU + (tabCenterW - (pwtl>>16))/2;
			} else {
				while( x<wwlim && (c=*d) ) {
					// TF_GET_WIDTH in the flags prevents any actual drawing, simply returning the pixw and charlen of the drawn text
					pwtl = DrawTextBM(0, d, x, 0, wwlim-x, HTH, HelpTextFlags[(pH->flags>>4)&0x07]+TF_GET_WIDTH+TF_BREAK_SPACE+((x<=lmargin)?TF_BREAK_CHAR:0), CLR_WHITE, CLR_BLACK);
					pH->len += (pwtl & 0x0FFFF);
					d += (pwtl & 0x0FFFF);
					x += (pwtl>>16);
					if( *d==0 ) wwlim = ww+UU2;
					if( pwtl==0 || *d || x>=wwlim ) {	// do the word break, wrap to next line
	newline:
						wwlim = ww;
						if( x>=wwlim ) {	// if we're wrapping the line, set flag to trim any leading spaces when starting the next line
							trimleadspace = TRUE;
						}
						pH[1].flags = pH->flags & 0x0000FFFF;
						// done with this HelpObj, move to the next one and the next line
						++pH;
						HelpPageH += HTH;
						// starting a new line, reset stuff
						if( imgH ) {
							imgH -= HTH;
							if( imgH <= 0 ) imgH = lmargin = 0;
						}
						if( (x=lmargin) ) x += UU;	// little extra spacing to right of graphic
						if( InZ ) {
							if( Ztype==0 ) x += 3*UU;
							else if( Ztype==1 ) x += 5*UU;
							else x += 7*UU;
						}
						pH->x = x+xo;
						pH->y = HelpPageH;
						pH->len = 0;
						while( (c=*d) && isspace(c) ) ++d;	// skip leading whitespace on next line
						pH->p = d;
					}
				}
			}
			++pH;
			break;
		 case 1:	// GAME GRAPHIC
			gSIZE = GU;
			goto whgraphics;
		 case 2:	// UI GRAPHIC
			gSIZE = UIBMU;
			goto whgraphics;
		 case 3:	// HELP GRAPHIC
			gSIZE = 4;
whgraphics:
			trimleadspace = FALSE;
			if( (flags & 7)==2 && (flags & 0x0300)==0x0300 ) {	// if @Gn>
				Gn = (flags>>10)&0x003F;
			} else {
				IsEndG = (flags & 7)==2 && (flags & 0x0300)==0x0200;	// if @G>
				// if this is a @G> break, set the flag as if we've had text after the image
				if( IsEndG ) {
					if( seennonimg ) {
						if( imgH+Gn*HTH/4 > 3*HTH/2 ) HelpPageH += imgH + Gn*HTH/4;
						else HelpPageH += 3*HTH/2;
					} else HelpPageH += imgH + Gn*HTH/4;
					pH->y = HelpPageH;
					x = lmargin = 0;
					pH->x = xo;
					imgH = 0;
				} else {
					if( seennonimg ) {
						if( imgH ) {
							HelpPageH += imgH + Gn*HTH/4;
						} else {
							HelpPageH += HTH;
						}
						pH->y = HelpPageH;
						x = lmargin = 0;
						pH->x = xo;
					}
					dw = *((WORD *)(d+8)) * UU;
					lmargin += dw;	// get dstW
					x = lmargin;
					imgH = (*((WORD *)(d+6)) * dw) / *((WORD *)(d+4));
				}
				seennonimg = 0;
			}
			++pH;
			break;
		 case 4:	// TAB
			trimleadspace = FALSE;
			seennonimg = 1;//seentab = 1;
			dw = (long)((flags>>8) & 0x0FF);
			if( dw==0 ) {	// end of current table
				tabSTART = NULL;
				tabCenterW = 0;
				x = 0;
				HelpPageH += (5*HTH+1)/4;
				++pH;
			} else if( dw==1 ) {	// simple tab, not a table
				x = (*(WORD*)(pH->p))*UU;
			} else if( dw==252 ) {	// start-of-row
				tabNEXT = tabSTART;
				pH->len = *((WORD*)d);	// set color# in pH->len
				tcol = 0;
				goto nextcell;
			} else if( dw==253 ) {	// end-of-row
				tabNEXT = tabSTART;
				x = (long)(*(WORD*)tabNEXT)*UU;
				HelpPageH += (5*HTH+1)/4;
				tcol = 0;
				++pH;
			} else if( dw==255 ) {	// advance to next tab
				tabNEXT += 2;
				pH->len = ++tcol;
nextcell:
				pH->x = (long)(*(WORD*)tabNEXT)*UU;
				if( tabCenterCols & (1<<tcol) ) tabCenterW = (long)(*(WORD*)(tabNEXT+2))*UU - pH->x;
				else tabCenterW = 0;
				x = pH->x + UU;
				++pH;
			} else {	// start table
				tabSTART = tabNEXT = d;
				tcol = 0;
				tabCenterCols = (long)*((WORD*)(s + *((WORD*)s) - 2));	// get CENTER flags from last WORD
				pH->len = dw;	// # of columns
				++pH;
			}
			break;
		 case 5:	// MARK #
			trimleadspace = FALSE;
			HelpPageMarks[(flags >> 8) & 0x000000FF] = HelpPageH;
			break;
		 case 6:	// HYPERLINK
			trimleadspace = FALSE;
			seennonimg = 1;
			// TF_GET_WIDTH in the flags prevents any actual drawing, simply returning the pixw and charlen of the drawn text
			pwtl = DrawTextBM(0, d+6, x, 0, ww-x, HTH, CF_UNDERLINE+TF_GET_WIDTH, CLR_WHITE, Colors[ClrHelpLink]);
			if( (pwtl&0x00FFFF)<strlen(d+6) || x+(pwtl>>16)>ww ) {	// wrap entire link to next line
				HelpPageH += HTH;
				if( imgH ) {
					imgH -= HTH;
					if( imgH <= 0 ) imgH = lmargin = 0;
				}
				if( x=lmargin ) x += UU;	// little extra spacing to right of graphic
				if( InZ ) {
					if( Ztype==0 ) x += 3*UU;
					else if( Ztype==1 ) x += 5*UU;
					else x += 7*UU;
				}
				pH->x = x+xo;
				pH->y = HelpPageH;
				// TF_GET_WIDTH in the flags prevents any actual drawing, simply returning the pixw and charlen of the drawn text
				pwtl = DrawTextBM(0, d+6, x, 0, ww, HTH, CF_UNDERLINE+TF_GET_WIDTH, CLR_WHITE, Colors[ClrHelpLink]);
			}
			x += (pwtl>>16);
			pH->len = (pwtl & 0x0FFFF);
			++pH;
			break;
		 case 7:
			switch( flags & 0x0038 ) {
			 case 0x0000:	// LINE BREAK
				if( (flags & 0x0040)==0 && !InZ ) {	// @L
					IsGnext = 0;
					if( s+*((WORD*)s)<e ) {
						i = *((WORD*)(s+*((WORD*)s)+2)) & 7;
						if( i>=1 && i<=3 ) IsGnext = 1;
					}
					if( IsGnext ) {	// if @G coming up next
						HelpPageH += HTH;
					} else HelpPageH += 3*HTH/2;
					if( imgH ) {
						imgH -= 3*HTH/2;
						if( imgH <= 0 ) imgH = lmargin = 0;
					}
					if( (x=lmargin) ) x += UU;
				} else {	// @L0
					HelpPageH += HTH;
					if( InZ ) HelpPageH += ListItemH;
					if( imgH ) {
						imgH -= HTH;
						if( imgH <= 0 ) imgH = lmargin = 0;
					}
					if( (x=lmargin) ) x += UU;
				}
				if( InZ ) {
					// create "text object" for list bullet/index
					pH->flags = 0;//(LastHelpFlags & 0xFF70);
					pH->y = HelpPageH;	// set Y for this object (running height of help so far)
					x += 3*UU;
					pH->x = x;
					if( Ztype==0 ) pH->p = Z0;
					else if( Ztype==1 ) pH->p = (char*)bullet;
					else if( Ztype==2 ) pH->p = Zi[Znum++];
					else pH->p = Zi[1+Znum++];
					pwtl = DrawTextBM(0, pH->p, 0, 0, 32000, HTH, HelpTextFlags[(pH->flags>>4)&0x07]+TF_GET_WIDTH, CLR_WHITE, CLR_BLACK);
					pH->len = (pwtl & 0x0FFFF);
					x += (pwtl>>16);

					++pH;
				}
				break;
			 case 0x0008:	// comment out on SCREEN
				// ReadHelp(), for @CS> blocks, stores the ENTIRE contents between the @C> tags
				// in a single string in THIS HelpObj, so when we skip this obj below, we'll
				// be skipping ALL of the "commented out on SCREEN" contents.
				break;
			 case 0x0010:	// comment out for HTML
				// we're outputting to the screen, so we don't want to skip the stuff
				// between the @CH> "comment out for HTML" stuff, we just skip the
				// opening and closing @CH> tags themselves and output everything in between.
				break;
			 case 0x0018:	// start/end of LIST
				if( !InZ ) {	// starting LIST
					InZ = TRUE;
					Ztype = (flags>>6) & 3;
					Znum = 0;
					ListItemH = ((flags>>8) & 7)*HTH/4;
					pH->flags = 0;	// turn off all attributes
				} else {
					InZ = FALSE;
				}
				// do auto @L at start and end of @Zn> (replaces an @L)
				HelpPageH += 2*HTH;
				if( imgH ) {
					imgH -= 2*HTH;
					if( imgH <= 0 ) imgH = lmargin = 0;
				}
				if( (x=lmargin) ) x += UU;
				if( InZ ) {
					while( imgH ) {	// don't allow list block to right of graphics
						imgH -= HTH;
						if( imgH <= 0 ) imgH = lmargin = 0;
					}
					pH->y = HelpPageH;	// set Y for this object (running height of help so far)
					x += 3*UU;
					pH->x = x;
					if( Ztype==0 ) pH->p = Z0;
					else if( Ztype==1 ) pH->p = (char*)bullet;
					else if( Ztype==2 ) pH->p = Zi[Znum++];
					else pH->p = Zi[1+Znum++];
					pwtl = DrawTextBM(0, pH->p, 0, 0, 32000, HTH, HelpTextFlags[(pH->flags>>4)&0x07]+TF_GET_WIDTH, CLR_WHITE, CLR_BLACK);
					pH->len = (pwtl & 0x0FFFF);
					x += (pwtl>>16);

					++pH;
				}
				break;
			}
			break;
		}
		s += *((WORD *)s);	// skip this object, move on to the next one
	}
	pH->p = NULL;	// signify end of HELPOBJs
	while( imgH ) {
		HelpPageH += HTH;
		imgH -= HTH;
		if( imgH < 0 ) imgH = 0;
	}
}

//==========================================================================
void HelpChange() {

	long		dw;
	DWORD		hW;
	WNDSCROLL	*pW;
	SBINFO		sbi;

	hW = FindWndID(ID_HELP_CHANGED);
	ShowWnd(hW, (HelpChanged && CurHelpPage==0) ? SW_SHOW : SW_HIDE);
	WrapHelp(CurHelpPage);
	hW = FindWndID(ID_HELP_TEXT);
	pW = ((WNDSCROLL*)HeapPtr(hW));

	pW->ppuX = 1;
	pW->ppuY = HTH;
	SendMsg(hW, WM_COMMAND, WC_SETSURFSIZE, 1, (HelpPageH+2*HTH)/pW->ppuY);
	SendMsg(hW, WM_COMMAND, WC_SETSCROLLBARS, 0, 0);

	hW = FindWndID(ID_HELP_CHANGED);
}

//==========================================================================
// Items in the ID_KEYMAP_LIST have val1 set to the index into WorkKeyMaps[]
// Items in the ID_KEYS_LIST have val1 set to the index into Keys[]
// Items in the ID_FUNC_LIST have val1 set to the index into KF_FUNC list
DWORD KeyMapListProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	DWORD	wix;
	
	switch( msg ) {
	 case WM_LBUTTDBLCLICK:
		i = (long)SendMsg(hW, LBM_GETCURSEL, 0, 0, 0);	// get the current selection
		SendMsg(hW, LBM_GETITEM, i, (DWORD)&wix, LBGI_VAL1);	// get WorkKeyMaps[] index
		for(j=0; j<KeysCnt; j++) if( WorkKeyMaps[wix].key==Keys[j].code ) break;
		SendMsgID(ID_KEYS_LIST, LBM_SELVAL1, j, 0, 0);
		SendMsgID(ID_FUNC_LIST, LBM_SELVAL1, WorkKeyMaps[wix].func, 0, 0);
		SetCheckID(ID_KEY_SHIFT, (WorkKeyMaps[wix].flags & MK_SHIFT));
		SetCheckID(ID_KEY_CTL, (WorkKeyMaps[wix].flags & MK_CTL));
		
		return 0;
	 case LBM_GETCOLWIDTH:
		switch( arg1 ) {
		 case 0:	// key
			i = 50*UU;
			break;
		 case 1:	// func
			i = 100*UU;
			break;
		 default:
			i = 10*UU;
			break;
		}
		return (DWORD)i;
	}
	return ListBoxProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
// Items in the ID_KEYMAP_LIST have val1 set to the index into WorkKeyMaps[]
// Items in the ID_KEYS_LIST have val1 set to the index into Keys[]
// Items in the ID_FUNC_LIST have val1 set to the index into KF_FUNC list
DWORD KeyListProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j, mapcur, mapcnt;
	DWORD	wix;
	HWND	hMAP;
	
	switch( msg ) {
	 case WM_LBUTTDBLCLICK:
		i = (long)SendMsg(hW, LBM_GETCURSEL, 0, 0, 0);	// get the current selection
		
		hMAP = FindWndID(ID_KEYMAP_LIST);
		mapcur = (long)SendMsg(hMAP, LBM_GETCURSEL, 0, 0, 0);	// get cur KeyMap selection
		mapcnt = (long)SendMsg(hMAP, LBM_GETCOUNT, 0, 0, 0);	// get # items in KeyMap list
		for(j=mapcur+1; j<mapcnt; j++) {
			SendMsg(hMAP, LBM_GETITEM, j, (DWORD)&wix, LBGI_VAL1);
			if( WorkKeyMaps[wix].key==Keys[i].code ) break;
		}
		if( j>=mapcnt ) {
			for(j=0; j<mapcur; j++) {
				SendMsg(hMAP, LBM_GETITEM, j, (DWORD)&wix, LBGI_VAL1);
				if( WorkKeyMaps[wix].key==Keys[i].code ) break;
			}
		}
		if( j!=mapcur ) {
			SendMsg(hMAP, LBM_SETCURSEL, j, 0, 0);
			SendMsg(hMAP, LBM_GETITEM, j, (DWORD)&wix, LBGI_VAL1);	// get WorkKeyMaps[] index
			SetCheckID(ID_KEY_SHIFT, (WorkKeyMaps[wix].flags & MK_SHIFT));
			SetCheckID(ID_KEY_CTL, (WorkKeyMaps[wix].flags & MK_CTL));
			SendMsgID(ID_FUNC_LIST, LBM_SELVAL1, WorkKeyMaps[wix].func, 0, 0);
		}
		return 0;
	}
	return ListBoxProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
// Items in the ID_KEYMAP_LIST have val1 set to the index into WorkKeyMaps[]
// Items in the ID_KEYS_LIST have val1 set to the index into Keys[]
// Items in the ID_FUNC_LIST have val1 set to the index into KF_FUNC list
DWORD KeyFuncListProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j, mapcur, mapcnt;
	DWORD	wix, f;
	HWND	hMAP;
	
	switch( msg ) {
	 case WM_LBUTTDBLCLICK:
		i = (long)SendMsg(hW, LBM_GETCURSEL, 0, 0, 0);	// get the current selection
		SendMsg(hW, LBM_GETITEM, i, (DWORD)&f, LBGI_VAL1);
		
		hMAP = FindWndID(ID_KEYMAP_LIST);
		mapcur = (long)SendMsg(hMAP, LBM_GETCURSEL, 0, 0, 0);	// get cur KeyMap selection
		mapcnt = (long)SendMsg(hMAP, LBM_GETCOUNT, 0, 0, 0);	// get # items in KeyMap list
		for(j=mapcur+1; j<mapcnt; j++) {
			SendMsg(hMAP, LBM_GETITEM, j, (DWORD)&wix, LBGI_VAL1);
			if( WorkKeyMaps[wix].func==f ) break;
		}
		if( j>=mapcnt ) {
			for(j=0; j<mapcur; j++) {
				SendMsg(hMAP, LBM_GETITEM, j, (DWORD)&wix, LBGI_VAL1);
				if( WorkKeyMaps[wix].func==f ) break;
			}
		}
		if( j!=mapcur ) {
			SendMsg(hMAP, LBM_SETCURSEL, j, 0, 0);
			SendMsg(hMAP, LBM_GETITEM, j, (DWORD)&wix, LBGI_VAL1);	// get WorkKeyMaps[] index
			SetCheckID(ID_KEY_SHIFT, (WorkKeyMaps[wix].flags & MK_SHIFT));
			SetCheckID(ID_KEY_CTL, (WorkKeyMaps[wix].flags & MK_CTL));
			for(j=0; j<KeysCnt; j++) if( WorkKeyMaps[wix].key==Keys[j].code ) break;
			SendMsgID(ID_KEYS_LIST, LBM_SELVAL1, j, 0, 0);
		}
		return 0;
	}
	return ListBoxProc(hW, msg, arg1, arg2, arg3);
}

DWORD	LastKeycodeTime;

//==========================================================================
DWORD KeycodeDlgProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	t;
	
	switch( msg ) {
	 case WM_KEYDN:
		if( arg1!=K_SHIFT && arg1!=K_CTL ) {
			t = TimeMilli();
			if( t-LastKeycodeTime < 250 ) strcpy(ScratBuf, "--");
			else sprintf(ScratBuf, "%2.2X", arg1);
			SendMsgID(ID_KEYVAL, ELM_SETTEXT, (DWORD)ScratBuf, 0, 0);
			LastKeycodeTime = t;
		}
		return 0;
	 case WM_KEYUP:
	 case WM_CHAR:
		return 0;
	}
	return DefDlgProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD KeyvalProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	switch( msg ) {
	 case WM_CHAR:
		return 0;
	}
	return EditLineProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DLGRES	KeycodeDlg[] = {
	{ID_KEYCODE_DLG, WT_WND,		-1, -1,48,  8, WF_SHOW, &KeycodeDlgProc, 0, 0, 0},
	{ID_KEYVAL,	WT_EDITLINE,		17, 2, 30,  4, WF_SHOW+WF_NSC+CF_GROUP+CF_TABSTOP+CF_FOCUS, KeyvalProc, 0, (void*)30, 0},
	{ID_OK, WT_BUTTONTEXT,			 1, 1, 15,  6, WF_SHOW+CF_TABSTOP+CF_GROUP+CF_DEFAULT, DefComButtProc, MAKESTR(BLK_MISC, STR_OK), 0, 0},
	
	{0}
};

//==========================================================================
void UpdateKeyMapList() {
	
	long	i, j;
	char	*pK;
	HWND	hW=FindWndID(ID_KEYMAP_LIST);
	
	SendMsg(hW, LBM_DELITEM, -1, 0, 0);
	for(i=0; i<WorkKeyMapsCnt; i++) {
		ScratBuf[8000] = 0;
		for(j=0; j<KeysCnt; j++) if( Keys[j].code==WorkKeyMaps[i].key ) break;
		if( j>=KeysCnt ) pK = "????";
		else {
			pK = (char*)Keys[j].name;
			if( WorkKeyMaps[i].flags & MK_SHIFT ) sprintf(ScratBuf+8000, "%s-", KString(BLK_KEY, STR_KEY_SHIFT));
			if( WorkKeyMaps[i].flags & MK_CTL ) sprintf(ScratBuf+8000+strlen(ScratBuf+8000), "%s-", KString(BLK_KEY, STR_KEY_CTL));
		}
		sprintf(ScratBuf, "%s%s\t%s", ScratBuf+8000, (char*)pK, KString(BLK_KEY, STR_KF_FIRSTFUNC+WorkKeyMaps[i].func));
		SendMsg(hW, LBM_ADDSTRING, (DWORD)ScratBuf, i, 0);
	}
}

//==========================================================================
void UpdateKeyMDList() {
	
	long	i;
	char	*pK;
	HWND	hW=FindWndID(ID_MD_FUNC_LIST);
	
	SendMsg(hW, LBM_DELITEM, -1, 0, 0);
	MDflags = 0;
	for(i=0; i<WorkKeyMapsCnt; i++) {
		ScratBuf[8000] = 0;
		if( MDkey==WorkKeyMaps[i].key ) {
			pK = Keys[MDkeyIX].name;
			switch( WorkKeyMaps[i].flags & (MK_SHIFT | MK_CTL) ) {
			 case 0:
				MDflags |= 1;
				break;
			 case MK_SHIFT:
				MDflags |= 2;
				break;
			 case MK_CTL:
				MDflags |= 4;
				break;
			 case MK_SHIFT+MK_CTL:
				MDflags |= 8;
				break;
			}
			if( WorkKeyMaps[i].flags & MK_SHIFT ) sprintf(ScratBuf+8000, "%s-", KString(BLK_KEY, STR_KEY_SHIFT));
			if( WorkKeyMaps[i].flags & MK_CTL ) sprintf(ScratBuf+8000+strlen(ScratBuf+8000), "%s-", KString(BLK_KEY, STR_KEY_CTL));
			sprintf(ScratBuf, "%s%s\t%s", ScratBuf+8000, (char*)pK, KString(BLK_KEY, STR_KF_FIRSTFUNC+WorkKeyMaps[i].func));
			SendMsg(hW, LBM_ADDSTRING, (DWORD)ScratBuf, i, 0);
		}
	}
}

//==========================================================================
DWORD KeyMoveDupeDlgProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	f;
	long	i;

	switch( msg ) {
	 case WM_CREATE:
		DefDlgProc(hW, msg, arg1, arg2, arg3);

		// Add all keys to the key list
		for(i=0; i<KeysCnt; i++) SendMsgID(ID_MD_KEYS_LIST, LBM_ADDSTRING, (DWORD)Keys[i].name, (DWORD)i, 0);
// Items in the ID_KEYMAP_LIST have val1 set to the index into WorkKeyMaps[]
		SendMsgID(ID_KEYMAP_LIST, LBM_GETITEM, -1, (DWORD)&f, LBGI_VAL1);
		MDkey = WorkKeyMaps[f].key;
		for(MDkeyIX=0; MDkeyIX<KeysCnt; MDkeyIX++) if( Keys[MDkeyIX].code==MDkey ) break;
// Items in the ID_KEYS_LIST have val1 set to the index into Keys[]
		SendMsgID(ID_MD_KEYS_LIST, LBM_SELVAL1, MDkeyIX, 0, 0);

		SendMsgID(ID_MD_FUNC_LIST, LBM_SORTCOL, 0, 0, 0);	// sort list by shift/ctl options
		UpdateKeyMDList();
		
		return 0;
	 case WM_DESTROY:
		if( arg1==ID_OK ) {
			SendMsgID(ID_MD_KEYS_LIST, LBM_GETITEM, -1, (DWORD)&DlgResultI, LBGI_VAL1);
		}
		break;
	}
	return DefDlgProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
// Items in the ID_KEYMAP_LIST have val1 set to the index into WorkKeyMaps[]
// Items in the ID_KEYS_LIST have val1 set to the index into Keys[]
// Items in the ID_FUNC_LIST have val1 set to the index into KF_FUNC list
DWORD MDKeyListProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	WND		*pW;
	
	switch( msg ) {
	 case WM_LBUTTDBLCLICK:
		pW = ((WND*)HeapPtr(hW));
		SendMsg(FindChildWndID(pW->parent, ID_OK), WM_ACTIVATE, 0, 0, 0);
		return 0;
	}
	return ListBoxProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
// Items in the ID_KEYMAP_LIST have val1 set to the index into WorkKeyMaps[]
// Items in the ID_KEYS_LIST have val1 set to the index into Keys[]
// Items in the ID_FUNC_LIST have val1 set to the index into KF_FUNC list
DWORD MDFuncListProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j, mapcur, mapcnt;
	DWORD	wix, f;
	HWND	hMAP;
	
	switch( msg ) {
	 case WM_LBUTTDBLCLICK:
		i = (long)SendMsg(hW, LBM_GETCURSEL, 0, 0, 0);	// get the current selection
		SendMsg(hW, LBM_GETITEM, i, (DWORD)&f, LBGI_VAL1);
		
		hMAP = FindWndID(ID_KEYMAP_LIST);
		mapcur = (long)SendMsg(hMAP, LBM_GETCURSEL, 0, 0, 0);	// get cur KeyMap selection
		mapcnt = (long)SendMsg(hMAP, LBM_GETCOUNT, 0, 0, 0);	// get # items in KeyMap list
		for(j=mapcur+1; j<mapcnt; j++) {
			SendMsg(hMAP, LBM_GETITEM, j, (DWORD)&wix, LBGI_VAL1);
			if( WorkKeyMaps[wix].func==f ) break;
		}
		if( j>=mapcnt ) {
			for(j=0; j<mapcur; j++) {
				SendMsg(hMAP, LBM_GETITEM, j, (DWORD)&wix, LBGI_VAL1);
				if( WorkKeyMaps[wix].func==f ) break;
			}
		}
		if( j!=mapcur ) {
			SendMsg(hMAP, LBM_SETCURSEL, j, 0, 0);
			SendMsg(hMAP, LBM_GETITEM, j, (DWORD)&wix, LBGI_VAL1);	// get WorkKeyMaps[] index
			SetCheckID(ID_KEY_SHIFT, (WorkKeyMaps[wix].flags & MK_SHIFT));
			SetCheckID(ID_KEY_CTL, (WorkKeyMaps[wix].flags & MK_CTL));
			for(j=0; j<KeysCnt; j++) if( WorkKeyMaps[wix].key==Keys[j].code ) break;
			SendMsgID(ID_KEYS_LIST, LBM_SELVAL1, j, 0, 0);
		}
		return 0;
	 case LBM_GETCOLWIDTH:
		switch( arg1 ) {
		 case 0:	// key
			i = 50*UU;
			break;
		 case 1:	// func
			i = 100*UU;
			break;
		 default:
			i = 10*UU;
			break;
		}
		return (DWORD)i;
	}
	return ListBoxProc(hW, msg, arg1, arg2, arg3);
}


//==========================================================================
DLGRES	KeyMoveDupeDlg[] = {
	{ID_KEYMOVEDUPE_DLG, WT_WND,	-1, -1,135,108, WF_SHOW, &KeyMoveDupeDlgProc, 0},

	{ID_MD_KEYS_LIST, WT_LISTBOX,	 2, 32, 49, 74, WF_SHOW+CF_TABSTOP+CF_GROUP+CF_FOCUS/*+CF_SORT*/, MDKeyListProc, MAKESTR(BLK_KEY, STR_KEYS_HEAD), 0, 0},

	{ID_MD_FUNC_LIST, WT_LISTBOX,	 2,  6,131, 20, WF_SHOW+CF_TABSTOP+CF_GROUP+CF_SORT+CF_STR, MDFuncListProc, MoveDupeStr, 0, 0},

	{ID_OK, WT_BUTTONTEXT,			118, 93, 15,  6, WF_SHOW+CF_TABSTOP+CF_GROUP+CF_DEFAULT, DefComButtProc, MAKESTR(BLK_MISC, STR_OK)},
	{ID_CANCEL, WT_BUTTONTEXT,		118,100, 15,  6, WF_SHOW+CF_TABSTOP, DefComButtProc, MAKESTR(BLK_MISC, STR_CANCEL)},

	{0}
	};

//==========================================================================
DWORD KeyMapHelpProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	f;
	WND		*pW;
	RECT	r;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		PopupHelp("KEYMAP",0);
		return 0;
	 case WM_RBUTTDN:
		if( pW->flags & CF_DISABLED ) {
			BeepIll();
			return 0;
		}
		CaptureMouse(hW);	// capture mouse for case where button is depressed, then mouse is dragged OFF button
		pW->flags |= CF_HELD_DOWN;
		InvalidateAllWND(hW);	// make sure we get redrawn
		break;	// let DefWndProc see the message too so we get focus if we didn't have it
	 case WM_RBUTTUP:
		if( hW==hCapture ) {	// only activate if mouse went DOWN on this button too!
			ReleaseMouse();
			pW->flags &= ~CF_HELD_DOWN;
			if( pW->flags & CF_DISABLED ) break;	// in case some idiot disables the button WHILE we have it held down
			InvalidateAllWND(hW);
			GetRectWnd(hW, &r);
			if( arg1<r.x || arg1>=r.x+r.w || arg2<r.y || arg2>=r.y+r.h ) break;	// in case mouse-button was released OFF of the pushbutton
			if( KeyFlags & MK_CTL ) {
				DoModal(KeycodeDlg, hMain);
				return 0;
			}
		}
		break;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD KeyMapAddProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	f, k, i, j, wix, flags;
	HWND	hMAP;

	switch( msg ) {
	 case WM_ACTIVATE:
		k = SendMsgID(ID_KEYS_LIST, LBM_GETCURSEL, 0, 0, 0);
		flags = 0;
		if( GetCheckID(ID_KEY_SHIFT) ) flags |= MK_SHIFT;
		if( GetCheckID(ID_KEY_CTL) ) flags |= MK_CTL;

		for(i=0; i<WorkKeyMapsCnt; i++) if( WorkKeyMaps[i].key==Keys[k].code && WorkKeyMaps[i].flags==flags ) break;
		if( i<WorkKeyMapsCnt ) {	// if mapping for this key already exists
			if( ID_YES!=MessageBox(KString(BLK_KEY, STR_REMAP_CONFIRM), MB_YESNO) ) return 0;
			memcpy((BYTE*)&WorkKeyMaps[i], (BYTE*)&WorkKeyMaps[i+1], sizeof(KEYMAP)*(WorkKeyMapsCnt-i-1));
			--WorkKeyMapsCnt;
		}
		if( WorkKeyMapsCnt<MAXKEYMAP ) {
			j = SendMsgID(ID_FUNC_LIST, LBM_GETCURSEL, 0, 0, 0);
			SendMsgID(ID_FUNC_LIST, LBM_GETITEM, j, (DWORD)&f, LBGI_VAL1);
			WorkKeyMaps[WorkKeyMapsCnt].key = Keys[k].code;
			WorkKeyMaps[WorkKeyMapsCnt].flags = flags;
			WorkKeyMaps[WorkKeyMapsCnt].func = f;
			++WorkKeyMapsCnt;
			UpdateKeyMapList();
			hMAP = FindWndID(ID_KEYMAP_LIST);
			j = SendMsg(hMAP, LBM_GETCOUNT, 0, 0, 0);
			for(i=0; i<j; i++) {
				SendMsg(hMAP, LBM_GETITEM, i, (DWORD)&wix, LBGI_VAL1);
				if( WorkKeyMaps[wix].key == Keys[k].code && WorkKeyMaps[wix].flags == flags ) break;
			}
			if( i<j ) SendMsg(hMAP, LBM_SETCURSEL, i, 0, 0);
		}
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD KeyMapDelProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	wcnt, wsel, wix;
	HWND	hMAP;

	switch( msg ) {
	 case WM_ACTIVATE:
		hMAP = FindWndID(ID_KEYMAP_LIST);
		wcnt = SendMsg(hMAP, LBM_GETCOUNT, 0, 0, 0);
		if( wcnt ) {
			wsel = SendMsg(hMAP, LBM_GETCURSEL, 0, 0, 0);
			SendMsg(hMAP, LBM_GETITEM, wsel, (DWORD)&wix, LBGI_VAL1);
			if( wix<WorkKeyMapsCnt ) {
				memcpy((BYTE*)&WorkKeyMaps[wix], (BYTE*)&WorkKeyMaps[wix+1], sizeof(KEYMAP)*(WorkKeyMapsCnt-wix-1));
				--WorkKeyMapsCnt;
			}
			UpdateKeyMapList();
		}
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD KeyMapResetProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	f;

	switch( msg ) {
	 case WM_ACTIVATE:
		if( ID_YES==MessageBox(KString(BLK_KEY, STR_KRESET_CONFIRM), MB_YESNO) ) {
			memcpy((BYTE*)&WorkKeyMaps[0], (BYTE*)&defkeymap[0], DEFKEYMAPCNT*sizeof(KEYMAP));
			WorkKeyMapsCnt = DEFKEYMAPCNT;
			UpdateKeyMapList();
		}
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD KeyMapExportProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	DWORD	hFile;
	char	eolbuf[8];

	switch( msg ) {
	 case WM_ACTIVATE:
		sprintf(ScratBuf+7000, "%s_%s_keymap.txt", CurPlayer.name, CurMood.name);
		if( -1==(hFile=fopen(ScratBuf+7000, O_WRBINNEW)) ) return 0;
		
		GetEOL(eolbuf, 7);
		for(i=0; i<WorkKeyMapsCnt; i++) {
			ScratBuf[1024] = 0;
			for(j=0; j<KeysCnt; j++) if( WorkKeyMaps[i].key==Keys[j].code ) break;
			if( WorkKeyMaps[i].flags & MK_CTL ) strcat(ScratBuf+1024, KString(BLK_KEY, STR_KEY_CTL));
			if( (WorkKeyMaps[i].flags & (MK_CTL+MK_SHIFT))==(MK_CTL+MK_SHIFT) ) strcat(ScratBuf+1024, "+");
			if( WorkKeyMaps[i].flags & MK_SHIFT ) strcat(ScratBuf+1024, KString(BLK_KEY, STR_KEY_SHIFT));
			if( (WorkKeyMaps[i].flags & (MK_CTL+MK_SHIFT)) ) strcat(ScratBuf+1024, " ");
			strcat(ScratBuf+1024, Keys[j].name);
			sprintf(ScratBuf, "%s (%s)%s", KString(BLK_KEY, STR_KF_FIRSTFUNC+WorkKeyMaps[i].func), ScratBuf+1024, eolbuf);
			
			fwrite(hFile, ScratBuf, strlen(ScratBuf));
		}
		fclose(hFile);
		GetAppDataPath(ScratBuf+6000);
		sprintf(ScratBuf, "%s\n%s%s", KString(BLK_KEY, STR_KEYS_EXPORTED), ScratBuf+6000, ScratBuf+7000);
		BeepCool();
		MessageBox(ScratBuf, MB_WAYCOOL);
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD KeyMapMoveProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	WND		*pW;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		strcpy(MoveDupeStr, KString(BLK_KEY, STR_MOVE_FUNCS));
		if( ID_OK==DoModal(KeyMoveDupeDlg, pW->parent) ) {
			// DlgResultI = Keys[] index of destination key
			// MDkeyIX = Keys[] index of source key
			
			// first, make sure there are no mappings to DlgResultI that
			// conflict with the SHIFT-CTL mappings being moved from MDkeyIX.
			for(i=j=0; i<WorkKeyMapsCnt; i++) {
				if( WorkKeyMaps[i].key==Keys[DlgResultI].code ) {
					if( (WorkKeyMaps[i].flags==0 && (MDflags & 1))
					 || (WorkKeyMaps[i].flags==MK_SHIFT && (MDflags & 2))
					 || (WorkKeyMaps[i].flags==MK_CTL && (MDflags & 4))
					 || (WorkKeyMaps[i].flags==(MK_SHIFT+MK_CTL) && (MDflags & 8)) ) ++j;
				}
			}
			// if conflicts, generate CONFIRM MsgBox
			if( j && ID_YES==MessageBox(KString(BLK_KEY, STR_KEYMAP_OVERWRITE), MB_YESNO) ) {
				for(i=j=0; i<WorkKeyMapsCnt; i++) {
					if( WorkKeyMaps[i].key==Keys[DlgResultI].code ) {
						if( (WorkKeyMaps[i].flags==0 && (MDflags & 1))
						 || (WorkKeyMaps[i].flags==MK_SHIFT && (MDflags & 2))
						 || (WorkKeyMaps[i].flags==MK_CTL && (MDflags & 4))
						 || (WorkKeyMaps[i].flags==(MK_SHIFT+MK_CTL) && (MDflags & 8)) ) {
							memcpy((BYTE*)&WorkKeyMaps[i], (BYTE*)&WorkKeyMaps[i+1], sizeof(KEYMAP)*(WorkKeyMapsCnt-i-1));
							--WorkKeyMapsCnt;
							--i;
							UpdateKeyMapList();
						 }
					}
				}
				j = 0;
			}

			// if OK, edit old mappings to new keycode
			if( !j ) {
				if( MDflags & 1 ) {	// wouldn't be set if there wasn't a SRC mapping
					for(i=0; i<WorkKeyMapsCnt; i++) {
						if( WorkKeyMaps[i].key==MDkey && WorkKeyMaps[i].flags==0 ) {
							WorkKeyMaps[i].key = Keys[DlgResultI].code;
							break;
						}
					}
				}
				if( MDflags & 2 ) {	// wouldn't be set if there wasn't a SRC mapping
					for(i=0; i<WorkKeyMapsCnt; i++) {
						if( WorkKeyMaps[i].key==MDkey && WorkKeyMaps[i].flags==MK_SHIFT ) {
							WorkKeyMaps[i].key = Keys[DlgResultI].code;
							break;
						}
					}
				}
				if( MDflags & 4 ) {	// wouldn't be set if there wasn't a SRC mapping
					for(i=0; i<WorkKeyMapsCnt; i++) {
						if( WorkKeyMaps[i].key==MDkey && WorkKeyMaps[i].flags==MK_CTL ) {
							WorkKeyMaps[i].key = Keys[DlgResultI].code;
							break;
						}
					}
				}
				if( MDflags & 8 ) {	// wouldn't be set if there wasn't a SRC mapping
					for(i=0; i<WorkKeyMapsCnt; i++) {
						if( WorkKeyMaps[i].key==MDkey && WorkKeyMaps[i].flags==(MK_SHIFT+MK_CTL) ) {
							WorkKeyMaps[i].key = Keys[DlgResultI].code;
							break;
						}
					}
				}
				UpdateKeyMapList();
			}
		}
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD KeyMapDupeProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	WND		*pW;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		strcpy(MoveDupeStr, KString(BLK_KEY, STR_DUPE_FUNCS));
		if( ID_OK==DoModal(KeyMoveDupeDlg, pW->parent) ) {
			// DlgResultI = Keys[] index of destination key
			// MDkeyIX = Keys[] index of source key
			
			// first, make sure there are no mappings to DlgResultI that
			// conflict with the SHIFT-CTL mappings being duped from MDkeyIX.
			for(i=j=0; i<WorkKeyMapsCnt; i++) {
				if( WorkKeyMaps[i].key==Keys[DlgResultI].code ) {
					if( (WorkKeyMaps[i].flags==0 && (MDflags & 1))
					 || (WorkKeyMaps[i].flags==MK_SHIFT && (MDflags & 2))
					 || (WorkKeyMaps[i].flags==MK_CTL && (MDflags & 4))
					 || (WorkKeyMaps[i].flags==(MK_SHIFT+MK_CTL) && (MDflags & 8)) ) ++j;
				}
			}
			// if conflicts, generate CONFIRM MsgBox
			if( j && ID_YES==MessageBox(KString(BLK_KEY, STR_KEYMAP_OVERWRITE), MB_YESNO) ) j = 0;

			// if OK, copy old mappings to new keycode, overwriting any pre-existing mappings on the target key
			if( !j ) {
				if( MDflags & 1 ) {	// wouldn't be set if there wasn't a SRC mapping
					for(i=0; i<WorkKeyMapsCnt; i++) {
						// find the src mapping
						if( WorkKeyMaps[i].key==MDkey && WorkKeyMaps[i].flags==0 ) {
							// if there's an existing mapping on the target key
							for(j=0; j<WorkKeyMapsCnt; j++) if( WorkKeyMaps[j].key==Keys[DlgResultI].code && WorkKeyMaps[j].flags==0 ) break;
							if( j>=WorkKeyMapsCnt ) ++WorkKeyMapsCnt;	// if not already existing, add on end
							WorkKeyMaps[j].key = Keys[DlgResultI].code;
							WorkKeyMaps[j].flags = WorkKeyMaps[i].flags;
							WorkKeyMaps[j].func = WorkKeyMaps[i].func;
							break;
						}
					}
				}
				if( MDflags & 2 ) {	// wouldn't be set if there wasn't a SRC mapping
					for(i=0; i<WorkKeyMapsCnt; i++) {
						if( WorkKeyMaps[i].key==MDkey && WorkKeyMaps[i].flags==MK_SHIFT ) {
							// if there's an existing mapping on the target key
							for(j=0; j<WorkKeyMapsCnt; j++) if( WorkKeyMaps[j].key==Keys[DlgResultI].code && WorkKeyMaps[j].flags==MK_SHIFT ) break;
							if( j>=WorkKeyMapsCnt ) ++WorkKeyMapsCnt;	// if not already existing, add on end
							WorkKeyMaps[j].key = Keys[DlgResultI].code;
							WorkKeyMaps[j].flags = WorkKeyMaps[i].flags;
							WorkKeyMaps[j].func = WorkKeyMaps[i].func;
							break;
						}
					}
				}
				if( MDflags & 4 ) {	// wouldn't be set if there wasn't a SRC mapping
					for(i=0; i<WorkKeyMapsCnt; i++) {
						if( WorkKeyMaps[i].key==MDkey && WorkKeyMaps[i].flags==MK_CTL ) {
							// if there's an existing mapping on the target key
							for(j=0; j<WorkKeyMapsCnt; j++) if( WorkKeyMaps[j].key==Keys[DlgResultI].code && WorkKeyMaps[j].flags==MK_CTL ) break;
							if( j>=WorkKeyMapsCnt ) ++WorkKeyMapsCnt;	// if not already existing, add on end
							WorkKeyMaps[j].key = Keys[DlgResultI].code;
							WorkKeyMaps[j].flags = WorkKeyMaps[i].flags;
							WorkKeyMaps[j].func = WorkKeyMaps[i].func;
							break;
						}
					}
				}
				if( MDflags & 8 ) {	// wouldn't be set if there wasn't a SRC mapping
					for(i=0; i<WorkKeyMapsCnt; i++) {
						if( WorkKeyMaps[i].key==MDkey && WorkKeyMaps[i].flags==(MK_SHIFT+MK_CTL) ) {
							// if there's an existing mapping on the target key
							for(j=0; j<WorkKeyMapsCnt; j++) if( WorkKeyMaps[j].key==Keys[DlgResultI].code && WorkKeyMaps[j].flags==(MK_SHIFT+MK_CTL) ) break;
							if( j>=WorkKeyMapsCnt ) ++WorkKeyMapsCnt;	// if not already existing, add on end
							WorkKeyMaps[j].key = Keys[DlgResultI].code;
							WorkKeyMaps[j].flags = WorkKeyMaps[i].flags;
							WorkKeyMaps[j].func = WorkKeyMaps[i].func;
							break;
						}
					}
				}
				UpdateKeyMapList();
			}
		}
		return 0;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD PuzzWProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	WND		*pW;
	DWORD	hMOOD;
	MOOD	*pMOOD, *pCM;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		InvalidateAllWnd(FindWndID(ID_PUZZW_2 + CurPlayer.CurButtNum/6));
		if( Paused ) return 0;

		if( NeedNewGame ) {
			if( (CurPlayer.CurPuzzNum+1) < MAXPUZZLENUM ) {
				CurPlayer.CurButtPuzzNum[CurPlayer.CurButtNum] = ++CurPlayer.CurPuzzNum;
			}
			NeedNewGame = FALSE;
		}
		EndPuzzleType();

		// change the puzzle type
		CurPlayer.CurButtNum = (pW->id - ID_PUZZW_2)*6+(CurPlayer.CurButtNum%6);
		InvalidateAllWnd(FindWndID(ID_PUZZW_2 + CurPlayer.CurButtNum/6));

		StartPuzzleType();
		return 0;
	 case WM_PAINT:
		if( pW->id == ID_PUZZW_2 + CurPlayer.CurButtNum/6 ) pW->flags |= CF_CHECKED;
		else pW->flags &= ~CF_CHECKED;
		break;
	 case WM_PTRMOVE:
		return 0;
	}
	return BarButtBMProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD PuzzHProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	WND		*pW;
	DWORD	hMOOD;
	MOOD	*pMOOD, *pCM;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		InvalidateAllWnd(FindWndID(ID_PUZZH_2 + (CurPlayer.CurButtNum%6)));
		if( Paused ) return 0;

		if( NeedNewGame ) {
			if( (CurPlayer.CurPuzzNum+1) < MAXPUZZLENUM ) {
				CurPlayer.CurButtPuzzNum[CurPlayer.CurButtNum] = ++CurPlayer.CurPuzzNum;
			}
			NeedNewGame = FALSE;
		}
		EndPuzzleType();

		// change the puzzle type
		CurPlayer.CurButtNum = (CurPlayer.CurButtNum/6)*6 + (pW->id - ID_PUZZH_2);
		InvalidateAllWnd(FindWndID(ID_PUZZH_2 + (CurPlayer.CurButtNum%6)));

		StartPuzzleType();
		return 0;
	 case WM_PAINT:
		if( pW->id == ID_PUZZH_2 + (CurPlayer.CurButtNum%6) ) pW->flags |= CF_CHECKED;
		else pW->flags &= ~CF_CHECKED;
		break;
	 case WM_PTRMOVE:
		return 0;
	}
	return BarButtBMProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD PrevPuzzProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	WND		*pW;
	
	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		if( !Paused && CurPlayer.CurPuzzNum ) {
			EndPuzzle();
			StartPuzzle(CurPlayer.CurPuzzNum-1);
		}
		return 0;
	 case WM_PAINT:
		pW->flags = (pW->flags & ~CF_DISABLED) | (CurPlayer.CurPuzzNum ? 0 : CF_DISABLED);
		break;
	 case WM_PTRMOVE:
		return 0;
	}
	return BarButtBMProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD NextPuzzProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	WND		*pW;
	DWORD	hMOOD;
	MOOD	*pMOOD, *pCM;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		if( !Paused && CurPlayer.CurPuzzNum+1<MAXPUZZLENUM ) {
			EndPuzzle();
			StartPuzzle(CurPlayer.CurPuzzNum+1);
		}
		return 0;
	 case WM_PAINT:
		pW->flags = (pW->flags & ~CF_DISABLED) | ((CurPlayer.CurPuzzNum+1<MAXPUZZLENUM) ? 0 : CF_DISABLED);
		break;
	 case WM_PTRMOVE:
		return 0;
	}
	return BarButtBMProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD PuzzNumProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	EDITLINE	*pW;
	DWORD	hMOOD;
	MOOD	*pMOOD, *pCM;
	DWORD	pSaveText;
	DWORD	*pClrs;

	pW = ((EDITLINE*)HeapPtr(hW));
	switch( msg ) {
	 case WM_CREATE:
		pW->ex = pW->xoff;
		pW->ey = pW->yoff;
		pW->ew = pW->w;
		pW->eh = pW->h;
		break;
	 case WM_PARENTSIZED:
		if( pW->uu!=UU ) {
			DefWndProc(hW, msg, arg1, arg2, arg3);	// do normal resizing/repositioning
			pW->ew = (DWORD)pW->pRES->xx*UU;
			pW->ex = pW->xoff;
			pW->ey = pW->yoff;
			pW->eh = pW->h;
		}
		return 0;
	 case WM_GETCOLORS:
		// set (DWORD *)arg1[0] = fill color
		// set (DWORD *)arg1[1] = edge color
		// set (DWORD *)arg1[2] = text color
		// set (DWORD *)arg1[3] = selection fill color
		// set (DWORD *)arg1[4] = selection text color
		// set (DWORD *)arg1[5] = cursor color
		// set (DWORD *)arg1[6] = opaque label fill (not used, no label)
		// set (DWORD *)arg1[7] = label text (not used, no label)
		pClrs = (DWORD*)arg1;
		pClrs[0] = Colors[IsPuzzleSolved() ? ClrPuzzNumFillS : ClrPuzzNumFillU];
		pClrs[1] = Colors[ClrPuzzNumEdge];
		pClrs[2] = Colors[IsPuzzleSolved() ? ClrPuzzNumTextS : ClrPuzzNumTextU];
		pClrs[3] = CLR_TEAL;
		pClrs[4] = CLR_WHITE;
		pClrs[5] = Colors[ClrEDITcursor];
		return 0;
	 case WM_PAINT:
		pSaveText = pW->text;
		pW->text = 0;
		
		EditLineProc(hW, msg, arg1, arg2, arg3);
		
		pW->text = pSaveText;
		return 0;
	 case WM_CHAR:
		if( Paused || *(char*)arg1<'0' || *(char*)arg1>'9' ) return 0;
		break;
	 case WM_KEYDN:
		if( Paused ) return 0;
		if( arg1==K_ENTER ) {
			DWORD	n;

			n = SendMsg(hW, ELM_GETNUM, 0, 0, 0)-1;
			if( n > MAXPUZZLENUM ) {
				sprintf(ScratBuf, KString(BLK_MISC, STR_PUZZNUMERR), MAXPUZZLENUM);
				MessageBox(ScratBuf, MB_BUMMER);
				n = MAXPUZZLENUM;
			}
			
			EndPuzzle();
			StartPuzzle(n);

			SetFocus(hMain);
			return 0;
		}
		break;
	 case WM_PTRMOVE:
		break;
	 case WM_HOVER:
		if( arg1 && (CurMood.flags & PF_SHOW_TOOLTIPS) ) strcpy(MsgText, KString(BLK_BUTTS, STR_PUZZNUM));
		else MsgText[0] = 0;
		MsgBackClr = Colors[ClrMSGfillNORM];
		MsgTextClr = Colors[ClrMSGtextNORM];
		InvalidateAllWnd(hMsgBar);
		break;
	}
	return EditLineProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD PauseProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	WND		*pW;
	DWORD	hMOOD;
	MOOD	*pMOOD, *pCM;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		if( !(CurMood.flags & PF_REMOVE_PAUSE) || Paused ) SetPause(!Paused);
		return 0;
	 case WM_PTRMOVE:
		return 0;
	}
	return BarButtBMProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD RestartProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	WND		*pW;
	DWORD	hMOOD;
	MOOD	*pMOOD, *pCM;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		if( !Paused ) {
			if( CurMood.flags & PF_PROMPTRESTART ) {
				if( !GameWon && Game.MoveCnt ) {
					if( ID_NO==MessageBox(KString(BLK_MISC, STR_CONFIRM_RESTART), MB_YESNO) ) return 0;
				}
			}
			// delete possible saved game file
			BuildSaveGameName(ScratBuf);
			fremove(ScratBuf);

			RestartPuzzle();
		}
		return 0;
	 case WM_PTRMOVE:
		return 0;
	}
	return BarButtBMProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD SaveGameProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	WND		*pW;
	DWORD	hMOOD;
	MOOD	*pMOOD, *pCM;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		if( !Paused ) SaveGame();
		return 0;
	 case WM_PTRMOVE:
		return 0;
	}
	return BarButtBMProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD UndoProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j;
	WND		*pW;
	DWORD	hMOOD;
	MOOD	*pMOOD, *pCM;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		if( !Paused ) UndoDo();
		return 0;
	 case WM_LBUTTDN:
		if( !Paused && Game.CurDo ) {
			NoBlink();
			i = Game.Undos[Game.CurDo-1].move;
			// destination
			BlinkList[2] = i&0x0F;
			BlinkList[3] = (i & 0x0080)?Game.PuzzH-1:0;
			// src
			BlinkList[0] = (i>>8)&0x0F;
			if( i & 0x8000 ) {
				for(BlinkList[1]=Game.PuzzH-2; Game.board[BlinkList[1]][BlinkList[0]]>254; --BlinkList[1]) ;
			} else {
				for(BlinkList[1]=1; Game.board[BlinkList[1]][BlinkList[0]]>254; ++BlinkList[1]) ;
			}
			BlinkListCnt = 2;
		}
		break;
	 case WM_LBUTTUP:
		NoBlink();
		break;
	 case WM_PAINT:
		pW->flags = (pW->flags & ~CF_DISABLED) | (Game.CurDo ? 0 : CF_DISABLED);
		break;
	 case WM_PTRMOVE:
		return 0;
	}
	return BarButtBMProc(hW, msg, arg1, arg2, arg3);
}

//==========================================================================
DWORD RedoProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	long	i, j, stp, sc, dtp, dc;
	WND		*pW;

	pW = ((WND*)HeapPtr(hW));
	switch( msg ) {
	 case WM_ACTIVATE:
		if( !Paused ) RedoDo();
		return 0;
	 case WM_LBUTTDN:
		if( !Paused && Game.CurDo < Game.DoCnt ) {
			NoBlink();
			i = Game.Undos[Game.CurDo].move;
			BlinkList[0] = i&0x0F;
			if( i & 0x0080 ) {
				for(BlinkList[1]=Game.PuzzH-2; Game.board[BlinkList[1]][BlinkList[0]]>254; --BlinkList[1]) ;
			} else {
				for(BlinkList[1]=1; Game.board[BlinkList[1]][BlinkList[0]]>254; ++BlinkList[1]) ;
			}
			BlinkList[3] = (i&0x8000)?Game.PuzzH-1:0;
			BlinkList[2] = (i>>8)&0x0F;
			BlinkListCnt = 2;
		}
		break;
	 case WM_LBUTTUP:
		NoBlink();
		break;
	 case WM_PAINT:
		pW->flags = (pW->flags & ~CF_DISABLED) | ((Game.CurDo<Game.DoCnt) ? 0 : CF_DISABLED);
		break;
	 case WM_PTRMOVE:
		return 0;
	}
	return BarButtBMProc(hW, msg, arg1, arg2, arg3);
}

//=======================================================================
DWORD ExpBestCntsProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	hFile;
	BYTE	*pB;
	char	eol[20], spaces[32];
	long	i, len, col2;

	switch( msg ) {
	 case WM_ACTIVATE:
		for(i=0; i<31; i++) spaces[i] = ' ';
		spaces[i] = 0;
		sprintf(ScratBuf+8100, "%dCTLIST.TXT", HumanButtNum);
		if( -1!=(hFile=fopen(ScratBuf+8100, O_WRBINNEW)) ) {
			// write out the "Puzzle#    Moves" header
			strcpy(ScratBuf, KString(BLK_DLG, STR_BEST_PUZZNUM));
			col2 = strlen(ScratBuf);
			do strcat(ScratBuf, " "); while( ++col2 < 6 );
			strcat(ScratBuf, KString(BLK_DLG, STR_BEST_MOVECNT));
			GetEOL(eol, 20);
			strcat(ScratBuf, eol);
			fwrite(hFile, ScratBuf, strlen(ScratBuf));
			
			// now write out the Best Counts, 1 puzzle/line
			pB = GetBestPtr(0);
			for(i=0; i<65536; i++) {
				len = *((WORD*)pB);
				if( len ) {
					sprintf(ScratBuf, "%5d%s%5d%s", i+1, spaces+32-(col2-5), len, eol);
					fwrite(hFile, ScratBuf, strlen(ScratBuf));
				}
				pB += 2 + 2*len;
			}
			fclose(hFile);
			// show where the exported file is
			GetAppDataPath(ScratBuf+1024);
			sprintf(ScratBuf+2048, KString(BLK_DLG, STR_BEXPTO), ScratBuf+1024, ScratBuf+8100);
			MessageBox(ScratBuf+2048, MB_OK);
		}
		return 0;
	 default:
		break;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//=======================================================================
DWORD ExpCurBestProc (HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	WND		*pW;
	DWORD	hFile;
	WORD	m;
	BYTE	*pB;
	char	eol[20];
	long	i, len;
	
	pW = (WND*)HeapPtr(hW);
	switch( msg ) {
	 case WM_PAINT:
		if( BestMoveCnt ) pW->flags &= ~CF_DISABLED;
		else pW->flags |= CF_DISABLED;
		break;
	 case WM_ACTIVATE:
		sprintf(ScratBuf+8100, "%dCT%d.TXT", HumanButtNum, CurPlayer.CurPuzzNum+1);
		if( -1!=(hFile=fopen(ScratBuf+8100, O_WRBINNEW)) ) {
			// now write out the Best Moves list
			pB = GetBestPtr(CurPlayer.CurPuzzNum);
			len = *((WORD*)pB);
			pB += 2;	// skip len
			ScratBuf[0] = 0;
			while( len-- ) {
				m = *((WORD*)pB);
				pB += 2;
				sprintf(ScratBuf+strlen(ScratBuf), "%c%d%c%d,", (m&0x0080)?'B':'T', m&0x7F, (m&0x8000)?'B':'T', (m>>8)&0x7F);
			}
			ScratBuf[strlen(ScratBuf)-1] = 0;	// remove trailing ','
			fwrite(hFile, ScratBuf, strlen(ScratBuf));
			fclose(hFile);
			// show where the exported file is
			GetAppDataPath(ScratBuf+1024);
			sprintf(ScratBuf+2048, KString(BLK_DLG, STR_BMEXPTO), ScratBuf+1024, ScratBuf+8100);
			MessageBox(ScratBuf+2048, MB_OK);
		}
		return 0;
	 default:
		break;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}
//=======================================================================
DWORD ImpCurBestProc (HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

	DWORD	hM, cd, dc, mc;
	BYTE	*pM;
	WND		*pW;
	DWORD	hFile;
	WORD	m, n;
	BYTE	*pB;
	char	eol[20];
	long	i, len;
	
	pW = (WND*)HeapPtr(hW);
	switch( msg ) {
	 case WM_PAINT:
		sprintf(ScratBuf, "%dCT%d.TXT", HumanButtNum, CurPlayer.CurPuzzNum+1);
		i = fsize(ScratBuf);
		if( i>0 ) pW->flags &= ~CF_DISABLED;
		else pW->flags |= CF_DISABLED;
		break;
	 case WM_ACTIVATE:
		sprintf(ScratBuf+8100, "%dCT%d.TXT", HumanButtNum, CurPlayer.CurPuzzNum+1);
		if( -1!=(hFile=fopen(ScratBuf+8100, O_RDBIN)) ) {
			// now read the exported Best Moves list to import and NUL-terminate it
			ScratBuf[fread(hFile, ScratBuf, 8192)] = 0;
			fclose(hFile);
			
			// Save current do/undo/redo stack
			hM = HeapAlloc(sizeof(Game.Undos));
			pM = (BYTE*)HeapPtr(hM);
			memcpy(pM, (BYTE*)&Game.Undos, sizeof(Game.Undos));
			cd = Game.CurDo;
			dc = Game.DoCnt;
			mc = Game.MoveCnt;

			Game.DoCnt = Game.CurDo = Game.MoveCnt = 0;
			pB = (BYTE*)ScratBuf;
			while( *pB==' ' || *pB=='\t' ) ++pB;
			while( pB ) {
				// get src top/bot
				if( toupper(*pB)=='T' ) m = 0;
				else if( toupper(*pB)=='B' ) m = 0x0080;
				else break;
				++pB;
				// get src col
				if( !isdigit(*pB) ) break;
				n = *pB++ - '0';
				if( n==1 && isdigit(*pB) ) n = 10 + *pB++ - '0';
				if( n>12 ) break;
				m |= n;
				// get dst top/bot
				if( toupper(*pB)=='T' ) ;
				else if( toupper(*pB)=='B' ) m |= 0x8000;
				else break;
				++pB;
				// get dst col
				if( !isdigit(*pB) ) break;
				n = *pB++ - '0';
				if( n==1 && isdigit(*pB) ) n = 10 + *pB++ - '0';
				if( n>12 ) break;
				m |= (n<<8);
				
				Game.Undos[Game.CurDo++].move = m;
				++Game.DoCnt;
				++Game.MoveCnt;
				while( *pB==' ' || *pB=='\t' || *pB==',' ) ++pB;
			}
			if( !*pB ) {
				SetBest(FALSE);
				GetBest();
				Game.LastBest = -1;	// force toolbar update on next timer
				MessageBox(KString(BLK_DLG, STR_SOLUTION_IMPORTED), MB_WHATEVER);
			}

			Game.MoveCnt = mc;
			Game.DoCnt = dc;
			Game.CurDo = cd;
			pM = (BYTE*)HeapPtr(hM);
			memcpy((BYTE*)&Game.Undos, pM, sizeof(Game.Undos));
			HeapFree(hM);
			
			if( !*pB && Game.MoveCnt==0 && Game.DoCnt==0 ) {
				GetBest();
			}
		}
		return 0;
	 default:
		break;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//===========================================================================
BYTE *GetMergePtr(long n) {
	
	BYTE	*pP, *pB;
	DWORD	bo;
	long	tp, cp, len, bp;
	
	if( hMergeData ) {
		pB = (BYTE*)HeapPtr(hMergeData);	// ptr to Best memory block
		bp = *(DWORD*)(pB+4*(n/1024));
		pP = pB + bp;	// ptr to start of specific 1024-Best-block
		tp = (n & 0x03FF);	// which (0-1023) 'best' solution within the block
		// skip through to find the specific best solution for THIS puzzle
		for(cp=0; cp<tp; cp++) {
			len = *(WORD*)pP;
			pP += 2 + 2*len;
		}
		return pP;
	}
	return NULL;
}

//=======================================================================
DWORD MergeAllProc   (HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {

// merge ?CTMERGE with ?CTBEST
// log to CTMERGE.LOG:
	DWORD	hM, cd, dc, mc, fs, hF, cpn, deltaF;
	BYTE	*pM, *pB, *pF, *pOF, *pOB, *pX;
	WND		*pW;
	DWORD	hFile;
	long	bn, mn;
	char	eol[20];
	long	i, j, len;
	long	mBESTcnt, mMERGEcnt, mMERGEDcnt;
	
	pW = (WND*)HeapPtr(hW);
	switch( msg ) {
	 case WM_PAINT:
		sprintf(ScratBuf, "%dCTMERGE", HumanButtNum);
		i = fsize(ScratBuf);
		if( i>0 ) pW->flags &= ~CF_DISABLED;
		else pW->flags |= CF_DISABLED;
		break;
	 case WM_ACTIVATE:
		if( hMergeData ) {
			if( -1==(hFile = fopen("CTMERGE.LOG", O_WRBINNEW)) ) {
				SystemMessage("Oops! Couldn't create CTMERGE.LOG!");
				HeapFree(hF);
				return 0;
			}
			GetEOL(eol, sizeof(eol));
			sprintf(ScratBuf, KString(BLK_DLG, STR_MERGE_FROM), MergeFileName);
			strcat(ScratBuf, eol);
			fwrite(hFile, ScratBuf, strlen(ScratBuf));
			
			// Save current do/undo/redo stack and CurPuzzNum
			hM = HeapAlloc(sizeof(Game.Undos));
			pM = (BYTE*)HeapPtr(hM);
			memcpy(pM, (BYTE*)&Game.Undos, sizeof(Game.Undos));
			cd = Game.CurDo;
			dc = Game.DoCnt;
			mc = Game.MoveCnt;
			cpn = CurPlayer.CurPuzzNum;

			mBESTcnt = mMERGEcnt = mMERGEDcnt = 0;
			
			pOF = (BYTE*)HeapPtr(hMergeData);
			pOB = (BYTE*)HeapPtr(hBest);
			
			pF = pOF+0x0100;
			pB = pOB+0x0100;

			for(i=0; i<65536; i++) {
				if( (bn = *((WORD*)pB)) ) ++mBESTcnt;
				if( (mn = *((WORD*)pF)) ) ++mMERGEcnt;
				if( mn ) {
					if( (bn==0 || bn>mn) ) {
						++mMERGEDcnt;
						Game.DoCnt = Game.CurDo = Game.MoveCnt = 0;
						for(j=0; j<mn; j++) {
							Game.Undos[Game.CurDo++].move = ((WORD*)(pF+2))[j];
							++Game.DoCnt;
							++Game.MoveCnt;
						}
						CurPlayer.CurPuzzNum = i;
						SetBest(FALSE);
						// if SetBest() caused either Merge or Best memblocks to move, reset pointers
						if( (pX=(BYTE*)HeapPtr(hMergeData))!=pOF ) {
							pOF = pX;
							pF = pOF+0x0100;
							for(j=0; j<i; j++) pF += 2+2*(*(WORD*)pF);
						}
						if( (pX=(BYTE*)HeapPtr(hBest))!=pOB ) {
							pOB = pX;
							pB = pOB+0x0100;
							for(j=0; j<i; j++) pB += 2+2*(*(WORD*)pB);
						}

						sprintf(ScratBuf, "%d %d->%d%s", CurPlayer.CurPuzzNum+1, bn, mn, eol);
						fwrite(hFile, ScratBuf, strlen(ScratBuf));

						bn = mn;
					} else {
						sprintf(ScratBuf, "%d %d%s", i+1, mn, eol);
						fwrite(hFile, ScratBuf, strlen(ScratBuf));
					}
				}
				pB += 2 + 2*(*(WORD*)pB);	// skip to next BEST entry
				pF += 2 + 2*(*(WORD*)pF);	// skip to next MERGE entry
			}

			if( mMERGEDcnt ) SaveBest = TRUE;
			
			sprintf(ScratBuf, KString(BLK_DLG, STR_MERGE_BEST), mBESTcnt);
			strcat(ScratBuf, eol);
			sprintf(ScratBuf+strlen(ScratBuf), KString(BLK_DLG, STR_MERGE_MERGE), mMERGEcnt);
			strcat(ScratBuf, eol);
			sprintf(ScratBuf+strlen(ScratBuf), KString(BLK_DLG, STR_MERGE_MERGED), mMERGEDcnt);
			strcat(ScratBuf, eol);

			fwrite(hFile, ScratBuf, strlen(ScratBuf));
			fclose(hFile);

			MessageBox(ScratBuf, MB_OK);
			
			CurPlayer.CurPuzzNum = cpn;

			GetBest();
			Game.LastBest = -1;	// force toolbar update on next timer

			Game.MoveCnt = mc;
			Game.DoCnt = dc;
			Game.CurDo = cd;
			pM = (BYTE*)HeapPtr(hM);
			memcpy((BYTE*)&Game.Undos, pM, sizeof(Game.Undos));
			HeapFree(hM);
			
			if( Game.MoveCnt==0 && Game.DoCnt==0 ) {
				GetBest();
			}
		}
		return 0;
	 default:
		break;
	}
	return ButtonProc(hW, msg, arg1, arg2, arg3);
}

//=======================================================================
DWORD HGroupboxProc(HWND hW, DWORD msg, DWORD arg1, DWORD arg2, DWORD arg3) {
	
	switch( msg ) {
	 case WM_LBUTTDN:
	 case WM_LBUTTUP:
	 case WM_MBUTTDN:
	 case WM_MBUTTUP:
	 case WM_RBUTTDN:
	 case WM_RBUTTUP:
	 case WM_BBUTTDN:
	 case WM_BBUTTUP:
	 case WM_FBUTTDN:
	 case WM_FBUTTUP:
		// to prevent misclicks within the Help dialog from sending the focus to HIDE
		return 0;
	}
	return GroupboxProc(hW, msg, arg1, arg2, arg3);
}

//=======================================================================
DLGRES ExportDlg[] = {
	{ID_EXPORT_DLG,		WT_WND,	 		0,  0,210,106, WF_SHOW, ExportDlgProc, 0, 0, 0},
	
	{ID_EXPCLR_GROUP,	WT_GROUPBOX,	 2,  0, 60,  51, WF_SHOW, GroupboxProc, MAKESTR(BLK_DLG, STR_EXPCLR), 0, 0},
	{ID_EXPCLR_BACK,	WT_CHECKBOX,	 4,  5, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR+CF_GROUP, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_BACK), 0, 0},
	{ID_EXPCLR_TEXT,	WT_CHECKBOX,	 4,  9, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_TEXT), 0, 0},
	{ID_EXPCLR_HEADBACK,WT_CHECKBOX,	 4, 13, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_HEADBACK), 0, 0},
	{ID_EXPCLR_H1,		WT_CHECKBOX,	 4, 17, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_H1), 0, 0},
	{ID_EXPCLR_HEADTEXT,WT_CHECKBOX,	 4, 21, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_HEADTEXT), 0, 0},
	{ID_EXPCLR_HEADFRAME,WT_CHECKBOX,	 4, 25, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_HEADFRAME), 0, 0},
	{ID_EXPCLR_H2,		WT_CHECKBOX,	 4, 29, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_H2), 0, 0},
	{ID_EXPCLR_H3,		WT_CHECKBOX,	 4, 33, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_H3), 0, 0},
	{ID_EXPCLR_CONTBACK,WT_CHECKBOX,	 4, 37, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_CONTBACK), 0, 0},
	{ID_EXPCLR_CONTTEXT,WT_CHECKBOX,	 4, 41, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_CONTTEXT), 0, 0},
	{ID_EXPCLR_CONTLINK,WT_CHECKBOX,	 4, 45, 55, 4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_COLOR, ExportColorProc, MAKESTR(BLK_DLG, STR_EXPCLR_CONTLINK), 0, 0},
	
	{ID_COLOR_PICKER,	WT_CUSTOM,		 2, 52, 60, 53, WF_SHOW+WF_NSC, ColorPickerProc, 0, 0, 0},

	{ID_EXFONT_GROUP,	WT_GROUPBOX,	63,  0, 50, 22, WF_SHOW, GroupboxProc, MAKESTR(BLK_DLG, STR_EXFONT), 0, 0},
	{ID_EXFONT_TEXT,	WT_RADIOBUTTON,	67,  4, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, FontButtonProc, MAKESTR(BLK_DLG, STR_EXFONT_TEXT), 0, 0},
	{ID_EXFONT_H1,		WT_RADIOBUTTON,	67,  8, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP, FontButtonProc, MAKESTR(BLK_DLG, STR_EXFONT_H1), 0, 0},
	{ID_EXFONT_H2,		WT_RADIOBUTTON,	67, 12, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP, FontButtonProc, MAKESTR(BLK_DLG, STR_EXFONT_H2), 0, 0},
	{ID_EXFONT_H3,		WT_RADIOBUTTON,	67, 16, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP, FontButtonProc, MAKESTR(BLK_DLG, STR_EXFONT_H3), 0, 0},

	{ID_EXFONTL_GROUP,	WT_GROUPBOX,	63, 23, 50, 46, WF_SHOW, GroupboxProc, 0, 0, 0},
	{ID_EXFONT_DEF,		WT_RADIOBUTTON,	67, 25, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, RadioButtonProc, MAKESTR(BLK_DLG, STR_EXFONT_DEF), 0, 0},
	{ID_EXFONT_ARIAL,	WT_RADIOBUTTON,	67, 34, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP, FontTypeProc, MAKESTR(BLK_DLG, STR_EXFONT_ARIAL), 0, 0},
	{ID_EXFONT_VERDANA,	WT_RADIOBUTTON,	67, 38, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP, FontTypeProc, MAKESTR(BLK_DLG, STR_EXFONT_VERDANA), 0, 0},
	{ID_EXFONT_HELVETICA,WT_RADIOBUTTON,67, 42, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP, FontTypeProc, MAKESTR(BLK_DLG, STR_EXFONT_HELVETICA), 0, 0},
	{ID_EXFONT_TAHOMA,	WT_RADIOBUTTON,	67, 46, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP, FontTypeProc, MAKESTR(BLK_DLG, STR_EXFONT_TAHOMA), 0, 0},
	{ID_EXFONT_TIMES,	WT_RADIOBUTTON,	67, 55, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP, FontTypeProc, MAKESTR(BLK_DLG, STR_EXFONT_TIMES), 0, 0},
	{ID_EXFONT_GEORGIA,	WT_RADIOBUTTON,	67, 59, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP, FontTypeProc, MAKESTR(BLK_DLG, STR_EXFONT_GEORGIA), 0, 0},
	{ID_EXFONT_GARAMOND,WT_RADIOBUTTON,	67, 63, 45,  4, WF_SHOW+WF_NSC+CF_TABSTOP, FontTypeProc, MAKESTR(BLK_DLG, STR_EXFONT_GARAMOND), 0, 0},

	{ID_EXPOPT_GROUP,	WT_GROUPBOX,	114,  2,94, 67, WF_SHOW, GroupboxProc, 0, 0, 0},
	{ID_HRULE,			WT_CHECKBOX,	115,  4,92,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, 0, MAKESTR(BLK_DLG, STR_HRULE), 0, 0},
	{ID_HRULE2,			WT_CHECKBOX,	115, 19,92,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_DLG, STR_HRULE2), 0, 0},
	{ID_LINKCONTENTS,	WT_CHECKBOX,	115, 34,92,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_DLG, STR_LINKCONTENTS), 0, 0},

	{ID_HRULETOP,		WT_EDITLINE,	120,  9,87,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_LEFT, EditLineProc, MAKESTR(BLK_DLG, STR_RULETOP), (void*)5, 0},
	{ID_HRULEBOT,		WT_EDITLINE,	120, 14,87,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_LEFT, EditLineProc, MAKESTR(BLK_DLG, STR_RULEBOT), (void*)5, 0},
	{ID_HRULE2TOP,		WT_EDITLINE,	120, 24,87,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_LEFT, EditLineProc, MAKESTR(BLK_DLG, STR_RULETOP), (void*)5, 0},
	{ID_HRULE2BOT,		WT_EDITLINE,	120, 29,87,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_LEFT, EditLineProc, MAKESTR(BLK_DLG, STR_RULEBOT), (void*)5, 0},
	{ID_EXPCONTENTW,	WT_EDITLINE,	115, 39,92,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_LEFT, EditLineProc, MAKESTR(BLK_DLG, STR_EXPCONTENTW), (void*)5, 0},
	{ID_EXPCONTENTSP,	WT_EDITLINE,	115, 44,92,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_LEFT, EditLineProc, MAKESTR(BLK_DLG, STR_EXPCONTENTSP), (void*)5, 0},
	{ID_EXPWIDTH,		WT_EDITLINE,	115, 49,92,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_LEFT, EditLineProc, MAKESTR(BLK_DLG, STR_EXPWIDTH), (void*)5, 0},
	{ID_EXPLMARGIN,		WT_EDITLINE,	115, 54,92,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_LEFT, EditLineProc, MAKESTR(BLK_DLG, STR_EXPLMARGIN), (void*)5, 0},

	{ID_EXPEXP1,		WT_TEXT,		63, 81,144,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, 0, MAKESTR(BLK_DLG, STR_EXPEXP1), 0, 0},
	{ID_EXPEXP2,		WT_TEXT,		63, 86,144,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, 0, MAKESTR(BLK_DLG, STR_EXPEXP2), 0, 0},

	{ID_EXPHELP,		WT_BUTTONTEXT,	63, 91, 14,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER+CF_GROUP, ExpHelpButtProc, MAKESTR(BLK_DLG, STR_EXPHELP), 0, 0},
	{ID_EXPSAVECHANGES,	WT_BUTTONTEXT,	78, 91, 35,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER+CF_GROUP, ExpSaveButtProc, MAKESTR(BLK_DLG, STR_EXPSAVECHANGES), 0, 0},
	{ID_OK,				WT_BUTTONTEXT,	63, 98, 35,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER+CF_GROUP, DefComButtProc, MAKESTR(BLK_DLG, STR_DLG_EXPORT), 0, 0},
	{ID_CANCEL,			WT_BUTTONTEXT,	99, 98, 14,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER+CF_GROUP, DefComButtProc, MAKESTR(BLK_MISC, STR_CANCEL), 0, 0},

	{ID_EXFONT_SANS,	WT_TEXT,		64, 30, 48,  4, WF_SHOW+CF_LEFT, TextProc, MAKESTR(BLK_DLG, STR_EXFONT_SANS), 0, 0},
	{ID_EXFONT_SERIF,	WT_TEXT,		64, 51, 48,  4, WF_SHOW+CF_LEFT, TextProc, MAKESTR(BLK_DLG, STR_EXFONT_SERIF), 0, 0},

	{0}
};

//==========================================================================
DLGRES HelpCtls[] = {
// NOTE: If the UH height of ID_HELP_TITLE and/or ID_HELP_TEXT changes,
// make sure to change the values in MenuDlgProc()'s HM_HYPERJUMP code!
	{ID_HELP_GROUP, WT_GROUPBOX,	 31,  1,146,104, WF_SHOW, HGroupboxProc, 0, 0, 0},

	{ID_HELP_TITLE, WT_CUSTOM,		 32,  2,144, 14, WF_SHOW, HelpTitleProc, 0, 0, 0},
	{ID_HELP_TEXT, WT_CUSTOM,		 32, 17,144, 80, WF_SHOW, HelpTextProc, 0, 0, 0},

	{ID_HELP_CHANGED, WT_CUSTOM,	 34, 67,140, 28, 0, HelpChangedProc, 0, 0, 0},

	{ID_HELP_HIDE, WT_BUTTONTEXT,	 32, 98, 18,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, HelpHideProc,  MAKESTR(BLK_DLG, STR_HELP_HIDE), 0, 0},
	{ID_HELP_EXPORT,WT_BUTTONTEXT,	 63, 98, 18,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, HelpExportProc, MAKESTR(BLK_DLG, STR_HELP_EXPORT), 0, 0},
	{ID_HELP_INDEX,WT_BUTTONTEXT,	 91, 98, 18,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, HelpIndexProc, MAKESTR(BLK_DLG, STR_HELP_INDEX), 0, 0},
	{ID_HELP_BACK, WT_BUTTONTEXT,	110, 98, 18,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, HelpBackProc,  MAKESTR(BLK_DLG, STR_HELP_BACK), 0, 0},
	{ID_HELP_PREV, WT_BUTTONTEXT,	139, 98, 18,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, HelpPrevProc,  MAKESTR(BLK_DLG, STR_HELP_PREV), 0, 0},
	{ID_HELP_NEXT, WT_BUTTONTEXT,	158, 98, 18,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_FOCUS, HelpNextProc,  MAKESTR(BLK_DLG, STR_HELP_NEXT), 0, 0},

	{0}
};

//==========================================================================
DLGRES BestMovesCtls[] = {

	{ID_EXP_ALLCNTS, WT_BUTTONTEXT,	 32,  2,100,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_STR, ExpBestCntsProc,  BestButtStr, 0, 0},
	{ID_EXP_CURBEST, WT_BUTTONTEXT,	 32,  9,100,  6, WF_SHOW+WF_NSC+CF_TABSTOP, ExpCurBestProc, MAKESTR(BLK_DLG, STR_EXP_CURBEST), 0, 0},
	{ID_IMP_CURBEST, WT_BUTTONTEXT,	 32, 16,100,  6, WF_SHOW+WF_NSC+CF_TABSTOP, ImpCurBestProc, MAKESTR(BLK_DLG, STR_IMP_CURBEST), 0, 0},
	{ID_MERGE_ALL, WT_BUTTONTEXT,	 32, 23,100,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_STR, MergeAllProc, MergeButtStr, 0, 0},

	{ID_BEST_CNT, WT_TEXT,			 32, 30,100,  4, WF_SHOW+CF_STR+CF_LEFT, TextProc, BestCntStr, 0, 0},
	{ID_MERGE_CNT, WT_TEXT,			 32, 34,100,  4, WF_SHOW+CF_STR+CF_LEFT, TextProc, MergeCntStr, 0, 0},

	{0}
};
//==========================================================================
DLGRES AboutCtls[] = {
	
	{ID_ABOUT_GROUP1, WT_GROUPBOX,	31,  1, 60, 92, WF_SHOW, GroupboxProc, 0, 0, 0},
	{ID_ABOUT_COPYRIGHT0, WT_TEXT,	32,  5, 58,  6, WF_SHOW+CF_STR+CF_CENTER+CF_BOLD,	TextProc, PgmTitle, 0, 0},
	{ID_ABOUT_COPYRIGHT3, WT_TEXT,	32, 11, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, AboutRevision, 0, 0},
	{ID_ABOUT_COPYRIGHT4, WT_TEXT,	32, 15, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, LicStr, 0, 0},
	{ID_ABOUT_COPYRIGHT1, WT_TEXT,	32, 19, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, Copyright, 0, 0},
	{ID_ABOUT_COPYRIGHT2, WT_TEXT,	32, 23, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, AllRights, 0, 0},

	{ID_ABOUT_CONTACT1, WT_TEXT,	32, 31, 58,  4, WF_SHOW+WF_NSC+CF_CENTER,			TextProc, MAKESTR(BLK_DLG, STR_CONTACT), 0, 0},
	{ID_ABOUT_CONTACT2, WT_TEXT,	32, 35, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, str_mod_help1, 0, 0},
	{ID_ABOUT_CONTACT3, WT_TEXT,	32, 39, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, str_mod_help2, 0, 0},
	{ID_ABOUT_CONTACT4, WT_TEXT,	32, 43, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, str_mod_help3, 0, 0},
	{ID_ABOUT_CONTACT5, WT_TEXT,	32, 47, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, str_mod_help4, 0, 0},
	{ID_ABOUT_CONTACT6, WT_TEXT,	32, 51, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, str_mod_help5, 0, 0},
	
	{ID_ABOUT_BUILD1, WT_TEXT,		32, 60, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, AboutDate, 0, 0},
	{ID_ABOUT_BUILD2, WT_TEXT,		32, 64, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, AboutBuildNum, 0, 0},
	{ID_ABOUT_KINT, WT_TEXT,		32, 68, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, AboutKINT, 0, 0},

	{ID_ABOUT_SCREEN, WT_TEXT,		32, 76, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, AboutScreen, 0, 0},
	{ID_ABOUT_WINDOW, WT_TEXT,		32, 80, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, AboutWindow, 0, 0},
	{ID_ABOUT_UI, WT_TEXT,			32, 84, 58,  4, WF_SHOW+CF_STR+CF_CENTER,			TextProc, AboutUI, 0, 0},

	{ID_ABOUT_COPY,	WT_BUTTONTEXT,	41, 94, 40,  6, WF_SHOW+WF_NSC+CF_DEFAULT+CF_TABSTOP+CF_GROUP, AboutCopyProc, MAKESTR(BLK_DLG, STR_ABOUT_COPY), 0, 0},

	{0}
};

//==========================================================================
DLGRES SelPlyCtls[] = {
	
	{ID_LIST,		WT_LISTBOX,		31,  1, 60, 62, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_FOCUS, PlayerListProc, MAKESTR(BLK_DLG, STR_SELPLAYER), 0, 0},
	{ID_SELPLAYER,	WT_BUTTONTEXT,	31, 64, 24,  6, WF_SHOW+WF_NSC+CF_DEFAULT+CF_TABSTOP+CF_GROUP, PlayerSelProc, MAKESTR(BLK_DLG, STR_SELECT), 0, 0},

	{0}
};

//==========================================================================
DLGRES AddPlyCtls[] = {
	
	{ID_NEWPLYGROUP,WT_GROUPBOX,	31,  1,135,  8, WF_SHOW, GroupboxProc, 0, 0, 0},

	{ID_NEWPLYNAME,	WT_EDITLINE,	32,  3,132,  4, WF_SHOW+WF_NSC+CF_GROUP+CF_TABSTOP+CF_RIGHT+CF_FOCUS, EditLineProc, MAKESTR(BLK_DLG, STR_NEWPLAYER), (void*)50, 0},

	{ID_NPMOODGROUP,WT_GROUPBOX,	31, 10,135, 16, WF_SHOW, GroupboxProc, 0, 0, 0},
	{ID_DEFMOOD,	WT_RADIOBUTTON,	32, 12, 50,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, RadioButtonProc, MAKESTR(BLK_DLG, STR_DEFMOOD), 0, 0},
	{ID_COPYCURMOOD,WT_RADIOBUTTON,	32, 16,133,  4, WF_SHOW+WF_NSC+CF_TABSTOP, RadioButtonProc, MAKESTR(BLK_DLG, STR_COPYCURMOOD), 0, 0},
	{ID_COPYALLMOODS,WT_RADIOBUTTON,32, 20,133,  4, WF_SHOW+WF_NSC+CF_TABSTOP, RadioButtonProc, MAKESTR(BLK_DLG, STR_COPYALLMOODS), 0, 0},

	{ID_NPDEFMOODNAME,WT_EDITLINE,	83, 12, 81,  4, WF_SHOW+WF_NSC+CF_GROUP+CF_TABSTOP+CF_RIGHT, EditLineProc, MAKESTR(BLK_DLG, STR_NPDEFMOODNAME), (void*)50, 0},

	{ID_NEWPLYADD,	WT_BUTTONTEXT,	31, 29, 24,  6, WF_SHOW+WF_NSC+CF_DEFAULT+CF_TABSTOP+CF_GROUP, PlayerAddProc, MAKESTR(BLK_DLG, STR_ADD), 0, 0},
	
	{0}
};

//==========================================================================
DLGRES RenPlyCtls[] = {
	
	{ID_RENPLYGROUP,WT_GROUPBOX,	31,  1, 88,  8, WF_SHOW, GroupboxProc, 0, 0, 0},

	{ID_RENPLYNAME,	WT_EDITLINE,	32,  3, 85,  4, WF_SHOW+WF_NSC+CF_GROUP+CF_TABSTOP+CF_RIGHT+CF_FOCUS, EditLineProc, MAKESTR(BLK_DLG, STR_REN_PLAYER), (void*)50, 0},

	{ID_RENPLYREN,	WT_BUTTONTEXT,	31, 10, 24,  6, WF_SHOW+WF_NSC+CF_DEFAULT+CF_TABSTOP+CF_GROUP, PlayerRenProc, MAKESTR(BLK_DLG, STR_RENAME), 0, 0},

	{0}
};

//==========================================================================
DLGRES DelPlyCtls[] = {
	
	{0}
};

//==========================================================================
DLGRES SelMoodCtls[] = {
	
	{ID_LIST,		WT_LISTBOX,		31,  1, 60, 62, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_FOCUS, MoodListProc, MAKESTR(BLK_DLG, STR_SELMOOD), 0, 0},
	{ID_SELMOOD,	WT_BUTTONTEXT,	31, 64, 24,  6, WF_SHOW+WF_NSC+CF_DEFAULT+CF_TABSTOP+CF_GROUP, MoodSelProc, MAKESTR(BLK_DLG, STR_SELECTMOOD), 0, 0},

	{0}
};

//==========================================================================
DLGRES AddMoodCtls[] = {
	
	{ID_NEWMOODGROUP,WT_GROUPBOX,	31,  1, 88,  8, WF_SHOW, GroupboxProc, 0, 0, 0},

	{ID_NEWMOODNAME,WT_EDITLINE,	32,  3, 85,  4, WF_SHOW+WF_NSC+CF_GROUP+CF_TABSTOP+CF_RIGHT+CF_FOCUS, EditLineProc, MAKESTR(BLK_DLG, STR_NEWMOODNAME), (void*)50, 0},

	{ID_NPMOODGROUP,WT_GROUPBOX,	31, 10, 88, 12, WF_SHOW, GroupboxProc, 0, 0, 0},
	{ID_DEFMOOD,	WT_RADIOBUTTON,	32, 12, 83,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, RadioButtonProc, MAKESTR(BLK_DLG, STR_DEFMOOD), 0, 0},
	{ID_COPYCURMOOD,WT_RADIOBUTTON,	32, 16, 83,  4, WF_SHOW+WF_NSC+CF_TABSTOP, RadioButtonProc, MAKESTR(BLK_DLG, STR_NEWMOODCOPY), 0, 0},

	{ID_NEWMOODADD,	WT_BUTTONTEXT,	31, 25, 24,  6, WF_SHOW+WF_NSC+CF_DEFAULT+CF_TABSTOP+CF_GROUP, MoodAddProc, MAKESTR(BLK_DLG, STR_NEWMOODADD), 0, 0},
	
	{0}
};

//==========================================================================
DLGRES RenMoodCtls[] = {
	
	{ID_RENMOODGROUP,WT_GROUPBOX,	31,  1, 88,  8, WF_SHOW, GroupboxProc, 0, 0, 0},

	{ID_RENMOODNAME,WT_EDITLINE,	32,  3, 85,  4, WF_SHOW+WF_NSC+CF_GROUP+CF_TABSTOP+CF_RIGHT+CF_FOCUS, EditLineProc, MAKESTR(BLK_DLG, STR_REN_MOOD), (void*)50, 0},

	{ID_RENMOODREN,	WT_BUTTONTEXT,	31, 12, 24,  6, WF_SHOW+WF_NSC+CF_DEFAULT+CF_TABSTOP+CF_GROUP, MoodRenProc, MAKESTR(BLK_DLG, STR_RENMOOD_BUTTON), 0, 0},

	{0}
};

//==========================================================================
DLGRES DelMoodCtls[] = {
	
	{0}
};

//==========================================================================
DLGRES MusicCtls[] = {
	{ID_MUSIC_GROUP,WT_GROUPBOX,	 31,  1,122, 99, WF_SHOW, GroupboxProc, 0, 0, 0},

	{ID_LIST,		WT_LISTBOX,		 33,  3, 38,  95, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_SORT+CF_FOCUS, MavailProc, MAKESTR(BLK_DLG, STR_MUSIC_AVAIL), 0, 0},

	{ID_ADDBACK, WT_BUTTONTEXT,		 72, 13, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, MaddbackProc, MAKESTR(BLK_DLG, STR_M_ADDBACK), 0, 0},
	{ID_ADDBACKALL, WT_BUTTONTEXT,	 72, 20, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, MaddbackallProc, MAKESTR(BLK_DLG, STR_M_ADDBACKALL), 0, 0},
	{ID_REMBACK, WT_BUTTONTEXT,		 72, 28, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, MrembackProc, MAKESTR(BLK_DLG, STR_M_REMBACK), 0, 0},
	{ID_REMBACKALL, WT_BUTTONTEXT,	 72, 35, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, MrembackallProc, MAKESTR(BLK_DLG, STR_M_REMBACKALL), 0, 0},
	{ID_TEST, WT_BUTTONTEXT,		 72, 55, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, MtestProc, MAKESTR(BLK_DLG, STR_M_TEST), 0, 0},
	{ID_ADDWIN, WT_BUTTONTEXT,		 72, 70, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, MaddwinProc, MAKESTR(BLK_DLG, STR_M_ADDWIN), 0, 0},
	{ID_ADDWINALL, WT_BUTTONTEXT,	 72, 77, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, MaddwinallProc, MAKESTR(BLK_DLG, STR_M_ADDWINALL), 0, 0},
	{ID_REMWIN, WT_BUTTONTEXT,		 72, 85, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, MremwinProc, MAKESTR(BLK_DLG, STR_M_REMWIN), 0, 0},
	{ID_REMWINALL, WT_BUTTONTEXT,	 72, 92, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, MremwinallProc, MAKESTR(BLK_DLG, STR_M_REMWINALL), 0, 0},

	{ID_RANDMUSIC,WT_CHECKBOX,		103,  3, 48,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, 0, MAKESTR(BLK_DLG, STR_M_RANDOM), 0, 0},
	{ID_PLAYBACK,WT_CHECKBOX,		103,  8, 48,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_DLG, STR_PLAYBACKMUSIC), 0, 0},
	{ID_LISTBACK, WT_LISTBOX,		103, 12, 48, 42, WF_SHOW+CF_TABSTOP+CF_GROUP, MbackProc, NULL, 0, 0},

	{ID_PLAYWIN,WT_CHECKBOX,		103, 57, 48,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_DLG, STR_PLAYWINMUSIC), 0, 0},
	{ID_LISTWIN, WT_LISTBOX,		103, 61, 48, 37, WF_SHOW+CF_TABSTOP+CF_GROUP, MwinProc, NULL, 0, 0},

	{ID_MIRROR_CHANGES,WT_CHECKBOX,	 31,101,150,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_MM, STR_MIRROR_CHANGES), 0, 0},

	{0}
};

//==========================================================================
DLGRES IFSCtls[] = {
	
	{ID_LIST,		WT_LISTBOX,		31, 28, 60, 60, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, ListBoxProc, MAKESTR(BLK_DLG, STR_IF_FILE), 0, 0},
	{ID_IF_IMGBY,	WT_TEXT,		31, 91, 27,  4, WF_SHOW+WF_NSC+CF_RIGHT, TextProc, MAKESTR(BLK_DLG, STR_IF_BY), 0, 0},
	{ID_IF_CREDITS,	WT_CUSTOM,		59, 89, 32,  8, WF_SHOW, IFcreditsProc, (void*)0, 0, 0},
	{ID_IF_SIZE,	WT_TEXT,		31, 24, 60,  4, WF_SHOW+WF_NSC+CF_LEFT+CF_STR, TextProc, IFsizeStr, 0, 0},

	{ID_MIRROR_CHANGES,WT_CHECKBOX,31,101,150,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_MM, STR_MIRROR_CHANGES), 0, 0},

	{0}
};

//==========================================================================
DLGRES LangCtls[] = {
	{ID_LANG_GROUP,WT_GROUPBOX,	 31,  1,126, 94, WF_SHOW, GroupboxProc, 0, 0, 0},

	{ID_LANG_STRINGS,WT_LISTBOX, 33,  2, 60, 85, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_SORT+CF_FOCUS, ListBoxProc, MAKESTR(BLK_DLG, STR_LANG_STRINGS), 0, 0},
	{ID_LANG_HELP,	WT_LISTBOX,	 95,  2, 60, 85, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_SORT, ListBoxProc, MAKESTR(BLK_DLG, STR_LANG_HELP), 0, 0},
	{ID_LANG_STR_BY,WT_TEXT,	 31, 88, 62,  4, WF_SHOW+CF_CENTER+CF_STR, TextProc, LangStrBy, 0, 0},
	{ID_LANG_HLP_BY,WT_TEXT,	 93, 88, 62,  4, WF_SHOW+CF_CENTER+CF_STR, TextProc, LangHlpBy, 0, 0},

	{ID_MIRROR_CHANGES,WT_CHECKBOX,31,101,150,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_MM, STR_MIRROR_CHANGES), 0, 0},

	{0}
};

//==========================================================================
DLGRES GraphCtls[] = {
	
	{ID_IF_UUGROUP,	WT_GROUPBOX,	31,  1, 168, 99, WF_SHOW, GroupboxProc, 0, 0, 0},
	{ID_LIST,		WT_LISTBOX,		32,  2, 60,  83, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_FOCUS+CF_SORT, ListBoxProc, MAKESTR(BLK_DLG, STR_GG_FILE), 0, 0},
	{ID_GG_IMGBY,	WT_TEXT,		32, 85, 60,   4, WF_SHOW+WF_NSC+CF_CENTER, TextProc, MAKESTR(BLK_DLG, STR_IF_BY), 0, 0},
	{ID_GG_CREDITS,	WT_CUSTOM,		50, 90, 24,   8, WF_SHOW, GGcreditsProc, (void*)0, 0, 0},
	{ID_GG_PREVIEW, WT_CUSTOM,		94,  6, 84,  84, WF_SHOW, GGpreviewProc, (void*)0, 0, 0},

	{ID_MIRROR_CHANGES,WT_CHECKBOX,	31,101,150,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_MM, STR_MIRROR_CHANGES), 0, 0},

	{0}
};

//==========================================================================
DLGRES MouseMapCtls[] = {
	{ID_MM_BUTTGROUP,WT_GROUPBOX,	31,  0, 42, 86, WF_SHOW+WF_NSC, GroupboxProc, MAKESTR(BLK_MM, STR_MM_BUTTGROUP), 0, 0},

	{ID_MM_LEFT,WT_RADIOBUTTON,		32,  4, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_FOCUS, MMButtonProc, MAKESTR(BLK_MM, STR_MM_LEFT), 0, 0},
	{ID_MM_MIDDLE,WT_RADIOBUTTON,	32,  8, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_MIDDLE), 0, 0},
	{ID_MM_RIGHT,WT_RADIOBUTTON,	32, 12, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_RIGHT), 0, 0},
	{ID_MM_BACK,WT_RADIOBUTTON,		32, 16, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_BACK), 0, 0},
	{ID_MM_FWD,WT_RADIOBUTTON,		32, 20, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_FWD), 0, 0},

	{ID_MM_SLEFT,WT_RADIOBUTTON,	32, 24, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_SLEFT), 0, 0},
	{ID_MM_SMIDDLE,WT_RADIOBUTTON,	32, 28, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_SMIDDLE), 0, 0},
	{ID_MM_SRIGHT,WT_RADIOBUTTON,	32, 32, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_SRIGHT), 0, 0},
	{ID_MM_SBACK,WT_RADIOBUTTON,	32, 36, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_SBACK), 0, 0},
	{ID_MM_SFWD,WT_RADIOBUTTON,		32, 40, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_SFWD), 0, 0},

	{ID_MM_CLEFT,WT_RADIOBUTTON,	32, 44, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_CLEFT), 0, 0},
	{ID_MM_CMIDDLE,WT_RADIOBUTTON,	32, 48, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_CMIDDLE), 0, 0},
	{ID_MM_CRIGHT,WT_RADIOBUTTON,	32, 52, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_CRIGHT), 0, 0},
	{ID_MM_CBACK,WT_RADIOBUTTON,	32, 56, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_CBACK), 0, 0},
	{ID_MM_CFWD,WT_RADIOBUTTON,		32, 60, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_CFWD), 0, 0},

	{ID_MM_SCLEFT,WT_RADIOBUTTON,	32, 64, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_SCLEFT), 0, 0},
	{ID_MM_SCMIDDLE,WT_RADIOBUTTON,	32, 68, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_SCMIDDLE), 0, 0},
	{ID_MM_SCRIGHT,WT_RADIOBUTTON,	32, 72, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_SCRIGHT), 0, 0},
	{ID_MM_SCBACK,WT_RADIOBUTTON,	32, 76, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_SCBACK), 0, 0},
	{ID_MM_SCFWD,WT_RADIOBUTTON,	32, 80, 40,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMButtonProc, MAKESTR(BLK_MM, STR_MM_SCFWD), 0, 0},

	{ID_MM_ACTGROUP,WT_GROUPBOX,	74,  0,124, 86, WF_SHOW+WF_NSC,	GroupboxProc, MAKESTR(BLK_MM, STR_MM_ACTGROUP), 0, 0},
	{ID_MM_NOACTION,WT_RADIOBUTTON,	75,  4,122,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, MMActButtonProc, MAKESTR(BLK_MM, STR_MM_NOACTION), 0, 0},
	{ID_MM_MOVETILE,WT_RADIOBUTTON,	75,  8,122,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMActButtonProc, MAKESTR(BLK_MM, STR_MM_MOVETILE), 0, 0},
	{ID_MM_FINDAVAIL,WT_RADIOBUTTON,75, 12,122,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMActButtonProc, MAKESTR(BLK_MM, STR_MM_FINDAVAIL), 0, 0},
	{ID_MM_FINDTPBT,WT_RADIOBUTTON,	75, 16,122,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMActButtonProc, MAKESTR(BLK_MM, STR_MM_FINDTPBT), 0, 0},
	{ID_MM_FINDALL,WT_RADIOBUTTON,	75, 20,122,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMActButtonProc, MAKESTR(BLK_MM, STR_MM_FINDALL), 0, 0},
	{ID_MM_UNDO,WT_RADIOBUTTON,		75, 24,122,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMActButtonProc, MAKESTR(BLK_MM, STR_MM_UNDO), 0, 0},
	{ID_MM_REDO,WT_RADIOBUTTON,		75, 28,122,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMActButtonProc, MAKESTR(BLK_MM, STR_MM_REDO), 0, 0},
	{ID_MM_NEXT_MOOD,WT_RADIOBUTTON,75, 32,122,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMActButtonProc, MAKESTR(BLK_MM, STR_MM_NEXT_MOOD), 0, 0},
	{ID_MM_PREV_MOOD,WT_RADIOBUTTON,75, 36,122,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MMActButtonProc, MAKESTR(BLK_MM, STR_MM_PREV_MOOD), 0, 0},

	{ID_RESET, WT_BUTTONTEXT,		31, 87, 20,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, MMresetProc, MAKESTR(BLK_MISC, STR_RESET)},
	
	{ID_REV_WHEEL,WT_CHECKBOX,		53, 87,145,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, 0, MAKESTR(BLK_MM, STR_REV_WHEEL), 0, 0},
	{ID_REV_TILT,WT_CHECKBOX,		53, 91,145,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_MM, STR_REV_TILT), 0, 0},

	{ID_MM_EXPORT,WT_BUTTONTEXT,	31, 94, 20,  6, WF_SHOW+WF_NSC+CF_TABSTOP, MapExportProc, MAKESTR(BLK_MM, STR_MM_EXPORT), 0, 0},

	{ID_MIRROR_CHANGES,WT_CHECKBOX,	31,101,150,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_MM, STR_MIRROR_CHANGES), 0, 0},

	{0}
};

//==========================================================================
DLGRES KeyMapCtls[] = {
	{ID_KEY_GROUP,WT_GROUPBOX,	 	 31,  1,150, 99, WF_SHOW, GroupboxProc, 0, 0, 0},

	{ID_KEYMAP_LIST,WT_LISTBOX,		 33,  2,146, 40, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_SORT+CF_FOCUS, KeyMapListProc, MAKESTR(BLK_KEY, STR_KEYMAP_HEAD), 0, 0},
	
	{ID_KEYS_LIST,WT_LISTBOX,		 33, 44, 32, 45, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, KeyListProc, MAKESTR(BLK_KEY, STR_KEYS_HEAD), 0, 0},
	{ID_KEY_SHIFT,WT_CHECKBOX,		 33, 90, 32,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, 0, MAKESTR(BLK_KEY, STR_KEY_SHIFT), 0, 0},
	{ID_KEY_CTL,WT_CHECKBOX,		 33, 94, 32,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_KEY, STR_KEY_CTL), 0, 0},

	{ID_FUNC_LIST,WT_LISTBOX,		 67, 44, 80, 54, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, KeyFuncListProc, MAKESTR(BLK_KEY, STR_FUNC_HEAD), 0, 0},

	{ID_KEY_ADD,   WT_BUTTONTEXT,	149, 48, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, KeyMapAddProc, MAKESTR(BLK_KEY, STR_KEYMAP_ADD), 0, 0},
	{ID_KEY_DELETE,WT_BUTTONTEXT,	149, 55, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, KeyMapDelProc, MAKESTR(BLK_KEY, STR_KEYMAP_DEL), 0, 0},
	{ID_KEY_MOVE,  WT_BUTTONTEXT,	149, 62, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, KeyMapMoveProc, MAKESTR(BLK_KEY, STR_KEYMAP_MOVE), 0, 0},
	{ID_KEY_DUPE,  WT_BUTTONTEXT,	149, 69, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, KeyMapDupeProc, MAKESTR(BLK_KEY, STR_KEYMAP_DUPE), 0, 0},
	{ID_KEY_RESET, WT_BUTTONTEXT,	149, 76, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, KeyMapResetProc, MAKESTR(BLK_KEY, STR_KEYMAP_RESET), 0, 0},
	{ID_KEY_EXPORT,WT_BUTTONTEXT,	149, 83, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, KeyMapExportProc, MAKESTR(BLK_KEY, STR_KEYMAP_EXPORT), 0, 0},
	{ID_KEY_HELP,  WT_BUTTONTEXT,	149, 90, 30,  6, WF_SHOW+WF_NSC+CF_TABSTOP, KeyMapHelpProc, MAKESTR(BLK_KEY, STR_KEYMAP_HELP), 0, 0},

	{ID_MIRROR_CHANGES,WT_CHECKBOX,	31,101,150,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_MM, STR_MIRROR_CHANGES), 0, 0},

	{0}
};

//==========================================================================
DLGRES ExitCtls[] = {
	
	{0}
};

//==========================================================================
DLGRES OptionsCtls[] = {
	
	{ID_OPT_GROUP1,		WT_GROUPBOX,	31,  1, 74, 54, WF_SHOW, GroupboxProc, 0, 0, 0},
	{ID_BYPASS_TITLE,	WT_CHECKBOX,	32,  2, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP+CF_FOCUS, CheckboxProc, MAKESTR(BLK_OPT, STR_BYPASS_TITLE), 0, 0},
	{ID_GAMESOUNDS,		WT_CHECKBOX,	32,  6, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_GAME_SOUNDS), 0, 0},
	{ID_ERRORSOUNDS,	WT_CHECKBOX,	32, 10, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_ERROR_SOUNDS), 0, 0},
	{ID_PROMPTNEXT,		WT_CHECKBOX,	32, 14, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_PROMPT_NEXT), 0, 0},
	{ID_PROMPTRESTART,	WT_CHECKBOX,	32, 18, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_PROMPT_RESTART), 0, 0},
	{ID_ENABLECLICK,	WT_CHECKBOX,	32, 22, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_ENABLE_CLICK), 0, 0},
	{ID_STARTBOTTOM,	WT_CHECKBOX,	32, 26, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_START_BOTTOM), 0, 0},
	{ID_SCRAMBLEORDER,	WT_CHECKBOX,	32, 30, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_SCRAMBLE_TILES), 0, 0},
	{ID_SHOWTIMER,		WT_CHECKBOX,	32, 34, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_SHOW_TIMER), 0, 0},
	{ID_REMOVE_PAUSE,	WT_CHECKBOX,	32, 38, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_REMOVE_PAUSE), 0, 0},
	{ID_SHOWTILESMOVED,	WT_CHECKBOX,	32, 42, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_SHOW_MOVECNT), 0, 0},
	{ID_SHOWBESTCOUNT,	WT_CHECKBOX,	32, 46, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_SHOW_BESTCNT), 0, 0},
	{ID_SHOW_TOOLTIPS,	WT_CHECKBOX,	32, 50, 72,  4, WF_SHOW+WF_NSC+CF_TABSTOP, CheckboxProc, MAKESTR(BLK_OPT, STR_SHOW_TOOLTIPS), 0, 0},

//NOTE: If you add 'flags' options, be sure to add them to the #define	OPTION_FLAGS at the top of this file!!!

	{ID_WINGROUP,		WT_GROUPBOX,	105,  1, 94, 43, WF_SHOW, GroupboxProc, MAKESTR(BLK_OPT, STR_WIN_DISP), 0, 0},
	{ID_WIN_FIRE,		WT_RADIOBUTTON,	106,  6, 92,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, RadioButtonProc, MAKESTR(BLK_OPT, STR_WIN_FIRE), 0, 0},
	{ID_WIN_QUILT,		WT_RADIOBUTTON,	106, 10, 92,  4, WF_SHOW+WF_NSC+CF_TABSTOP, RadioButtonProc, MAKESTR(BLK_OPT, STR_WIN_QUILT), 0, 0},
	{ID_WIN_WEAVE,		WT_RADIOBUTTON,	106, 14, 92,  4, WF_SHOW+WF_NSC+CF_TABSTOP, RadioButtonProc, MAKESTR(BLK_OPT, STR_WIN_WEAVE), 0, 0},
	{ID_WIN_BOUNCE,		WT_RADIOBUTTON,	106, 18, 92,  4, WF_SHOW+WF_NSC+CF_TABSTOP, RadioButtonProc, MAKESTR(BLK_OPT, STR_WIN_BOUNCE), 0, 0},
	{ID_WIN_RANDOM,		WT_RADIOBUTTON,	106, 22, 92,  4, WF_SHOW+WF_NSC+CF_TABSTOP, RadioButtonProc, MAKESTR(BLK_OPT, STR_WIN_RANDOM), 0, 0},
	{ID_WIN_NONE,		WT_RADIOBUTTON,	106, 26, 92,  4, WF_SHOW+WF_NSC+CF_TABSTOP, RadioButtonProc, MAKESTR(BLK_OPT, STR_WIN_NONE), 0, 0},

	{ID_WIN_DELAY,		WT_EDITLINE,	107, 32, 91,  4, WF_SHOW+WF_NSC+CF_GROUP+CF_TABSTOP+CF_LEFT, EditLineProc, MAKESTR(BLK_OPT, STR_WIN_DELAY), (void*)6, 0},
	{ID_WIN_SPEED,		WT_EDITLINE,	107, 37, 91,  4, WF_SHOW+WF_NSC+CF_GROUP+CF_TABSTOP+CF_LEFT, EditLineProc, MAKESTR(BLK_OPT, STR_WIN_SPEED), (void*)6, 0},

	{ID_PUZZLE_SIZE,	WT_EDITLINE,	107, 46, 91,  4, WF_SHOW+WF_NSC+CF_GROUP+CF_TABSTOP+CF_LEFT, EditLineProc, MAKESTR(BLK_OPT, STR_PUZZLE_SIZE), (void*)6, 0},
	{ID_CSV_SEP,		WT_EDITLINE,	107, 51, 91,  4, WF_SHOW+WF_NSC+CF_GROUP+CF_TABSTOP+CF_LEFT, EditLineProc, MAKESTR(BLK_OPT, STR_CSV_SEP), (void*)6, 0},
	

	{ID_MIRROR_CHANGES,	WT_CHECKBOX,	 31,101,150,  4, WF_SHOW+WF_NSC+CF_TABSTOP, 0, MAKESTR(BLK_MM, STR_MIRROR_CHANGES), 0, 0},

	{0}
};

//=======================================================================
DLGRES MenuDlg[] = {
	{ID_MENU_DLG,		WT_WND,			 -BARWUU,  0,200,106, WF_SHOW, MenuDlgProc, 0, 0, 0},
	
	{ID_MENU_GROUP,		WT_GROUPBOX,	 1,  1, 29, 94, WF_SHOW, MenuGroupboxProc, 0, 0, 0},

	{ID_MENU_HELP,		WT_RADIOBUTTON,	 2,  2, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_GROUP, MenuItemProc, MAKESTR(BLK_MENU, STR_HELP), (void*)HelpCtls, 0},
	{ID_MENU_BESTMOVES,	WT_RADIOBUTTON,	 2,  6, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MenuItemProc, MAKESTR(BLK_MENU, STR_BESTMOVES), (void*)BestMovesCtls, 0},
	{ID_MENU_ABOUT,		WT_RADIOBUTTON,	 2, 10, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MenuItemProc, MAKESTR(BLK_MENU, STR_ABOUT), (void*)AboutCtls, 0},
	{ID_MENU_EXIT,		WT_RADIOBUTTON,	 2, 14, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_RIGHT, MenuItemProc, MAKESTR(BLK_MENU, STR_EXITGAME), (void*)ExitCtls, 0},

	{ID_MENU_PLYR_SEL,	WT_RADIOBUTTON,	 2, 21, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MenuItemProc, MAKESTR(BLK_MENU, STR_CHANGE_PLAYER), (void*)SelPlyCtls, 0},
	{ID_MENU_PLYR_ADD,	WT_RADIOBUTTON,	 2, 25, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MenuItemProc, MAKESTR(BLK_MENU, STR_ADD_PLAYER), (void*)AddPlyCtls, 0},
	{ID_MENU_PLYR_REN,	WT_RADIOBUTTON,	 2, 29, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MenuItemProc, MAKESTR(BLK_MENU, STR_RENAME_PLAYER), (void*)RenPlyCtls, 0},
	{ID_MENU_PLYR_DEL,	WT_RADIOBUTTON,	 2, 33, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MenuItemProc, MAKESTR(BLK_MENU, STR_DELETE_PLAYER), (void*)DelPlyCtls, 0},

	{ID_MENU_MOOD_SEL,	WT_RADIOBUTTON,	 2, 40, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MenuItemProc, MAKESTR(BLK_MENU, STR_CHANGE_MOOD), (void*)SelMoodCtls, 0},
	{ID_MENU_MOOD_ADD,	WT_RADIOBUTTON,	 2, 44, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MenuItemProc, MAKESTR(BLK_MENU, STR_ADD_MOOD), (void*)AddMoodCtls, 0},
	{ID_MENU_MOOD_REN,	WT_RADIOBUTTON,	 2, 48, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MenuItemProc, MAKESTR(BLK_MENU, STR_RENAME_MOOD), (void*)RenMoodCtls, 0},
	{ID_MENU_MOOD_DEL,	WT_RADIOBUTTON,	 2, 52, 27,  4, WF_SHOW+WF_NSC+CF_TABSTOP, MenuItemProc, MAKESTR(BLK_MENU, STR_DELETE_MOOD), (void*)DelMoodCtls, 0},

	{ID_MENU_MUSIC,		WT_RADIOBUTTON,	 4, 65, 23,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER, MenuItemProc, MAKESTR(BLK_MENU, STR_MUSIC), (void*)MusicCtls, 0},
	{ID_MENU_INTERFACE,	WT_RADIOBUTTON,	 4, 69, 23,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER, MenuItemProc, MAKESTR(BLK_MENU, STR_IF), (void*)IFSCtls, 0},
	{ID_MENU_LANG,		WT_RADIOBUTTON,	 4, 73, 23,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER, MenuItemProc, MAKESTR(BLK_MENU, STR_LANG), (void*)LangCtls, 0},
	{ID_MENU_GRAPHICS,	WT_RADIOBUTTON,	 4, 77, 23,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER, MenuItemProc, MAKESTR(BLK_MENU, STR_GRAPHICS), (void*)GraphCtls, 0},
	{ID_MENU_MOUSE,		WT_RADIOBUTTON,	 4, 81, 23,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER, MenuItemProc, MAKESTR(BLK_MENU, STR_MOUSE_MAP), (void*)MouseMapCtls, 0},
	{ID_MENU_KEYS,		WT_RADIOBUTTON,	 4, 85, 23,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER, MenuItemProc, MAKESTR(BLK_MENU, STR_KEY_MAP), (void*)KeyMapCtls, 0},

	{ID_MENU_OPTIONS,	WT_RADIOBUTTON,	 4, 89, 23,  4, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER, MenuItemProc, MAKESTR(BLK_MENU, STR_OPTIONS), (void*)OptionsCtls, 0},
	
	{ID_OK,				WT_BUTTONTEXT,	 1, 96, 14,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER+CF_GROUP, DefComButtProc, MAKESTR(BLK_MISC, STR_OK), 0, 0},
	{ID_CANCEL,			WT_BUTTONTEXT,	16, 96, 14,  6, WF_SHOW+WF_NSC+CF_TABSTOP+CF_CENTER+CF_GROUP, DefComButtProc, MAKESTR(BLK_MISC, STR_CANCEL), 0, 0},

// The ID_MENU_SPACE* controls allow the possibility of adding some "line graphics" between groups,
// but are here at the end, so as not to screw up the coordination of the main menu "radiobutton" entries.
// If pText=(char*)2, then it's a simple spacer line.
// If pText=(char*)1, then it's the "spacer line with down arrows" MOOD separator.

	{ID_MENU_SPACE1,	WT_CUSTOM,		 2, 19, 27,  1, WF_SHOW, MenuSpaceProc, (char*)2, 0, 0},

	{ID_MENU_SPACE2,	WT_CUSTOM,		 2, 38, 27,  1, WF_SHOW, MenuSpaceProc, (char*)2, 0, 0},
//	{ID_MENU_SPACE3,	WT_CUSTOM,		 2, 35, 27,  1, WF_SHOW, MenuSpaceProc, (char*)2, 0, 0},

	{ID_MENU_CURMOOD,	WT_TEXT,		 2, 58, 27,  4, WF_SHOW+CF_CENTER+CF_STR,	CurMoodProc, MenuMoodName, 0, 0},

	{ID_MENU_SPACE4,	WT_CUSTOM,		 2, 63, 27,  2, WF_SHOW, MenuSpaceProc, (char*)1, 0, 0},


	{0}
};

//=======================================================================
DLGRES ButtBarDlg[] = {
	{ID_BUTT_BAR_DLG,	WT_WND,	-BARWUU, -MSGHUU, 12,100, WF_SHOW, ButtBarDlgProc, 0, 0, 0},

	{ID_MENU_BUTT, WT_BUTTONBM, 		 0,  0, BARWUU,  MSGHUU, WF_SHOW+CF_TABSTOP+CF_GROUP, MenuButtProc, MAKESTR(BLK_BUTTS, STR_MENU_BUTT), (void*)((X_MENUBUTT<<16)+Y_MENUBUTT), (12<<16)+5},
	
	{ID_PUZZW_2, WT_BUTTONBM,		 1,  6,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PuzzWProc, MAKESTR(BLK_BUTTS, STR_PUZZW_2), (void*)((24<<16)+30), (5<<16)+5},
	{ID_PUZZH_2, WT_BUTTONBM,		 6,  6,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PuzzHProc, MAKESTR(BLK_BUTTS, STR_PUZZH_2), (void*)((24<<16)+ 0), (5<<16)+5},
	{ID_PUZZW_3, WT_BUTTONBM,		 1, 11,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PuzzWProc, MAKESTR(BLK_BUTTS, STR_PUZZW_3), (void*)((24<<16)+35), (5<<16)+5},
	{ID_PUZZH_3, WT_BUTTONBM,		 6, 11,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PuzzHProc, MAKESTR(BLK_BUTTS, STR_PUZZH_3), (void*)((24<<16)+ 5), (5<<16)+5},
	{ID_PUZZW_4, WT_BUTTONBM,		 1, 16,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PuzzWProc, MAKESTR(BLK_BUTTS, STR_PUZZW_4), (void*)((24<<16)+40), (5<<16)+5},
	{ID_PUZZH_4, WT_BUTTONBM,		 6, 16,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PuzzHProc, MAKESTR(BLK_BUTTS, STR_PUZZH_4), (void*)((24<<16)+10), (5<<16)+5},
	{ID_PUZZW_5, WT_BUTTONBM,		 1, 21,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PuzzWProc, MAKESTR(BLK_BUTTS, STR_PUZZW_5), (void*)((24<<16)+45), (5<<16)+5},
	{ID_PUZZH_5, WT_BUTTONBM,		 6, 21,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PuzzHProc, MAKESTR(BLK_BUTTS, STR_PUZZH_5), (void*)((24<<16)+15), (5<<16)+5},
	{ID_PUZZH_6, WT_BUTTONBM,		 6, 26,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PuzzHProc, MAKESTR(BLK_BUTTS, STR_PUZZH_6), (void*)((24<<16)+20), (5<<16)+5},
	{ID_PUZZH_7, WT_BUTTONBM,		 6, 31,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PuzzHProc, MAKESTR(BLK_BUTTS, STR_PUZZH_7), (void*)((24<<16)+25), (5<<16)+5},

	{ID_PREVPUZZ, WT_BUTTONBM,			 1, 37,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PrevPuzzProc, MAKESTR(BLK_BUTTS, STR_PREVPUZZ), (void*)((34<<16)+40), (5<<16)+5},
	{ID_NEXTPUZZ, WT_BUTTONBM,			 6, 37,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, NextPuzzProc, MAKESTR(BLK_BUTTS, STR_NEXTPUZZ), (void*)((34<<16)+50), (5<<16)+5},
	{ID_PUZZNUM, WT_EDITLINE,			 1, 42, 10,  4, WF_SHOW+CF_TABSTOP+CF_GROUP+CF_TOP, PuzzNumProc, MAKESTR(BLK_BUTTS, STR_PUZZNUM), (void*)10, 0},
	
	{ID_RESTART, WT_BUTTONBM,			 1, 47,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, RestartProc, MAKESTR(BLK_BUTTS, STR_RESTART), (void*)((34<<16)+20), (5<<16)+5},
	{ID_SAVEGAME, WT_BUTTONBM,			 6, 47,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, SaveGameProc, MAKESTR(BLK_BUTTS, STR_SAVEGAME), (void*)((34<<16)+25), (5<<16)+5},
	
	{ID_UNDO, WT_BUTTONBM,				 1, 53,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, UndoProc, MAKESTR(BLK_BUTTS, STR_UNDO), (void*)((34<<16)+0), (5<<16)+5},
	{ID_REDO, WT_BUTTONBM,				 6, 53,  5,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, RedoProc, MAKESTR(BLK_BUTTS, STR_REDO), (void*)((34<<16)+10),(5<<16)+5},
	
	{ID_PAUSE, WT_BUTTONBM,				 1, 58, 10,  5, WF_SHOW+CF_TABSTOP+CF_GROUP, PauseProc, MAKESTR(BLK_BUTTS, STR_PAUSE), (void*)((34<<16)+30), (10<<16)+5},
	
	{ID_TIME, WT_TEXT,					 0, 64, 12,  4, WF_SHOW+CF_GROUP+CF_CENTER+CF_STR, 	TextProc, StatusTime, 0, 0},
	{ID_MOVES, WT_TEXT,					 0, 68, 12,  4, WF_SHOW+CF_GROUP+CF_CENTER+CF_STR, 	TextProc, StatusMoves, 0, 0},
	{ID_BEST, WT_TEXT,					 0, 72, 12,  4, WF_SHOW+CF_GROUP+CF_CENTER+CF_STR, 	TextProc, StatusBest, 0, 0},

	{0}
};

//=======================================================================
DLGRES MsgBarDlg[] = {
	{ID_MSG_BAR_DLG,	WT_WND,			 0, -MSGHUU, 100, MSGHUU, WF_SHOW, MsgBarDlgProc, 0, 0, 0},
	
	{0}
};

